#include "format.h"

























void do_formatting( void )
{
  
  void do_chip_to_gencoord_files( void );
  void do_chip_seq_files( void );
  void do_region_binary_format( void );

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case '\0' :
    do_format_seq_file();
    break;
    
  /*  Previous :
  case 'a' :
    /*  In gen_coord.c:  
    do_fasta_to_gencoord_files();
    break;
 
  case 'b' :
    /*  In gen_coord.c:  
    do_maf_alignment_condensing();
    break;
    
  case 'c' :
    /*  In extract.c:  
    do_maf_alignment_extraction();
    break;
  */ 

  /*
  case 'a' :
    /*  In chip.c:  
    do_chip_to_gencoord_files();
    break;
    
  case 'b' :
    /*  In chip.c:  
    do_chip_seq_files();
    break;
  
  case 'c' :
    /*  In ft_new.c:  
    do_region_new_binary_format();
    break;
    
    /*  In ft.c:  
    do_region_binary_format();
    break;
    
  case 'm' :
    /*  In mf_align.c:  
    do_mf_align();
    break;
    
  case 'z' :
    /*  In chip.c:  
    do_region_chip_gencoord();
    break;
    
  */
  
  default :
    error( 1000, "Unrecognized minor mode passed to formatting function.\n" );
    break;
  
  }

}














/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/













void do_format_seq_file( void )
{

  extern MOTIF major_motif;

  check_major_motif();
  
  do_my_format_seq_file( &major_motif );
  
}











void do_my_format_seq_file( MOTIF *mf )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_binary_file_writing( char a[], char b[] );
  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char seq_align_file[ BUFFER ], input_file[ BUFFER ];
  extern char region_file[ BUFFER ];
  
  FILE *seq_fh = NULL, *reg_fh = NULL;
  FILE *ft_fh = NULL, *ind_fh = NULL, *spec_fh = NULL, *ss_fh = NULL;
  
  seq_fh = (FILE *)open_text_file_reading( seq_align_file, "" );
  reg_fh = (FILE *)open_text_file_reading( region_file, "" );
  ft_fh = (FILE *)open_binary_file_writing( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_writing( input_file, "i" );
  spec_fh = (FILE *)open_binary_file_writing( input_file, "x" );
  ss_fh = (FILE *)open_binary_file_writing( input_file, "s" );

  do_format_seq_file_w_fhs( mf, seq_fh, reg_fh, ft_fh, ind_fh, spec_fh, ss_fh );
  
  close_file( seq_fh );
  close_file( reg_fh );
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( spec_fh );
  close_file( ss_fh );
  
}












void do_format_seq_file_w_fhs( MOTIF *mf, FILE *seq_fh, FILE *reg_fh,
  FILE *ft_fh, FILE *ind_fh, FILE *spec_fh, FILE *ss_fh )
{

  TREE *make_and_set_tree( TREE *tree );
  
  TREE *tree = NULL;
  /*  In ../tree/create_tree.c:  */
  tree = (TREE *)make_and_set_tree( tree );
  
  /*  In this file, below:  */
  set_spec_cell_binary_file( tree, spec_fh );
  
  /*  In this file, below:  */
  do_format_seq_file_w_tree( tree, mf, seq_fh, reg_fh, ft_fh, ind_fh, spec_fh,
    ss_fh );
  
  /*  In ../tree/create_tree.c:  */
  kill_tree( tree );

}











void set_spec_cell_binary_file( TREE *tree, FILE *spec_fh )
{

  SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n );
  
  SPEC_CELL *spec_cell = NULL;
  
  INDEX n = get_numb_leaves_from_tree( tree );
  
  spec_cell = (SPEC_CELL *)create_spec_cell( spec_cell, n );
    
  NODE_LIST *node = tree->spec_header;
  
  int i = 0;
  
  while ( node != NULL ) {
    
    if ( node->my_node->leaf ) {
      strcpy( (spec_cell->x + i)->spec, node->my_node->label );
      (spec_cell->x + i)->numb = i;
      ++i;
    }
    
    node = node->next;
    
  }
  
  put( &n, sizeof(INDEX), spec_fh );
  put( spec_cell->x, sizeof(SPEC) * n, spec_fh );
  
  fflush( spec_fh );

}











int get_numb_leaves_from_tree( TREE *tree )
{

  NODE_LIST *node = tree->spec_header;
  
  int x = 0;
  
  while ( node != NULL ) {
  
    x += node->my_node->leaf;
    
    node = node->next;
  
  }
  
  return x;

}














void do_format_seq_file_w_tree( TREE *tree, MOTIF *mf, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *ind_fh, FILE *spec_fh, FILE *ss_fh )
{

  void do_binary_ft( MOTIF_LIST *mf_header, TREE *tree, FILE *seq_fh, FILE *reg_fh, 
    FILE *ft_fh, FILE *ind_fh, FILE *spec_fh, FILE *ss_fh );

  MOTIF_LIST *mf_header = NULL;
  /*  In this file, below:  */
  mf_header = (MOTIF_LIST *)get_motif_list_from_file( mf_header, mf );
  
  /*  In ft.c:  */
  do_binary_ft( mf_header, tree, seq_fh, reg_fh, ft_fh, ind_fh, spec_fh, ss_fh );

}












MOTIF_LIST *get_motif_list_from_file( MOTIF_LIST *mf_header, MOTIF *mf )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  extern MOTIF major_motif;
  extern char motif_file[ BUFFER ];
  
  char fname[ BUFFER ];

  if ( motif_file[ 0 ] == '\0' )
    /*  In this file, bottom:  */  
    get_default_motif_fname( fname, &major_motif );
  else
    strcpy( fname, motif_file );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( fname, "" );
  
  /*  In this file, below:  */
  mf_header = (MOTIF_LIST *)get_motif_list_w_fh( mf_header, fh );
  
  close_file( fh );

  return mf_header;

}












MOTIF_LIST *get_motif_list_w_fh( MOTIF_LIST *mf_header, FILE *fh )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) 
    mf_header = (MOTIF_LIST *)get_and_put_motif_lister_from_line( mf_header, line );
    
  return mf_header;
  
}









MOTIF_LIST *get_and_put_motif_lister_from_line( MOTIF_LIST *mf_header, char line[] )
{
  
  MOTIF_LIST *create_motif_lister( MOTIF_LIST *x );
  MF get_stack_from_string( char cons[] );
  
  MOTIF_LIST *mf = NULL;
  mf = (MOTIF_LIST *)create_motif_lister( mf );
  
  char cons[ BUFFER ];
  
  sscanf( line, "%s", cons );
  
  strcpy( mf->my_mf->cons, cons );
  mf->my_mf->length = strlen( cons );
  
  /*  In ../main/nucl.c:  */
  mf->my_mf->my_motif = get_stack_from_string( cons );
  
  /*  In this file, below:  */
  return put_motif_lister_end_of_list( mf_header, mf );

}











MOTIF_LIST *put_motif_lister_end_of_list( MOTIF_LIST *mf_header, MOTIF_LIST *mf )
{

  if ( mf_header == NULL )
    return mf;
    
  MOTIF_LIST *curr = mf_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = mf;
  
  return mf_header;

}







/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/









void do_format_motif_file( void )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  extern MOTIF major_motif;
  
  char fname[ BUFFER ];
  
  check_major_motif();
  
  get_default_motif_fname( fname, &major_motif );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_writing( fname, "" );
  
  do_format_motif_file_w_fh( &major_motif, fh );
  
  close_file( fh );

}












void get_default_motif_fname( char fname[], MOTIF *mf )
{

  char my_mf[ BUFFER ];
  
  upper( my_mf, mf->cons );
  
  sprintf( fname, "data/motif_file.%s.txt", my_mf );

}













void do_format_motif_file_w_fh( MOTIF *mf, FILE *fh )
{

  MF numb_of_mfs_from_length( char length );
  int get_motif_stack_mismatches( MOTIF *mf, MF stack );
  void get_string_from_stack( char cons[], MF stack, char length );
  
  extern int mismatch_thresh;
  
  /*  In ../main/nucl.c:  */
  MF numb_of_mfs = numb_of_mfs_from_length( mf->length );
  
  MOTIF rev_mf = { .length = mf->length };
  
  /*  In ../main/nucl.c:  */
  get_rev_complement_seq( rev_mf.cons, mf->cons );
  
  MF w;
  
  for ( w = 0; w < numb_of_mfs; w++ ) {
  
    char cons[ BUFFER ];
  
    /*  In ../main/nucl.c:  */
    if (( get_motif_stack_mismatches( mf, w ) <= mismatch_thresh ) ||
      ( get_motif_stack_mismatches( &rev_mf, w ) <= mismatch_thresh ))
    {
      /*  In ../main/nucl.c:  */
      get_string_from_stack( cons, w, mf->length );
      fprintf( fh, "%s\n", cons );
      printf( "%s\t%ld\t%ld\n", cons, w, numb_of_mfs );
    }
  
  }

}





/*
void do_region_format( void )
{

  void do_region_binary_format( void );
  
  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'a' :
    /*  In region.c:  
    do_regions();
    break;
    
  case 'b' :
    /*  In ft.c:  
    do_region_binary_format();
    break;
    
  case 'z' :
    /*  In check.c:  
    check_format();
    break;
    
  default :
    error( 1001, "Unrecognized minor mode passed to region format function.\n" );
    break;
  
  }

}


*/



















