#include "ft.h"































void do_binary_ft( MOTIF_LIST *mf_header, TREE *tree, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *ind_fh, FILE *spec_fh, FILE *ss_fh )
{

  MOTIF_LIST *align_header = NULL;
  align_header = (MOTIF_LIST *)get_empty_align_seq_mf_list( align_header,
    spec_fh );
    
  do_my_binary_ft( align_header, mf_header, tree, seq_fh, reg_fh, ft_fh, ind_fh,
    ss_fh );

}










MOTIF_LIST *get_empty_align_seq_mf_list( MOTIF_LIST *align_header, FILE *fh )
{

  SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n );
  void set_position( FPOS fpos, FILE *fh );

  set_position( 0, fh );
  
  INDEX n;
  get( &n, sizeof(INDEX), fh );
  
  SPEC_CELL *spec_cell = NULL;
  spec_cell = (SPEC_CELL *)create_spec_cell( spec_cell, n );
  
  get( spec_cell->x, sizeof(SPEC) * n, fh );
  
  int i;
  for ( i = 0; i < n; i++ )
    printf( "%2d  %s\n", i, (spec_cell->x + i)->spec );
    
  align_header = (MOTIF_LIST *)get_empty_align_seq_mf_list_w_spec_cell( align_header,
    spec_cell );
    
  kill_spec_cell( spec_cell );
  
  return align_header;

}












MOTIF_LIST *get_empty_align_seq_mf_list_w_spec_cell( MOTIF_LIST *align_header,
  SPEC_CELL *spec_cell )
{

  MOTIF_LIST *create_motif_lister( MOTIF_LIST *x );

  MOTIF_LIST *prev = NULL;

  int i;
  
  for ( i = 0; i < spec_cell->n; i++ ) {
  
    MOTIF_LIST *align = NULL;
    align = (MOTIF_LIST *)create_motif_lister( align );
    
    strcpy( align->spec, (spec_cell->x + i)->spec );
  
    if ( align_header == NULL ) {
      align_header = align;
      prev = align;
    }
    else {
      prev->next = align;
      prev = align;
    }
    
  }
  
  return align_header;

}













/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/















void do_my_binary_ft( MOTIF_LIST *align_header, MOTIF_LIST *mf_header, TREE *tree,
  FILE *seq_fh, FILE *reg_fh, FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  printf( "Counting motif occurrences." );
  printf( "..\n" );
  
  do_binary_ft_count_tfbs( align_header, mf_header, tree, seq_fh, reg_fh,
    ft_fh, ind_fh );
  
  printf( "Writing motif occurrences." );
  printf( "..\n" );
    
  do_binary_ft_put_tfbs( align_header, mf_header, tree, seq_fh, reg_fh, ft_fh,
    ind_fh, ss_fh );
    
}









void do_binary_ft_count_tfbs( MOTIF_LIST *align_header, MOTIF_LIST *mf_header,
  TREE *tree, FILE *seq_fh, FILE *reg_fh, FILE *ft_fh, FILE *ind_fh )
{

  int get_numb_leaves_from_tree( TREE *tree );
  void set_position( FPOS fpos, FILE *fh );
  
  /*  In format.c:  */
  int n = get_numb_leaves_from_tree( tree );
  
  char chr[ BUFFER ];
  int start, end;
  
  long ct[ BUFFER ], i;
  
  for ( i = 0; i < n; i++ )
    ct[ i ] = 0;
    
  char line[ LINE_BUFFER ];
  
  set_position( 0, seq_fh );
  set_position( 0, reg_fh );
  
  FPOS fpos = 0;
  
  int seq = 0;

  while ( fgets( line, LINE_BUFFER, reg_fh ) != NULL ) {
    fpos = get_binary_ft_count_block( ct, n, align_header, mf_header, fpos, line, 
      seq_fh );
    printf( "seq = %d\n", ++seq );
  }
      
  put_binary_ft_tfbs_count_array( ct, n, ft_fh, ind_fh );
  
}









void put_binary_ft_tfbs_count_array( long ct[], int n, FILE *ft_fh, FILE *ind_fh )
{

  FPOS get_position( FILE *fh );
  void set_position( FPOS fpos, FILE *fh );

  FT ft = { .seq = 0 };
  
  int i, j;
  
  for ( i = 0; i < MOTIF_LENGTH; i++ ) {
    ft.pos[ i ] = 0;
    ft.site[ i ] = '\0';
  }
  
  set_position( 0, ind_fh );  
  set_position( 0, ft_fh );
    
  for ( i = 0; i < n; i++ ) {
  
    FPOS fpos = get_position( ft_fh );
      
    FT_IND ft_ind = { .fpos = fpos, .n = ct[ i ], .x = 0 };

    for ( j = 0; j < ct[ i ]; j++ ) 
      put( &ft, sizeof(FT), ft_fh );
      
    put( &ft_ind, sizeof(FT_IND), ind_fh );
    
    fflush( ft_fh );
    fflush( ind_fh );
  
  }
  
}










void do_binary_ft_put_tfbs( MOTIF_LIST *align_header, MOTIF_LIST *mf_header,
  TREE *tree, FILE *seq_fh, FILE *reg_fh, FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  int get_numb_leaves_from_tree( TREE *tree );
  void set_position( FPOS fpos, FILE *fh );
  
  /*  In format.c:  */
  int n = get_numb_leaves_from_tree( tree );
  
  char chr[ BUFFER ];
  int start, end;
  
  FT_IND info_array[ NUMB_OF_SPEC ];
  FPOS fpos_array[ BUFFER ];
  int i;
  
  set_position( 0, ind_fh );
  
  get( info_array, sizeof(FT_IND) * n, ind_fh );
  
  for ( i = 0; i < n; i++ ) 
    fpos_array[ i ] = info_array[ i ].fpos;
       
  char line[ LINE_BUFFER ];
  
  set_position( 0, seq_fh );
  set_position( 0, reg_fh );
  
  SEQ seq_numb = 0;  
  FPOS fpos = 0;
  
  SEQ_LIST *seq_header = NULL, *last_seq = NULL;

  while ( fgets( line, LINE_BUFFER, reg_fh ) != NULL ) 
    fpos = get_binary_ft_put_tfbs_block( fpos_array, n, align_header, mf_header, 
      &seq_header, &last_seq, fpos, line, ++seq_numb, seq_fh, ft_fh, ind_fh );
        
  put_seq_info_list_binary( seq_header, ss_fh );
        
}










FPOS get_binary_ft_count_block( FPOS ct[], int n, MOTIF_LIST *align_header, 
  MOTIF_LIST *mf_header, FPOS fpos, char line[], FILE *seq_fh )
{

  extern char major_spec[ BUFFER ];

  GENCOORD_ENTRY gene_entry;
  MAF_LIST *maf_header = NULL;
  
  get_gencoord_entry_from_bed_line( &gene_entry, line );
  
  strcpy( gene_entry.spec, major_spec );
  
  maf_header = (MAF_LIST *)get_alignment_maf_list_single_gene( maf_header,
    &gene_entry, align_header, mf_header, &fpos, seq_fh );
    
  update_count_binary_array( ct, n, maf_header, mf_header );
    
  kill_maf_list( maf_header );
  
  return fpos;

}














void update_count_binary_array( long ct[], int n, MAF_LIST *maf_header,
  MOTIF_LIST *mf_header )
{

  MAF_LIST *maf = maf_header;

  int i;
  
  for ( i = 0; i < n; i++ ) {
    ct[ i ] += get_numb_of_tfbs_from_seq( maf->my_maf->seq, mf_header );
    maf = maf->next;
  }

}











int get_numb_of_tfbs_from_seq( char seq[], MOTIF_LIST *mf_header )
{

  int strs_match( char a[], char b[] );
  
  int i, j, n = 0, end = strlen( seq );
  
  if ( end == 0 )
    return 0;
  
  char site[ BUFFER ], len = 0;
  
  int mf_len = mf_header->my_mf->length;
  
  for ( i = 0; i < end; i++ ) {
  
    char c = tolower( seq[ i ] );
    
    if (( c == '.' ) || ( c == 'n' )) {
      site[ 0 ] = '\0';
      len = 0;
      continue;
    }
    
    if ( c == '-' )
      continue;
      
    if ( len < mf_len ) {
      site[ len++ ] = c;
      site[ len ] = '\0';
    }
    else {
      for ( j = 0; j < len - 1; j++ )
        site[ j ] = site[ j + 1 ];
      site[ len - 1 ] = c;
      site[ len ] = '\0';
    }
    
    if (( len == mf_len ) && ( site_in_motif_list( site, mf_header )))
      ++n;
      
  }
  
  return n;

}











int site_in_motif_list( char site[], MOTIF_LIST *mf_header )
{

  MF get_stack_from_string( char cons[] );
  
  /*  In ../main/nucl.c:  */
  MF stack = get_stack_from_string( site );

  MOTIF_LIST *mf = mf_header;
  
  while ( mf != NULL ) {
  
    if ( mf->my_mf->my_motif == stack )
      return 1;
      
    mf = mf->next;
  
  }
  
  return 0;

}








int get_gencoord_entry_from_bed_line( GENCOORD_ENTRY *gene_entry, char line[] )
{

  char entry[ BUFFER ], score_str[ BUFFER ];
  int start, end;
  
  int i = 0, j = 0;

  sscanf( line, "%s%d%d%s", gene_entry->chr, &start, &end, entry );
  
  gene_entry->start = start;
  gene_entry->end = end;
  
  for ( i = 0; i < strlen( entry ); i++ ) {
    score_str[ j++ ] = entry[ i ];
    if ( entry[ i ] == '.' )
      j = 0;
  }
  
  score_str[ j ] = '\0';
  
  return atoi( score_str );

}







FPOS get_binary_ft_put_tfbs_block( FPOS fpos_array[], int n, 
  MOTIF_LIST *align_header, MOTIF_LIST *mf_header, SEQ_LIST **seq_header,
  SEQ_LIST **last_seq, FPOS fpos, char line[], SEQ seq_numb, FILE *seq_fh, 
  FILE *ft_fh, FILE *ind_fh )
{

  extern char major_spec[ BUFFER ];

  GENCOORD_ENTRY gene_entry;
  MAF_LIST *maf_header = NULL;
  
  get_gencoord_entry_from_bed_line( &gene_entry, line );
  
  strcpy( gene_entry.spec, major_spec );
  
  maf_header = (MAF_LIST *)get_alignment_maf_list_single_gene( maf_header,
    &gene_entry, align_header, mf_header, &fpos, seq_fh );
    
  *seq_header = (SEQ_LIST *)get_and_put_seq_lister_region_line( *seq_header,
    last_seq, line, maf_header );

  update_binary_ft_put_tfbs_array( fpos_array, n, maf_header, mf_header, 
    seq_numb, ft_fh );
    
  kill_maf_list( maf_header );
  
  return fpos;

}








void update_binary_ft_put_tfbs_array( FPOS fpos_array[], int n, 
  MAF_LIST *maf_header, MOTIF_LIST *mf_header, SEQ seq_numb, FILE *ft_fh )
{

  MAF_LIST *maf = maf_header;

  int i;
  
  for ( i = 0; i < n; i++ ) {
    fpos_array[ i ] = put_binary_ft_tfbs_array( maf->my_maf->seq, mf_header,
      fpos_array[ i ], seq_numb, ft_fh );
    maf = maf->next;
  }

}











FPOS put_binary_ft_tfbs_array( char seq[], MOTIF_LIST *mf_header, FPOS fpos_index,
  SEQ seq_numb, FILE *ft_fh )
{

  void set_position( FPOS fpos, FILE *fh );

  set_position( fpos_index, ft_fh );
  
  FT ft = { .seq = seq_numb };
  
  int i, j = 0, k = 0, end = strlen( seq );
  
  for ( i = 0; i < MOTIF_LENGTH; i++ ) {
    ft.pos[ i ] = 0;
    ft.site[ i ] = '\0';
  }
  
  FPOS fpos = fpos_index;
  
  int len = 0, mf_len = mf_header->my_mf->length;
    
  for ( i = 0; i < end; i++ ) {
    
    char c = tolower( seq[ i ] );
    
    if ( c == '.' ) {
      ft.site[ 0 ] = '\0';
      len = 0;
      continue;
    }
    
    if ( c == 'n' ) {
      ft.site[ 0 ] = '\0';
      len = 0;
      ++k;
      continue;
    }
    
    if ( c == '-' )
      continue;
      
    if ( len < mf_len ) {
      ft.site[ len ] = c;
      ft.pos[ len++ ] = k++;
      ft.site[ len ] = '\0';
    }
    else {
      for ( j = 0; j < len - 1; j++ ) {
        ft.site[ j ] = ft.site[ j + 1 ];
        ft.pos[ j ] = ft.pos[ j + 1 ];
      }
      ft.site[ len - 1 ] = c;
      ft.pos[ len - 1 ] = k++;
      ft.site[ len ] = '\0';
    }
    
    if (( len == mf_len ) && ( site_in_motif_list( ft.site, mf_header ))) {
      put( &ft, sizeof(FT), ft_fh );
      fpos += sizeof(FT);
    }
    
  }
  
  fflush( ft_fh );
  
  return fpos;

}











SEQ_LIST *get_and_put_seq_lister_region_line( SEQ_LIST *seq_header, 
  SEQ_LIST **last_seq, char line[], MAF_LIST *maf_header )
{

  SEQ_LIST *create_seq_lister( SEQ_LIST *x );
  COUNT get_numb_of_nucls_seq( char seq[] );
  
  extern char major_spec[ BUFFER ];
  
  SEQ_LIST *seq = NULL;
  seq = (SEQ_LIST *)create_seq_lister( seq );
  
  SEQ_INFO *info = seq->my_seq;
  
  GENCOORD_ENTRY gene_entry = { .chr = "", .start = 0, .end = 0 };  
  info->score = get_gencoord_entry_from_bed_line( &gene_entry, line );
  
  MAF_LIST *maf = maf_header;
  
  int i = 0;
  
  while ( maf != NULL ) {
    /*  In ../main/nucl.c:  */
    seq->length[ i++ ] = get_numb_of_nucls_seq( maf->my_maf->seq );
    maf = maf->next;
  }
  
  seq->numb_of_spec = i;
  
  maf = maf_header;
  
  while ( maf != NULL ) {
    if ( ! strcmp( major_spec, maf->my_maf->entry->spec ))
      break;
    maf = maf->next;
  }
  
  strcpy( info->chr, gene_entry.chr );
  info->start = gene_entry.start;
  info->end = gene_entry.end;
  info->strand = '+';
  info->n = gene_entry.end - gene_entry.start;
  /*  In ../main/nucl.c:  */
  info->x = get_numb_of_nucls_seq( maf->my_maf->seq );
  
  if ( seq_header == NULL ) {
    *last_seq = seq;
    return seq;
  }
  
  (*last_seq)->next = seq;
  *last_seq = seq;
  
  return seq_header;

}













void put_seq_info_list_binary( SEQ_LIST *seq_header, FILE *ss_fh )
{

  SEQ_LIST *seq = seq_header;
  
  while ( seq != NULL ) {

    put( seq->my_seq, sizeof(SEQ_INFO), ss_fh );
    
    int i;
    
    for ( i = 0; i < seq->numb_of_spec; i++ )
      put( seq->length + i, sizeof(int), ss_fh );

    seq = seq->next;

  }

}








/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/








MAF_LIST *get_alignment_maf_list_single_gene( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FILE *seq_fh )
{

  void set_position( FPOS fpos, FILE *fh );

  set_position( *fpos, seq_fh );
  
  maf_header = (MAF_LIST *)make_and_set_maf_list_all_spec_cell( maf_header,
    align_header ); 
    
  return get_my_alignment_maf_list_single_gene( maf_header, gene_entry, 
    align_header, mf_header, fpos, seq_fh );

}












MAF_LIST *make_and_set_maf_list_all_spec_cell( MAF_LIST *maf_header, 
  MOTIF_LIST *mf_header )
{

  MOTIF_LIST *spec = mf_header;
  
  while ( spec != NULL ) 
    maf_header = (MAF_LIST *)make_and_set_single_maf_spec_and_step( maf_header,
      &spec );
      
  return maf_header;

}










MAF_LIST *make_and_set_single_maf_spec_and_step( MAF_LIST *maf_header, 
  MOTIF_LIST **spec )
{

  maf_header = (MAF_LIST *)make_and_set_single_maf_spec( maf_header, *spec );
  
  *spec = (*spec)->next;
  
  return maf_header;

}










MAF_LIST *make_and_set_single_maf_spec( MAF_LIST *maf_header, MOTIF_LIST *spec )
{

  MAF_LIST *create_maf_lister( MAF_LIST *mm );
  
  MAF_LIST *maf = NULL;
  maf = (MAF_LIST *)create_maf_lister( maf );
  
  strcpy( maf->my_maf->entry->spec, spec->spec );
  
  maf->my_maf->seq[ 0 ] = '\0';
  
  return put_single_maf_spec_into_list( maf_header, maf );

}












MAF_LIST *put_single_maf_spec_into_list( MAF_LIST *maf_header, MAF_LIST *maf )
{

  if ( maf_header == NULL )
    return maf;
    
  MAF_LIST *curr = maf_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = maf;
  
  return maf_header;

}











MAF_LIST *get_my_alignment_maf_list_single_gene( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FILE *seq_fh )
{

  FPOS get_position( FILE *ff );
  void set_position( FPOS fpos, FILE *fh );

  char line[ LINE_BUFFER ];
  int after_found = 0;
  int same_chr = 0;
  
  FPOS my_fpos;
  
  my_fpos = *fpos;
  
  while ( fgets( line, LINE_BUFFER, seq_fh ) != NULL ) {
  
    maf_header = (MAF_LIST *)get_alignment_maf_single_multiz_line( maf_header,
      line, gene_entry, align_header, mf_header, fpos, &my_fpos, &after_found,
      &same_chr, seq_fh );
  
    if (( after_found < 0 ) || ( same_chr < 0 ))
      return maf_header;
      
  }
  
  if ( same_chr == 0 ) {
    
    *fpos = 0;

    set_position( 0, seq_fh );
    
    while ( fgets( line, LINE_BUFFER, seq_fh ) != NULL ) {
    
      maf_header = (MAF_LIST *)get_alignment_maf_single_multiz_line( maf_header,
        line, gene_entry, align_header, mf_header, fpos, &my_fpos, &after_found,
        &same_chr, seq_fh );
  
      if (( after_found < 0 ) || ( same_chr < 0 ))
        return maf_header;
      
    }
  
  }
  
  return maf_header;

}













MAF_LIST *get_alignment_maf_single_multiz_line( MAF_LIST *maf_header, char line[], 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FPOS *my_fpos, int *after_found, int *same_chr, FILE *seq_fh )
{

  FPOS get_position( FILE *fh );

  extern char major_spec[ BUFFER ];
  
  char spec[ BUFFER ];

  if ( line[ 0 ] != 's' )
    return maf_header;
    
  get_spec_from_maf_line( spec, line );

  if ( strcmp( spec, major_spec )) 
    return maf_header;
    
  *my_fpos = get_position( seq_fh );

  GENCOORD_ENTRY maf_entry;
  get_gencoord_entry_from_maf_line( &maf_entry, line );
  
  *same_chr = set_same_chr( gene_entry, &maf_entry, *same_chr );
  
  if ( *same_chr < 0 )
    return maf_header;
    
  if ( ! gene_gencoord_matches_maf_gencoord( gene_entry, &maf_entry )) {
    if ( *after_found == 1 )
      *after_found = -1;
    return maf_header;
  }
  
  *after_found = 1;
  
  *fpos = *my_fpos;
  
  return get_alignment_maf_first_major_species_line( maf_header, 
    line, &maf_entry, gene_entry, after_found, fpos, seq_fh );
  
}











void get_spec_from_maf_line( char spec[], char line[] )
{

  char s[ BUFFER ];
  
  sscanf( line, "%*s%s", s );
  
  char i, end = strlen( s );
  
  for ( i = 0; i < end; i++ ) {
    if ( s[ i ] == '.' ) {
      spec[ i ] = '\0';
      break;
    }
    spec[ i ] = s[ i ];
  }

}








void get_gencoord_entry_from_maf_line( GENCOORD_ENTRY *entry, char line[] )
{

  char x[ BUFFER ], start[ BUFFER ], length[ BUFFER ], strand[ BUFFER ];
  int chr_length;
  
  if (( line[ 0 ] == '\n' ) || ( line[ 0 ] == '\0' ))
    return;
  //printf("%s\n",line);  
  sscanf( line, "%*s%s%s%s%s%d",
    x,
    start,
    length,
    strand,
    &chr_length );
  register char i = 0, j = 0;
  
  while ( x[ i ] != '.' ) {
    entry->spec[ i ] = x[ i ];
    ++i;
  }
    
  entry->spec[ i ] = '\0';
  
  strcpy( entry->chr, x + i + 1 );
  
  entry->start = (COORD)atoll( start );
  entry->end = entry->start + (COORD)atoll( length );
  entry->strand = strand[ 0 ];

  //printf("## strand:%c\n",strand[ 0 ]);
  if ( entry->strand == '-' ) {
    entry->start = chr_length - entry->end;
    entry->end = chr_length - (entry->end - atoll( length ));
  }
  
}











int set_same_chr( GENCOORD_ENTRY *gene_entry, GENCOORD_ENTRY *maf_entry, 
  int same_chr )
{

  if (( ! strcmp( maf_entry->spec, gene_entry->spec )) &&
    ( ! strcmp( maf_entry->chr, gene_entry->chr )))
  return 1;
  
  if ( same_chr != 1 )
    return same_chr;
    
  if (( ! strcmp( maf_entry->spec, gene_entry->spec )) &&
    ( strcmp( maf_entry->chr, gene_entry->chr )))
  return -1;
  
  return same_chr;

}












int gene_gencoord_matches_maf_gencoord( GENCOORD_ENTRY *gene_entry, 
  GENCOORD_ENTRY *maf_entry )
{

  if ( strcmp( gene_entry->spec, maf_entry->spec ))
    return 0;
    
  if ( gene_entry->start > maf_entry->end )
    return 0;
    
  if ( gene_entry->end < maf_entry->start )
    return 0;
    
  if ( strcmp( gene_entry->chr, maf_entry->chr ))
    return 0;
    
  return 1;

}















MAF_LIST *get_alignment_maf_first_major_species_line( MAF_LIST *maf_header, 
  char line[], GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry, 
  int *after_found, FPOS *fpos, FILE *seq_fh )
{

  char my_line[ LINE_BUFFER ];
  
  int still_going = 1;
  
  maf_header = (MAF_LIST *)get_alignment_maf_single_matching_line( maf_header,
      line, line, maf_entry, gene_entry, after_found, fpos, &still_going, seq_fh );
  
  while (( still_going ) && ( fgets( my_line, LINE_BUFFER, seq_fh ) != NULL ))   
    maf_header = (MAF_LIST *)get_alignment_maf_single_matching_line( maf_header,
      my_line, line, maf_entry, gene_entry, after_found, fpos, &still_going, 
      seq_fh );
      
  return maf_header;

}










MAF_LIST *get_alignment_maf_single_matching_line( MAF_LIST *maf_header,
  char my_line[], char line[], GENCOORD_ENTRY *maf_entry, 
  GENCOORD_ENTRY *gene_entry, int *after_found, FPOS *fpos, int *still_going, 
  FILE *seq_fh )
{

  FPOS get_position( FILE *fh );
  
  extern char major_spec[ BUFFER ];
  
  if ( my_line[ 0 ] != 's' ) {
    if ( my_line[ 0 ] == 'a' )
      *still_going = 0;
    return maf_header;
  }
  
  char spec[ BUFFER ];
  
  get_spec_from_maf_line( spec, my_line );

  if ( ! strcmp( spec, major_spec )) { 

    GENCOORD_ENTRY curr_maf_entry;
    get_gencoord_entry_from_maf_line( &curr_maf_entry, my_line );
  
    if ( ! gene_gencoord_matches_maf_gencoord( gene_entry, &curr_maf_entry )) {
      *still_going = 0;
      return maf_header;
    }

  }
    
  MAF_LIST *maf = maf_header;
  
  while ( maf != NULL ) {
  
    if ( ! strcmp( maf->my_maf->entry->spec, spec )) {
      int len = strlen( maf_header->my_maf->seq );
      if ( ! strcmp( maf->my_maf->entry->spec, major_spec ))
        len = -1;
      update_alignment_maf_single_maf_line( maf, len, my_line, maf_entry );
      return maf_header;
    }
    
    maf = maf->next;
  
  }
  
  error( 2201, "Species not found.\n" );
      
  return NULL;
    
}








void update_alignment_maf_single_maf_line( MAF_LIST *maf, int len, char line[],
  GENCOORD_ENTRY *maf_entry )
{

  int seq_len = strlen( maf->my_maf->seq );
  
  char new_seq[ LINE_BUFFER ], n_seq[ LINE_BUFFER ];
  char x[ BUFFER ], chr[ BUFFER ];
  int start, length, chr_length;
  char strand[ BUFFER ];
  
  sscanf( line, "%*s%s%d%d%s%d%s", x, &start, &length, strand, &chr_length, 
    new_seq );
  
  int n = len - (strlen( new_seq ) + seq_len);
  
  if ( len == -1 )
    n = 0;
  
  int i;
  
  for ( i = 0; i < n; i++ )
    n_seq[ i ] = '.';
    
  n_seq[ n ] = '\0';
  
  for ( i = 0; i < strlen( x ); i++ ) {
    if ( x[ i ] == '.' ) {
      strcpy( chr, x + i + 1 );
      break;
    }
  }
  
  if ( strand[ 0 ] == '+' ) {
    if ( maf->my_maf->entry->start < 1 ) 
      maf->my_maf->entry->start = start;
    maf->my_maf->entry->end = start + length;
  }
  else {
    if ( maf->my_maf->entry->end < 1 ) 
      maf->my_maf->entry->end = chr_length - start;
    maf->my_maf->entry->start = chr_length - (start + length);
  }
  
  maf->my_maf->entry->strand = strand[0];

  strcpy( maf->my_maf->entry->chr, chr );
  
  strcat( maf->my_maf->seq, n_seq );
  strcat( maf->my_maf->seq, new_seq );
    
}









