#include "dyn_alloc.h"
























STR_LIST *create_str_lister( STR_LIST *x )
{

  x = (STR_LIST *)malloc( sizeof(STR_LIST) );
  
  check_null( 1, x );
  
  return initialize_str_lister( x );

}











MAF_LIST *create_maf_lister( MAF_LIST *x )
{

  GENCOORD_ENTRY *a = NULL, *b = NULL;
  MAF *m = NULL;
  
  a = (GENCOORD_ENTRY *)malloc( sizeof(GENCOORD_ENTRY) );
  b = (GENCOORD_ENTRY *)malloc( sizeof(GENCOORD_ENTRY) );
  m = (MAF *)malloc( sizeof(MAF) );
  x = (MAF_LIST *)malloc( sizeof(MAF_LIST) );
  
  check_null( 4, a, b, m, x );
  
  return initialize_maf_lister( x, a, b, m );

}












REGION_LIST *create_region_lister( REGION_LIST *x )
{

  REGION *xx = NULL;
  FH *fh = NULL;
  xx = (REGION *)malloc( sizeof(REGION) );
  fh = (FH *)malloc( sizeof(FH) );
  x = (REGION_LIST *)malloc( sizeof(REGION_LIST) );
  
  check_null( 3, x, xx, fh );
  
  return initialize_region_lister( x, xx, fh );

}













SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n )
{

  SPEC *xx = NULL;
  xx = (SPEC *)malloc( sizeof(SPEC) * n );
  x = (SPEC_CELL *)malloc( sizeof(SPEC_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_spec_cell( x, xx, n );

}












COUNT_CELL *create_count_cell( COUNT_CELL *x, INDEX n )
{

  COUNT *xx = NULL;
  xx = (COUNT *)malloc( sizeof(COUNT) * n );
  x = (COUNT_CELL *)malloc( sizeof(COUNT_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_count_cell( x, xx, n );

}










SEQ_LIST *create_seq_lister( SEQ_LIST *x )
{

  SEQ_INFO *xx = NULL;
  xx = (SEQ_INFO *)malloc( sizeof(SEQ_INFO) );
  x = (SEQ_LIST *)malloc( sizeof(SEQ_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_seq_lister( x, xx );

}












POS_LIST *create_pos_lister( POS_LIST *x )
{

  x = (POS_LIST *)malloc( sizeof(POS_LIST) );
  
  check_null( 1, x );
  
  return initialize_pos_lister( x );

}














NODE_LIST *create_node_lister( NODE_LIST *x )
{

  NODE *node = NULL;
  NODE_INFO *info = NULL;
  NODE_INFO *d[ DBUFF ];
  NODE_INFO *dd = NULL;
  NODE_INFO *pr = NULL;
  NODE_TRANS *trans = NULL;
  NODE_PARAM *pp = NULL;
  TAB *tab = NULL;
  
  node = (NODE *)malloc( sizeof(NODE) );
  info = (NODE_INFO *)malloc( sizeof(NODE_INFO) );  
  dd = (NODE_INFO *)malloc( sizeof(NODE_INFO) );
  pr = (NODE_INFO *)malloc( sizeof(NODE_INFO) );
  trans = (NODE_TRANS *)malloc( sizeof(NODE_TRANS) );
  pp = (NODE_PARAM *)malloc( sizeof(NODE_PARAM) );
  tab = (TAB *)malloc( sizeof(TAB) );
  x = (NODE_LIST *)malloc( sizeof(NODE_LIST) );
  
  int i;
  
  for ( i = 0; i < DBUFF; i++ ) {
    d[ i ] = (NODE_INFO *)malloc( sizeof(NODE_INFO) );
    check_null( 1, d[ i ] );
  }
  
  check_null( 8, x, node, info, dd, pr, trans, pp, tab );
  
  return initialize_node_lister( x, node, info, d, dd, pr, trans, pp, tab );

}














OCCUR_CELL *create_occur_cell( OCCUR_CELL *x, INDEX n )
{

  x = (OCCUR_CELL *)malloc( sizeof(OCCUR_CELL) );
  
  check_null( 1, x );
  
  return initialize_occur_cell( x, n );

}














MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX m )
{

  MODEL *model = NULL;
  MOTIF *my_mf = NULL;
  MODEL_STATS *stats = NULL, *null_stats = NULL;
  REGION *r = NULL;
  PART_LIST *part_header = NULL;
  
  model = (MODEL *)malloc( sizeof(MODEL) );
  my_mf = (MOTIF *)malloc( sizeof(MOTIF) );
  stats = (MODEL_STATS *)malloc( sizeof(MODEL_STATS) );
  null_stats = (MODEL_STATS *)malloc( sizeof(MODEL_STATS) );
  r = (REGION *)malloc( sizeof(REGION) );
  x = (MODEL_LIST *)malloc( sizeof(MODEL_LIST) );
  
  part_header = (PART_LIST *)create_part_list( part_header, m );
  
  check_null( 6, x, model, my_mf, stats, null_stats, r );
  
  *my_mf = *mf;
  
  return initialize_model_lister( x, model, my_mf, stats, null_stats, r, 
    part_header, m );

}











PART_LIST *create_part_list( PART_LIST *part_header, INDEX m )
{

  int i = 0;
  
  while ( i++ < 1 + m )
    part_header = (PART_LIST *)create_and_put_part_lister( part_header );
    
  return part_header;

}












PART_LIST *create_and_put_part_lister( PART_LIST *part_header )
{

  PART_LIST *part = NULL;
  part = (PART_LIST *)create_part_lister( part );
  
  return put_part_lister_end_of_list( part_header, part );

}











PART_LIST *create_part_lister( PART_LIST *x )
{

  PART *part = NULL;
  PARAMS *pp = NULL;
  
  pp = (PARAMS *)malloc( sizeof(PARAMS) );
  part = (PART *)malloc( sizeof(PART) );
  x = (PART_LIST *)malloc( sizeof(PART_LIST) );
  
  check_null( 3, x, pp, part );
  
  return initialize_part_lister( x, part, pp );

}














LIST *create_lister( LIST *x, char type )
{

  x = (LIST *)malloc( sizeof(LIST) );
  
  check_null( 1, x );
  
  return initialize_lister( x, type );

}












PT_CELL *create_pt_cell( PT_CELL *x, INDEX n )
{

  x = (PT_CELL *)malloc( sizeof(PT_CELL) );
  
  check_null( 1, x );
  
  int i;
  
  for ( i = 0; i < n; i++ ) {
  
    x->pp[ i ] = (PARAMS *)malloc( sizeof(PARAMS) );
    x->branch[ i ] = NULL;
    
    check_null( 1, x->pp[ i ] );
  
  }
  
  return initialize_pt_cell( x, n );

}












VEC *create_vec( VEC *x, INDEX n )
{

  x = (VEC *)malloc( sizeof(VEC) );
  
  check_null( 1, x );
  
  return initialize_vec( x, n );

}














MX *create_mx( MX *mx, INDEX i, INDEX j )
{

  mx = (MX *)malloc( sizeof(MX) );
  
  check_null( 1, mx );
  
  return initialize_mx( mx, i, j );

}












NODE_INFO_CELL *create_node_info_cell( NODE_INFO_CELL *x, INDEX n )
{

  NODE_INFO *xx = NULL;
  xx = (NODE_INFO *)malloc( sizeof(NODE_INFO) * n );
  x = (NODE_INFO_CELL *)malloc( sizeof(NODE_INFO_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_node_info_cell( x, xx, n );

}














TREE_DATA *create_tree_data( TREE_DATA *x )
{

  x = (TREE_DATA *)malloc( sizeof(TREE_DATA) );
  
  check_null( 1, x );
  
  return initialize_tree_data( x );

}














LEAF_DATA_LIST *create_leaf_data_lister( LEAF_DATA_LIST *x )
{

  LEAF_DATA *xx = NULL;
  
  xx = (LEAF_DATA *)malloc( sizeof(LEAF_DATA) );
  x = (LEAF_DATA_LIST *)malloc( sizeof(LEAF_DATA_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_leaf_data_lister( x, xx );

}















TREE *create_tree( TREE *x )
{

  x = (TREE *)malloc( sizeof(TREE) );
  
  check_null( 1, x );
  
  return initialize_tree( x );

}














DATA *create_data( DATA *x )
{

  MOTIF *mf = NULL;
  REGION *reg = NULL;
  
  x = (DATA *)malloc( sizeof(DATA) );
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  reg = (REGION *)malloc( sizeof(REGION) );
  
  check_null( 3, x, mf, reg );
  
  return initialize_data( x, mf, reg );

}











PDATA_LIST *create_pdata_lister( PDATA_LIST *x )
{

  PDATA *xx = NULL;
  xx = (PDATA *)malloc( sizeof(PDATA) );
  x = (PDATA_LIST *)malloc( sizeof(PDATA_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_pdata_lister( x, xx );

}













EM_INFO *create_em_info( EM_INFO *x, INDEX n )
{

  PT_CELL *pt_a = NULL, *pt_b = NULL;
  REGION *reg = NULL;
  
  pt_a = (PT_CELL *)create_pt_cell( pt_a, n );
  pt_b = (PT_CELL *)create_pt_cell( pt_b, n );
  
  x = (EM_INFO *)malloc( sizeof(EM_INFO) );
  
  check_null( 3, x, pt_a, pt_b );
  
  return initialize_em_info( x, pt_a, pt_b );

}













TAB_CELL *create_tab_cell( TAB_CELL *tab_cell, INDEX n )
{

  tab_cell = (TAB_CELL *)malloc( sizeof(TAB_CELL) );
  
  int i;
  
  for ( i = 0; i < n; i++ ) {
    tab_cell->tab[ i ] = (TAB *)malloc( sizeof(TAB) );
    check_null( 1, tab_cell->tab[ i ] );
  }
  
  check_null( 1, tab_cell );
  
  return initialize_tab_cell( tab_cell, n );

}















BRANCH_LIST *create_branch_lister( BRANCH_LIST *x )
{

  BRANCH *xx = NULL;
  xx = (BRANCH *)malloc( sizeof(BRANCH) );
  x = (BRANCH_LIST *)malloc( sizeof(BRANCH_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_branch_lister( x, xx );

}













RESULT_LIST *create_result_lister( RESULT_LIST *x )
{

  MOTIF *mf = NULL;
  RESULT *xx = NULL;
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  xx = (RESULT *)malloc( sizeof(RESULT) );
  x = (RESULT_LIST *)malloc( sizeof(RESULT_LIST) );
  
  check_null( 3, x, xx, mf );
  
  return initialize_result_lister( x, xx, mf );

}












GENE_LIST *create_gene_lister( GENE_LIST *x )
{

  GENE *xx = NULL;
  GENCOORD_ENTRY *entry = NULL;
  GENE_STATS *stats = NULL;
  
  stats = (GENE_STATS *)malloc( sizeof(GENE_STATS) );
  entry = (GENCOORD_ENTRY *)malloc( sizeof(GENCOORD_ENTRY) );
  xx = (GENE *)malloc( sizeof(GENE) );
  x = (GENE_LIST *)malloc( sizeof(GENE_LIST) );
  
  check_null( 4, x, xx, stats, entry );
  
  return initialize_gene_lister( x, xx, entry, stats );

}














REL_LIST *create_rel_lister( REL_LIST *x )
{

  REL *xx = NULL;
  MOTIF *a_mf = NULL, *b_mf = NULL;
  
  a_mf = (MOTIF *)malloc( sizeof(MOTIF) );
  b_mf = (MOTIF *)malloc( sizeof(MOTIF) );
  xx = (REL *)malloc( sizeof(REL) );
  x = (REL_LIST *)malloc( sizeof(REL_LIST) );
  
  check_null( 4, x, xx, a_mf, b_mf );
  
  return initialize_rel_lister( x, xx, a_mf, b_mf );

}












REL_STATS_LIST *create_rel_stats_lister( REL_STATS_LIST *x )
{

  REL_STATS *xx = NULL;
  xx = (REL_STATS *)malloc( sizeof(REL_STATS) );
  x = (REL_STATS_LIST *)malloc( sizeof(REL_STATS_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_rel_stats_lister( x, xx );

}











MEMB_LIST *create_memb_lister( MEMB_LIST *x )
{

  MOTIF *mf = NULL;
  MEMB *xx = NULL;
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  xx = (MEMB *)malloc( sizeof(MEMB) );
  x = (MEMB_LIST *)malloc( sizeof(MEMB_LIST) );
  
  check_null( 3, x, xx, mf );
  
  return initialize_memb_lister( x, xx, mf );

}











CLUS_LIST *create_clus_lister( CLUS_LIST *x )
{

  CLUS *xx = NULL;
  xx = (CLUS *)malloc( sizeof(CLUS) );
  x = (CLUS_LIST *)malloc( sizeof(CLUS_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_clus_lister( x, xx );

}











MEMB_LIST *create_empty_memb_lister( MEMB_LIST *x )
{

  x = (MEMB_LIST *)malloc( sizeof(MEMB_LIST) );
  
  check_null( 1, x );
  
  return initialize_empty_memb_lister( x );

}













DINUCL_LIST *create_dinucl_lister( DINUCL_LIST *x )
{

  DINUCL *xx = NULL;
  xx = (DINUCL *)malloc( sizeof(DINUCL) );
  x = (DINUCL_LIST *)malloc( sizeof(DINUCL_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_dinucl_lister( x, xx );

}













SUM_LIST *create_sum_lister( SUM_LIST *x )
{

  SUM *xx = NULL;
  xx = (SUM *)malloc( sizeof(SUM) );
  x = (SUM_LIST *)malloc( sizeof(SUM_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_sum_lister( x, xx );

}












GO_TERM_LIST *create_go_term_lister( GO_TERM_LIST *x )
{

  GO_TERM *xx = NULL;
  xx = (GO_TERM *)malloc( sizeof(GO_TERM) );
  x = (GO_TERM_LIST *)malloc( sizeof(GO_TERM_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_go_term_lister( x, xx );

}










GO_GENE_LIST *create_go_gene_lister( GO_GENE_LIST *x )
{

  GO_GENE *xx = NULL;
  xx = (GO_GENE *)malloc( sizeof(GO_GENE) );
  x = (GO_GENE_LIST *)malloc( sizeof(GO_GENE_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_go_gene_lister( x, xx );

}








FPOS_LIST *create_fpos_lister( FPOS_LIST *x )
{

  x = (FPOS_LIST *)malloc( sizeof(FPOS_LIST) );
  
  x->c = '\0';
  x->fpos = 0;
  x->next = NULL;
  
  return x;

}








GO_LIST *create_go_lister( GO_LIST *x )
{

  GO *xx = NULL;
  xx = (GO *)malloc( sizeof(GO) );
  x = (GO_LIST *)malloc( sizeof(GO_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_go_lister( x, xx );

}












GO_STATS_LIST *create_go_stats_lister( GO_STATS_LIST *x )
{

  GO_STATS *xx = NULL;
  xx = (GO_STATS *)malloc( sizeof(GO_STATS) );
  x = (GO_STATS_LIST *)malloc( sizeof(GO_STATS_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_go_stats_lister( x, xx );

}











CHIP_GENE_LIST *create_chip_gene_lister( CHIP_GENE_LIST *x )
{

  CHIP_GENE *xx = NULL;
  xx = (CHIP_GENE *)malloc( sizeof(CHIP_GENE) );
  x = (CHIP_GENE_LIST *)malloc( sizeof(CHIP_GENE_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_chip_gene_lister( x, xx );

}











CHIP_PK_LIST *create_chip_pk_lister( CHIP_PK_LIST *x )
{

  CHIP_PK *xx = NULL;
  xx = (CHIP_PK *)malloc( sizeof(CHIP_PK) );
  x = (CHIP_PK_LIST *)malloc( sizeof(CHIP_PK_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_chip_pk_lister( x, xx );

}












CHIP_LIST *create_chip_lister( CHIP_LIST *x )
{

  CHIP *xx = NULL;
  xx = (CHIP *)malloc( sizeof(CHIP) );
  x = (CHIP_LIST *)malloc( sizeof(CHIP_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_chip_lister( x, xx );

}












CHIP_STATS_LIST *create_chip_stats_lister( CHIP_STATS_LIST *x )
{

  CHIP_STATS *a = NULL, *b = NULL;
  a = (CHIP_STATS *)malloc( sizeof(CHIP_STATS) );
  b = (CHIP_STATS *)malloc( sizeof(CHIP_STATS) );
  x = (CHIP_STATS_LIST *)malloc( sizeof(CHIP_STATS_LIST) );
  
  check_null( 3, x, a, b );
  
  return initialize_chip_stats_lister( x, a, b );

}















MOTIF_LIST *create_motif_lister( MOTIF_LIST *x )
{

  MOTIF *mf = NULL;
  MOTIF_STATS *stats = NULL;
  
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  stats = (MOTIF_STATS *)malloc( sizeof(MOTIF_STATS) );
  x = (MOTIF_LIST *)malloc( sizeof(MOTIF_LIST) );
  
  check_null( 3, x, mf, stats );
  
  return initialize_motif_lister( x, mf, stats );

}













USE_CELL *create_use_cell( USE_CELL *x, INDEX n )
{

  USE *xx = NULL;
  xx = (USE *)malloc( sizeof(USE) * n );
  x = (USE_CELL *)malloc( sizeof(USE_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_use_cell( x, xx, n );

}












CROSS_LIST *create_cross_lister( CROSS_LIST *x )
{

  CROSS *xx = NULL;
  xx = (CROSS *)malloc( sizeof(CROSS) );
  x = (CROSS_LIST *)malloc( sizeof(CROSS_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_cross_lister( x, xx );

}













EVOL_LIST *create_evol_lister( EVOL_LIST *x )
{

  EVOL_STATS *s = NULL;
  EVOL *xx = NULL;
  MOTIF *mf = NULL;
  
  s = (EVOL_STATS *)malloc( sizeof(EVOL_STATS) );
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  xx = (EVOL *)malloc( sizeof(EVOL) );
  x = (EVOL_LIST *)malloc( sizeof(EVOL_LIST) );
  
  check_null( 4, x, xx, s, mf );
  
  return initialize_evol_lister( x, xx, s, mf );

}












FT_ARRAY *create_ft_array( FT_ARRAY *x, int n )
{

  FPOS *fpos_array = NULL;
  fpos_array = (FPOS *)malloc( sizeof(FPOS) * n );
  x = (FT_ARRAY *)malloc( sizeof(FT_ARRAY) );
  
  check_null( 2, x, fpos_array );
  
  return initialize_ft_array( x, fpos_array, n );

}












FT_LIST *create_ft_lister( FT_LIST *x )
{

  FT *xx = NULL;
  xx = (FT *)malloc( sizeof(FT) );
  x = (FT_LIST *)malloc( sizeof(FT_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_ft_lister( x, xx );

}












DATA_LIST *create_data_lister( DATA_LIST *x )
{

  DATA *a = NULL, *b = NULL;
  a = (DATA *)create_data( a );
  b = (DATA *)create_data( b );
  x = (DATA_LIST *)malloc( sizeof(DATA_LIST) );
  
  check_null( 3, x, a, b );
  
  return initialize_data_lister( x, a, b );

}













ORIGIN_LIST *create_origin_lister( ORIGIN_LIST *x )
{

  MOTIF *mf = NULL;
  ORIGIN *xx = NULL;
  
  mf = (MOTIF *)malloc( sizeof(MOTIF) );
  xx = (ORIGIN *)malloc( sizeof(ORIGIN) );
  x = (ORIGIN_LIST *)malloc( sizeof(ORIGIN_LIST) );
  
  check_null( 3, x, xx, mf );
  
  return initialize_origin_lister( x, xx, mf );

}












SITE_LIST *create_site_lister( SITE_LIST *x )
{

  SEQ_INFO *info = NULL;
  SITE_STATS *stats = NULL;
  SITE_INFO *xx = NULL;
  
  info = (SEQ_INFO *)malloc( sizeof(SEQ_INFO ) );
  xx = (SITE_INFO *)malloc( sizeof(SITE_INFO) );
  stats = (SITE_STATS *)malloc( sizeof(SITE_STATS) );
  x = (SITE_LIST *)malloc( sizeof(SITE_LIST) );
  
  check_null( 3, x, xx, info, stats );
  
  return initialize_site_lister( x, xx, info, stats );

}











REL_ORIGIN_LIST *create_rel_origin_lister( REL_ORIGIN_LIST *x )
{

  MOTIF *a_mf = NULL, *b_mf = NULL;
  REL_HIST *best_hist = NULL, *rev_hist = NULL, *all_hist = NULL;
  OREL_STATS *stats = NULL, *rev = NULL;
  REL_ORIGIN *xx = NULL;
  
  a_mf = (MOTIF *)malloc( sizeof(MOTIF) );
  b_mf = (MOTIF *)malloc( sizeof(MOTIF) );
  stats = (OREL_STATS *)malloc( sizeof(OREL_STATS) );
  rev = (OREL_STATS *)malloc( sizeof(OREL_STATS) );
  best_hist = (REL_HIST *)malloc( sizeof(REL_HIST) );
  rev_hist = (REL_HIST *)malloc( sizeof(REL_HIST) );
  all_hist = (REL_HIST *)malloc( sizeof(REL_HIST) );
  xx = (REL_ORIGIN *)malloc( sizeof(REL_ORIGIN) );
  x = (REL_ORIGIN_LIST *)malloc( sizeof(REL_ORIGIN_LIST) );
  
  check_null( 5, x, xx, stats, a_mf, b_mf );
  
  x->my_rel = xx;
  xx->major_mf = a_mf;
  xx->minor_mf = b_mf;
  xx->best_stats = stats;
  xx->rev_stats = rev;
  xx->best_hist = best_hist;
  xx->rev_hist = rev_hist;
  xx->all_hist = all_hist;
  
  int i, j;
  
  for ( i = 0; i < STRAND_BUFFER; i++ ) {
  
    xx->major_hist[ i ] = (ORIGIN_HIST *)malloc( sizeof(ORIGIN_HIST) );
    xx->minor_hist[ i ] = (ORIGIN_HIST *)malloc( sizeof(ORIGIN_HIST) );
    
    for ( j = 0; j < STRAND_BUFFER; j++ ) {
      xx->rel_hist[ i ][ j ] = (REL_HIST *)malloc( sizeof(REL_HIST) );
      xx->rel_stats[ i ][ j ] = (OREL_STATS *)malloc( sizeof(OREL_STATS) );
      check_null( 2, xx->rel_hist[ i ][ j ], xx->rel_stats[ i ][ j ] );
    }
    
    check_null( 2, xx->major_hist[ i ], xx->minor_hist[ i ] );
    
  }
  
  x->next = NULL;
  
  return x;

}










CHROM_LIST *create_chrom_lister( CHROM_LIST *x )
{

  x = (CHROM_LIST *)malloc( sizeof(CHROM_LIST) );
  
  check_null( 1, x );
  
  x->chr[ 0 ] = '\0';
  x->site_header = NULL;
  x->next = NULL;
  
  return x;

}









REPEAT_FAM_LIST *create_repeat_fam_lister( REPEAT_FAM_LIST *x )
{

  x = (REPEAT_FAM_LIST *)malloc( sizeof(REPEAT_FAM_LIST) );
  
  check_null( 1, x );
  
  x->family[ 0 ] = '\0';
  x->total = 0;
  x->sites = 0;
  x->pval = 1.0;
  x->repeat_header = NULL;
  x->next = NULL;
  
  return x;

}











REPEAT_LIST *create_repeat_lister( REPEAT_LIST *x )
{

  x = (REPEAT_LIST *)malloc( sizeof(REPEAT_LIST) );
  
  check_null( 1, x );
  
  x->repeat[ 0 ] = '\0';
  x->total = 0;
  x->sites = 0;
  x->pval = 1.0;
  x->next = NULL;
  
  return x;

}








/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/












STR_LIST *initialize_str_lister( STR_LIST *x )
{

  x->str[ 0 ] = '\0';
  x->next = NULL;
  
  return x;

}











MAF_LIST *initialize_maf_lister( MAF_LIST *x, GENCOORD_ENTRY *a, GENCOORD_ENTRY *b, 
  MAF *m )
{

  a = (GENCOORD_ENTRY *)initialize_gencoord_entry( a );
  b = (GENCOORD_ENTRY *)initialize_gencoord_entry( b );
  
  m->entry = a;
  m->curr = b;
  m->seq[ 0 ] = '\0';
  m->use = 1;
  
  x->my_maf = m;
  
  x->next = NULL;
  x->same = NULL;
  
  return x;

}












GENCOORD_ENTRY *initialize_gencoord_entry( GENCOORD_ENTRY *x )
{

  x->spec[ 0 ] = '\0';
  x->gene[ 0 ] = '\0';
  x->chr[ 0 ] = '\0';
  
  x->start = -1;
  x->end = -1;
  x->chr_length = -1;
  
  x->strand = '\0';
  x->info[ 0 ] = '\0';
  
  return x;

}













REGION_LIST *initialize_region_lister( REGION_LIST *x, REGION *xx, FH *fh )
{

  xx->reg = '\0';
  xx->a = 0;
  xx->b = 0;
  
  initialize_fh( fh );
  
  x->my_region = xx;
  x->my_fh = fh;
  x->next = NULL;
  
  return x;

}












void initialize_fh( FH *fh )
{

  fh->text = NULL;
  fh->seq = NULL;
  fh->ct = NULL;
  fh->spec = NULL;
  fh->ft_ind = NULL;
  fh->ft = NULL;
  fh->spec_cell = NULL;
  fh->reg = '\0';

}








SPEC_CELL *initialize_spec_cell( SPEC_CELL *x, SPEC *xx, INDEX n )
{

  x->x = xx;
  x->n = n;
  
  SPEC *spec = xx;
  
  int i;
  
  for ( i = 0; i < n; i++ ) {
    spec->spec[ 0 ] = '\0';
    spec->numb = i;
    ++spec;
  }
    
  return x;

}














COUNT_CELL *initialize_count_cell( COUNT_CELL *x, COUNT *xx, INDEX n )
{

  x->x = xx;
  x->n = n;
  
  COUNT *ptr = xx;
  
  int i = 0;
  
  while ( i++ < n )
    *(ptr++) = 0;
    
  return x;

}












SEQ_LIST *initialize_seq_lister( SEQ_LIST *x, SEQ_INFO *xx )
{

  xx->fpos = 0;
  xx->n = 0;
  xx->x = 0;
  xx->gene[ 0 ] = '\0';
  xx->chr[ 0 ] = '\0';
  xx->start = 0;
  xx->end = 0;
  xx->strand = '\0';
  
  x->numb = 0;
  x->my_seq = xx;
  x->pos_header = NULL;
  x->nn_header = NULL;
  x->next = NULL;
  x->down = NULL;
  x->across = NULL;
  
  return x;

}











POS_LIST *initialize_pos_lister( POS_LIST *x )
{

  x->start = 0;
  x->end = 0;
  x->next = NULL;
  
  int i;
  
  for ( i = 0; i < CONS_BUFFER; i++ )
    x->pos[ i ] = IMPOSSIBLE;
  
  return x;

}














NODE_LIST *initialize_node_lister( NODE_LIST *x, NODE *node, NODE_INFO *info,
  NODE_INFO *d[], NODE_INFO *dd, NODE_INFO *pr, NODE_TRANS *trans, 
  NODE_PARAM *pp, TAB *tab )
{

  int i;

  x->my_node = node;
  x->my_info = info;
  x->my_trans = trans;  
  x->my_dd = dd;
  x->prior = pr;
  x->param = pp;
  x->tab = tab;
  
  initialize_node( node );
  initialize_node_info( info );
  initialize_node_info( pr );
  initialize_node_trans( trans );
  initialize_tab( tab );
  initialize_node_param( pp );
  
  for ( i = 0; i < DBUFF; i++ ) {
    x->my_d[ i ] = d[ i ];
    initialize_node_info( x->my_d[ i ] );
  }
  
  initialize_node_info( x->my_dd );
  
  x->up = NULL;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ )
    x->down[ i ] = NULL;

  x->next = NULL;
  x->prev = NULL;
  
  return x;

}












void initialize_tab( TAB *tab )
{

  tab->birth = 0.0;
  tab->death = 0.0;
  tab->siten = 0.0;
  tab->lhood = 0.0;
  tab->n = 0;
  tab->t = 0.0;

}













void initialize_node( NODE *node )
{
  node->numb = 0;
  node->label[ 0 ] = '\0';
  node->spec[ 0 ] = '\0';
  node->t = 0.0;
  node->leaf = 0;
}













void initialize_node_info( NODE_INFO *info )
{

  extern int max_occur;
  
  int end = max_occur + 2;

  int i;
  
  for ( i = 0; i < end; i++ )
    info->x[ i ] = 0.0;
    
  info->use = 0;

}












void initialize_node_trans( NODE_TRANS *trans )
{

  extern int max_occur;
  
  int end = max_occur + 2;

  int i, j;
  
  for ( i = 0; i < end; i++ ) {
    for ( j = 0; j < end; j++ )
      trans->p[ i ][ j ] = 0.0;
  }
  
  trans->u = 0.0;
  trans->v = 0.0;
  trans->n = 0.0;

}











void initialize_node_param( NODE_PARAM *pp )
{

  extern int max_occur;
  
  int end = max_occur + 2;

  int i, j;
  
  for ( i = 0; i < end; i++ ) {
    for ( j = 0; j < end; j++ ) {
      pp->a[ i ][ j ] = 0.0;
      pp->b[ i ][ j ] = 0.0;
    }
  }
  
}










OCCUR_CELL *initialize_occur_cell( OCCUR_CELL *x, INDEX n )
{

  int i;
  
  for ( i = 0; i < BUFFER; i++ ) {
    x->x[ i ] = NULL;
    x->spec[ i ][ 0 ] = '\0';
  }
    
  x->n = n;
  
  return x;

}














PART_LIST *initialize_part_lister( PART_LIST *x, PART *part, PARAMS *pp )
{

  x->my_part = part;
  x->next = NULL;
  
  part->pp = pp;
  part->branch_header = NULL;
  
  pp->a = 0.0;
  pp->b = 0.0;
  
  return x;

}














PART_LIST *put_part_lister_end_of_list( PART_LIST *part_header, PART_LIST *part )
{

  if ( part_header == NULL )
    return part;
    
  PART_LIST *curr = part_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = part;
  
  return part_header;

}
















MODEL_LIST *initialize_model_lister( MODEL_LIST *x, MODEL *model, MOTIF *mf, 
  MODEL_STATS *stats, MODEL_STATS *null_stats, REGION *r, PART_LIST *part_header, 
  INDEX m )
{

  x->my_model = model;
  x->next = NULL;
  x->down = NULL;

  model->m = m;
  model->part_n = 1 + m;
  
  model->mf = mf;
  model->stats = stats;
  model->null_stats = null_stats;
  model->my_region = r;

  model->part_header = part_header;
  
  initialize_model_stats( stats );
  initialize_model_stats( null_stats );
  
  return x;

}













void initialize_model_stats( MODEL_STATS *stats )
{
  stats->lhood = 0.0;
  stats->old_lhood = 0.0;
  stats->best_lhood = 0.0;
  stats->pval = 1.0;
  stats->n = 0;
  stats->dof_numer = 0;
  stats->dof_denom = 0;
  stats->max_occur = 0;
  stats->node_label[ 0 ] = '\0';
  stats->best_label[ 0 ] = '\0';
  stats->outcome = 0;
  stats->conv = 0;
}













LIST *initialize_lister( LIST *x, char type )
{

  x->type = type;
  x->next = NULL;

  switch ( type ) {
  
  case INT_TYPE :
    x->elem.d = 0;
    break;
    
  case DOUBLE_TYPE :
  case FLOAT_TYPE :
    x->elem.f = 0.0;
    break;
    
  default :
    error( 420, "Unrecognized type for lister element.\n" );
    break;
  
  }
  
  return x;

}













PT_CELL *initialize_pt_cell( PT_CELL *x, INDEX n )
{

  PARAMS pp = { .a = 0.0, .b = 0.0 };

  x->n = n;
  
  int i;
  
  for ( i = 0; i < n; i++ ) {
    *(x->pp[ i ]) = pp;
    x->branch[ i ] = NULL;
  }
    
  return x;

}














VEC *initialize_vec( VEC *x, INDEX n )
{

  int i;
  
  for ( i = 0; i < n; i++ )
    x->v[ i ] = 0.0;
    
  x->i = n;
  
  return x;

}















MX *initialize_mx( MX *mx, int i, int j )
{

  int a, b;
  
  for ( a = 0; a < i; a++ ) {
    for ( b = 0; b < j; b++ )
      mx->mx[ a ][ b ] = 0.0;
  }
  
  mx->i = i;
  mx->j = j;
  
  return mx;

}












NODE_INFO_CELL *initialize_node_info_cell( NODE_INFO_CELL *x, NODE_INFO *xx, 
  INDEX n )
{

  x->x = xx;
  x->n = n;
  
  return x;

}











TREE_DATA *initialize_tree_data( TREE_DATA *x )
{

  x->model = NULL;
  x->occur = NULL;
  x->root = NULL;
  x->leaf = NULL;
  
  return x;

}













LEAF_DATA_LIST *initialize_leaf_data_lister( LEAF_DATA_LIST *x, LEAF_DATA *xx )
{

  int i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
    xx->ct_array[ i ].ct = 0;
    xx->use_array[ i ].use = 0;
  }
  
  xx->n = 1;
  xx->changes = 0;
  xx->done = 0;
  xx->seq_numb = 0;
  
  x->data = xx;
  x->next = NULL;
  x->prev = NULL;
  
  return x;

}














TREE *initialize_tree( TREE *x )
{

  x->root = NULL;
  x->spec_header = NULL;
  x->inner_nodes = NULL;
  x->branch_header = NULL;
  x->death_header = NULL;
  
  return x;

}















DATA *initialize_data( DATA *x, MOTIF *mf, REGION *reg )
{

  x->tree = NULL;
  x->occur = NULL;
  x->pdata = NULL;
  x->mf = mf;
  x->reg = reg;
  
  return x;

}














PDATA_LIST *initialize_pdata_lister( PDATA_LIST *x, PDATA *xx )
{

  int i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
    xx->ct_array[ i ] = 0;
    xx->use_array[ i ] = 0;
  }
  
  xx->n = 0;
  xx->seq_numb = 0;
  xx->changes = 0;
  xx->done = 0;
  
  x->my_pdata = xx;
  x->next = NULL;
  x->prev = NULL;
  
  return x;

}














EM_INFO *initialize_em_info( EM_INFO *x, PT_CELL *pt_a, PT_CELL *pt_b )
{

  x->x = pt_a;
  x->old_x = pt_b;
  
  x->data = NULL;
  
  x->lhood = 0.0;
  x->old_lhood = 0.0;
  
  x->iter = 0;
  x->conv = '\0';
  x->outcome = '\0';
  
  return x;

}











TAB_CELL *initialize_tab_cell( TAB_CELL *tab_cell, INDEX n )
{

  int i;
  
  for ( i = 0; i < n; i++ )
    initialize_tab( tab_cell->tab[ i ] );
    
  tab_cell->n = n;
  
  return tab_cell;

}













BRANCH_LIST *initialize_branch_lister( BRANCH_LIST *x, BRANCH *xx )
{

  xx->node = NULL;
  xx->a = 0.0;
  
  x->my_branch = xx;
  x->next = NULL;
  x->prev = NULL;
  
  return x;

}













RESULT_LIST *initialize_result_lister( RESULT_LIST *x, RESULT *xx, MOTIF *mf )
{

  xx->model_header = NULL;
  xx->my_model = NULL;
  xx->null_model = NULL;
  xx->pval = 1.0;
  xx->m = 0;
  xx->mf = mf;
  
  x->my_result = xx;
  x->next = NULL;
  x->down = NULL;
  
  return x;

}
















GENE_LIST *initialize_gene_lister( GENE_LIST *x, GENE *xx, GENCOORD_ENTRY *entry, 
  GENE_STATS *stats )
{

  xx->gen_coord = entry;
  xx->stats = stats;
  
  initialize_gencoord_entry( entry );
  
  stats->node_q = 0;
  stats->parent_q = 0;
  
  x->my_gene = xx;
  x->next = NULL;
  
  return x;

}















REL_LIST *initialize_rel_lister( REL_LIST *x, REL *xx, MOTIF *a_mf, MOTIF *b_mf )
{

  xx->a_mf = a_mf;
  xx->b_mf = b_mf;
  xx->s_header = NULL;
  xx->pval = 1.0;
  
  initialize_motif( a_mf );
  initialize_motif( b_mf );
  
  x->my_rel = xx;
  x->next = NULL;
  
  return x;

}












void initialize_motif( MOTIF *mf )
{

  mf->cons[ 0 ] = '\0';
  mf->length = 0;
  mf->my_motif = 0;

}










REL_STATS_LIST *initialize_rel_stats_lister( REL_STATS_LIST *x, REL_STATS *xx )
{

  int i, j;
  
  for ( i = 0; i < PP; i++ ) {
    for ( j = 0; j < PP; j++ )
      xx->ct[ i ][ j ] = 0;
  }
  
  xx->pval = 1.0;
  xx->node[ 0 ] = '\0';
  
  x->s = xx;
  x->next = NULL;
  
  return x;

}













MEMB_LIST *initialize_memb_lister( MEMB_LIST *x, MEMB *xx, MOTIF *mf )
{

  initialize_motif( mf );
  
  xx->mf = mf;
  xx->node[ 0 ] = '\0';
  xx->offset = 0;
  xx->pval = 1.0;
  xx->class = CLASS_NONE;
  xx->used = 0;
  xx->model = NULL;
  
  x->my_memb = xx;
  x->next = NULL;
  
  return x;

}











CLUS_LIST *initialize_clus_lister( CLUS_LIST *x, CLUS *xx )
{

  xx->cons[ 0 ] = '\0';
  xx->node[ 0 ] = '\0';
  xx->label[ 0 ] = '\0';
  xx->memb_header = NULL;
  xx->pval = 1.0;
  xx->class = CLASS_NONE;
  xx->min_offset = 0;
  xx->max_offset = 0;
  xx->dupl = 0;
  xx->rc = NULL;
  xx->rc_other = NULL;
  xx->tf = NULL;
  
  x->my_clus = xx;
  x->next = NULL;
  x->down = NULL;
  
  return x;

}












MEMB_LIST *initialize_empty_memb_lister( MEMB_LIST *x )
{

  x->my_memb = NULL;
  x->next = NULL;
  
  return x;

}













DINUCL_LIST *initialize_dinucl_lister( DINUCL_LIST *x, DINUCL *xx )
{

  xx->spec[ 0 ] = '\0';
  xx->c = '\0';
  
  int i, j;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
    for ( j = 0; j < NUMB_OF_NUCL; j++ )
      xx->dinucl[ i ][ j ] = 0;
  }
  
  x->my_d = xx;
  x->next = NULL;
  
  return x;

}













SUM_LIST *initialize_sum_lister( SUM_LIST *x, SUM *xx )
{

  xx->spec[ 0 ] = '\0';
  xx->numb_of_seqs = 0;
  xx->clus_n = 0;
  xx->memb_n = 0;
  xx->memb_gc_n = 0;
  xx->memb_gc_only = 0;
  xx->memb_at_n = 0;
  xx->memb_mf_n = 0;
  
  int i;
  
  for ( i = 0; i < SHORT_BUFFER; i++ )
    xx->clus_array[ i ] = 0;
  
  x->my_sum = xx;
  x->next = NULL;
  
  return x;

}











GO_TERM_LIST *initialize_go_term_lister( GO_TERM_LIST *x, GO_TERM *xx )
{

  xx->id[ 0 ] = '\0';
  xx->term[ 0 ] = '\0';
  
  x->my_go = xx;
  x->next = NULL;
  x->down = NULL;
  
  return x;

}











GO_GENE_LIST *initialize_go_gene_lister( GO_GENE_LIST *x, GO_GENE *xx )
{

  xx->numb = 0;
  xx->acc[ 0 ] = '\0';
  xx->uniprot_header = NULL;
  xx->go_header = NULL;
  
  x->my_gene = xx;
  x->next = NULL;
  
  return x;

}












GO_LIST *initialize_go_lister( GO_LIST *x, GO *xx )
{

  xx->clus = NULL;
  xx->pval = 1.0;
  xx->stats_header = NULL;
  
  x->my_go = xx;
  x->next = NULL;
  x->prev = NULL;
  x->clus_next = NULL;
  x->clus_prev = NULL;
  
  return x;

}












GO_STATS_LIST *initialize_go_stats_lister( GO_STATS_LIST *x, GO_STATS *xx )
{

  xx->memb = NULL;
  xx->go_term = NULL;
  xx->pval = 1.0;
  xx->a = 0;
  xx->exp = 0.0;
  xx->aa = 0;
  xx->b = 0;
  xx->n = 0;
  
  x->my_stats = xx;
  x->next = NULL;
  
  return x;

}














CHIP_GENE_LIST *initialize_chip_gene_lister( CHIP_GENE_LIST *x, CHIP_GENE *xx )
{

  xx->numb = 0;
  xx->acc[ 0 ] = '\0';
  xx->chr[ 0 ] = '\0';
  xx->start = 0;
  xx->end = 0;
  xx->strand = '\0';
  xx->chip_header = NULL;
  
  x->my_gene = xx;
  x->next = NULL;
  x->prev = NULL;
  x->chr_next = NULL;
  x->chr_prev = NULL;
  x->coord_next = NULL;
  x->coord_prev = NULL;
  
  return x;

}












CHIP_PK_LIST *initialize_chip_pk_lister( CHIP_PK_LIST *x, CHIP_PK *xx )
{

  xx->tf[ 0 ] = '\0';
  xx->chr[ 0 ] = '\0';
  xx->start = 0;
  xx->end = 0;
  xx->score = 0;
  
  x->my_chip = xx;
  x->next = NULL;
  
  return x;

}











CHIP_LIST *initialize_chip_lister( CHIP_LIST *x, CHIP *xx )
{

  xx->clus = NULL;
  xx->node[ 0 ] = '\0';
  xx->pval = 1.0;
  xx->chip_header = NULL;
  
  x->my_chip = xx;
  x->next = NULL;
  
  return x;

}










CHIP_STATS_LIST *initialize_chip_stats_lister( CHIP_STATS_LIST *x, 
  CHIP_STATS *a, CHIP_STATS *b )
{

  initialize_chip_stats( a );
  initialize_chip_stats( b );
  
  x->my_stats = a;
  x->p_stats = b;
  x->next = NULL;
  
  return x;

}










void initialize_chip_stats( CHIP_STATS *x )
{

  x->memb = NULL;
  x->tf[ 0 ] = '\0';
  x->pval = 1.0;
  x->a = 0;
  x->aa = 0;
  x->b = 0;
  x->n = 0;
  x->exp = 0.0;
  x->node[ 0 ] = '\0';

}














MOTIF_LIST *initialize_motif_lister( MOTIF_LIST *x, MOTIF *mf, MOTIF_STATS *stats )
{

  initialize_motif( mf );
  initialize_motif_stats( stats );
  
  x->my_mf = mf;
  x->my_stats = stats;
  x->next = NULL;
  
  return x;

}














void initialize_motif_stats( MOTIF_STATS *stats )
{

  stats->zval = 0.0;
  stats->spec[ 0 ] = '\0';
  
  int i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ )
    initialize_rep( stats->rep_array + i );

}













void initialize_rep( REP *x )
{

  x->occur = 0;
  x->exp = 0.0;
  x->z = 0.0;
  x->spec[ 0 ] = '\0';
  x->use = 0;

}











USE_CELL *initialize_use_cell( USE_CELL *x, USE *xx, INDEX n )
{

  x->x = xx;
  x->n = n;
  
  USE *ptr = xx;
  
  int i;
  
  for ( i = 0; i < n; i++ )
    (ptr++)->use = 0;
    
  return x;

}












CROSS_LIST *initialize_cross_lister( CROSS_LIST *x, CROSS *xx )
{

  x->my_cross = xx;
  x->next = NULL;
  x->prev = NULL;
  
  xx->alt = NULL;
  xx->score = 0;
  
  int i;
  
  for ( i = 0; i < CROSS_BUFFER; i++ ) {
    initialize_cross_info( xx->info + i );
    xx->exists[ i ] = 0;
    xx->near_gene[ i ] = 0;
  }
    
  return x;

}













void initialize_cross_info( CROSS_INFO *info )
{

  info->chr[ 0 ] = '\0';
  info->gene[ 0 ] = '\0';
  info->name[ 0 ] = '\0';
  info->spec[ 0 ] = '\0';
  info->center = 0;
  info->strand = '+';

}














EVOL_LIST *initialize_evol_lister( EVOL_LIST *x, EVOL *xx, EVOL_STATS *s,
  MOTIF *mf )
{

  initialize_evol_stats( s );
  
  xx->mf = mf;
  xx->s = s;
  
  x->my_evol = xx;
  x->next = NULL;
  
  return x;

}










void initialize_evol_stats( EVOL_STATS *s )
{

  s->n = 0;
  s->numb_of_seqs = 0;
  s->length = 0;
  s->total_t = 0.0;
  
  int i;
  
  for ( i = 0; i < BUFFER; i++ ) {
    s->sub[ i ] = 0;
    s->indel[ i ] = 0;
  }

}














FT_ARRAY *initialize_ft_array( FT_ARRAY *x, FPOS *fpos_array, int n )
{

  x->fpos_array = fpos_array;
  x->n = n;
  x->total = 0;
  
  int i;
  
  for ( i = 0; i < NUMB_OF_WORDS; i++ ) {
    x->ft_array[ i ] = NULL;
    x->ft_end[ i ] = NULL;
  }
  
  x->empty_header = NULL;
  x->empty_last = NULL;
  
  return x;

}












FT_LIST *initialize_ft_lister( FT_LIST *x, FT *xx )
{

  x->ft = xx;
  x->next = NULL;
  
  xx->seq = 0;
  
  int i;
  
  for ( i = 0; i < WORD_LENGTH; i++ ) 
    xx->pos[ i ] = 0;
  
  return x;

}













DATA_LIST *initialize_data_lister( DATA_LIST *x, DATA *a, DATA *b )
{

  x->data = a;
  x->rc_data = b;
  x->next = NULL;
  
  return x;

}











ORIGIN_LIST *initialize_origin_lister( ORIGIN_LIST *x, ORIGIN *xx, MOTIF *mf )
{

  initialize_motif( mf );
  
  xx->mf = mf;
  xx->res = NULL;
  
  int i;
  
  for ( i = 0; i < STRAND_BUFFER; i++ )
    xx->site_header[ i ] = NULL;
  
  xx->total_seqs = 0;
  xx->n = 0;
  xx->frac = 0.0;
  
  xx->spec[ 0 ] = '\0';
  
  x->my_origin = xx;
  x->next = NULL;
  x->prev = NULL;
  
  return x;

}











SITE_LIST *initialize_site_lister( SITE_LIST *x, SITE_INFO *xx, SEQ_INFO *info,
  SITE_STATS *stats )
{

  initialize_seq_info( info );
  
  xx->loc = info;
  xx->seq[ 0 ] = '\0';
  xx->gene[ 0 ] = '\0';
  xx->seq_numb = 0;
  
  stats->occur_in_seq = 0;
  stats->node[ 0 ] = '\0';
  stats->pr = 0.0;
  
  x->site = xx;
  x->stats = stats;
  x->next = NULL;
  x->prev = NULL;
  
  return x;

}












void initialize_seq_info( SEQ_INFO *info )
{

  info->fpos = 0;
  info->n = 0;
  info->x = 0;
  info->gene[ 0 ] = '\0';
  info->chr[ 0 ] = '\0';
  info->start = 0;
  info->end;
  info->strand = '+';
  info->score = 0;

}












REL_ORIGIN_LIST *initialize_rel_origin_lister( REL_ORIGIN_LIST *x, REL_ORIGIN *xx, 
  ORIGIN_HIST *a, ORIGIN_HIST *b, REL_HIST *hist, OREL_STATS *rel, MOTIF *a_mf, 
  MOTIF *b_mf )
{

  /*  All is set in create_rel_origin_lister() above  */

  return x;

}











/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














void kill( void *x )
{

  if ( x == NULL )
    return;
    
  free( x );

}







void kill_str_list( STR_LIST *header )
{

  if ( header == NULL )
    return;
    
  STR_LIST *curr = header;
  
  while ( curr != NULL ) {
  
    STR_LIST *next = curr->next;
    
    kill_str_lister( curr );
    
    curr = next;
  
  }

}














void kill_str_lister( STR_LIST *x )
{
  
  if ( x == NULL )
    return;
    
  free( x );
  
}













void kill_maf_list( MAF_LIST *header )
{

  if ( header == NULL )
    return;
    
  MAF_LIST *x = header;
  
  while ( x != NULL ) {
  
    MAF_LIST *next = x->next;
    
    MAF_LIST *y = x;
    
    while ( y != NULL ) {
    
      MAF_LIST *y_next = y->same;
  
      kill_maf_lister( y );
      
      y = y_next;
      
    }
    
    x = next;
  
  }

}













void kill_maf_lister( MAF_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_maf->entry );
  free( x->my_maf->curr );
  free( x->my_maf );
  free( x );

}













void kill_region_list( REGION_LIST *header )
{

  if ( header == NULL )
    return;
    
  REGION_LIST *x = header;
  
  while ( x != NULL ) {
  
    REGION_LIST *next = x->next;
    
    kill_region_lister( x );
    
    x = next;
  
  }

}













void kill_region_lister( REGION_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_fh( x->my_fh );  
    
  free( x->my_region );
  free( x );

}












void kill_fh( FH *fh )
{

  if ( fh == NULL )
    return;
    
  if ( fh->spec_cell != NULL )
    kill_spec_cell( fh->spec_cell );
    
  free( fh );

}









void kill_spec_cell( SPEC_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}











void kill_count_cell( COUNT_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}














void kill_seq_list( SEQ_LIST *seq_header )
{

  if ( seq_header == NULL )
    return;
    
  SEQ_LIST *seq = seq_header;
  
  while ( seq != NULL ) {
  
    SEQ_LIST *next = seq->next;
    
    kill_seq_lister( seq );
    
    seq = next;
  
  }

}













void kill_seq_lister( SEQ_LIST *seq )
{

  if ( seq == NULL )
    return;
    
  kill_pos_list( seq->pos_header );
  kill_pos_list( seq->nn_header );
  
  free( seq->my_seq );
  free( seq );

}












void kill_pos_list( POS_LIST *pos_header )
{

  if ( pos_header == NULL )
    return;
    
  POS_LIST *pos = pos_header;
  
  while ( pos != NULL ) {
  
    POS_LIST *next = pos->next;
    
    free( pos );
    
    pos = next;
  
  }

}















void kill_occur_cell( OCCUR_CELL *x )
{

  if ( x == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < BUFFER; i++ ) {
  
    if ( x->x[ i ] != NULL )
      kill_seq_list( x->x[ i ] );
      
    x->x[ i ] = NULL;
  
  }
    
  free( x );

}
















void kill_node_lister( NODE_LIST *node )
{

  if ( node == NULL )
    return;
    
  free( node->my_node );
  free( node->my_info );  
  free( node->my_dd );
  free( node->prior );
  free( node->my_trans );
  free( node->param );
  
  int i;
  
  for ( i = 0; i < DBUFF; i++ )
    free( node->my_d[ i ] );
    
  free( node );

}















void kill_model_list( MODEL_LIST *model_header )
{

  if ( model_header == NULL )
    return;
    
  MODEL_LIST *model = model_header;
  
  while ( model != NULL ) {
  
    MODEL_LIST *next = model->next;
    
    kill_model_lister( model );
    
    model = next;
  
  }

}














void kill_model_lister( MODEL_LIST *x )
{

  if ( x == NULL )
    return;
    
  MODEL *model = x->my_model;
    
  kill_part_list( model->part_header );
  
  free( model->mf );
  free( model->stats );
  free( model->null_stats );
  free( model->my_region );
  free( model );
  free( x );

}













void kill_part_list( PART_LIST *header )
{

  if ( header == NULL )
    return;
    
  PART_LIST *part = header;
  
  while ( part != NULL ) {
  
    PART_LIST *next = part->next;
    
    kill_part_lister( part );
    
    part = next;
  
  }

}














void kill_part_lister( PART_LIST *part )
{

  if ( part == NULL )
    return;
  
  kill_list( part->my_part->branch_header );
    
  free( part->my_part->pp );
  free( part->my_part );
  free( part );

}














void kill_list( LIST *header )
{

  if ( header == NULL )
    return;
    
  LIST *x = header;
  
  while ( x != NULL ) {
  
    LIST *next = x->next;
    
    kill_lister( x );
    
    x = next;
  
  }

}














void kill_lister( LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x );

}












void kill_pt_cell( PT_CELL *x )
{

  if ( x == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < x->n; i++ ) {
    free( x->pp[ i ] );  
    kill_list( x->branch[ i ] );
  }
    
  free( x );

}











void kill_vec( VEC *x )
{

  if ( x == NULL )
    return;
    
  free( x );

}













void kill_mx( MX *mx )
{

  if ( mx == NULL )
    return;
    
  free( mx );

}












void kill_node_info_cell( NODE_INFO_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}









void kill_tree_data( TREE_DATA *x )
{

  if ( x == NULL )
    return;
    
  free( x );

}













void kill_leaf_data_list( LEAF_DATA_LIST *header )
{

  if ( header == NULL )
    return;
    
  LEAF_DATA_LIST *x = header;
  
  while ( x != NULL ) {
  
    LEAF_DATA_LIST *next = x->next;
    
    kill_leaf_data_lister( x );
    
    x = next;
  
  }

}















void kill_leaf_data_lister( LEAF_DATA_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->data );
  free( x );

}













void kill_tree( TREE *x )
{

  void kill_tree_from_root( NODE_LIST *root );

  if ( x == NULL )
    return;
  
  /*  In ../tree/create_tree.c:  */  
  kill_tree_from_root( x->root );
  
  /*  In this file, below:  */
  kill_branch_list( x->branch_header );
  
  /*  In this file, below:  */
  kill( x );

}














void kill_data( DATA *x )
{

  if ( x == NULL )
    return;
    
  kill_tree( x->tree );
  kill_occur_cell( x->occur );
  kill_pdata_list( x->pdata );
  kill_use_cell( x->use_cell );

  kill( x->mf );
  kill( x->reg );
  kill( x );

}














void kill_pdata_list( PDATA_LIST *header )
{

  PDATA_LIST *x = header;
  
  while ( x != NULL ) {
  
    PDATA_LIST *next = x->next;
    
    kill_pdata_lister( x );
    
    x = next;
  
  }

}















void kill_pdata_lister( PDATA_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_pdata );
  free( x );

}











void kill_em_info( EM_INFO *x )
{

  if ( x == NULL )
    return;
    
  kill_pt_cell( x->x );
  kill_pt_cell( x->old_x );
  
  kill( x );

}













void kill_tab_cell( TAB_CELL *tab_cell )
{

  if ( tab_cell == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < tab_cell->n; i++ )
    free( tab_cell->tab[ i ] );
    
  free( tab_cell );

}














void kill_branch_list( BRANCH_LIST *header )
{

  BRANCH_LIST *x = header;
  
  while ( x != NULL ) {
  
    BRANCH_LIST *next = x->next;
    
    kill_branch_lister( x );
    
    x = next;
  
  }

}












void kill_branch_lister( BRANCH_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_branch );
  free( x );

}











void kill_result_list( RESULT_LIST *header )
{

  RESULT_LIST *x = header;
  
  while ( x != NULL ) {
  
    RESULT_LIST *next = x->next;
    
    RESULT_LIST *y = x;
    
    while ( y != NULL ) {
    
      RESULT_LIST *y_next = y->down;
    
      kill_result_lister( y );
      
      y = y_next;
      
    }
    
    x = next;
  
  }

}











void kill_result_lister( RESULT_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_model_list( x->my_result->model_header );
  kill_model_lister( x->my_result->null_model );
  
  kill( x->my_result->mf );
  kill( x->my_result );
  kill( x );

}















void kill_gene_list( GENE_LIST *header )
{

  GENE_LIST *x = header;
  
  while ( x != NULL ) {
  
    GENE_LIST *next = x->next;
    
    kill_gene_lister( x );
    
    x = next;
  
  }

}













void kill_gene_lister( GENE_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_gene->gen_coord );
  free( x->my_gene->stats );
  free( x->my_gene );
  free( x );

}














void kill_rel_list( REL_LIST *header )
{

  REL_LIST *x = header;
  
  while ( x != NULL ) {
  
    REL_LIST *next = x->next;
    
    kill_rel_lister( x );
    
    x = next;
  
  }

}
















void kill_rel_lister( REL_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_rel_stats_list( x->my_rel->s_header );
    
  free( x->my_rel->a_mf );
  free( x->my_rel->b_mf );
  free( x->my_rel );
  free( x );

}














void kill_rel_stats_list( REL_STATS_LIST *header )
{

  REL_STATS_LIST *x = header;
  
  while ( x != NULL ) {
  
    REL_STATS_LIST *next = x->next;
    
    kill_rel_stats_lister( x );
    
    x = next;
  
  }

}














void kill_rel_stats_lister( REL_STATS_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->s );
  free( x );

}











void kill_memb_list( MEMB_LIST *header )
{

  MEMB_LIST *x = header;
  
  while ( x != NULL ) {
  
    MEMB_LIST *next = x->next;
    
    kill_memb_lister( x );
    
    x = next;
  
  }

}












void kill_memb_lister( MEMB_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_model_lister( x->my_memb->model );  
  free( x->my_memb->mf );
  free( x->my_memb );
  free( x );

}











void kill_clus_list( CLUS_LIST *header )
{

  CLUS_LIST *x = header;
  
  while ( x != NULL ) {
  
    CLUS_LIST *next = x->next;
    
    kill_clus_lister( x );
    
    x = next;
  
  }

}











void kill_clus_lister( CLUS_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_memb_list( x->my_clus->memb_header );
  
  free( x->my_clus );
  free( x );

}












void kill_empty_memb_list( MEMB_LIST *header )
{

  MEMB_LIST *x = header;
  
  while ( x != NULL ) {
  
    MEMB_LIST *next = x->next;
    
    kill( x );
    
    x = next;
  
  }

}













void kill_dinucl_list( DINUCL_LIST *header )
{

  DINUCL_LIST *x = header;
  
  while ( x != NULL ) {
  
    DINUCL_LIST *next = x->next;
    
    kill_dinucl_lister( x );
    
    x = next;
  
  }

}














void kill_dinucl_lister( DINUCL_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_d );
  free( x );

}












void kill_go_term_list( GO_TERM_LIST *header )
{

  GO_TERM_LIST *x = header;
  
  while ( x != NULL ) {
  
    GO_TERM_LIST *next = x->next;
    
    kill_go_term_lister( x );
    
    x = next;
  
  }

}












void kill_go_term_lister( GO_TERM_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_go );
  free( x );

}











void kill_go_gene_list( GO_GENE_LIST *header )
{

  GO_GENE_LIST *x = header;
  
  while ( x != NULL ) {
  
    GO_GENE_LIST *next = x->next;
    
    kill_go_gene_lister( x );
    
    x = next;
  
  }

}












void kill_go_gene_lister( GO_GENE_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_str_list( x->my_gene->uniprot_header );
  kill_go_term_list( x->my_gene->go_header );
  
  free( x->my_gene );
  free( x );

}












void kill_fpos_list( FPOS_LIST *header )
{

  FPOS_LIST *x = header;
  
  while ( x != NULL ) {
  
    FPOS_LIST *next = x->next;
    
    kill( x );
    
    x = next;
  
  }

}













void kill_go_list( GO_LIST *header )
{

  GO_LIST *x = header;
  
  while ( x != NULL ) {
  
    GO_LIST *next = x->next;
    
    kill_go_lister( x );
    
    x = next;
  
  }

}











void kill_go_lister( GO_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_go_stats_list( x->my_go->stats_header );
    
  free( x->my_go );
  free( x );

}











void kill_go_stats_list( GO_STATS_LIST *header )
{

  GO_STATS_LIST *x = header;
  
  while ( x != NULL ) {
  
    GO_STATS_LIST *next = x->next;
    
    kill_go_stats_lister( x );
    
    x = next;
  
  }

}










void kill_go_stats_lister( GO_STATS_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_stats );
  free( x );

}











void kill_chip_gene_list( CHIP_GENE_LIST *header )
{

  CHIP_GENE_LIST *x = header;
  
  while ( x != NULL ) {
  
    CHIP_GENE_LIST *next = x->next;
    
    kill_chip_gene_lister( x );
    
    x = next;
  
  }

}












void kill_chip_gene_lister( CHIP_GENE_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_chip_pk_list( x->my_gene->chip_header );
    
  free( x->my_gene );
  free( x );

}











void kill_chip_pk_list( CHIP_PK_LIST *header )
{

  CHIP_PK_LIST *x = header;
  
  while ( x != NULL ) {
  
    CHIP_PK_LIST *next = x->next;
    
    kill_chip_pk_lister( x );
    
    x = next;
  
  }

}













void kill_chip_pk_lister( CHIP_PK_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_chip );
  free( x );

}












void kill_chip_list( CHIP_LIST *header )
{

  CHIP_LIST *x = header;
  
  while ( x != NULL ) {
  
    CHIP_LIST *next = x->next;
    
    kill_chip_lister( x );
    
    x = next;
  
  }

}











void kill_chip_lister( CHIP_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_chip_stats_list( x->my_chip->chip_header );
  
  free( x->my_chip );
  free( x );

}












void kill_chip_stats_list( CHIP_STATS_LIST *header )
{

  CHIP_STATS_LIST *x = header;
  
  while ( x != NULL ) {
  
    CHIP_STATS_LIST *next = x->next;
    
    kill_chip_stats_lister( x );
    
    x = next;
  
  }

}













void kill_chip_stats_lister( CHIP_STATS_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_stats );
  free( x->p_stats );
  free( x );

}













void kill_motif_list( MOTIF_LIST *header )
{

  MOTIF_LIST *x = header;
  
  while ( x != NULL ) {
  
    MOTIF_LIST *next = x->next;
    
    kill_motif_lister( x );
    
    x = next;
  
  }

}












void kill_motif_lister( MOTIF_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_mf );
  free( x->my_stats );
  free( x );

}












void kill_use_cell( USE_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}












void kill_cross_list( CROSS_LIST *header )
{

  CROSS_LIST *x = header;
  
  while ( x != NULL ) {
  
    CROSS_LIST *next = x->next;
    
    kill_cross_lister( x );
    
    x = next;
  
  }

}












void kill_cross_lister( CROSS_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_cross );
  free( x );

}












void kill_evol_list( EVOL_LIST *header )
{

  EVOL_LIST *x = header;
  
  while ( x != NULL ) {
  
    EVOL_LIST *next = x->next;
    
    kill_evol_lister( x );
    
    x = next;
  
  }

}











void kill_evol_lister( EVOL_LIST *x )
{

  if ( x == NULL ) 
    return;
     
  free( x->my_evol->mf );
  free( x->my_evol->s );
  free( x->my_evol );
  free( x );    

}












void kill_ft_array( FT_ARRAY *x )
{

  if ( x == NULL )
    return;
    
  free( x->fpos_array );
  
  kill_ft_list_array( x->ft_array, x->n );
  kill_ft_list( x->empty_header );
  
  free( x );

}














void kill_ft_list_array( FT_LIST *ft_array[], int n )
{

  int i;
  
  for ( i = 0; i < n; i++ )
    kill_ft_list( ft_array[ i ] );

}












void kill_ft_list( FT_LIST *header )
{

  FT_LIST *x = header;
  
  while ( x != NULL ) {
  
    FT_LIST *next = x->next;
    
    kill_ft_lister( x );
    
    x = next;
  
  }

}












void kill_ft_lister( FT_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->ft );
  free( x );

}












void kill_data_list( DATA_LIST *header )
{

  DATA_LIST *x = header;
  
  while ( x != NULL ) {
  
    DATA_LIST *next = x->next;
    
    kill_data_lister( x );
    
    x = next;
  
  }

}












void kill_data_lister( DATA_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_data( x->data );
  kill_data( x->rc_data );
  free( x );

}











void kill_origin_list( ORIGIN_LIST *header )
{

  ORIGIN_LIST *x = header;
  
  while ( x != NULL ) {
  
    ORIGIN_LIST *next = x->next;
    
    kill_origin_lister( x );
    
    x = next;
  
  }

}











void kill_origin_lister( ORIGIN_LIST *x )
{

  if ( x == NULL )
    return;
    
  kill_result_list( x->my_origin->res );
  
  int i;
  
  for ( i = 0; i < STRAND_BUFFER; i++ )
    kill_site_list( x->my_origin->site_header[ i ] );  
    
  free( x->my_origin->mf );
  free( x->my_origin );
  free( x );

}












void kill_site_list( SITE_LIST *header )
{

  SITE_LIST *x = header;
  
  while ( x != NULL ) {
  
    SITE_LIST *next = x->next;
    
    kill_site_lister( x );
    
    x = next;
  
  }

}












void kill_site_lister( SITE_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->stats );
  free( x->site->loc );
  free( x->site );
  free( x );

}












void kill_rel_origin_list( REL_ORIGIN_LIST *header )
{

  REL_ORIGIN_LIST *x = header;
  
  while ( x != NULL ) {
  
    REL_ORIGIN_LIST *next = x->next;
    
    kill_rel_origin_lister( x );
    
    x = next;
  
  }

}













void kill_rel_origin_lister( REL_ORIGIN_LIST *x )
{

  if ( x == NULL )
    return;
    
  int i, j;
  
  for ( i = 0; i < STRAND_BUFFER; i++ ) {  
  
    free( x->my_rel->major_hist[ i ] );
    free( x->my_rel->minor_hist[ i ] );
  
    for ( j = 0; j < STRAND_BUFFER; j++ ) {
      free( x->my_rel->rel_hist[ i ][ j ] );
      free( x->my_rel->rel_stats[ i ][ j ] );
    }
  
  }
  
  free( x->my_rel->best_hist );
  free( x->my_rel->rev_hist );
  free( x->my_rel->all_hist );
  free( x->my_rel->best_stats );
  free( x->my_rel->rev_stats );
  
  free( x->my_rel->major_mf );
  free( x->my_rel->minor_mf );
  
  free( x->my_rel );
  free( x );

}







/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void check_null( int numb, ... )
{

  int i;
  
  va_list arg_ptr;
  
  va_start( arg_ptr, numb );
  
  for ( i = 0; i < numb; i++ ) 
    check_single_null( (void *)va_arg( arg_ptr, void * ) );
    
  va_end( arg_ptr );

}












void check_single_null( void *x )
{
  if ( x == NULL )
    error( 400, "Memory allocation exceeds buffer.\n" );
}















