#include "main.h"
























int main( int argc, char *argv[] )
{

  printf( "\n" );
  printf( "Starting Branch of Origin finder...\n" );
  
  /*  In this file, below:  */
  my_main( argc, argv );
  
  printf( "\n" );
  printf( "Program successful.\n" );
  printf( "\n" );
  
  return 0;

}



















void my_main( int argc, char *argv[] )
{

  /*  In param.c:  */
  set_parameters( argc, argv );
  
  /*  In this file, below:  */
  do_phylo();

}
















void do_phylo( void )
{

  extern char mode;
  
  switch ( mode ) {
  
  case 'f' :
  case 'F' :
    /*  In ../format/format.c:  */
    do_formatting();
    break;
    
  case 'm' :
    /*  In ../format/format.c:  */    
    do_format_motif_file();
    break;
    
  case '\0' :
    /*  In ../origin/origin.c:  */
    do_origin();
    break;
    
  case 'z' :
    /*  In ../analysis/analysis.c:  */
    do_analysis();
    break;
    
  default :
    error( 1, "Unrecognized mode (parameter -m).\n" );
    break;
  
  }

}























/*================================================================================*/
/*================================================================================*/
/*================================================================================*/
/*================================================================================*/
/*================================================================================*/
















void error( int numb, char err[] )
{

  printf( "Error numb :  %d\n", numb );
  printf( "%s\n", err );
  
  exit(numb);

}












void check_nan( STAT x, char func[], char file[] )
{
  if (( isnan( x )) || ( isinf( x )))
    error_nan( x, func, file );
}












void error_nan( STAT x, char func[], char file[] )
{

  char err[ LINE_BUFFER ], code[ BUFFER ];
  
  printf( "\n\n" );
  
  if ( isnan( x ))
    strcpy( code, "Floating point decimal:  NaN.  " );
  if ( isinf( x ))
    strcpy( code, "Float point decimal:  Inf.  " );
    
  sprintf( err, "Function :  '%s()'\nFile :      '%s'\n\n%s\n", func, file, code );
  
  error( 99, err );

}










void check_phylo_spec( void )
{

  extern char phylo_spec[ BUFFER ];
  
  if ( phylo_spec[ 0 ] == '\0' )
    error( 10, "Unset phylo species.  Use '-z' parameter command.\n" );
  
//  check_major_reg();
    
}











void check_major_reg( void )
{

  extern char major_reg;
  
  if ( major_reg == '\0' )
    error( 20, "Region not selected.  Use '-r' parameter command.\n" );

}










void check_major_spec( void )
{

  extern char major_spec[ BUFFER ];
  
  if ( major_spec[ 0 ] == '\0' )
    error( 11, "Unset major species.  Use '-x' parameter command.\n" );

}









void check_minor_spec( void )
{

  extern char minor_spec[ BUFFER ];
  
  if ( minor_spec[ 0 ] == '\0' )
    error( 11, "Unset minor species.  Use '-X' parameter command.\n" );

}













void check_major_motif( void )
{

  extern MOTIF major_motif;
  extern char motif_file[ BUFFER ];
  
  if (( major_motif.length == 0 ) && ( motif_file[ 0 ] == '\0' ))
    error( 12, "Unset major motif.  Use '-a' or '-q' parameter commands.\n" );

}











void check_minor_motif( void )
{

  extern MOTIF minor_motif;
  
  if ( minor_motif.length == 0 )
    error( 12, "Unset major motif.  Use '-a' parameter command.\n" );

}












void check_major_tf( void )
{

  extern char major_tf[ BUFFER ];
  
  if ( major_tf[ 0 ] == '\0' )
    error( 21, "Major trans-factor not set.  Use -q command.\n" );

}










void check_minor_tf( void )
{

  extern char minor_tf[ BUFFER ];
  
  if ( minor_tf[ 0 ] == '\0' )
    error( 22, "Minor trans-factor not set.  Use -Q command.\n" );

}











void check_min_rank( void )
{

  extern int min_rank;
  
  if ( min_rank < 0 )
    error( 23, "Minimum rank must be set.  Use -n command.\n" );

}











void check_max_rank( void )
{

  extern int max_rank;
  
  if ( max_rank < 0 )
    error( 24, "Maximum rank must be set.  Use -N command.\n" );

}








/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/










#define CHIP_PEAK_DIR "data/chip/peaks"
#define CHIP_PEAK_FNAME "chip_seq"












void set_chip_type( char tf[] )
{

  extern char chip_type[ BUFFER ];
  
  if ( chip_type[ 0 ] != '\0' ) {
    printf( "Chip type manually set to :  '%s'\n\n", chip_type );
    return;
  }
    
  get_chip_type_w_factor( chip_type, tf );
  
  printf( "Chip type set :  '%s'\n\n", chip_type );

}








void get_chip_type_w_factor( char chip_type[], char tf[] )
{

  extern char phylo_spec[ BUFFER ];
  
  get_chip_type_w_factor_and_phylo_spec( chip_type, tf, phylo_spec );
  
}










void get_chip_type_w_factor_and_phylo_spec( char chip_type[], char tf[],
  char phylo_spec[] )
{

  char *chip_array[ CHIP_TYPE_BUFF ] = CHIP_TYPE;

  int i;
  
  /*  Set in ../ext/struct.h:  */
  for ( i = 0; i < CHIP_TYPE_BUFF; i++ ) {
  
    char fname[ BUFFER ];
    
    sprintf( fname, "%s/%s_%s.%s.%s.txt", CHIP_PEAK_DIR, CHIP_PEAK_FNAME,
      chip_array[ i ], phylo_spec, tf );
  
    FILE *fh = NULL;
    fh = (FILE *)fopen( fname, "r" );
    
    if ( fh != NULL ) {
      strcpy( chip_type, chip_array[ i ] );
      close_file( fh );
      return;
    }
  
  }
  
  char err[ BUFFER ];
  
  strcpy( err, "Could not find matching tf for listed experiments.\n" );
  strcat( err, "May need to update struct.h :  'CHIP_TYPE' array.\n" );
  
  error( 30, err );

}












