#include "reg_defn.h"




















#define HG_REG_MODES "XY"
#define HG_REG_BUFFER 2


/*
#define HG_REG_MODES "Y"
#define HG_REG_BUFFER 1
*/

#define A_START -120
#define A_END -20

#define B_START 65
#define B_END 215

#define C_START -240
#define C_END -80

#define D_START -90
#define D_END 10

#define E_START 10
#define E_END 170

#define R_START -50
#define R_END 50





#define Z_START -200
#define Z_END 200

#define Y_START -100
#define Y_END 100

#define X_START -350
#define X_END 350










REGION_LIST *get_region_list_spec( REGION_LIST *reg_header, char phylo_spec[] )
{

  if ( ! strcmp( phylo_spec, "hg19" ))
    return get_region_list_array( reg_header, HG_REG_MODES, HG_REG_BUFFER );
    
  if ( ! strcmp( phylo_spec, "mm9" ))
    return get_region_list_array( reg_header, HG_REG_MODES, HG_REG_BUFFER );
    
  error( 500, "Unrecognized phylo species name for region list.\n" );  
    
  return reg_header;

}













REGION_LIST *get_region_list_array( REGION_LIST *reg_header, char mode_array[],
  int buffer )
{

  int i = 0;
  
  while ( i < buffer )
    reg_header = (REGION_LIST *)get_and_put_new_reg_lister( reg_header, 
      mode_array[ i++ ] );
      
  return reg_header;

}













REGION_LIST *get_and_put_new_reg_lister( REGION_LIST *reg_header, char mode )
{

  REGION_LIST *create_region_lister( REGION_LIST *x );
  
  REGION_LIST *reg = NULL;
  reg = (REGION_LIST *)create_region_lister( reg );
  
  set_reg_lister_from_mode( reg, mode );
  
  return put_reg_lister_end_of_list( reg_header, reg );

}












REGION_LIST *put_reg_lister_end_of_list( REGION_LIST *reg_header, 
  REGION_LIST *reg )
{

  if ( reg_header == NULL )
    return reg;
    
  REGION_LIST *curr = reg_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = reg;
  
  return reg_header;

}















void set_reg_lister_from_mode( REGION_LIST *reg, char mode )
{

  switch ( mode ) {
  
  case 'X' :
    set_reg_lister( reg, 'X', X_START, X_END );
    break;
  
  case 'Y' :
    set_reg_lister( reg, 'Y', Y_START, Y_END );
    break;
  
  case 'Z' :
    set_reg_lister( reg, 'Z', Z_START, Z_END );
    break;
  
  case 'A' :
    set_reg_lister( reg, 'A', A_START, A_END );
    break;
    
  case 'B' :
    set_reg_lister( reg, 'B', B_START, B_END );
    break;
    
  case 'C' :
    set_reg_lister( reg, 'C', C_START, C_END );
    break;
    
  case 'D' :
    set_reg_lister( reg, 'D', D_START, D_END );
    break;
    
  case 'E' :
    set_reg_lister( reg, 'E', E_START, E_END );
    break;
    
  case 'R' :
    set_reg_lister( reg, 'R', R_START, R_END );
    break;
    
  case '1' :
    set_reg_lister( reg, '1', A_START, A_END );
    break;
    
  case '2' :
    set_reg_lister( reg, '2', A_START, A_END );
    break;
    
  case '3' :
    set_reg_lister( reg, '3', A_START, A_END );
    break;
    
  default :
    error( 501, "Unknown region passed to function.\n" );
    break;
  
  }

}











REGION get_region_from_mode( char mode )
{

  REGION reg = { .reg = mode };

  switch ( mode ) {
  
  case 'X' :
    reg.a = X_START;
    reg.b = X_END;
    return reg;
  
  case 'Y' :
    reg.a = Y_START;
    reg.b = Y_END;
    return reg;
  
  case 'Z' :
    reg.a = Z_START;
    reg.b = Z_END;
    return reg;
  
  case 'A' :
    reg.a = A_START;
    reg.b = A_END;
    return reg;
    
  case 'B' :
    reg.a = B_START;
    reg.b = B_END;
    return reg;
    
  case 'C' :
    reg.a = C_START;
    reg.b = C_END;
    return reg;
    
  case 'D' :
    reg.a = D_START;
    reg.b = D_END;
    return reg;
    
  case 'E' :
    reg.a = E_START;
    reg.b = E_END;
    return reg;
    
  case 'R' :
    reg.a = R_START;
    reg.b = R_END;
    return reg;
    
  case '1' :
    reg.a = A_START;
    reg.b = A_END;
    return reg;
    
  case '2' :
    reg.a = A_START;
    reg.b = A_END;
    return reg;
    
  case '3' :
    reg.a = A_START;
    reg.b = A_END;
    return reg;
    
  default :
    error( 502, "Unrecognized region.\n" );
    break;
  
  }

}












void set_reg_lister( REGION_LIST *reg, char mode, COORD start, COORD end )
{
  reg->my_region->reg = mode;
  reg->my_region->a = start;
  reg->my_region->b = end;
}













COORD get_region_width( REGION *reg )
{

  if ( reg->a * reg->b < 0 )
    return reg->b - reg->a;
    
  return reg->b - reg->a + 1;

}







