#include "stream.h"
























FILE *open_text_file_reading( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  set_fname( fname, a, b );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "r" );
  
  if ( fh == NULL )
    file_error( 200, fname, "text", "reading" );

  return fh;

}















FILE *open_text_file_writing( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  set_fname( fname, a, b );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "w" );
  
  if ( fh == NULL )
    file_error( 201, fname, "text", "writing" );
    
  return fh;

}













FILE *open_text_file_append( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  set_fname( fname, a, b );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "a" );
  
  if ( fh == NULL )
    file_error( 220, fname, "text", "appending" );
    
  return fh;

}









FILE *open_binary_file_reading( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  set_fname( fname, a, b );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "rb" );
  
  if ( fh == NULL )
    file_error( 202, fname, "binary", "reading" );

  return fh;

}















FILE *open_binary_file_writing( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  set_fname( fname, a, b );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "wb+" );
  
  if ( fh == NULL )
    file_error( 203, fname, "binary", "writing" );
    
  return fh;

}













FILE *open_temp_file( void )
{

  FILE *fh = NULL;
  fh = (FILE *)tmpfile();
  
  if ( fh == NULL )
    error( 207, "Unable to open temporary file.\n" );
    
  return fh;

}










void close_file( FILE *fh )
{
  if ( fclose( fh ) != 0 )
    error( 205, "Unable to close file.\n" );
}








void set_fname( char fname[], char a[], char b[] )
{

  if ( b[ 0 ] == '\0' )
    strcpy( fname, a );
  else
    sprintf( fname, "%s.%s", a, b );

}










int set_fname_numb( char fname[], char base_fname[], int numb )
{

  sprintf( fname, "%s.%d.txt", base_fname, numb );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( fname, "r" );
  
  int exists = ( fh == NULL ) ? (0) : (1);
  
  if ( exists )
    close_file( fh );
    
  return exists;

}










void file_error( int numb, char fname[], char x[], char rw[] )
{

  char err[ BUFFER + BUFFER ];
  
  sprintf( err, "Unable to open %s file '%s' for %s", x, fname, rw );
  
  error( numb, err );

}














/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/


















void set_position( FPOS fpos, FILE *fh )
{
  if ( fseek( fh, fpos, SEEK_SET ))
    error( 210, "Unable to set filehandle position.\n" );
}













FPOS get_position( FILE *fh )
{
  return (FPOS)ftell( fh );
}













/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
















int get( void *x, size_t size, FILE *fh )
{

  if ( fread( x, size, 1, fh ) != 1 )
    return 0;
    
  return 1;

}










void put( void *x, size_t size, FILE *fh )
{
  if ( fwrite( x, size, 1, fh ) != 1 )
    error( 210, "Unable to write object to file.\n" );
}










int get_array( void *x, size_t size, int n, FILE *fh )
{

  if ( fread( x, size, n, fh ) != n )
    return 0;
    
  return 1;

}










void put_array( void *x, size_t size, int n, FILE *fh )
{
  if ( fwrite( x, size, n, fh ) != n )
    error( 211, "Unable to write array to file.\n" );
}















