#include "data.h"













#define MIN_NUCL_COUNT 20










DATA_LIST *get_origin_data( DATA_LIST *data, MOTIF *mf )
{

  DATA_LIST *create_data_lister( DATA_LIST *x );

  data = (DATA_LIST *)create_data_lister( data );
  
  /*  In this file, below:  */  
  data->data = (DATA *)get_my_origin_data( data->data, mf );
  
  return data;

}











DATA *get_my_origin_data( DATA *data, MOTIF *mf )
{

  TREE *make_and_set_tree( TREE *tree );
  
  /*  In ../tree/create_tree.c:  */
  data->tree = (TREE *)make_and_set_tree( data->tree );
  
  /*  In this file, below:  */
  data->spec_cell = (SPEC_CELL *)get_spec_cell();
  
  /*  In this file, below:  */
  set_tree_ancestor_branches( data->tree );
  
  *(data->mf) = *mf;
  
  /*  In this file, below:  */
  data->pdata = (PDATA_LIST *)get_listed_pdata_list( data );
  
  printf( "b1\n" );
  
  /*  In this file, below:  */
  set_region_from_binary_file( data->reg, data->pdata );
    
  /*  In ../model/data.c:  */
//  set_tree_params( data->tree, data );
  
  printf( "b2\n" );
  
  /*  In ../model/data.c:  */
  set_prior_probs_pdata( data->tree, data->pdata );
  
  printf( "b3\n" );
  
  /*  In ../model/data.c:  */
  set_max_occur( data->pdata );
  
  printf( "b4\n" );
  
  return data;

}









SPEC_CELL *get_spec_cell( void )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n );
  
  extern char input_file[ BUFFER ];
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "x" );
  
  INDEX n;
  
  get( &n, sizeof(INDEX), fh );
  
  SPEC_CELL *spec_cell = NULL;
  spec_cell = (SPEC_CELL *)create_spec_cell( spec_cell, n );
  
  get( spec_cell->x, sizeof(SPEC) * n, fh );
  
  return spec_cell;

}















void set_tree_ancestor_branches( TREE *tree )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );

  extern char major_spec[ BUFFER ];

  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, major_spec );
  
  int i = 0;
  
  while ( node != NULL ) {
  
    char label[ BUFFER ];
    
    ++i;
    
    if ( node->my_node->label[ 0 ] == '\0' ) {
      if ( node->up == NULL )
        strcpy( node->my_node->label, "Root" );
      else
        sprintf( node->my_node->label, "Node_%d", i );
    }
    
    node = node->up;
  
  }

}










PDATA_LIST *get_listed_pdata_list( DATA *data )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *ft_fh = NULL, *ind_fh = NULL, *seq_fh = NULL;
  ft_fh = (FILE *)open_binary_file_reading( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_reading( input_file, "i" );
  seq_fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  get_listed_pdata_list_w_fhs( data, ft_fh, ind_fh, seq_fh );
  
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( seq_fh );

  return data->pdata;

}













void get_listed_pdata_list_w_fhs( DATA *data, FILE *ft_fh, FILE *ind_fh,
  FILE *seq_fh )
{

  FT ft_array[ NUMB_OF_SPEC ];
  FT_IND ind_array[ NUMB_OF_SPEC ];
  
  initialize_first_ft_array( ft_array, NUMB_OF_SPEC );
  
  get( ind_array, sizeof(FT_IND) * data->spec_cell->n, ind_fh );
  
  get_my_listed_pdata_list_w_fhs( data, ft_array, ind_array, ft_fh, seq_fh );

}










void initialize_first_ft_array( FT ft_array[], int n )
{

  FT ft = { .seq = 0 };

  int i;
  for ( i = 0; i < MOTIF_LENGTH; i++ ) {
    ft.pos[ i ] = 0;
    ft.site[ i ] = '\0';
  }
  
  for ( i = 0; i < n; i++ )
    ft_array[ i ] = ft;

}









void get_my_listed_pdata_list_w_fhs( DATA *data, FT ft_array[], FT_IND ind_array[],
  FILE *ft_fh, FILE *seq_fh )
{

  void set_position( FPOS fpos, FILE *fh );

  int i;
  
  for ( i = 0; i < data->spec_cell->n; i++ ) 
    update_ft_array_from_binary_fh( ft_array, ind_array, i, ft_fh );

  SEQ_INFO seq_info;
  int length[ NUMB_OF_SPEC ];  
  
  PDATA_LIST *pdata_header = NULL, *last_pdata = NULL;
  
  int seq_numb = 0;
    
  while ( get_new_seq_region_fh( &seq_info, length, data->spec_cell->n, seq_fh ))   
    pdata_header = (PDATA_LIST *)get_pdata_list_single_seq( pdata_header,
      &last_pdata, data, ft_array, ind_array, &seq_info, length, ++seq_numb,
      ft_fh );
      
  data->pdata = pdata_header;

}












int get_new_seq_region_fh( SEQ_INFO *seq_info, int length[], int numb_of_spec,
  FILE *seq_fh )
{

  static int numb = 0;

  if ( ! get( seq_info, sizeof(SEQ_INFO), seq_fh ))
    return 0;
    
  get( length, sizeof(int) * numb_of_spec, seq_fh );
  
  return 1;

}










int update_ft_array_from_binary_fh( FT ft_array[], FT_IND ind_array[], int i,
  FILE *ft_fh )
{

  void set_position( FPOS fpos, FILE *fh );

  if ( ind_array[ i ].n <= 0 )
    return 0;
    
  set_position( ind_array[ i ].fpos, ft_fh );
  
  ind_array[ i ].fpos += sizeof(FT);
  
  --(ind_array[ i ].n);
  
  get( ft_array + i, sizeof(FT), ft_fh );
  
  return 1;

}












PDATA_LIST *get_pdata_list_single_seq( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  SEQ_INFO *seq_info, int length[], SEQ seq_numb, FILE *ft_fh )
{

  extern int score_thresh;

  int use_array[ NUMB_OF_SPEC ];
  
  if ( seq_info->score < score_thresh )
    return pdata_header;
  
  set_use_array_from_length_array( use_array, length, data->spec_cell->n );
  
  if ( array_sum( use_array, data->spec_cell->n ) <= 3 ) 
    return pdata_header;
    
  return get_and_put_pdata_lister_single_seq( pdata_header, last_pdata, data,
    ft_array, ind_array, use_array, seq_info, seq_numb, ft_fh );

}











void set_use_array_from_length_array( int use_array[], int length[], int n )
{

  int i;
  
  for ( i = 0; i < n; i++ )
    use_array[ i ] = ( length[ i ] >= MIN_NUCL_COUNT ) ? (1) : (0);

}








int array_sum( int array[], int n )
{

  int sum = 0, i;
  
  for ( i = 0; i < n; i++ )
    sum += array[ i ];
    
  return sum;

}












PDATA_LIST *get_and_put_pdata_lister_single_seq( PDATA_LIST *pdata_header, 
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, FILE *ft_fh )
{

  PDATA_LIST *create_pdata_lister( PDATA_LIST *x );
  
  PDATA_LIST *pdata = NULL;
  pdata = (PDATA_LIST *)create_pdata_lister( pdata );
  
  set_pdata_lister_info( pdata, data, ft_array, ind_array, use_array, seq_info,
    seq_numb, ft_fh );
    
  return put_pdata_lister_into_list( pdata_header, last_pdata, pdata );
  
}











PDATA_LIST *put_pdata_lister_into_list( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, PDATA_LIST *pdata )
{

  if ( pdata_header == NULL ) {
    *last_pdata = pdata;
    return pdata;
  }
  
  (*last_pdata)->next = pdata;
  pdata->prev = *last_pdata;

  *last_pdata = pdata;
  
  return pdata_header;

}









void set_pdata_lister_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  FILE *ft_fh )
{

  pdata->my_pdata->seq_numb = seq_numb;
  pdata->my_pdata->numb_of_spec = data->spec_cell->n;

  int i;
  
  for ( i = 0; i < data->spec_cell->n; i++ ) 
    set_pdata_lister_single_spec_info( pdata, data, ft_array, ind_array, use_array,
      seq_info, seq_numb, i, ft_fh );

}











void set_pdata_lister_single_spec_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  int spec_numb, FILE *ft_fh )
{

  pdata->my_pdata->use_array[ spec_numb ] = use_array[ spec_numb ];
  pdata->my_pdata->ct_array[ spec_numb ] = 0;

  if ( ! use_array[ spec_numb ] )
    return;
    
  FT *ft = ft_array + spec_numb;

  while ( ft->seq <= seq_numb ) {
  
    if ( ft->seq == seq_numb ) {
      int center = seq_info->n / 2;
      int x = ft->pos[ 0 ];
      if (( center + reg_start <= x ) && ( center + reg_end > x ))
        ++(pdata->my_pdata->ct_array[ spec_numb ]);
    }
      
    /*  In this file, above:  */
    if ( ! update_ft_array_from_binary_fh( ft_array, ind_array, spec_numb, ft_fh ))
      break;
      
    ft = ft_array + spec_numb;
  
  }    

}














/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/











void set_region_from_binary_file( REGION *reg, PDATA_LIST *pdata_header )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  set_region_from_binary_fh( reg, pdata_header, fh );
  
  close_file( fh );

}
















void set_region_from_binary_fh( REGION *reg, PDATA_LIST *pdata_header,
  FILE *fh )
{

  PDATA_LIST *pdata = pdata_header;
  
  SEQ seq_numb = 0;
  
  long total_len = 0, total_seq = 0, x = 0;
  int array[ NUMB_OF_SPEC ];
  
  SEQ_INFO seq_info;
  
  while ( pdata != NULL ) {
  
    while ( get( &seq_info, sizeof(SEQ_INFO), fh )) {
    
      get( array, sizeof(int) * pdata->my_pdata->numb_of_spec, fh );
      
      if ( ++seq_numb == pdata->my_pdata->seq_numb )
        break;
    
    }
    
    total_len += seq_info.x;
    ++total_seq;
    
    pdata = pdata->next;
  
  }
  
  int len = total_len / total_seq;
  
  reg->a = 0;
  reg->b = len;
  
}









/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/












void set_prior_probs_pdata( TREE *tree, PDATA_LIST *pdata_header )
{

  int array[ OCCUR_BUFFER ];  
  
  initialize_int_array( array, OCCUR_BUFFER );

  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL )
    set_ct_array_single_pdata_lister_and_step( array, &pdata );
    
  set_prior_probs_w_array( tree, array );
  
}










void initialize_int_array( int array[], int buffer )
{

  int i;
  
  for ( i = 0; i < buffer; i++ )
    array[ i ] = 0;

}








void set_ct_array_single_pdata_lister_and_step( int array[], PDATA_LIST **pdata )
{
  set_ct_array_single_pdata_lister( array, *pdata );
  *pdata = (*pdata)->next;
}













void set_ct_array_single_pdata_lister( int array[], PDATA_LIST *pdata )
{

  int i;
  
  for ( i = 0; i < pdata->my_pdata->numb_of_spec; i++ ) {
    if ( pdata->my_pdata->use_array[ i ] )
      ++(array[ pdata->my_pdata->ct_array[ i ] ]);      
  }

}











void set_prior_probs_w_array( TREE *tree, int array[] )
{

  STAT mu = get_expected_val_int_array( array, OCCUR_BUFFER );
  
  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL )
    set_prior_probs_node_lister_and_step( &node, mu );
    
}














STAT get_expected_val_int_array( int array[], int buffer )
{

  STAT sum = 0.0, n = 0.0;
  
  int i;
  
  for ( i = 0; i < buffer; i++ ) {
    sum += (STAT)(array[ i ] * i);
    n += array[ i ];
  }
  
  return sum / n;

}














void set_prior_probs_node_lister_and_step( NODE_LIST **node, STAT mu )
{
  set_prior_probs_node_lister( *node, mu );
  *node = (*node)->next;
}














void set_prior_probs_node_lister( NODE_LIST *node, STAT mu )
{

  int i;
  
  for ( i = 0; i < OCCUR_BUFFER; i++ ) 
    node->prior->x[ i ] = get_poisson_prob( mu, i );

}













STAT get_poisson_prob( STAT mu, int k )
{

  COUNT i;
  
  STAT x = exp( -1.0 * mu );
  
  for ( i = 1; i <= k; i++ )
    x *= mu / (STAT)i;

  return x;
  
}











COUNT fac( int k )
{

  COUNT x = 1;

  int i;
  
  for ( i = 1; i <= k; i++ )
    x *= i;
    
  return x;

}













void set_max_occur( PDATA_LIST *pdata_header )
{

  extern int max_occur;
  
  max_occur = 0;

  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL ) {
  
    int i;
    
    for ( i = 0; i < pdata->my_pdata->numb_of_spec; i++ ) {
      if ( pdata->my_pdata->ct_array[ i ] > max_occur ) 
        max_occur = pdata->my_pdata->ct_array[ i ];
    }
    
    pdata = pdata->next;
  
  }
  
  if ( max_occur + 5 >= OCCUR_BUFFER )
    error( 6130, "Max numb of occurrences exceeds OCCUR_BUFFER.\n" );

}










