#include "grad_vec.h"



















#define INDEX 0
















void get_gradient_vec( VEC *f, TREE_DATA *d )
{

  void set_trans_probs_tree_w_model( NODE_LIST *root, MODEL_LIST *model );
  void set_tree_derivs( NODE_LIST *root, MODEL_LIST *model );
  
  /*  In lhood.c:  */
  set_trans_probs_tree_w_model( d->root, d->model );
  
  /*  In deriv.c:  */
  set_tree_derivs( d->root, d->model );

  int i = 0, p, b;
  
  for ( p = 0; p < d->model->my_model->part_n; p++ ) {

    for ( b = 0; b < BD; b++ ) 
      /*  In this file, below:  */
      f->v[ i++ ] = get_grad_vec_elem( d, p, b );

  }
  
}












STAT get_grad_vec_elem( TREE_DATA *d, int p, int b )
{

  TREE_DATA *create_tree_data( TREE_DATA *x );
  void copy_tree_data( TREE_DATA *d, TREE_DATA *a );
  
  TREE_DATA *data = NULL;
  data = (TREE_DATA *)create_tree_data( data );
  
  /*  In model_set.c:  */
  copy_tree_data( data, d );
  
  /*  In this file, below:  */
  STAT x = get_my_grad_vec_elem( data, p, b );
  
  kill_all_tree_data( data );
  
  return x;

}










STAT get_my_grad_vec_elem( TREE_DATA *data, int p, int b )
{

  STAT x = 0.0;

  while ( data->occur->x[ 0 ] != NULL )
    x += get_grad_vec_elem_single_seq_and_step( data, p, b );

  return x;

}












STAT get_grad_vec_elem_single_seq_and_step( TREE_DATA *data, int p, int b )
{

  void step_occur_cell( OCCUR_CELL *occur );

  /*  In this file, below:  */
  STAT x = get_grad_vec_elem_single_seq( data, p, b );
  
  /*  In lhood.c:  */
  step_occur_cell( data->occur );
  
  return x;
  
}














STAT get_grad_vec_elem_single_seq( TREE_DATA *data, int p, int b )
{

  int numb_of_spec_in_align( OCCUR_CELL *occur );
  void clear_tree_all( NODE_LIST *root );
  void set_leaf_occurs( NODE_LIST *root, OCCUR_CELL *occur );

  static int i = 0;

  /*  In lhood.c:  */
  if ( numb_of_spec_in_align( data->occur ) < 2 )
    return 0.0;
    
  /*  In set.c:  */
  clear_tree_all( data->root );
  
  /*  In set.c:  */
  set_leaf_occurs( data->root, data->occur );
  
  /*  In this file, below:  */
  return get_my_grad_vec_elem_single_seq( data, p, b );
  
}












STAT get_my_grad_vec_elem_single_seq( TREE_DATA *data, int p, int b )
{  

  NODE_LIST *get_spec_header( NODE_LIST *node );
  void check_nan( STAT x, char func[], char file[] );
  STAT get_node_info_lhood( NODE_INFO *x, NODE_INFO *prior );
  
  NODE_LIST *root = data->root;  
    
  /*  In ../tree/get.c:  */
  NODE_LIST *node = (NODE_LIST *)get_spec_header( root );
  
  while ( node != NULL )
    /*  In this file, below:  */
    set_grad_deriv_vals_single_node_and_step( &node, p, b );
    
  /*  In lhood.c:  */
  STAT x = get_node_info_lhood( root->my_d[ INDEX ], root->prior );
  STAT y = get_node_info_lhood( root->my_info, root->prior );
  
  STAT z = x / y;
  
  check_nan( z, "get_my_grad_vec_elem_single_seq", "grad_vec.c" );
  
  return z;
    
}


















STAT get_array_numerical_sum( STAT array[], int mean, int max )
{

  STAT a = get_array_numerical_sum_single_dir( array, mean, max, INCREM );
  STAT b = get_array_numerical_sum_single_dir( array, mean - 1, max, DECREM );
  
  return a + b;

}















STAT get_array_numerical_sum_single_dir( STAT array[], int start, int max,
  int dir )
{

  int ct_done( STAT x, STAT total, STAT *last );

  STAT total = 0.0, last = 0.0;

  int i;
  
  for ( i = start; i < max && i >= 0; i += dir ) {
  
    total += array[ i ];
    
    /*  In lhood.c:  */
    if ( ct_done( array[ i ], total, &last ))
      return total;
  
  }
  
  return total;

}









void set_grad_deriv_vals_single_node_and_step( NODE_LIST **node, int p, int b )
{
  set_grad_deriv_vals_single_node( *node, p, b );
  *node = (*node)->next;
}












void set_grad_deriv_vals_single_node( NODE_LIST *node, int p, int b )
{

  void set_ct_single_node( NODE_LIST *node );

  if (( node->my_info->use == 0 ) || ( node->my_node->leaf ))
    return;
    
  set_grad_ct_and_deriv_single_node( node, INDEX, p, b );
    
}


/*===============================================================

  To calculate count probabilities and derivatives separately:
  
  /*  In lhood.c:  
  set_ct_single_node( node );
  
  /*  In this file, below:  
  set_derivative_vals_single_node( node, INDEX, p, b );

===============================================================*/












void set_grad_ct_and_deriv_single_node( NODE_LIST *node, int d_index, int p,
  int b )
{

  STAT get_node_lhood_single_ct( NODE_LIST *node, int i );
  int ct_done( STAT x, STAT total, STAT *last );

  STAT ct_total = 0.0, ct_last = 0.0, d_total = 0.0, d_last = 0.0;
  
  int i;
  
  for ( i = 0; i < OCCUR_BUFFER; i++ ) {
  
    /*  In lhood.c:  */
    node->my_info->x[ i ] = get_node_lhood_single_ct( node, i );
  
    /*  In this file, below:  */
    node->my_d[ d_index ]->x[ i ] = get_deriv_single_ct( node, d_index, i, p, b );

    STAT cx = node->my_info->x[ i ] * node->prior->x[ i ];
    STAT dx = node->my_d[ d_index ]->x[ i ] * node->prior->x[ i ];
    
    ct_total += cx;
    d_total += dx;
    
    /*  In lhood.c:  */
    if (( ct_done( cx, ct_total, &ct_last )) && ( ct_done( dx, d_total, &d_last )))
      break;
      
    node->my_info->max = i;
    
  }

}











/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/















void set_derivative_vals_single_node( NODE_LIST *node, int d_index, int p, int b )
{

  int ct_done( STAT x, STAT total, STAT *last );

  STAT total = 0.0, last = 0.0;
  
  int i;
  
  for ( i = 0; i < OCCUR_BUFFER; i++ ) {
  
    /*  In this file, below:  */
    STAT d = get_deriv_single_ct( node, d_index, i, p, b );

    node->my_d[ d_index ]->x[ i ] = d;
    
    STAT x = d * node->prior->x[ i ];
    
    total += x;
    
    /*  In lhood.c:  */
    if ( ct_done( x, total, &last ))
      break;
      
  }

}
















STAT get_deriv_single_ct( NODE_LIST *node, int d_index, int i, int p, int b )
{

  void check_nan( STAT x, char func[], char file[] );

  if ( node->my_info->x[ i ] == 0.0 )
    return 0.0;
    
  STAT sum = 0.0;
  
  int k;
  
  for ( k = 0; k < BRANCH_BUFFER; k++ ) {
  
    NODE_LIST *d = node->down[ k ];
  
    if ( d == NULL )
      break;
  
    sum += get_deriv_single_ct_single_daughter_node( d, d_index, i, p, b );
    
  }
    
  check_nan( sum, "get_deriv_single_ct", "grad_vec.c" );
  
  return node->my_info->x[ i ] * sum;

}














STAT get_deriv_single_ct_single_daughter_node( NODE_LIST *d, int d_index, int i, 
  int p, int b )
{
  
  int ct_done( STAT x, STAT total, STAT *last );

  if ( d->my_info->use == 0 )
    return 0.0;
  
  STAT numer = 0.0, denom = 0.0;

  int j;
    
  for ( j = 0; j <= d->my_info->max; j++ ) {
    denom += get_deriv_single_daughter_denom( d, i, j );    
    numer += get_deriv_single_daughter_numer( d, d_index, i, j, p, b );  
  }
  
  return ( denom == 0.0 ) ? (0.0) : (numer / denom);

}














STAT get_deriv_single_ct_single_daughter_node_single_dir( NODE_LIST *d,
  int d_index, int start, STAT *numer, STAT *denom, int dir, int i, int p, int b )
{

  int ct_done( STAT x, STAT total, STAT *last );

  STAT last = 0.0;

  int j;
    
  for ( j = start; j < OCCUR_BUFFER && j >= 0; j += dir ) {
    
    if ( d->my_info->x[ j ] == 0.0 )
      break;
    
    STAT curr_den = get_deriv_single_daughter_denom( d, i, j );    
    STAT curr_num = get_deriv_single_daughter_numer( d, d_index, i, j, p, b );
        
    *denom += curr_den;    
    *numer += curr_num;  
    
    /*  In lhood.c:  */
    if ( ct_done( curr_num / curr_den, *numer / *denom, &last ))
      break;
    
  }
  
  return ( *denom == 0.0 ) ? (0.0) : (*numer / *denom);
    
}














STAT get_deriv_single_daughter_denom( NODE_LIST *d, int i, int j )
{
  return d->my_trans->p[ i ][ j ] * d->my_info->x[ j ];
}












STAT get_deriv_single_daughter_numer( NODE_LIST *d, int d_index, int i, int j, 
  int p, int b )
{

  STAT x = d->my_trans->p[ i ][ j ] * d->my_d[ d_index ]->x[ j ];
  
  if ( d->my_trans->part != p )
    return x;
    
  return x + (d->my_trans->p_d[ b ][ i ][ j ] * d->my_info->x[ j ]);

}

















