

















#include "../ext/struct.h"









void get_hessian_and_grad( MX *mx, VEC *f, TREE_DATA *d );

void get_my_hessian_and_grad( MX *mx, VEC *f, TREE_DATA *d );

void get_hessian_and_grad_single_row( MX *mx, VEC *f, TREE_DATA *d, int pi,
  int bi, int n );

STAT get_hessian_elem_and_grad( TREE_DATA *d, VEC *f, int i, int j, int pi, int bi, 
  int pj, int bj );

STAT get_my_hessian_elem_and_grad( TREE_DATA *data, VEC *f, int i, int j, int pi, 
  int bi, int pj, int bj );

STAT get_hessian_elem_and_grad_single_seq_and_step( TREE_DATA *data, VEC *f,
  int i, int j, int pi, int bi, int pj, int bj );

STAT get_hessian_elem_and_grad_single_seq( TREE_DATA *data, VEC *f, int i, int j,
  int pi, int bi, int pj, int bj );

STAT get_my_hessian_elem_and_grad_single_seq( TREE_DATA *data, VEC *f, int i, 
  int j, int pi, int bi, int pj, int bj );

void get_hessian_elem_ct_d_dd_single_node_and_step( NODE_LIST **node, int pi, 
  int bi, int pj, int bj );

void get_hessian_elem_ct_d_dd_single_node( NODE_LIST *node, int pi, int bi, 
  int pj, int bj );

void get_my_hessian_elem_ct_d_dd_single_node( NODE_LIST *node, int pi, int bi, 
  int pj, int bj );

STAT get_dd_single_ct( NODE_LIST *node, int i, int pi, int bi, int pj, int bj );

STAT get_dd_term_single_ct( NODE_LIST *node, int i, int pi, int bi, int pj,
  int bj );

STAT get_dd_term_single_daughter_node( NODE_LIST *d, int i, int pi, int bi,
  int pj, int bj );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/



void get_hessian_mx( MX *mx, TREE_DATA *d );

void get_my_hessian_mx( MX *mx, TREE_DATA *d );

void get_hessian_mx_single_row( MX *mx, TREE_DATA *d, int pi, int bi, int n );

STAT get_hessian_elem( TREE_DATA *d, int pi, int bi, int pj, int bj );

STAT get_my_hessian_elem( TREE_DATA *data, int pi, int bi, int pj, int bj );

STAT get_hessian_elem_single_seq_and_step( TREE_DATA *data, int pi, int bi,
  int pj, int bj );

STAT get_hessian_elem_single_seq( TREE_DATA *data, int pi, int bi, int pj, int bj );

STAT get_my_hessian_elem_single_seq( TREE_DATA *data, int pi, int bi, int pj,
  int bj );

void get_hessian_elem_single_node_and_step( NODE_LIST **node, int pi, int bi,
  int pj, int bj );

void get_hessian_elem_single_node( NODE_LIST *node, int pi, int bi, int pj, int bj );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/



void set_second_deriv_vals_single_node( NODE_LIST *node, int pi, int bi, int pj, 
  int bj );

void set_second_deriv_vals_single_node_single_dir( NODE_LIST *node, int start,
  STAT *total, int pi, int bi, int pj, int bj, int dir );

STAT get_second_deriv_single_ct( NODE_LIST *node, int i, int pi, int bi, int pj,
  int bj );

STAT get_deriv_single_ct_sum( NODE_LIST *node, int d_index, int i, int p, int b );

STAT get_second_deriv_term_single_ct( NODE_LIST *node, int i, int pi, int bi, 
  int pj, int bj );

STAT get_second_deriv_term_single_daughter_node( NODE_LIST *d, int i, int pi, 
  int bi, int pj, int bj );

STAT get_second_deriv_term_single_daughter_single_dir( NODE_LIST *d, STAT *a,
  STAT *b, STAT c[], int start, int i, int pi, int bi, int pj, int bj, int dir );

STAT get_second_deriv_term( STAT a, STAT b, STAT c[] );

STAT get_second_deriv_s_single_ct( NODE_LIST *d, int i, int j );

STAT get_second_deriv_d_single_ct( NODE_LIST *d, int d_index, int i, int j, 
  int p, int b );

STAT get_second_deriv_dd_single_ct( NODE_LIST *d, int i, int j, int pi, int bi, 
  int pj, int bj );






