#include "lhood.h"













#define DO_ALL 1

#define PRT 0







int seq_numb;










STAT get_lhood_from_data( MODEL_LIST *model, DATA *data )
{

  STAT lhood = 0.0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_model( data->tree, model );
  
  while ( pdata != NULL )
    lhood += get_lhood_pdata_single_seq_and_step( data->tree, &pdata );
    
  printf( "lhood :  %15.6f\n", (double)lhood );

  return lhood;

}















STAT get_lhood_pdata_single_seq_and_step( TREE *tree, PDATA_LIST **pdata )
{

  STAT lhood = get_lhood_pdata_single_seq( tree, *pdata );
  
  *pdata = (*pdata)->next;
  
  return lhood;

}













STAT get_lhood_pdata_single_seq( TREE *tree, PDATA_LIST *pdata )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );
  
  /*  In ../birth/set.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  return get_my_lhood_pdata_single_seq( tree );

}













STAT get_my_lhood_pdata_single_seq( TREE *tree )
{

  STAT get_node_info_lhood( NODE_INFO *x, NODE_INFO *prior );

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL )
    /*  In this file, below:  */
    set_lhood_pdata_single_seq_and_step( &node );
    
  /*  In this file, below:  */
  return get_lhood_pdata_root( tree->root );
  
}












STAT get_lhood_pdata_root( NODE_LIST *root )
{
    
  STAT lhood = 0.0;
  
  int i;
  
  for ( i = 0; i <= root->my_info->max; i++ ) 
    lhood += root->my_info->x[ i ] * root->prior->x[ i ];

  if (( isnan( logl( lhood ))) || ( lhood <= 0.0 ))
    return 0.0;
    
  return logl( lhood );

}












void set_lhood_pdata_single_seq_and_step( NODE_LIST **node )
{
  set_lhood_pdata_single_seq( *node );
  *node = (*node)->next;
}











void set_lhood_pdata_single_seq( NODE_LIST *node )
{

  INDEX get_max_occur_node( NODE_LIST *node );
  void set_lhood_tree_data_node( NODE_LIST *node );
  
  if ( node->my_info->use == 0 ) 
    return;

  if ( node->my_node->leaf )
    return;
    
  /*  In ../tree/get.c:  */
  node->my_info->max = get_max_occur_node( node );
  
  /*  In this file, below:  */
  set_lhood_pdata_single_node( node );

}














void set_lhood_pdata_single_node( NODE_LIST *node )
{

  int i;
  
  for ( i = 0; i <= node->my_info->max; i++ ) 
    node->my_info->x[ i ] = get_lhood_pdata_single_node_ct( node, i );

}













STAT get_lhood_pdata_single_node_ct( NODE_LIST *node, int i )
{

  STAT z = 1.0;
  
  int k;
  
  for ( k = 0; k < BRANCH_BUFFER; k++ ) {
  
    NODE_LIST *d = node->down[ k ];
    
    if ( d == NULL )
      break;
      
    z *= get_lhood_pdata_single_ct_single_daughter( d, i );
  
  }
  
  return z;

}













STAT get_lhood_pdata_single_ct_single_daughter( NODE_LIST *d, int i )
{

  STAT get_node_lhood_single_ct_pair( NODE_LIST *d, int i, int j );

  if ( d->my_info->use == 0 )
    return 1.0;
    
  STAT lhood = 0.0;
  
  int j;
  
  for ( j = 0; j <= d->my_info->max; j++ ) 
    lhood += get_node_lhood_single_ct_pair( d, i, j );
  
  return lhood;

}









STAT get_node_lhood_single_ct_pair( NODE_LIST *d, int i, int j )
{

  if ( d->my_info->x[ j ] == 0.0 )
    return 0.0;
    
  return d->my_trans->p[ i ][ j ] * d->my_info->x[ j ];

}












/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/















STAT get_max_q_lhood_params_tree_new( TAB_CELL *tab_cell, DATA *data, 
  PT_CELL *pt_cell )
{

  extern int max_occur;

  STAT lhood = 0.0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_pt_cell( data->tree, pt_cell, data->reg );
  
  while ( pdata != NULL ) 
    lhood += get_max_q_lhood_single_seq_new_and_step( tab_cell, data->tree, pt_cell, 
      &pdata );
    
  printf( "my lhood :  %15.6f\n", (double)lhood );
  
  return lhood;

}












STAT get_max_q_lhood_single_seq_new_and_step( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell, PDATA_LIST **pdata )
{

  STAT lhood = get_max_q_lhood_single_seq_new( tab_cell, tree, pt_cell, *pdata );
  
  *pdata = (*pdata)->next;
  
  return lhood;

}











STAT get_max_q_lhood_single_seq_new( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata )
{

  /*  In this file, above:  */
  STAT lhood = get_lhood_pdata_single_seq( tree, pdata );
  
  if ( lhood == 0.0 )
    return lhood;
    
  /*  In this file, below:  */
  update_max_q_lhood_counts_single_seq_new( tab_cell, tree, pt_cell );
  
  return lhood;

}













void update_max_q_lhood_counts_single_seq_new( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell )
{

  tree->root->my_info->q = get_max_q_root( tree->root );
  
  update_my_max_q_lhood_counts_single_seq_new( tab_cell, tree, pt_cell );

}












void update_my_max_q_lhood_counts_single_seq_new( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell )
{
  update_max_q_lhood_counts_single_node_new( tab_cell, tree->root, pt_cell ); 
}











void update_max_q_lhood_counts_single_node_new( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell )
{

  if ( node == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      return;
      
    if ( node->down[ i ]->my_info->use == 0 )
      continue;
      
    do_max_q_lhood_single_node_new( tab_cell, node->down[ i ], pt_cell );
    
    update_max_q_lhood_counts_single_node_new( tab_cell, node->down[ i ], pt_cell );
  
  }

}













void do_max_q_lhood_single_node_new( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell )
{

  if ( node->my_info->use == 0 ) {
    node->my_info->q = -1;
    return;
  }
  
  TAB *tab = NULL;
  tab = (TAB *)get_tab_from_node_pt_cell( tab_cell, node, pt_cell );
  
  do_my_max_q_lhood_single_node_new( tab, node );

}











void do_my_max_q_lhood_single_node_new( TAB *tab, NODE_LIST *node )
{

  INDEX q = get_q_from_daughter_node( node );    
  
  node->my_info->q = q;
  
  INDEX p = node->up->my_info->q;
  
  tab->birth += node->param->a[ p ][ q ];
  tab->death += node->param->b[ p ][ q ];
  
  tab->siten += (STAT)p;

  tab->n += 1;    
  tab->t += node->my_node->t;

}











/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/











STAT get_max_q_lhood_params_tree( TAB_CELL *tab_cell, DATA *data, PT_CELL *pt_cell )
{

  TAB_CELL *create_tab_cell( TAB_CELL *x, INDEX nn );

  extern int seq_numb;
  seq_numb = 0;

  TAB_CELL *curr_tab = NULL;
  curr_tab = (TAB_CELL *)create_tab_cell( curr_tab, tab_cell->n );
  
  STAT lhood = 0.0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_pt_cell( data->tree, pt_cell, data->reg );
  
  while ( pdata != NULL )
    lhood += get_max_q_lhood_single_seq_and_step( tab_cell, curr_tab, data->tree, 
      pt_cell, &pdata );
    
  printf( "lhood :  %15.6f\n", (double)lhood );
  
  kill_tab_cell( curr_tab );

  return lhood;

}













STAT get_max_q_lhood_single_seq_and_step( TAB_CELL *tab_cell, TAB_CELL *curr_tab, 
  TREE *tree, PT_CELL *pt_cell, PDATA_LIST **pdata )
{

  extern int seq_numb;
  ++seq_numb;
  
  STAT lhood = get_max_q_lhood_single_seq( tab_cell, curr_tab, tree, pt_cell,
    *pdata );
    
  *pdata = (*pdata)->next;
  
  return lhood;

}











STAT get_max_q_lhood_single_seq( TAB_CELL *tab_cell, TAB_CELL *curr_tab, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata )
{

  /*  In this file, below:  */
  initialize_my_tab_cell( curr_tab );

  /*  In this file, above:  */
  STAT lhood = get_lhood_pdata_single_seq( tree, pdata );

  /*  In this file, below:  */
  update_max_q_lhood_counts_single_seq( curr_tab, tree, pt_cell );
  
  /*  In this file, below:  */
  update_tab_cell( tab_cell, curr_tab );
  
  return lhood;

}












void initialize_my_tab_cell( TAB_CELL *tab_cell )
{

  void initialize_tab( TAB *tab );
  
  int i;
  
  for ( i = 0; i < tab_cell->n; i++ )
    initialize_tab( tab_cell->tab[ i ] );

}










void update_max_q_lhood_counts_single_seq( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell )
{

  tree->root->my_info->q = get_max_q_root( tree->root );
  
  update_max_q_lhood_counts_single_node( tab_cell, tree->root, pt_cell );

}











int get_max_q_root( NODE_LIST *root )
{

  int i, q = 0;
  
  STAT max = 0.0;
  
  for ( i = 0; i <= root->my_info->max; i++ ) {
  
    STAT x = root->my_info->x[ i ] * root->prior->x[ i ];
    
    if ( x > max ) {
      max = x;
      q = i;
    }
  
  }
  
  return q;

}








void update_max_q_lhood_counts_single_node( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell )
{

  if ( node == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      return;
      
    do_max_q_lhood_single_node( tab_cell, node->down[ i ], pt_cell );
    
    update_max_q_lhood_counts_single_node( tab_cell, node->down[ i ], pt_cell );
  
  }

}












void do_max_q_lhood_single_node( TAB_CELL *tab_cell, NODE_LIST *node, 
  PT_CELL *pt_cell )
{

  if ( node->my_info->use == 0 ) {
    node->my_info->q = -1;
    return;
  }
  
  TAB *tab = NULL;
  tab = (TAB *)get_tab_from_node_pt_cell( tab_cell, node, pt_cell );
  
  do_my_max_q_lhood_single_node( tab, node );
  
}












TAB *get_tab_from_node_pt_cell( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell )
{

  int i;
  
  for ( i = 0; i < tab_cell->n; i++ ) {
    if ( index_is_in_list( pt_cell->branch[ i ], node->my_node->numb )) {
      return tab_cell->tab[ i ];
    }
  }
  
  error( 7310, "Could not find node index in list.\n" );
  return NULL;

}










int index_is_in_list( LIST *header, int numb )
{

  LIST *x = header;
  
  while ( x != NULL ) {
  
    if ( numb == x->elem.d ) 
      return 1;
      
    x = x->next;
  
  }
  
  return 0;

}








void do_my_max_q_lhood_single_node( TAB *tab, NODE_LIST *node )
{

  INDEX q = get_q_from_daughter_node( node );    
  
  node->my_info->q = q;
  
  INDEX p = node->up->my_info->q;
  
  if ( p < q )
    tab->birth += (STAT)(q - p);
  else
    tab->death += (STAT)(p - q);
    
  tab->siten += (STAT)p;

  tab->n += 1;    
  tab->t += node->my_node->t;

}











INDEX get_q_from_daughter_node( NODE_LIST *node )
{

  if ( node->up == NULL )
    error( 6201, "Unexpected null value for parent node.\n" );
  
  int i, q = 0;
  
  INDEX p = node->up->my_info->q;
  
  STAT max = 0.0;
  
  for ( i = 0; i <= node->my_info->max; i++ ) {
  
    STAT x = node->my_info->x[ i ] * node->my_trans->p[ p ][ i ];
    
    if ( x > max ) {
      max = x;
      q = i;
    }
  
  }
  
  return q;
    
}













void update_tab_cell( TAB_CELL *a, TAB_CELL *b )
{

  int i;
  
  for ( i = 0; i < a->n; i++ )
    update_tab( a->tab[ i ], b->tab[ i ] );

}








void update_tab( TAB *tab, TAB *curr_tab )
{

  tab->birth += curr_tab->birth;
  tab->death += curr_tab->death;
  tab->siten += curr_tab->siten;
  tab->lhood += curr_tab->lhood;
  tab->n += curr_tab->n;
  tab->t += curr_tab->t;

}









/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/













STAT get_lhood_and_q( TREE *tree, PDATA_LIST *pdata )
{

  /*  In this file, above:  */
  STAT lhood = get_lhood_pdata_single_seq( tree, pdata );
  
  /*  In this file, below:  */
  set_tree_q( tree );
  
  return lhood;

}














void set_tree_q( TREE *tree )
{

  /*  In this file, above:  */
  tree->root->my_info->q = get_max_q_root( tree->root );
  
  /*  In this file, below:  */
  set_node_lister_q( tree->root );
  
}












void set_node_lister_q( NODE_LIST *node )
{

  if ( node == NULL )
    return;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = node->down[ i ];
    
    if ( d == NULL )
      break;
      
    if ( d->my_info->use == 0 )
      continue;
  
    /*  In this file, above:  */
    d->my_info->q = get_q_from_daughter_node( d );
    
    /*  Recursion:  */
    set_node_lister_q( d );
    
  }

}
















/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/













STAT get_max_q_lhood_params_tree_full( TAB_CELL *tab_cell, DATA *data, 
  PT_CELL *pt_cell )
{

  extern int max_occur;

  STAT lhood = 0.0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_pt_cell( data->tree, pt_cell, data->reg );
  
  while ( pdata != NULL )
    lhood += get_max_q_lhood_single_seq_full_and_step( tab_cell, data->tree, pt_cell, 
      &pdata );
  
  /*  
  int x = pt_cell->n  - 1;  
    
  printf( "\t\t\t\t\t\tRates :  %15.6e  %15.6e\n", 
    (double)pt_cell->pp[ x ]->a,
    (double)pt_cell->pp[ x ]->b );  
  printf( "\t\t\t\t\t\tCount :  %15.2f  %15.2f\n",
    (float)tab_cell->tab[ x ]->birth,
    (float)tab_cell->tab[ x ]->death );
  */
  printf( "lhood :  %15.6f\n", (double)lhood );
  
  return lhood;

}












STAT get_max_q_lhood_single_seq_full_and_step( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell, PDATA_LIST **pdata )
{

  STAT lhood = get_max_q_lhood_single_seq_full( tab_cell, tree, pt_cell, *pdata );
  
  *pdata = (*pdata)->next;
  
  return lhood;

}













STAT get_max_q_lhood_single_seq_full( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata )
{

  /*  In this file, above:  */
  STAT lhood = get_lhood_pdata_single_seq( tree, pdata );
  
  if ( lhood == 0.0 ) 
    return lhood;
  
  /*  In this file, below:  */
  update_max_q_lhood_counts_single_seq_full( tab_cell, tree, pt_cell );
  
  return lhood;

}













void update_max_q_lhood_counts_single_seq_full( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell )
{

  STAT q[ OCCUR_BUFFER ];
  
  get_q_distr_root( q, tree->root );
  
  tree->root->my_info->q = get_max_q_root( tree->root );
  
  update_my_max_q_lhood_counts_single_seq_full( tab_cell, tree->root, q, pt_cell );

}













void get_q_distr_root( STAT q[], NODE_LIST *root )
{

  int i;
  
  for ( i = 0; i <= root->my_info->max; i++ )
    q[ i ] = root->my_info->x[ i ] * root->prior->x[ i ];
    
  for ( ; i < OCCUR_BUFFER; i++ )
    q[ i ] = 0.0;
    
}












void update_my_max_q_lhood_counts_single_seq_full( TAB_CELL *tab_cell,
  NODE_LIST *node, STAT q[], PT_CELL *pt_cell )
{

  if ( node == NULL )
    return;
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = node->down[ i ];
    
    if ( d == NULL )
      break;
      
    if ( d->my_info->use == 0 )
      continue;
      
    STAT q_copy[ OCCUR_BUFFER ];
  
    copy_q_array( q_copy, q, node->my_info->max );
    
    update_max_q_lhood_full_single_node( tab_cell, d, q, pt_cell );
    
    update_my_max_q_lhood_counts_single_seq_full( tab_cell, d, q, pt_cell );
  
    copy_q_array( q, q_copy, node->my_info->max );
  
  }

}















void update_max_q_lhood_full_single_node( TAB_CELL *tab_cell, NODE_LIST *node,
  STAT q[], PT_CELL *pt_cell )
{

  node->my_info->q = get_q_from_daughter_node( node );    

  TAB *tab = NULL;
  tab = (TAB *)get_tab_from_node_pt_cell( tab_cell, node, pt_cell );
  
  update_my_max_q_lhood_full_single_node( tab, node, q );
  
}













void update_my_max_q_lhood_full_single_node( TAB *tab, NODE_LIST *node, STAT q[] )
{
  
  STAT r[ OCCUR_BUFFER ];
  
  initialize_q_array( r, OCCUR_BUFFER - 1 );
  
  STAT siten = 0.0, n = 0.0;
  
  int i = node->up->my_info->q, j;
  
  STAT birth_numer = 0.0, death_numer = 0.0, denom = 0.0;
  
  for ( i = 0; i <= node->up->my_info->max; i++ ) {
  
    for ( j = 0; j <= node->my_info->max; j++ ) {
    
      STAT x = node->my_trans->p[ i ][ j ] * q[ i ];
      
  //    if ( i < j )
        birth_numer += node->param->a[ i ][ j ] * x;
        
    //  if ( i > j )
        death_numer += node->param->b[ i ][ j ] * x;
      
      denom += x;
      
      siten += (STAT)(i) * q[ i ];
      n += q[ i ];
      
      r[ j ] += q[ i ] * node->my_trans->p[ i ][ j ];
    
    } 
    
  }

  tab->birth += birth_numer / denom;
  tab->death += death_numer / denom;
  
  tab->siten += siten / n;
  
  tab->n += 1;
  tab->t += node->my_node->t;
  
  copy_q_array( q, r, OCCUR_BUFFER - 1 );
  
}













void initialize_q_array( STAT q[], int max )
{

  int i;
  
  for ( i = 0; i <= max; i++ )
    q[ i ] = 0.0;

}













void copy_q_array( STAT q[], STAT r[], int max )
{

  int i;
  
  for ( i = 0; i <= max; i++ )
    q[ i ] = r[ i ];

}









/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/














STAT get_lhood_model_w_node_label( MODEL_LIST *model, DATA *data, 
  char node_label[], COUNT *nn )
{

  STAT lhood = 0.0;
  
  *nn = 0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_model( data->tree, model );
  
  while ( pdata != NULL )
    lhood += get_lhood_pdata_single_seq_node_label_and_step( data->tree, &pdata,
      node_label, nn );
    
  return lhood;

}















STAT get_lhood_pdata_single_seq_node_label_and_step( TREE *tree, PDATA_LIST **pdata,
  char node_label[], COUNT *nn )
{
  STAT lhood = get_lhood_pdata_single_seq_node_label( tree, *pdata, node_label, nn ); 
  *pdata = (*pdata)->next;
  return lhood;
}















STAT get_lhood_pdata_single_seq_node_label( TREE *tree, PDATA_LIST *pdata,
  char node_label[], COUNT *nn )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );
  
  /*  In ../birth/lhood.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  return get_my_lhood_pdata_single_seq_node_label( tree, node_label, nn );

}















STAT get_my_lhood_pdata_single_seq_node_label( TREE *tree, char node_label[],
  COUNT *nn )
{

  /*  In this file, below:  */
  if ( ! node_label_has_use( tree, node_label ))
    return 0.0;
    
  /*  In this file, below:  */
//  if ( ! node_label_has_sister_use( tree, node_label ))
  //  return 0.0;
    
  /*  In this file, above:  */
  STAT lhood = get_my_lhood_pdata_single_seq( tree );

  if ( lhood == 0.0 )
    return lhood;

  ++(*nn);
  
  return lhood;
  
}
















int node_label_has_use( TREE *tree, char node_label[] )
{

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
  
    if ( ! strcmp( node->my_node->label, node_label ))
      return node->my_info->use;
      
    node = node->next;
  
  }
  
  error( 6220, "Could not find node label in tree.\n" );
  
  return 0;

}










int node_label_has_sister_use( TREE *tree, char node_label[] )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );
  
  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, node_label );
  
  NODE_LIST *p = node->up;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = p->down[ i ];
    
    if ( d == NULL )
      break;
    
    if ( ! strcmp( d->my_node->label, node_label ))
      continue;
      
    if ( d->my_info->use )
      return 1;
  
  }
  
  return 0;

}







/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/












STAT get_best_lhood_model_w_node_label( MODEL_LIST *model, DATA *data, 
  char node_label[] )
{

  STAT lhood = 0.0;
  
  PDATA_LIST *pdata = data->pdata;
  
  set_trans_probs_model( data->tree, model );
  
  while ( pdata != NULL )
    lhood += get_best_lhood_single_node_w_label_and_step( data->tree, &pdata,
      node_label );
    
  return lhood;


}














STAT get_best_lhood_single_node_w_label_and_step( TREE *tree, PDATA_LIST **pdata, 
  char node_label[] )
{

  STAT lhood = get_best_lhood_single_node_w_label( tree, *pdata, node_label );
  
  *pdata = (*pdata)->next;

  return lhood;

}













STAT get_best_lhood_single_node_w_label( TREE *tree, PDATA_LIST *pdata,
  char node_label[] )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );
  
  /*  In ../birth/lhood.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  return get_my_best_lhood_single_node_w_label( tree, node_label );

}













STAT get_my_best_lhood_single_node_w_label( TREE *tree, char node_label[] )
{

  /*  In this file, above:  */
  if ( ! node_label_has_use( tree, node_label ))
    return 0.0;
    
  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL )
    /*  In this file, below:  */
    set_best_lhood_single_node_and_step( &node );
    
  /*  In this file, above:  */
  return get_lhood_pdata_root( tree->root );
  
}













void set_best_lhood_single_node_and_step( NODE_LIST **node )
{
  set_best_lhood_single_node( *node );
  *node = (*node)->next;
}













void set_best_lhood_single_node( NODE_LIST *node )
{

  INDEX get_max_occur_node( NODE_LIST *node );
  
  if ( node->my_node->leaf )
    return;
    
  if ( node->my_info->use == 0 ) 
    return;

  /*  In ../tree/get.c:  */
  node->my_info->max = get_max_occur_node( node );
  
  int i;
  
  for ( i = 0; i <= node->my_info->max; i++ )
    node->my_info->x[ i ] = 1.0;
    
}








/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/













int get_sum_seqs_spec_data( DATA *data, char label[] )
{

  int numb = 0;

  PDATA_LIST *pdata = data->pdata;
  
  while ( pdata != NULL )
    numb += get_sum_seqs_single_pdata_and_step( &pdata, data->tree, label );
    
  return numb;    

}















int get_sum_seqs_single_pdata_and_step( PDATA_LIST **pdata, TREE *tree,
  char label[] )
{

  int numb = get_sum_seqs_single_pdata( *pdata, tree, label );
  
  *pdata = (*pdata)->next;
  
  return numb;

}















int get_sum_seqs_single_pdata( PDATA_LIST *pdata, TREE *tree, char label[] )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );

  /*  In ../birth/set.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  return label_has_use_tree( tree, label );

}















int label_has_use_tree( TREE *tree, char label[] )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );

  NODE_LIST *node = tree->spec_header;
  
  while ( node->my_node->leaf )
    /*  In this file, below:  */
    set_use_tree_single_node_and_step( &node );
    
  /*  In ../tree/get.c:  */  
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, label );
  
  return node->my_info->use;

}















void set_use_tree_single_node_and_step( NODE_LIST **node )
{
  set_use_tree_single_node( *node );
  *node = (*node)->next;
}












void set_use_tree_single_node( NODE_LIST *node )
{

  void set_use_leaf( NODE_LIST *leaf );
  
  if ( node->my_info->use )
    /*  In ../birth/lhood.c:  */
    set_use_leaf( node );

}






/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/













void set_trans_probs_model( TREE *tree, MODEL_LIST *model )
{

  set_u_and_v_vals_tree( tree->root, model );

  set_trans_probs_tree_trans_p_mx( tree->root );

}









void set_trans_probs_tree_w_model( NODE_LIST *root, MODEL_LIST *model )
{

  set_u_and_v_vals_tree( root, model );
  
  set_trans_probs_tree_p_mx( root, model->my_model->stats->max_occur );

}










void set_u_and_v_vals_tree( NODE_LIST *root, MODEL_LIST *model )
{

  if ( root == NULL )
    return;
    
  set_u_and_v_vals_node( root, model );
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( root->down[ i ] == NULL )
      break;
      
    set_u_and_v_vals_tree( root->down[ i ], model );
  
  }

}








void set_u_and_v_vals_node( NODE_LIST *node, MODEL_LIST *model )
{

  COORD get_region_width( REGION *reg );
  REGION get_region_from_mode( char mode );
  
  extern char major_reg;

  /*  In this file, below:  */
  PARAMS *pp = (PARAMS *)get_params_node_by_numb( node, model );
  
  /*  In this file, below:  */
  set_u_and_v_vals_node_w_params( node, pp );
  
  node->my_trans->n = model->my_model->my_region->b
    - model->my_model->my_region->a;
    
}












PARAMS *get_params_node_by_numb( NODE_LIST *node, MODEL_LIST *model )
{

  PART_LIST *part = model->my_model->part_header;
  
  while ( part != NULL ) {
  
    if ( node_in_part( node, part ))
      return part->my_part->pp;
      
    part = part->next;
  
  }
  
  error( 5202, "Could not find node in any partition.\n" );

}













int node_in_part( NODE_LIST *node, PART_LIST *part )
{

  LIST *branch = part->my_part->branch_header;
  
  while ( branch != NULL ) {
  
    if ( branch->elem.d == node->my_node->numb )
      return 1;
      
    branch = branch->next;
  
  }
  
  return 0;

}













void set_u_and_v_vals_node_w_params( NODE_LIST *node, PARAMS *pp )
{
  node->my_trans->u = get_u_val_params( pp, node->my_node->t );
  node->my_trans->v = get_v_val_params( pp, node->my_node->t );
}














STAT get_u_val_params( PARAMS *pp, TIME t )
{

  extern STAT branch_factor;

  STAT a = pp->a;
  STAT b = pp->b;
  
  if ( a + b == 0.0 )
    return 1.0;

  STAT ex = -1.0 * (a + b) * MILLION * t;
  
  return (a / (a + b)) + (b * exp( ex ) / (a + b));

}











STAT get_v_val_params( PARAMS *pp, TIME t )
{

  extern STAT branch_factor;

  STAT a = pp->a;
  STAT b = pp->b;
  
  if ( a + b == 0.0 )
    return 0.0;

  STAT coeff = a / (a + b);
  STAT ex = -1.0 * (a + b) * MILLION * t;
  
  return coeff - (coeff * exp( ex ));

}














void set_trans_probs_tree_p_mx( NODE_LIST *root, COUNT max_occur )
{

  if ( root == NULL )
    return;
    
  set_trans_probs_p_mx_single_node( root, max_occur );
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( root->down[ i ] == NULL )
      break;
      
    set_trans_probs_tree_p_mx( root->down[ i ], max_occur );
  
  }
  
}












void set_trans_probs_p_mx_single_node( NODE_LIST *node, COUNT n )
{

  extern int max_occur;
  
  int end = max_occur + 3;

  int i, j;
  
  for ( i = 0; i < end; i++ ) {
    for ( j = 0; j < end; j++ ) 
      node->my_trans->p[ i ][ j ] = get_trans_prob( node, i, j );
  }
  
}















void initialize_p_array_mx( STAT p[ OCCUR_BUFFER ][ OCCUR_BUFFER ] )
{

  int i, j;
  
  for ( i = 0; i < OCCUR_BUFFER; i++ ) {
    for ( j = 0; j < OCCUR_BUFFER; j++ )
      p[ i ][ j ] = 0.0;
  }

}












STAT get_trans_prob( NODE_LIST *node, int i, int j )
{

  extern int max_occur;
  
  int nn = max_occur + 3;
  
  STAT u = node->my_trans->u;
  STAT v = node->my_trans->v;
  STAT n = node->my_trans->n;
    
  if (( u == 1.0 ) && ( v == 0.0 ))
    return ( i == j ) ? (1.0) : (0.0);
  
  STAT uu[ OCCUR_BUFFER ], vv[ OCCUR_BUFFER ];
  
  STAT uu_x = pow( 1.0 - u, i );
  STAT vv_x = pow( 1.0 - v, n - i );
  
  STAT uu_step = u / (1.0 - u);
  STAT vv_step = v / (1.0 - v);
  
  STAT uu_numer = i, uu_denom = 1.0;
  STAT vv_numer = n - i, vv_denom = 1.0;
  
  int k;
  
  for ( k = 0; k < nn; k++ ) {

    uu[ k ] = uu_x;
    vv[ k ] = vv_x;
    
    uu_x *= uu_step * (uu_numer--) / (uu_denom++);
    vv_x *= vv_step * (vv_numer--) / (vv_denom++);
    
  }
  
  if ( u == 1.0 ) {
    for ( k = 0; k < nn; k++ ) 
      uu[ k ] = 0.0;
    uu[ i ] = 1.0;  
  }
  
  int end = MIN( i, j );
  
  STAT p = 0.0, aa = 0.0, bb = 0.0;
  
  for ( k = 0; k <= end; k++ ) {

    STAT x = uu[ k ] * vv[ j - k ];
    p += x;
    aa += (STAT)(j - k) * x;
    bb += (STAT)(i - k) * x;

  }
  
  node->param->a[ i ][ j ] = aa / p;
  node->param->b[ i ][ j ] = bb / p;
  
  if (( node->param->a[ i ][ j ] < j - i ) || ( node->param->a[ i ][ j ] < 0.0 ))
    node->param->a[ i ][ j ] = MAX( j - i, 0.0 );

  if (( node->param->b[ i ][ j ] < i - j ) || ( node->param->b[ i ][ j ] < 0.0 ))
    node->param->b[ i ][ j ] = MAX( i - j, 0.0 );
  
  /*
  if ( isnan( p )) {
    printf( "p_[%d,%d] is nan\n", i, j );
    printf( "n = %d\n", nn );
  }
  */
  
  /*
  if ( node->param->a[ i ][ j ] < j - i - 0.0001 )
    printf( "%s  %3d  %3d :   a = %.3f\n", node->my_node->label,
       i, j, (float)node->param->a[ i ][ j ] );
  if ( node->param->b[ i ][ j ] < i - j - 0.0001 )
    printf( "%s  %3d  %3d :   b = %.3f\n", node->my_node->label,
      i, j, (float)node->param->b[ i ][ j ] );
    */
  return p;

}













STAT get_binom( STAT p, int n, int k )
{
  return pow( p, k ) * pow( 1.0 - p, n - k ) * choose( n, k );
}










STAT choose( int n, int k )
{

  if (( k == 0 ) || ( n == k ))
    return 1.0;
    
  if (( n < k ) || ( k < 0 ))
    return 0.0;
    
  STAT choose = 1.0;
  
  long numer = n, denom = 1;

  int end = MIN( k, n - k );
  
  while ( denom <= end ) {
    choose *= numer--;
    choose /= denom++;
  }
  
  return choose;

}














/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/













void set_trans_probs_pt_cell( TREE *tree, PT_CELL *pt_cell, REGION *reg )
{

  set_u_and_v_vals_tree_pt_cell( tree->spec_header, pt_cell, reg );
  
  set_trans_probs_tree_trans_p_mx( tree->root );

}













void set_u_and_v_vals_tree_pt_cell( NODE_LIST *spec_header, PT_CELL *pt_cell,
  REGION *reg )
{

  NODE_LIST *node = spec_header;
  
  while ( node != NULL )
    set_u_and_v_vals_pt_cell_single_node_and_step( &node, pt_cell, reg );

}













void set_u_and_v_vals_pt_cell_single_node_and_step( NODE_LIST **node, 
  PT_CELL *pt_cell, REGION *reg )
{
  set_u_and_v_vals_pt_cell_single_node( *node, pt_cell, reg );
  *node = (*node)->next;
}











void set_u_and_v_vals_pt_cell_single_node( NODE_LIST *node, PT_CELL *pt_cell,
  REGION *reg )
{

  void set_u_and_v_vals_node_w_params( NODE_LIST *node, PARAMS *pp );
  COORD get_region_width( REGION *reg );

  /*  In this file, below:  */
  PARAMS *pp = (PARAMS *)get_params_pt_cell_by_numb( node, pt_cell );
  
  /*  In ../birth/lhood.c:  */
  set_u_and_v_vals_node_w_params( node, pp );
  
  /*  In ../main/reg_defn.c:  */
  node->my_trans->n = get_region_width( reg );

}











PARAMS *get_params_pt_cell_by_numb( NODE_LIST *node, PT_CELL *pt_cell )
{

  if ( pt_cell->n == 1 )
    return pt_cell->pp[ 0 ];

  int i;
  
  for ( i = 0; i < pt_cell->n; i++ ) {
    if ( node_in_list_numb( node, pt_cell->branch[ i ] )) 
      return pt_cell->pp[ i ];
  }
  
  if ( node->up == NULL )
    return pt_cell->pp[ 0 ];
  
  if ( ! strcmp( node->my_node->label, "Vertebrata" )) 
    return pt_cell->pp[ 0 ];
    
  printf( "Got here\n" );
    
  printf( "Label :  %s\n", node->my_node->label );
  
  error( 6200, "Could not find node in part cell list.\n" );

}













int node_in_list_numb( NODE_LIST *node, LIST *header )
{

  LIST *x = header;
  
  while ( x != NULL ) {
  
    if ( x->elem.d == node->my_node->numb )
      return 1;
      
    x = x->next;
  
  }
  
  return 0;

}










void set_trans_probs_tree_trans_p_mx( NODE_LIST *node )
{

  if ( node == NULL )
    return;
    
  set_trans_probs_tree_trans_p_mx_single_node( node );
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      break;
      
    set_trans_probs_tree_trans_p_mx( node->down[ i ] );
  
  }

}













void set_trans_probs_tree_trans_p_mx_single_node( NODE_LIST *node )
{

  STAT get_trans_prob( NODE_LIST *node, int i, int j );
  
  extern int max_occur;
  
  if ( max_occur == 0 )
    error( 6230, "Max number of occurrences not calc.  See 'model/data.c'.\n" );

  int i, j;
  
  int pr = ( node->up == NULL ) ? (1) : (0);
  
  pr = 0;
  
  if ( pr ) {
    printf( "u = %.12e\n", (double)node->my_trans->u );
    printf( "v = %.12e\n", (double)node->my_trans->v );
    printf( "\n\n" );    
  }
  
  int end = max_occur + 3;

  for ( i = 0; i < end; i++ ) {
    if ( pr )
      printf( "%3d\t\t", i );
    for ( j = 0; j < end; j++ ) {
      /*  In ../birth/lhood.c:  */
      node->my_trans->p[ i ][ j ] = get_trans_prob( node, i, j );
      if ( pr ) {
        printf( "%.3e\t", (double)node->my_trans->p[ i ][ j ] );
      }
    }
    if ( pr ) {
      printf( "\n" );
    }
  }

}









/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/















int get_max_ct_daughter_nodes( NODE_LIST *node )
{

  int i, max = 0;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      return max;
      
    int x = node->down[ i ]->my_info->max;
    
    if ( x > max )
      max = x;
  
  }
  
  return -1;

}












STAT get_mean_occur_node( NODE_LIST *node )
{

  STAT total = 0.0, n = 0.0;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      break;
      
    if ( node->down[ i ]->my_info->use == 0 )
      continue;
      
    total += node->down[ i ]->my_info->mean;
    ++n;
  
  }
  
  return total / n;

}













STAT get_mean_occur_pdata( PDATA_LIST *pdata_header )
{

  STAT x = 0.0, n = 0.0;
  
  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL ) 
    x += get_mean_occur_pdata_single_seq_and_step( &pdata, &n );
    
  return x / n;

}












STAT get_mean_occur_pdata_single_seq_and_step( PDATA_LIST **pdata, STAT *n )
{
  STAT x = get_mean_occur_pdata_single_seq( *pdata, n );
  *pdata = (*pdata)->next;
  return x;
}












STAT get_mean_occur_pdata_single_seq( PDATA_LIST *pdata, STAT *n )
{

  STAT x = 0.0;

  int i;
  
  for ( i = 0; i < pdata->my_pdata->numb_of_spec; i++ ) {
  
    if ( pdata->my_pdata->use_array[ i ] == 0 )
      continue;
      
    ++(*n);
    
    x += pdata->my_pdata->ct_array[ i ];
  
  }
  
  return x;

}






