















#include "../ext/struct.h"










STAT get_lhood_from_data( MODEL_LIST *model, DATA *data );

STAT get_lhood_pdata_single_seq_and_step( TREE *tree, PDATA_LIST **pdata );

STAT get_lhood_pdata_single_seq( TREE *tree, PDATA_LIST *pdata );

STAT get_my_lhood_pdata_single_seq( TREE *tree );

STAT get_lhood_pdata_root( NODE_LIST *root );

void set_lhood_pdata_single_seq_and_step( NODE_LIST **node );

void set_lhood_pdata_single_seq( NODE_LIST *node );

void set_lhood_pdata_single_node( NODE_LIST *node );

STAT get_lhood_pdata_single_node_ct( NODE_LIST *node, int i );

STAT get_lhood_pdata_single_ct_single_daughter( NODE_LIST *d, int i );

STAT get_node_lhood_single_ct_pair( NODE_LIST *d, int i, int j );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_max_q_lhood_params_tree_new( TAB_CELL *tab_cell, DATA *data, 
  PT_CELL *pt_cell );

STAT get_max_q_lhood_single_seq_new_and_step( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell, PDATA_LIST **pdata );

STAT get_max_q_lhood_single_seq_new( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata );

void update_max_q_lhood_counts_single_seq_new( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell );

void update_my_max_q_lhood_counts_single_seq_new( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell );

void update_max_q_lhood_counts_single_node_new( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell );

void do_max_q_lhood_single_node_new( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell );

void do_my_max_q_lhood_single_node_new( TAB *tab, NODE_LIST *node );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_max_q_lhood_params_tree( TAB_CELL *tab_cell, DATA *data, PT_CELL *pt_cell );

STAT get_max_q_lhood_single_seq_and_step( TAB_CELL *tab_cell, TAB_CELL *curr_tab, 
  TREE *tree, PT_CELL *pt_cell, PDATA_LIST **pdata );

STAT get_max_q_lhood_single_seq( TAB_CELL *tab_cell, TAB_CELL *curr_tab, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata );

void initialize_my_tab_cell( TAB_CELL *tab_cell );

void update_max_q_lhood_counts_single_seq( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell );

int get_max_q_root( NODE_LIST *root );

void update_max_q_lhood_counts_single_node( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell );

void do_max_q_lhood_single_node( TAB_CELL *tab_cell, NODE_LIST *node, 
  PT_CELL *pt_cell );

TAB *get_tab_from_node_pt_cell( TAB_CELL *tab_cell, NODE_LIST *node,
  PT_CELL *pt_cell );

int index_is_in_list( LIST *header, int numb );

void do_my_max_q_lhood_single_node( TAB *tab, NODE_LIST *node );

INDEX get_q_from_daughter_node( NODE_LIST *node );

void update_tab_cell( TAB_CELL *a, TAB_CELL *b );

void update_tab( TAB *tab, TAB *curr_tab );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_lhood_and_q( TREE *tree, PDATA_LIST *pdata );

void set_tree_q( TREE *tree );

void set_node_lister_q( NODE_LIST *node );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_max_q_lhood_params_tree_full( TAB_CELL *tab_cell, DATA *data, 
  PT_CELL *pt_cell );

STAT get_max_q_lhood_single_seq_full_and_step( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell, PDATA_LIST **pdata );

STAT get_max_q_lhood_single_seq_full( TAB_CELL *tab_cell, TREE *tree, 
  PT_CELL *pt_cell, PDATA_LIST *pdata );

void update_max_q_lhood_counts_single_seq_full( TAB_CELL *tab_cell, TREE *tree,
  PT_CELL *pt_cell );

void get_q_distr_root( STAT q[], NODE_LIST *root );

void update_my_max_q_lhood_counts_single_seq_full( TAB_CELL *tab_cell,
  NODE_LIST *node, STAT q[], PT_CELL *pt_cell );

void update_max_q_lhood_full_single_node( TAB_CELL *tab_cell, NODE_LIST *node,
  STAT q[], PT_CELL *pt_cell );

void update_my_max_q_lhood_full_single_node( TAB *tab, NODE_LIST *node, STAT q[] );

void initialize_q_array( STAT q[], int max );

void copy_q_array( STAT q[], STAT r[], int max );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_lhood_model_w_node_label( MODEL_LIST *model, DATA *data, 
  char node_label[], COUNT *nn );

STAT get_lhood_pdata_single_seq_node_label_and_step( TREE *tree, PDATA_LIST **pdata,
  char node_label[], COUNT *nn );

STAT get_lhood_pdata_single_seq_node_label( TREE *tree, PDATA_LIST *pdata,
  char node_label[], COUNT *nn );

STAT get_my_lhood_pdata_single_seq_node_label( TREE *tree, char node_label[],
  COUNT *nn );

int node_label_has_use( TREE *tree, char node_label[] );

int node_label_has_sister_use( TREE *tree, char node_label[] );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



STAT get_best_lhood_model_w_node_label( MODEL_LIST *model, DATA *data, 
  char node_label[] );

STAT get_best_lhood_single_node_w_label_and_step( TREE *tree, PDATA_LIST **pdata, 
  char node_label[] );

STAT get_best_lhood_single_node_w_label( TREE *tree, PDATA_LIST *pdata,
  char node_label[] );

STAT get_my_best_lhood_single_node_w_label( TREE *tree, char node_label[] );

void set_best_lhood_single_node_and_step( NODE_LIST **node );

void set_best_lhood_single_node( NODE_LIST *node );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



int get_sum_seqs_spec_data( DATA *data, char label[] );

int get_sum_seqs_single_pdata_and_step( PDATA_LIST **pdata, TREE *tree,
  char label[] );

int get_sum_seqs_single_pdata( PDATA_LIST *pdata, TREE *tree, char label[] );

int label_has_use_tree( TREE *tree, char label[] );

void set_use_tree_single_node_and_step( NODE_LIST **node );

void set_use_tree_single_node( NODE_LIST *node );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void set_trans_probs_model( TREE *tree, MODEL_LIST *model );

void set_trans_probs_tree_w_model( NODE_LIST *root, MODEL_LIST *model );

void set_u_and_v_vals_tree( NODE_LIST *root, MODEL_LIST *model );

void set_u_and_v_vals_node( NODE_LIST *node, MODEL_LIST *model );

PARAMS *get_params_node_by_numb( NODE_LIST *node, MODEL_LIST *model );

int node_in_part( NODE_LIST *node, PART_LIST *part );

void set_u_and_v_vals_node_w_params( NODE_LIST *node, PARAMS *pp );

STAT get_u_val_params( PARAMS *pp, TIME t );

STAT get_v_val_params( PARAMS *pp, TIME t );

void set_trans_probs_tree_p_mx( NODE_LIST *root, COUNT max_occur );

void set_trans_probs_p_mx_single_node( NODE_LIST *node, COUNT n );

void initialize_p_array_mx( STAT p[ OCCUR_BUFFER ][ OCCUR_BUFFER ] );

STAT get_trans_prob( NODE_LIST *node, int i, int j );

STAT get_binom( STAT p, int n, int k );

STAT choose( int n, int k );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void set_trans_probs_pt_cell( TREE *tree, PT_CELL *pt_cell, REGION *reg );

void set_u_and_v_vals_tree_pt_cell( NODE_LIST *spec_header, PT_CELL *pt_cell,
  REGION *reg );

void set_u_and_v_vals_pt_cell_single_node_and_step( NODE_LIST **node, 
  PT_CELL *pt_cell, REGION *reg );

void set_u_and_v_vals_pt_cell_single_node( NODE_LIST *node, PT_CELL *pt_cell,
  REGION *reg );

PARAMS *get_params_pt_cell_by_numb( NODE_LIST *node, PT_CELL *pt_cell );

int node_in_list_numb( NODE_LIST *node, LIST *header );

void set_trans_probs_tree_trans_p_mx( NODE_LIST *node );

void set_trans_probs_tree_trans_p_mx_single_node( NODE_LIST *node );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



int get_max_ct_daughter_nodes( NODE_LIST *node );

STAT get_mean_occur_node( NODE_LIST *node );

STAT get_mean_occur_pdata( PDATA_LIST *pdata_header );

STAT get_mean_occur_pdata_single_seq_and_step( PDATA_LIST **pdata, STAT *n );

STAT get_mean_occur_pdata_single_seq( PDATA_LIST *pdata, STAT *n );







