#!/bin/bash

# Use bowtie + MACS to call peaks

# re-format peak into input format of boo
# download 46-way multiz alignment file from UCSC, here we save those files into /home/yzhan116/data/yzhan116/Genome_UCSC/Human/hg19/multiz46way/*maf
mafsInRegion chip_genCoord_Broad_GM12878.hg19.CTCF.txt hg19_multiz_Broad_GM12878.CTCF.txt /home/yzhan116/data/yzhan116/Genome_UCSC/Human/hg19/multiz46way/*maf >>log 2>&1 &

# create a new folder called data, put data into a TF specific folder under data/
mkdir data
mkdir data/hg19
mkdir data/hg19/CTCF
mv hg19_multiz_Broad_GM12878.CTCF.txt data/hg19/CTCF/
mv chip_genCoord_Broad_GM12878.hg19.CTCF.txt data/hg19/CTCF/

# here we use the tool we proviced to generate pwm, kmer from peak region. Other method is also okay.
../bin/boo_pwm -m F -s data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt -r data/hg19/CTCF/chip_genCoord_Broad_GM12878.hg19.CTCF.txt -w -100:100 -k 100 -t tree_file.nh -x hg19 >>log 2>&1
../bin/boo_pwm -m w -s data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt -r data/hg19/CTCF/chip_genCoord_Broad_GM12878.hg19.CTCF.txt -w -100:100 -k 100 -t tree_file.nh -x hg19  -a GGGGCKC >>log 2>&1

# run boo
../bin/boo -m f -s data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt -r data/hg19/CTCF/chip_genCoord_Broad_GM12878.hg19.CTCF.txt -t tree_file.nh -x hg19 -k 100 -w -100:100 -a GGGGCKC -q data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt.-100\:100_motif_GGGGCKC.txt
../bin/boo -s data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt -r data/hg19/CTCF/chip_genCoord_Broad_GM12878.hg19.CTCF.txt -t tree_file.nh -x hg19 -k 100 -w -100:100 -a GGGGCKC -q data/hg19/CTCF/hg19_multiz_Broad_GM12878.CTCF.txt.-100\:100_motif_GGGGCKC.txt
