#include "cluster.h"













//For 6-mers:
/*
#define STRONG_PVAL_THRESH 1e-5
#define MIN_SIM 4
#define MIN_SCORE 4.4
#define MISMATCH_PENALTY -0.5
#define MY_PENALTY -1.0
#define MATCH_SCORE 1.0
*/


//  For 7-mers :

#define STRONG_PVAL_THRESH 1e-15
#define MIN_SIM 6
#define MIN_SCORE 5.5
#define MISMATCH_PENALTY -0.5
#define MY_PENALTY -1.0
#define MATCH_SCORE 1.0

//  New:
#define CONS_MATCH_THRESH 4.5
#define TOP_KMER_DUPL 3


/*  
    Note: GC lineages defined at bottom of this file...
*/














CLUS_LIST *get_cluster_list_from_r_list( CLUS_LIST *clus_header,
  RESULT_LIST *res_header )
{

  printf( "\n" );
  printf( "Determining motif member list...\n\n" );

  MEMB_LIST *memb_header = NULL;
  memb_header = (MEMB_LIST *)get_memb_list_from_r_list( memb_header,
    res_header );
    
  printf( "Motif member list done.\n" );

  return get_cluster_list_from_memb_list( clus_header, memb_header );

}














CLUS_LIST *get_cluster_list_from_memb_list( CLUS_LIST *clus_header,
  MEMB_LIST *memb_header )
{

  printf( "Combining GC-rich motifs...\n\n" );

  clus_header = (CLUS_LIST *)get_gc_cluster_list( clus_header, memb_header );
  
  printf( "GC-rich motifs done.\n" );
  
  return get_mf_cluster_list( clus_header, memb_header );

}












CLUS_LIST *get_mf_cluster_list( CLUS_LIST *clus_header, MEMB_LIST *memb_header )
{

  MEMB_LIST *memb = memb_header;
  
  while ( memb != NULL )
    clus_header = (CLUS_LIST *)get_mf_cluster_list_major_loop_and_step( clus_header,
      &memb );

  /*  New in bd:  */
  return merge_dupl_clusters( clus_header );

}












CLUS_LIST *get_mf_cluster_list_major_loop_and_step( CLUS_LIST *clus_header,
  MEMB_LIST **memb )
{

  clus_header = (CLUS_LIST *)get_mf_cluster_list_major_loop( clus_header, *memb );
  
  *memb = (*memb)->next;
  
  return clus_header;

}












CLUS_LIST *get_mf_cluster_list_major_loop( CLUS_LIST *clus_header, 
  MEMB_LIST *major_memb )
{

  if ( major_memb->my_memb->used )
    return clus_header;
    
  if ( major_memb->my_memb->class == CLASS_MF_BIRTH )
    return get_my_mf_cluster_list_major_loop( clus_header, major_memb );
    
  if ( major_memb->my_memb->class == CLASS_MF_DEATH )
    return get_my_mf_cluster_list_major_loop( clus_header, major_memb );
    
  return clus_header;

}














CLUS_LIST *get_my_mf_cluster_list_major_loop( CLUS_LIST *clus_header,
  MEMB_LIST *major_memb )
{

  
  CLUS_LIST *clus = clus_header;
  
  while ( clus != NULL ) {
  
    if ( clus->my_clus->class == major_memb->my_memb->class ) {
    
      int join = 0;
  
      int offset = get_memb_lister_aligned_offset( clus, major_memb, &join );
    
      if ( join ) {
        add_memb_lister_to_cluster( clus, major_memb, offset );
        return clus_header;
      }
    
    }
    
    clus = clus->next;
    
  }
  
  
  return get_mf_cluster_list_major_loop_no_match( clus_header, major_memb );

}








CLUS_LIST *get_mf_cluster_list_major_loop_no_match( CLUS_LIST *clus_header,
  MEMB_LIST *major_memb )
{
  
  CLUS_LIST *create_clus_lister( CLUS_LIST *x );
  
  extern char major_reg;
  
  CLUS_LIST *clus = NULL;
  clus = (CLUS_LIST *)create_clus_lister( clus );
  
  MEMB_LIST *new = NULL;
  new = (MEMB_LIST *)make_memb_lister_copy( major_memb );
  
  set_clus_lister_memb_lister( clus, new );
  
  clus->my_clus->reg = major_reg;
  
  return get_mf_cluster_list_w_major_memb( clus_header, clus, major_memb );

}












CLUS_LIST *get_mf_cluster_list_w_major_memb( CLUS_LIST *clus_header, 
  CLUS_LIST *clus, MEMB_LIST *major_memb )
{

  get_my_mf_cluster_list_w_major_memb( clus, major_memb );
  
  return put_clus_lister_sorted_list( clus_header, clus );

}












void get_my_mf_cluster_list_w_major_memb( CLUS_LIST *clus, MEMB_LIST *major_memb )
{

  void set_clus_lister_cons_seq( CLUS_LIST *clus );

  MEMB_LIST *start_memb = major_memb->next;

  int still_going = 1;
  
  while ( still_going )
    /*  In this file, below:  */
    still_going = update_mf_cluster_w_major_memb( clus, &start_memb );
    
  /*  In cons.c:  */
  set_clus_lister_cons_seq( clus );

}












int update_mf_cluster_w_major_memb( CLUS_LIST *clus, MEMB_LIST **start_memb )
{

  MEMB_LIST *memb = *start_memb;
  
  int join = 0;
  
  while ( memb != NULL ) {
  
//    if ( memb->my_memb->pval >= STRONG_PVAL_THRESH )
      *start_memb = memb;
  
    int offset = get_memb_lister_aligned_offset( clus, memb, &join );
    
    if ( join ) 
      return add_memb_lister_to_cluster( clus, memb, offset );
      
    memb = memb->next;
  
  }
  
  return 0;

}











int add_memb_lister_to_cluster( CLUS_LIST *clus, MEMB_LIST *memb, char offset )
{

  void set_clus_lister_cons_seq( CLUS_LIST *clus );

  MEMB_LIST *new = NULL;
  /*  In this file, below:  */
  new = (MEMB_LIST *)make_memb_lister_copy( memb );
  
  new->my_memb->offset = offset;
  
  /*  In this file, below:  */
  put_memb_lister_sorted_list( clus->my_clus->memb_header, new );
  
  if ( offset < clus->my_clus->min_offset )
    clus->my_clus->min_offset = offset;
    
  if ( offset > clus->my_clus->max_offset )
    clus->my_clus->max_offset = offset;
  
  /*  In cons.c:  */
  set_clus_lister_cons_seq( clus );

  return 1;

}









MEMB_LIST *put_memb_lister_sorted_list( MEMB_LIST *memb_header, MEMB_LIST *memb )
{

  if ( memb_header == NULL )
    return memb;
    
  if ( memb->my_memb->pval < memb_header->my_memb->pval ) {
    memb->next = memb_header;
    return memb;
  }
  
  MEMB_LIST *curr = memb_header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_memb->pval <= memb->my_memb->pval )) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = memb;
    
  memb->next = curr;
  
  return memb_header;

}








int get_memb_lister_aligned_offset( CLUS_LIST *clus, MEMB_LIST *memb, int *join )
{

  if ( memb->my_memb->used )
    return 0;
    
  if ( memb->my_memb->class != clus->my_clus->class )
    return 0;
    
  if ( strcmp( memb->my_memb->node, clus->my_clus->node ))
    return 0;
    
  return get_my_memb_lister_aligned_offset( clus, memb, join );
  
}










int get_my_memb_lister_aligned_offset( CLUS_LIST *clus, MEMB_LIST *memb, int *join )
{

  MEMB_LIST *m = clus->my_clus->memb_header;
  
  while ( m != NULL ) {
  
    if ( memb_listers_match( m, memb )) {
      if ( consensus_seqs_match( clus->my_clus->cons, memb->my_memb->mf->cons )) {
        *join = 1;
        return get_best_memb_lister_offset( clus, memb );
      }
    }
    
    m = m->next;
  
  }
  
  return 0;

}











int memb_listers_match( MEMB_LIST *a, MEMB_LIST *b )
{

  MOTIF *a_mf = a->my_memb->mf, *b_mf = b->my_memb->mf;
  
  int len = a_mf->length;
  
  int i;
  
  for ( i = MIN_SIM - len; i <= len - MIN_SIM; i++ ) {
  
    int j, end = ( i >= 0 ) ? (len) : (len + i);  
    float sim = 0.0;

    for ( j = MAX( 0, i ); j < end; j++ )     
      sim += nucl_pair_identity( a_mf->cons[ j ], b_mf->cons[ j - i ] );
    
    if ( sim >= MIN_SCORE )
      return 1;
  
  }
  
  return 0;

}












int consensus_seqs_match( char a[], char b[] )
{

  float sim = 0.0;
  
  char small[ BUFFER ], large[ BUFFER ];
  
  if ( strlen( a ) < strlen( b )) {
    strcpy( small, a );
    strcpy( large, b );
  }
  else {
    strcpy( small, b );
    strcpy( large, a );
  }
  
  int start = MIN_SIM - strlen( small );
  int end = strlen( large ) - MIN_SIM;
  
  int i;
  
  for ( i = start; i <= end; i++ ) {
  
    int j, end_len = MIN( strlen( small ) + i, strlen( large ) );  
    float sim = 0.0;

    for ( j = MAX( 0, i ); j < end_len; j++ ) 
      sim += consensus_nucl_score( large[ j ], small[ j - i ] );
      
    if ( sim >= CONS_MATCH_THRESH )
      return 1;
  
  }
  
  return 0;

}











float consensus_nucl_score( char a, char b )
{

  int nucl_matches_bp_degen( char nucl, MF bp );
  
  if ( tolower( a ) == tolower( b ))
    return MATCH_SCORE;

  int i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
  
    /*  In ../main/nucl.c:  */
    if ( nucl_matches_bp_degen( a, i ) && nucl_matches_bp_degen( b, i ))
      return MATCH_SCORE;
  
  }
  
  return MISMATCH_PENALTY;

}









int get_best_memb_lister_offset( CLUS_LIST *clus, MEMB_LIST *memb )
{

  int offset_max = 0;
  STAT max_id;
  
  int len = memb->my_memb->mf->length;
  int min = clus->my_clus->min_offset, max = clus->my_clus->max_offset; 
  
  max_id = get_clus_mf_identity_w_offset( clus, memb, 0 );
  
  int i;
  
  for ( i = 1; i <= max + (len - MIN_SIM); i++ ) {
  
    STAT id = get_clus_mf_identity_w_offset( clus, memb, i );
    
    if ( id > max_id ) {
      max_id = id;
      offset_max = i;
    }
  
  }
  
  for ( i = -1; i >= min - (len - MIN_SIM); i-- ) {

    STAT id = get_clus_mf_identity_w_offset( clus, memb, i );

    if ( id > max_id ) {
      max_id = id;
      offset_max = i;    
    }

  }
  
  return offset_max;

}











void get_min_max_offset_clus( CLUS_LIST *clus, int *min, int *max )
{

  *min = *max = 0;

  MEMB_LIST *memb = clus->my_clus->memb_header;
  
  while ( memb != NULL ) {
  
    char offset = memb->my_memb->offset;
    
    if ( offset < *min )
      *min = offset;
    
    if ( offset > *max )
      *max = offset;
      
    memb = memb->next;
  
  }

}







STAT get_clus_mf_identity_w_offset( CLUS_LIST *clus, MEMB_LIST *memb, int offset )
{

  int string_is_repeat( char str[], char length );

  STAT id = 0.0;

  MEMB_LIST *m = clus->my_clus->memb_header;
  
  /*  In ../main/nucl.c:  */
  while (( m != NULL ) && ( m->next != NULL ) &&
    ( string_is_repeat( m->my_memb->mf->cons, 1 ) ||
      string_is_repeat( m->my_memb->mf->cons, 2 )))
  {
    m = m->next;
  }
  
  while ( m != NULL )
    id += get_memb_pair_identity_and_step( memb, &m, offset, m->my_memb->offset );
    
  return id;

}








STAT get_memb_pair_identity_and_step( MEMB_LIST *a, MEMB_LIST **b, char a_offset,
  char b_offset )
{
  STAT id = get_memb_pair_identity( a, *b, a_offset, b_offset ); 
  *b = (*b)->next;
  return id;
}











STAT get_memb_pair_identity( MEMB_LIST *a, MEMB_LIST *b, char a_offset,
  char b_offset )
{

  MOTIF *a_mf = a->my_memb->mf, *b_mf = b->my_memb->mf;

  int len = a->my_memb->mf->length;
  int offset = b_offset - a_offset;
  
  int end = MIN( len, len - offset );
  
  STAT id = 0.0;
  
  int i;
  
  for ( i = MAX( 0, offset ); i < end; i++ ) 
    id += nucl_pair_identity( a_mf->cons[ i + offset ], b_mf->cons[ i ] );
    
  return id;

}









STAT nucl_pair_identity( char a, char b )
{
  return ( a == b ) ? (MATCH_SCORE) : (MISMATCH_PENALTY);
}











/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/










CLUS_LIST *merge_dupl_clusters( CLUS_LIST *clus_header )
{

  CLUS_LIST *clus = clus_header;
  
  while ( clus != NULL )
    merge_dupl_clusters_single_loop_and_step( &clus );
      
  return clus_header;

}









void merge_dupl_clusters_single_loop_and_step( CLUS_LIST **major_clus )
{
  merge_dupl_clusters_single_loop( *major_clus );
  *major_clus = (*major_clus)->next;
}










void merge_dupl_clusters_single_loop( CLUS_LIST *major_clus )
{

  CLUS_LIST *prev = major_clus, *curr = major_clus->next;
  
  while ( curr != NULL )
    merge_dupl_clusters_single_clus_pair_and_step( major_clus, &prev, &curr );

}












void merge_dupl_clusters_single_clus_pair_and_step( CLUS_LIST *major_clus,
  CLUS_LIST **prev, CLUS_LIST **curr )
{

  if ( clusters_have_common_memb( *curr, major_clus )) {
    (*prev)->next = (*curr)->next;
    put_cluster_end_of_down_list( major_clus, *curr );
    *curr = (*prev)->next;
  }
  else {
    *prev = *curr;
    *curr = (*curr)->next;
  }

}












int clusters_have_common_memb( CLUS_LIST *a, CLUS_LIST *b )
{

  MEMB_LIST *memb_a = a->my_clus->memb_header;
  
  int i = 0;
  
  while (( memb_a != NULL ) && ( ++i <= TOP_KMER_DUPL )) {
  
    MEMB_LIST *memb_b = b->my_clus->memb_header;
    
    int j = 0;
    
    while (( memb_b != NULL ) && ( ++j <= TOP_KMER_DUPL )) {
    
      if ( ! strcmp( memb_a->my_memb->mf->cons, memb_b->my_memb->mf->cons ))
        return 1;
        
      memb_b = memb_b->next;
    
    }
    
    memb_a = memb_a->next;
  
  }
  
  return 0;

}











void put_cluster_end_of_down_list( CLUS_LIST *major_clus, CLUS_LIST *clus )
{

  CLUS_LIST *curr = major_clus;
  
  while ( curr->down != NULL )
    curr = curr->down;
    
  curr->down = clus;
  
  clus->next = NULL;

}






/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/











void realign_memb_list_in_clus_lister( CLUS_LIST *clus )
{

  MEMB_LIST *major_memb = clus->my_clus->memb_header->next;
  
  while ( major_memb != NULL )
    realign_memb_list_single_major_memb_and_step( clus, &major_memb );

}













void realign_memb_list_single_major_memb_and_step( CLUS_LIST *clus, 
  MEMB_LIST **major_memb )
{
  realign_memb_list_single_major_memb( clus, *major_memb );
  *major_memb = (*major_memb)->next;
}













void realign_memb_list_single_major_memb( CLUS_LIST *clus, MEMB_LIST *major_memb )
{

  MEMB_LIST *sim_header = NULL;
  sim_header = (MEMB_LIST *)get_similar_memb_list( sim_header, major_memb );
  
  realign_memb_list_w_sim_list( clus, sim_header );
    
  kill_empty_memb_list( sim_header );

}













void realign_memb_list_w_sim_list( CLUS_LIST *clus, MEMB_LIST *sim_header )
{

  int offset = find_best_offset_memb_sublist( clus, sim_header );
  
  if ( offset == 0 )
    return;
    
  update_memb_list_offset( sim_header, offset );
    
  reset_min_max_offset_clus_lister( clus );
  
}











void update_memb_list_offset( MEMB_LIST *header, char offset )
{

  MEMB_LIST *memb = header;
  
  while ( memb != NULL ) {
    memb->my_memb->offset += offset;
    memb = memb->next;
  }
  
}












void reset_min_max_offset_clus_lister( CLUS_LIST *clus )
{

  MEMB_LIST *memb = clus->my_clus->memb_header;
  
  clus->my_clus->min_offset = clus->my_clus->max_offset = 0;
  
  while ( memb != NULL ) {
  
    if ( memb->my_memb->offset < clus->my_clus->min_offset )
      clus->my_clus->min_offset = memb->my_memb->offset;
      
    if ( memb->my_memb->offset > clus->my_clus->max_offset )
      clus->my_clus->max_offset = memb->my_memb->offset;
      
    memb = memb->next;
  
  }

}










int find_best_offset_memb_sublist( CLUS_LIST *clus, MEMB_LIST *sim_header )
{

  int max_diff = 5;
  
  int best_offset = 0;

  STAT max_score = get_score_sublist_offset( clus, sim_header, best_offset );

  int i;
  
  for ( i = -1; i >= -1 * max_diff; i-- ) {
    STAT score = get_score_sublist_offset( clus, sim_header, i );
    if ( score > max_score ) {
      best_offset = i;
      max_score = score;
    }
  }
  
  for ( i = 1; i <= max_diff; i++ ) {
    STAT score = get_score_sublist_offset( clus, sim_header, i );
    if ( score > max_score ) {
      best_offset = i;
      max_score = score;
    }
  }
  
  return best_offset;

}












STAT get_score_sublist_offset( CLUS_LIST *clus, MEMB_LIST *sim_header, int offset )
{

  update_memb_list_offset( sim_header, offset );
  
  STAT score = 0.0;
  
  MEMB_LIST *memb = clus->my_clus->memb_header;
  
  while ( memb != NULL )
    score += get_memb_lister_score_clus_and_step( &memb, clus );
    
  update_memb_list_offset( sim_header, offset * -1 );
  
  return score;

}














STAT get_memb_lister_score_clus_and_step( MEMB_LIST **memb, CLUS_LIST *clus )
{

  STAT score = get_memb_lister_score_clus( *memb, clus );
  
  *memb = (*memb)->next;
  
  return score;

}













STAT get_memb_lister_score_clus( MEMB_LIST *memb, CLUS_LIST *clus )
{

  STAT score = 0.0;
  
  MEMB_LIST *m = clus->my_clus->memb_header;
  
  while ( m != NULL )
    /*  In this file, above:  */
    score += get_memb_pair_score_and_step( memb, &m );
      
  return score;

}












STAT get_memb_pair_score_and_step( MEMB_LIST *a, MEMB_LIST **b )
{

  STAT score = get_memb_pair_score( a, *b );
  
  *b = (*b)->next;
  
  return score;

}











STAT get_memb_pair_score( MEMB_LIST *a, MEMB_LIST *b )
{

  MOTIF *a_mf = a->my_memb->mf, *b_mf = b->my_memb->mf;

  int len = a->my_memb->mf->length;
  int offset = b->my_memb->offset - a->my_memb->offset;
  
  int end = MIN( len, len - offset );
  
  STAT id = 0.0;
  
  int i;
  
  for ( i = MAX( 0, offset ); i < end; i++ ) 
    id += ( a_mf->cons[ i + offset ] == b_mf->cons[ i ] ) ? (MATCH_SCORE) 
      : (-2.0);
      
  return id;
    
}






MEMB_LIST *get_similar_memb_list( MEMB_LIST *sim_header, MEMB_LIST *major_memb )
{

  MEMB_LIST *memb = major_memb;
  
  while ( memb != NULL )
    sim_header = (MEMB_LIST *)get_similar_memb_single_memb_and_step( sim_header,
      &memb, major_memb );
      
  return sim_header;

}











MEMB_LIST *get_similar_memb_single_memb_and_step( MEMB_LIST *sim_header,
  MEMB_LIST **memb, MEMB_LIST *major_memb )
{

  sim_header = (MEMB_LIST *)get_similar_memb_single_memb( sim_header, *memb,
    major_memb );
  
  *memb = (*memb)->next;
  
  return sim_header;

}










MEMB_LIST *get_similar_memb_single_memb( MEMB_LIST *sim_header, MEMB_LIST *memb,
  MEMB_LIST *major_memb )
{

  MEMB_LIST *create_empty_memb_lister( MEMB_LIST *x );
  
  if ( cons_id_memb_lister_pair( memb, major_memb ) < MIN_SIM )
    return sim_header;
    
  MEMB_LIST *new = NULL;
  new = (MEMB_LIST *)create_empty_memb_lister( new );
  
  new->my_memb = memb->my_memb;
  
  return put_memb_lister_end_of_list( sim_header, new );

}










int cons_id_memb_lister_pair( MEMB_LIST *a, MEMB_LIST *b )
{

  MOTIF *a_mf = a->my_memb->mf, *b_mf = b->my_memb->mf;

  int offset = b->my_memb->offset - a->my_memb->offset;
  int len = a_mf->length;
  int end = MIN( len, len - offset );
  
  int id = 0;
  
  int i;
  
  for ( i = MAX( 0, offset ); i < end; i++ ) 
    id += ( a_mf->cons[ i ] == b_mf->cons[ i + offset ] ) ? (1) : (0);
  
  return id;

}







/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/











CLUS_LIST *get_gc_cluster_list( CLUS_LIST *clus_header, MEMB_LIST *memb_header )
{

  MEMB_LIST *memb = memb_header;
  
  while ( memb != NULL )
    clus_header = (CLUS_LIST *)get_gc_cluster_single_memb_and_step( clus_header,
      &memb );
      
  return clus_header;

}












CLUS_LIST *get_gc_cluster_single_memb_and_step( CLUS_LIST *clus_header,
  MEMB_LIST **memb )
{

  clus_header = (CLUS_LIST *)get_gc_cluster_single_memb( clus_header, *memb );
  
  *memb = (*memb)->next;
  
  return clus_header;

}











CLUS_LIST *get_gc_cluster_single_memb( CLUS_LIST *clus_header, MEMB_LIST *memb )
{

  if ( memb->my_memb->class != CLASS_GC )
    return clus_header;
    
  CLUS_LIST *clus = NULL;
  
  clus = (CLUS_LIST *)get_gc_clus_lister_w_label_class( clus_header, 
    memb->my_memb->node );
    
  if ( clus == NULL )
    return make_and_put_new_clus_lister( clus_header, memb );
    
  MEMB_LIST *new = NULL;
  new = (MEMB_LIST *)make_memb_lister_copy( memb );
  
  put_memb_lister_end_of_list( clus->my_clus->memb_header, new );
  
  return clus_header;

}












CLUS_LIST *get_gc_clus_lister_w_label_class( CLUS_LIST *clus_header, char node[] )
{

  CLUS_LIST *clus = clus_header;
  
  while ( clus != NULL ) {
  
    if ( clus->my_clus->class == CLASS_GC ) {
      if ( ! strcmp( clus->my_clus->node, node ))
        return clus;
    }
    
    clus = clus->next;
  
  }
  
  return NULL;

}









CLUS_LIST *make_and_put_new_clus_lister( CLUS_LIST *clus_header, MEMB_LIST *memb )
{

  CLUS_LIST *create_clus_lister( CLUS_LIST *x );
  
  CLUS_LIST *clus = NULL;
  clus = (CLUS_LIST *)create_clus_lister( clus );
  
  MEMB_LIST *new = NULL;
  new = (MEMB_LIST *)make_memb_lister_copy( memb );
  
  set_clus_lister_memb_lister( clus, new );
  
  return put_clus_lister_sorted_list( clus_header, clus );

}












void set_clus_lister_memb_lister( CLUS_LIST *clus, MEMB_LIST *memb )
{

  void set_clus_lister_cons_seq( CLUS_LIST *clus );

  strcpy( clus->my_clus->node, memb->my_memb->node );
  
  clus->my_clus->memb_header = memb;
  clus->my_clus->pval = memb->my_memb->pval;
  clus->my_clus->class = memb->my_memb->class;
  
  /*  In cons.c:  */
  set_clus_lister_cons_seq( clus );

}











CLUS_LIST *put_clus_lister_sorted_list( CLUS_LIST *clus_header, 
  CLUS_LIST *clus )
{

  if ( clus_header == NULL )
    return clus;
    
  if ( clus->my_clus->pval < clus_header->my_clus->pval ) {
    clus->next = clus_header;
    return clus;
  }
  
  CLUS_LIST *curr = clus_header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_clus->pval < clus->my_clus->pval )) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = clus;
    
  clus->next = curr;
  
  return clus_header;

}








/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/












MEMB_LIST *make_memb_lister_copy( MEMB_LIST *memb )
{

  MEMB_LIST *create_memb_lister( MEMB_LIST *x );
  
  MEMB_LIST *new = NULL;
  new = (MEMB_LIST *)create_memb_lister( new );
  
  memb->my_memb->used = 1;
  
  copy_memb_lister( new, memb );
  
  return new;

}







void copy_memb_lister( MEMB_LIST *a, MEMB_LIST *b )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *m, MOTIF *mf, INDEX xx );
  void copy_models( MODEL_LIST *a, MODEL_LIST *b );
  
  MODEL_LIST *model = NULL;
  model = (MODEL_LIST *)create_model_lister( model, b->my_memb->mf, 
    b->my_memb->model->my_model->m );

  *(a->my_memb->mf) = *(b->my_memb->mf);
  
  strcpy( a->my_memb->node, b->my_memb->node );
  
  a->my_memb->offset = b->my_memb->offset;
  a->my_memb->pval = b->my_memb->pval;
  a->my_memb->class = b->my_memb->class;
  a->my_memb->used = b->my_memb->used;
  
  copy_models( model, b->my_memb->model );
  
  a->my_memb->model = model;

}









MEMB_LIST *put_memb_lister_end_of_list( MEMB_LIST *memb_header, MEMB_LIST *memb )
{

  if ( memb_header == NULL )
    return memb;

  MEMB_LIST *curr = memb_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = memb;
  
  return memb_header;

}











/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/












MEMB_LIST *get_memb_list_from_r_list( MEMB_LIST *memb_header, 
  RESULT_LIST *r_header )
{

  RESULT_LIST *res = r_header;
  
  while ( res != NULL ) 
    memb_header = (MEMB_LIST *)get_memb_lister_r_lister_and_step( memb_header, 
      &res );

  return memb_header;
  
}











MEMB_LIST *get_memb_lister_r_lister_and_step( MEMB_LIST *memb_header,
  RESULT_LIST **res )
{

  memb_header = (MEMB_LIST *)get_memb_lister_r_lister( memb_header, *res );
  
  *res = (*res)->next;
  
  return memb_header;

}











MEMB_LIST *get_memb_lister_r_lister( MEMB_LIST *memb_header, RESULT_LIST *res )
{

  if (( res == NULL ) || ( res->my_result->model_header == NULL ))
    return memb_header;
    
  return get_my_memb_lister_r_lister( memb_header, res );
  
}











MEMB_LIST *get_my_memb_lister_r_lister( MEMB_LIST *memb_header, RESULT_LIST *res )
{

  MODEL_LIST *model = res->my_result->model_header;

  do {
  
    memb_header = (MEMB_LIST *)get_and_put_memb_lister_model_and_step( memb_header,
      &model );
  
  } while (( model != NULL ) && ( model->my_model->stats->pval < PVAL_THRESH ));    
  
  return memb_header;

}










MEMB_LIST *get_and_put_memb_lister_model_and_step( MEMB_LIST *memb_header,
  MODEL_LIST **model )
{

  memb_header = (MEMB_LIST *)get_and_put_memb_lister_model( memb_header, *model );
  
  *model = (*model)->down;
  
  return memb_header;
  
}










MEMB_LIST *get_and_put_memb_lister_model( MEMB_LIST *memb_header, 
  MODEL_LIST *model )
{

  MEMB_LIST *create_memb_lister( MEMB_LIST *x ); 
  
  MEMB_LIST *memb = NULL;
  memb = (MEMB_LIST *)create_memb_lister( memb );
  
  set_memb_lister_model_lister( memb, model );
  
  return put_memb_lister_into_sorted_list( memb_header, memb );
  
}












MEMB_LIST *put_memb_lister_into_sorted_list( MEMB_LIST *memb_header, 
  MEMB_LIST *memb )
{

  if ( memb_header == NULL )
    return memb;
    
  if ( memb->my_memb->pval < memb_header->my_memb->pval ) {
    memb->next = memb_header;
    return memb;
  }
  
  MEMB_LIST *curr = memb_header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_memb->pval <= memb->my_memb->pval )) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = memb;
    
  memb->next = curr;
  
  return memb_header;

}









void set_memb_lister_model_lister( MEMB_LIST *memb, MODEL_LIST *model )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX mm );
  void copy_models( MODEL_LIST *a, MODEL_LIST *b );

  MODEL_LIST *m = NULL;
  m = (MODEL_LIST *)create_model_lister( m, model->my_model->mf,
    model->my_model->m );
    
  /*  In ../birth/model_set.c:  */
  copy_models( m, model );

  *(memb->my_memb->mf) = *(model->my_model->mf);
  
  strcpy( memb->my_memb->node, model->my_model->stats->node_label );
  
  /*  In this file, below:  */
  memb->my_memb->class = get_memb_lister_alpha( model );
  
  memb->my_memb->pval = model->my_model->stats->pval;
  
  memb->my_memb->model = m;

}











char get_memb_lister_alpha( MODEL_LIST *model )
{

  PART_LIST *a = model->my_model->part_header;
  
  if ( a == NULL )
    return CLASS_NONE;
    
  if ( model->my_model->stats->pval >= PVAL_THRESH )
    return CLASS_NON_SIG;  
    
  PART_LIST *b = model->my_model->part_header->next;
  
  if ( b == NULL )
    return CLASS_NON_SIG;
    
  if ( model_is_gc_motif( model ))
    return CLASS_GC;
    
  PARAMS *pa = a->my_part->pp, *pb = b->my_part->pp;
    
  STAT ratio = (pb->a / pb->b) / (pa->a / pa->b);
  
  return ( ratio >= 1.0 ) ? (CLASS_MF_BIRTH) : (CLASS_MF_DEATH);

}












int model_is_gc_motif( MODEL_LIST *model )
{

  if ( ! label_is_gc_lineage( model->my_model->stats->node_label ))
    return 0;
    
  MOTIF *mf = model->my_model->mf;  
    
  int i, at = 0;
  
  for ( i = 0; i < mf->length; i++ ) {
  
    char c = tolower( mf->cons[ i ] );
    
    at += (( c == 'a' ) || ( c == 't' )) ? (1) : (0);
  
    if ( at > 1 )
      return 0;
    
  }
  
  return 1;

}











int label_is_gc_lineage( char label[] )
{

  if ( ! strcmp( label, "canFam2" ))
    return 1;
    
  if ( ! strcmp( label, "oryCun2" ))
    return 1;
  
  /*  
  if ( ! strcmp( label, "Catarrhini" ))
    return 1;
    
  if ( ! strcmp( label, "Simiiformes" ))
    return 1;
  */  
  return 0;

}








