














#include "../ext/struct.h"








CLUS_LIST *get_cluster_list_from_r_list( CLUS_LIST *clus_header,
  RESULT_LIST *res_header );

CLUS_LIST *get_cluster_list_from_memb_list( CLUS_LIST *clus_header,
  MEMB_LIST *memb_header );

CLUS_LIST *get_mf_cluster_list( CLUS_LIST *clus_header, MEMB_LIST *memb_header );

CLUS_LIST *get_mf_cluster_list_major_loop_and_step( CLUS_LIST *clus_header,
  MEMB_LIST **memb );

CLUS_LIST *get_mf_cluster_list_major_loop( CLUS_LIST *clus_header, 
  MEMB_LIST *major_memb );

CLUS_LIST *get_my_mf_cluster_list_major_loop( CLUS_LIST *clus_header,
  MEMB_LIST *major_memb );

CLUS_LIST *get_mf_cluster_list_major_loop_no_match( CLUS_LIST *clus_header,
  MEMB_LIST *major_memb );

CLUS_LIST *get_mf_cluster_list_w_major_memb( CLUS_LIST *clus_header, 
  CLUS_LIST *clus, MEMB_LIST *major_memb );

void get_my_mf_cluster_list_w_major_memb( CLUS_LIST *clus, MEMB_LIST *major_memb );

int update_mf_cluster_w_major_memb( CLUS_LIST *clus, MEMB_LIST **start_memb );

int add_memb_lister_to_cluster( CLUS_LIST *clus, MEMB_LIST *memb, char offset );

MEMB_LIST *put_memb_lister_sorted_list( MEMB_LIST *memb_header, MEMB_LIST *memb );

int get_memb_lister_aligned_offset( CLUS_LIST *clus, MEMB_LIST *memb, int *join );

int get_my_memb_lister_aligned_offset( CLUS_LIST *clus, MEMB_LIST *memb, int *join );

int memb_listers_match( MEMB_LIST *a, MEMB_LIST *b );

int consensus_seqs_match( char a[], char b[] );

float consensus_nucl_score( char a, char b );

int get_best_memb_lister_offset( CLUS_LIST *clus, MEMB_LIST *memb );

void get_min_max_offset_clus( CLUS_LIST *clus, int *min, int *max );

STAT get_clus_mf_identity_w_offset( CLUS_LIST *clus, MEMB_LIST *memb, int offset );

STAT get_memb_pair_identity_and_step( MEMB_LIST *a, MEMB_LIST **b, char a_offset,
  char b_offset );

STAT get_memb_pair_identity( MEMB_LIST *a, MEMB_LIST *b, char a_offset,
  char b_offset );

STAT nucl_pair_identity( char a, char b );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/



CLUS_LIST *merge_dupl_clusters( CLUS_LIST *clus_header );

void merge_dupl_clusters_single_loop_and_step( CLUS_LIST **major_clus );

void merge_dupl_clusters_single_loop( CLUS_LIST *major_clus );

void merge_dupl_clusters_single_clus_pair_and_step( CLUS_LIST *major_clus,
  CLUS_LIST **prev, CLUS_LIST **curr );

int clusters_have_common_memb( CLUS_LIST *a, CLUS_LIST *b );

void put_cluster_end_of_down_list( CLUS_LIST *major_clus, CLUS_LIST *clus );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/



void realign_memb_list_in_clus_lister( CLUS_LIST *clus );

void realign_memb_list_single_major_memb_and_step( CLUS_LIST *clus, 
  MEMB_LIST **major_memb );

void realign_memb_list_single_major_memb( CLUS_LIST *clus, MEMB_LIST *major_memb );

void realign_memb_list_w_sim_list( CLUS_LIST *clus, MEMB_LIST *sim_header );

void update_memb_list_offset( MEMB_LIST *header, char offset );

void reset_min_max_offset_clus_lister( CLUS_LIST *clus );

int find_best_offset_memb_sublist( CLUS_LIST *clus, MEMB_LIST *sim_header );

STAT get_score_sublist_offset( CLUS_LIST *clus, MEMB_LIST *sim_header, int offset );

STAT get_memb_lister_score_clus_and_step( MEMB_LIST **memb, CLUS_LIST *clus );

STAT get_memb_lister_score_clus( MEMB_LIST *memb, CLUS_LIST *clus );

STAT get_memb_pair_score_and_step( MEMB_LIST *a, MEMB_LIST **b );

STAT get_memb_pair_score( MEMB_LIST *a, MEMB_LIST *b );

MEMB_LIST *get_similar_memb_list( MEMB_LIST *sim_header, MEMB_LIST *major_memb );

MEMB_LIST *get_similar_memb_single_memb_and_step( MEMB_LIST *sim_header,
  MEMB_LIST **memb, MEMB_LIST *major_memb );

MEMB_LIST *get_similar_memb_single_memb( MEMB_LIST *sim_header, MEMB_LIST *memb,
  MEMB_LIST *major_memb );

int cons_id_memb_lister_pair( MEMB_LIST *a, MEMB_LIST *b );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/



CLUS_LIST *get_gc_cluster_list( CLUS_LIST *clus_header, MEMB_LIST *memb_header );

CLUS_LIST *get_gc_cluster_single_memb_and_step( CLUS_LIST *clus_header,
  MEMB_LIST **memb );

CLUS_LIST *get_gc_cluster_single_memb( CLUS_LIST *clus_header, MEMB_LIST *memb );

CLUS_LIST *get_gc_clus_lister_w_label_class( CLUS_LIST *clus_header, char node[] );

CLUS_LIST *make_and_put_new_clus_lister( CLUS_LIST *clus_header, MEMB_LIST *memb );

void set_clus_lister_memb_lister( CLUS_LIST *clus, MEMB_LIST *memb );

CLUS_LIST *put_clus_lister_sorted_list( CLUS_LIST *clus_header, 
  CLUS_LIST *clus );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/


MEMB_LIST *make_memb_lister_copy( MEMB_LIST *memb );

void copy_memb_lister( MEMB_LIST *a, MEMB_LIST *b );

MEMB_LIST *put_memb_lister_end_of_list( MEMB_LIST *memb_header, MEMB_LIST *memb );



/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/


  
MEMB_LIST *get_memb_list_from_r_list( MEMB_LIST *memb_header, 
  RESULT_LIST *r_header );

MEMB_LIST *get_memb_lister_r_lister_and_step( MEMB_LIST *memb_header,
  RESULT_LIST **res );

MEMB_LIST *get_memb_lister_r_lister( MEMB_LIST *memb_header, RESULT_LIST *res );

MEMB_LIST *get_my_memb_lister_r_lister( MEMB_LIST *memb_header, RESULT_LIST *res );

MEMB_LIST *get_and_put_memb_lister_model_and_step( MEMB_LIST *memb_header,
  MODEL_LIST **model );

MEMB_LIST *get_and_put_memb_lister_model( MEMB_LIST *memb_header, 
  MODEL_LIST *model );

MEMB_LIST *put_memb_lister_into_sorted_list( MEMB_LIST *memb_header, 
  MEMB_LIST *memb );

void set_memb_lister_model_lister( MEMB_LIST *memb, MODEL_LIST *model );

char get_memb_lister_alpha( MODEL_LIST *model );

int model_is_gc_motif( MODEL_LIST *model );
  
int label_is_gc_lineage( char label[] );












