#include "get_rlist.h"














#define MAX_WIND 2000
#define WIND_STEP 10










RESULT_LIST *get_result_list( RESULT_LIST *res_header, TREE *tree, MOTIF *mf )
{

  int min_rank = 0, max_rank;
  
  while ( result_file_present( &min_rank, &max_rank )) {
  
    res_header = (RESULT_LIST *)update_result_list_single_file( res_header,
      tree, min_rank, max_rank, mf );
      
    min_rank = max_rank;
      
  } 
  
  return res_header;

}














int result_file_present( int *min_rank, int *max_rank )
{

  extern char input_file[ BUFFER ];
  extern int reg_start, reg_end;
  
  for ( *max_rank = *min_rank + MAX_WIND; *max_rank >= *min_rank + WIND_STEP; 
    *max_rank -= WIND_STEP ) 
  {
    
    char fname[ BUFFER ];
    
    sprintf( fname, "%s.kmerRes_%d:%d_%d:%d.out", input_file,
      reg_start, reg_end, *min_rank, *max_rank );
    
    FILE *fh = NULL;
    fh = (FILE *)fopen( fname, "r" );
    
    if ( fh != NULL ) {
  
      fclose( fh );
  
      return 1;
  
    }
    
  }
  
  return 0;

}













RESULT_LIST *update_result_list_single_file( RESULT_LIST *res_header, TREE *tree, 
  int min_rank, int max_rank, MOTIF *mf )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  extern int reg_start, reg_end;
  extern char input_file[ BUFFER ];
  
  char fname[ BUFFER ];
  
  sprintf( fname, "%s.kmerRes_%d:%d_%d:%d", input_file, 
    reg_start, reg_end, min_rank, max_rank );
  
  FILE *all_fh = NULL, *sum_fh = NULL;
  all_fh = (FILE *)open_text_file_reading( fname, "out" );
  sum_fh = (FILE *)open_text_file_reading( fname, "sum" );
  
  printf( "fname = %s\n", fname );
  
  res_header = (RESULT_LIST *)update_result_list_chip_w_fh( res_header, tree, mf,
    fname, min_rank, max_rank, sum_fh, all_fh );
    
  close_file( sum_fh );
  close_file( all_fh );
  
  return res_header;

}













RESULT_LIST *update_result_list_chip_w_fh( RESULT_LIST *res_header, TREE *tree,
  MOTIF *mf, char fname[], int min_rank, int max_rank, FILE *sum_fh, FILE *all_fh )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  extern int top_rank;
  
  MF mf_array[ NUMB_OF_WORDS ];
  
  FILE *mf_fh = NULL;
  mf_fh = (FILE *)open_binary_file_reading( input_file, "m" );
  
  get( mf_array, sizeof(MF) * top_rank, mf_fh );
  
  close_file( mf_fh );
  
  return update_my_result_list_chip_w_fh( res_header, mf_array, tree, mf, fname, 
    min_rank, max_rank, sum_fh, all_fh );

}









RESULT_LIST *update_my_result_list_chip_w_fh( RESULT_LIST *res_header, 
  MF mf_array[], TREE *tree, MOTIF *mf, char fname[], int min_rank, int max_rank,
  FILE *sum_fh, FILE *all_fh )
{

  int i;
  
  for ( i = min_rank; i < max_rank; i++ )
    /*  In this file, below:  */
    res_header = (RESULT_LIST *)update_result_list_chip_single_word( res_header,
      tree, mf, mf_array[ i ], fname, sum_fh, all_fh );
      
  return res_header;

}












RESULT_LIST *update_result_list_chip_single_word( RESULT_LIST *res_header, 
  TREE *tree, MOTIF *mf, MF w, char fname[], FILE *sum_fh, FILE *all_fh )
{

  int motif_matches_stack( MOTIF *mf, MF stack );
  
  /*  In ../main/nucl.c:  */
  if ( motif_matches_stack( mf, w ) && ( ! stack_in_result_list( res_header, w ))) 
    /*  In this file, below:  */    
    return update_my_result_list_chip_single_word( res_header, tree, mf, w, 
      fname, sum_fh, all_fh );
  
  return res_header;

}











int stack_in_result_list( RESULT_LIST *res_header, MF w )
{

  RESULT_LIST *res = res_header;
  
  while ( res != NULL ) {
  
    if ( res->my_result->mf->my_motif == w )
      return 1;
      
    res = res->next;
  
  }
  
  return 0;

}








RESULT_LIST *update_my_result_list_chip_single_word( RESULT_LIST *res_header,
  TREE *tree, MOTIF *mf, MF w, char fname[], FILE *sum_fh, FILE *all_fh )
{

  void get_string_from_stack( char cons[], MF stack, char length );
  
  MOTIF mf_holder = *mf;
  
  /*  In ../main/nucl.c:  */
  get_string_from_stack( mf->cons, w, mf->length );
  mf->my_motif = w;
  
  /*  In this file, below:  */
  if ( motif_in_sum_fh( mf, sum_fh ))
    /*  In this file, below:  */
    res_header = (RESULT_LIST *)get_and_put_result_lister_chip( res_header,
      tree, mf, fname, all_fh );
    
  *mf = mf_holder;
  
  return res_header;

}











int motif_in_sum_fh( MOTIF *mf, FILE *sum_fh )
{

  set_position( 0, sum_fh );
  
  char line[ BUFFER ], cons[ BUFFER ];
  
  while ( fgets( line, BUFFER, sum_fh ) != NULL ) {
  
    sscanf( line, "%s", cons );
    
    if ( ! strcmp( cons, mf->cons ))
      return 1;
  
  }
  
  return 0;

}








RESULT_LIST *get_and_put_result_lister_chip( RESULT_LIST *res_header, TREE *tree,
  MOTIF *mf, char fname[], FILE *in )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *r );
  RESULT_LIST *put_result_lister_end_of_list( RESULT_LIST *r_header, 
    RESULT_LIST *r );
  
  RESULT_LIST *res = NULL;
  res = (RESULT_LIST *)create_result_lister( res );
  
  set_position( 0, in );
  
  /*  In this file, below:  */
  set_result_lister_chip( res, tree, mf, in );
  
  if ( res->my_result->use ) {
  
    char file[ BUFFER ];
    /*  In this file, below:  */
    get_file_only_name( file, fname );
  
    printf( "Found mf :  %s   '%s'\n", mf->cons, file );
  
    /*  In r_list.c:  */
    return put_result_lister_end_of_list( res_header, res );
  
  }
    
  kill_result_lister( res );
  
  return res_header;

}








void get_file_only_name( char file[], char fname[] )
{

  int i, index = 0;
  
  for ( i = 0; i < strlen( fname ); i++ ) {
    if ( fname[ i ] == '/' )
      index = i;
  }
  
  strcpy( file, fname + index + 1 );

}








void set_result_lister_chip( RESULT_LIST *res, TREE *tree, MOTIF *mf, FILE *in )
{

  void set_my_result_lister_model_lists( RESULT_LIST *r, TREE *tree, MOTIF *mf, 
    FILE *fh );

  RESULT *rr = res->my_result;

  *(rr->mf) = *mf;
  
  rr->model_header = NULL;
  rr->my_model = NULL;
  rr->null_model = NULL;
  rr->pval = 1.0;
  rr->m = 0;
  rr->use = 0;

  /*  In r_list.c:  */
  set_my_result_lister_model_lists( res, tree, mf, in );

}














RESULT_LIST *put_result_lister_end_of_list( RESULT_LIST *res_header, 
  RESULT_LIST *res )
{

  if ( res_header == NULL )
    return res;
    
  RESULT_LIST *curr = res_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = res;
  
  return res_header;

}









/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/

















void set_my_result_lister_model_lists( RESULT_LIST *res, TREE *tree, MOTIF *mf, 
  FILE *fh )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL ) {
  
    if ( line[ 0 ] == '>' ) {
      if ( output_line_matches_mf( line, mf )) {
        set_result_lister_model_lists_entry( res, tree, mf, fh );
        return;
      }
    }
  
  }

}













int output_line_matches_mf( char line[], MOTIF *mf )
{

  int strs_match( char a[], char b[] );
  
  char str[ BUFFER ], cons[ BUFFER ];
  int d;
  
  sscanf( line, "%*s%s%s%d", str, cons, &d );
  
  if ( strcmp( str, "Motif:" ))
    error( 7100, "Incorrect entry format.\n" );
    
  /*  In ../main/nucl.c:  */  
  if ( strs_match( cons, mf->cons )) {
    if ( mf->my_motif != d ) 
      error( 7101, "Unmatching stack value.\n" );
    return 1;
  }
  
  return 0;

}












void set_result_lister_model_lists_entry( RESULT_LIST *r, TREE *tree, MOTIF *mf, 
  FILE *fh )
{

  /*
  MODEL_LIST *get_null_model_from_output( MODEL_LIST *null_model, TREE *tree,
    MOTIF *mf, FILE *fh );
  */
  MODEL_LIST *get_all_model_list_from_output( MODEL_LIST *model_header, TREE *tree,
    MOTIF *mf, FILE *fh );
  
  
  RESULT *rr = r->my_result;

  /*  In read_model.c:  */
  rr->model_header = (MODEL_LIST *)get_all_model_list_from_output( NULL, tree,
    mf, fh );
    
  
    
  rr->null_model = rr->model_header;
    
  if (( rr->model_header != NULL ) && ( rr->null_model != NULL ))
    rr->use = 1;

}














