#include "format.h"













#define READ_ONLY 0 














void do_formatting( void )
{
  
  void do_chip_to_gencoord_files( void );
  void do_chip_seq_files( void );
  void do_region_binary_format( void );

  extern char minor_mode;
  
//  error( 1, "Removed formatting possibility.  Update format.c.\n" );
  
  switch ( minor_mode ) {
  
  case '\0' :
    do_format_seq_file();
    break;
    
  /*  Previous :
  case 'a' :
    /*  In gen_coord.c:  
    do_fasta_to_gencoord_files();
    break;
 
  case 'b' :
    /*  In gen_coord.c:  
    do_maf_alignment_condensing();
    break;
    
  case 'c' :
    /*  In extract.c:  
    do_maf_alignment_extraction();
    break;
  */ 

  /*
  case 'a' :
    /*  In chip.c:  
    do_chip_to_gencoord_files();
    break;
    
  case 'b' :
    /*  In chip.c:  
    do_chip_seq_files();
    break;
  
  case 'c' :
    /*  In ft_new.c:  
    do_region_new_binary_format();
    break;
    
    /*  In ft.c:  
    do_region_binary_format();
    break;
    
  case 'm' :
    /*  In mf_align.c:  
    do_mf_align();
    break;
    
  case 'z' :
    /*  In chip.c:  
    do_region_chip_gencoord();
    break;
    
  */
  
  default :
    error( 1000, "Unrecognized minor mode passed to formatting function.\n" );
    break;
  
  }

}














/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/













void do_format_seq_file( void )
{

  extern MOTIF major_motif;

  do_my_format_seq_file( &major_motif );
  
}











void do_my_format_seq_file( MOTIF *mf )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_binary_file_writing( char a[], char b[] );
  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char seq_align_file[ BUFFER ], input_file[ BUFFER ];
  extern char region_file[ BUFFER ];
  
  FILE *seq_fh = NULL, *reg_fh = NULL;
  FILE *ft_fh = NULL, *ind_fh = NULL, *mf_fh = NULL, *spec_fh = NULL;
  FILE *fpos_fh = NULL, *ss_fh = NULL;
  
  seq_fh = (FILE *)open_text_file_reading( seq_align_file, "" );
  reg_fh = (FILE *)open_text_file_reading( region_file, "" );

  spec_fh = (FILE *)open_binary_file_writing( input_file, "x" );

  if ( ! READ_ONLY ) {  
    ft_fh = (FILE *)open_binary_file_writing( input_file, "f" );
    ind_fh = (FILE *)open_binary_file_writing( input_file, "i" );
    mf_fh = (FILE *)open_binary_file_writing( input_file, "m" );
    fpos_fh = (FILE *)open_binary_file_writing( input_file, "p" );
    ss_fh = (FILE *)open_binary_file_writing( input_file, "s" );  
  }
  
  do_format_seq_file_w_fhs( mf, seq_fh, reg_fh, ft_fh, ind_fh, mf_fh,
    fpos_fh, spec_fh, ss_fh );
  
  close_file( seq_fh );
  close_file( reg_fh );
  
  close_file( spec_fh );

  if ( ! READ_ONLY ) {  
    close_file( ft_fh );
    close_file( ind_fh );
    close_file( mf_fh );
    close_file( fpos_fh );
    close_file( ss_fh );
  }
  
}












void do_format_seq_file_w_fhs( MOTIF *mf, FILE *seq_fh, FILE *reg_fh,
  FILE *ft_fh, FILE *ind_fh, FILE *mf_fh, FILE *fpos_fh, FILE *spec_fh, 
  FILE *ss_fh )
{

  TREE *make_and_set_tree( TREE *tree );
  
  TREE *tree = NULL;
  /*  In ../tree/create_tree.c:  */
  tree = (TREE *)make_and_set_tree( tree );
  
  /*  In this file, below:  */
  set_spec_cell_binary_file( tree, spec_fh );
  
  /*  In this file, below:  */
  do_format_seq_file_w_tree( tree, mf, seq_fh, reg_fh, ft_fh, ind_fh, mf_fh, 
    fpos_fh, spec_fh, ss_fh );
  
  /*  In ../tree/create_tree.c:  */
  kill_tree( tree );

}











void set_spec_cell_binary_file( TREE *tree, FILE *spec_fh )
{

  SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n );
  
  SPEC_CELL *spec_cell = NULL;
  
  INDEX n = get_numb_leaves_from_tree( tree );
  
  spec_cell = (SPEC_CELL *)create_spec_cell( spec_cell, n );
    
  NODE_LIST *node = tree->spec_header;
  
  int i = 0;
  
  while ( node != NULL ) {
    
    if ( node->my_node->leaf ) {
      strcpy( (spec_cell->x + i)->spec, node->my_node->label );
      (spec_cell->x + i)->numb = i;
      ++i;
    }
    
    node = node->next;
    
  }
  
  put( &n, sizeof(INDEX), spec_fh );
  put( spec_cell->x, sizeof(SPEC) * n, spec_fh );
  
  fflush( spec_fh );

}











int get_numb_leaves_from_tree( TREE *tree )
{

  NODE_LIST *node = tree->spec_header;
  
  int x = 0;
  
  while ( node != NULL ) {
  
    x += node->my_node->leaf;
    
    node = node->next;
  
  }
  
  return x;

}














void do_format_seq_file_w_tree( TREE *tree, MOTIF *mf, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *ind_fh, FILE *mf_fh, FILE *fpos_fh, FILE *spec_fh, 
  FILE *ss_fh )
{

  void do_binary_ft( MOTIF_LIST *mf_header, TREE *tree, FILE *seq_fh, FILE *reg_fh, 
    FILE *ft_fh, FILE *ind_fh, FILE *mf_fh, FILE *fpos_fh, FILE *spec_fh, 
    FILE *ss_fh );

  MOTIF_LIST *mf_header = NULL;
  
  /*  In ft.c:  */
  do_binary_ft( mf_header, tree, seq_fh, reg_fh, ft_fh, ind_fh, mf_fh, fpos_fh,
    spec_fh, ss_fh );

}













/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/


























