









#include "../ext/struct.h"











void do_binary_ft( MOTIF_LIST *mf_header, TREE *tree, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *ind_fh, FILE *mf_fh, FILE *fpos_fh, FILE *spec_fh, 
  FILE *ss_fh );

MOTIF_LIST *get_empty_align_seq_mf_list( MOTIF_LIST *align_header, FILE *fh );

MOTIF_LIST *get_empty_align_seq_mf_list_w_spec_cell( MOTIF_LIST *align_header,
  SPEC_CELL *spec_cell );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void do_my_binary_ft( MOTIF_LIST *align_header, MOTIF_LIST *mf_header, TREE *tree,
  FILE *seq_fh, FILE *reg_fh, FILE *ft_fh, FILE *ind_fh, FILE *mf_fh, 
  FILE *fpos_fh, FILE *ss_fh );

void print_mf_list_stdout( MOTIF_LIST *mf_header );

MOTIF_LIST *get_motif_freq_list( MOTIF_LIST *mf_header, int use_array[],
  int rank_array[], MOTIF_LIST *align_header, TREE *tree, FILE *seq_fh, 
  FILE *reg_fh, FILE *ft_fh, FILE *ind_fh );

void initialize_int_array( int array[], int n );

void get_motif_freq_count_array( int ct_array[], COUNT *total_ct, 
  MOTIF_LIST *align_header, TREE *tree, FILE *seq_fh, FILE *reg_fh, FILE *ft_fh );

FPOS get_binary_motif_freq_array_block( int ct_array[], COUNT *total_ct, int n,
  MOTIF_LIST *align_header, TREE *tree, FPOS fpos, char line[], FILE *seq_fh );

COUNT update_count_motif_freq_array( int ct_array[], MAF_LIST *maf_header );

MAF_LIST *get_maf_lister_w_spec_str( MAF_LIST *maf_header, char spec[] );

COUNT update_count_motif_freq_array_seq( int ct_array[], char seq[] );

MOTIF_LIST *get_motif_freq_list_from_array( MOTIF_LIST *mf_header, int use_array[],
  int rank_array[], int ct_array[], COUNT total_ct );

void copy_int_array( int copy_array[], int ct_array[], COUNT n );

void bubble_sort( int rank_array[], int ct_array[], COUNT n );

MOTIF_LIST *get_motif_freq_list_from_sorted_array( MOTIF_LIST *mf_header, 
  int use_array[], int kmer_array[], int mf_array[], int rank_array[], 
  int ct_array[] );

void get_word_use_array_from_rank_array( int boolean_array[], int mf_array[],
  int top_rank );

void update_word_use_array_from_single_mf( int boolean_array[], int mf );

MOTIF_LIST *get_my_motif_freq_list_from_sorted_array( MOTIF_LIST *mf_header, 
  int use_array[], int rank_array[], int kmer_array[], int top_rank );

MOTIF_LIST *make_and_put_motif_top_list_single_mf( MOTIF_LIST *mf_header,
  MOTIF_LIST **last_mf, MF mf );

void print_mf_binary_file( MOTIF_LIST *mf_header, int use_array[], TREE *tree, 
  FILE *mf_fh, FILE *fpos_fh );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void do_binary_ft_count_tfbs( MOTIF_LIST *align_header, MOTIF_LIST *mf_header,
  int use_array[], int rank_array[], TREE *tree, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *ind_fh );

void put_binary_ft_tfbs_count_array( long ct[ NUMB_OF_KMERS ][ NUMB_OF_SPEC ], 
  int n, int use_array[], int loop, FILE *ft_fh, FILE *ind_fh );

FPOS get_binary_ft_count_block( FPOS ct[ NUMB_OF_KMERS ][ NUMB_OF_SPEC ], int n, 
  MOTIF_LIST *align_header, MOTIF_LIST *mf_header, int use_array[], 
  int kmer_array[], FPOS fpos, char line[], int loop, FILE *seq_fh );

void update_count_binary_array( FPOS ct[ NUMB_OF_KMERS ][ NUMB_OF_SPEC ], int n, 
  MAF_LIST *maf_header, MOTIF_LIST *mf_header, int use_array[], int kmer_array[],
  int loop );

void get_numb_of_tfbs_from_seq_stack( FPOS ct[ NUMB_OF_KMERS ][ NUMB_OF_SPEC ],
  char seq[], int use_array[], int spec_numb );

int site_equals_stack( char site[], MF stack );

int get_gencoord_entry_from_bed_line( GENCOORD_ENTRY *gene_entry, char line[] );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void do_binary_ft_put_tfbs( MOTIF_LIST *align_header, MOTIF_LIST *mf_header,
  int use_array[], int kmer_array[], TREE *tree, FILE *seq_fh, FILE *reg_fh, 
  FILE *ft_fh, FILE *fpos_fh, FILE *ind_fh, FILE *ss_fh );

FPOS get_binary_ft_put_tfbs_block( FPOS fpos_array[], int n, 
  MOTIF_LIST *align_header, MOTIF_LIST *mf_header, FT_LIST *ft_array[],
  FT_LIST *last_ft[], int spec_numb, SEQ_LIST **seq_header, SEQ_LIST **last_seq, 
  int use_array[], FPOS fpos, char line[], SEQ seq_numb, FILE *seq_fh, 
  FILE *ft_fh );

void update_ft_put_tfbs_array( FT_LIST *ft_array[], FT_LIST *last_ft[], 
  int spec_numb, int use_array[], MAF_LIST *maf_header, MOTIF_LIST *mf_header, 
  SEQ seq_numb, FILE *ft_fh );

void put_binary_ft_tfbs_array( FT_LIST *ft_array[], FT_LIST *last_ft[],
  char seq[], int use_array[], SEQ seq_numb );

void put_ft_info_list_binary( FT_LIST *ft_array[], int spec_numb, int use_array[],
  FPOS fpos_array[], FILE *ind_fh, FILE *ft_fh );

SEQ_LIST *get_and_put_seq_lister_region_line( SEQ_LIST *seq_header, 
  SEQ_LIST **last_seq, char line[], MAF_LIST *maf_header );

void put_seq_info_list_binary( SEQ_LIST *seq_header, FILE *ss_fh );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



MAF_LIST *get_alignment_maf_list_single_gene( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FILE *seq_fh );

MAF_LIST *make_and_set_maf_list_all_spec_cell( MAF_LIST *maf_header, 
  MOTIF_LIST *mf_header );

MAF_LIST *make_and_set_single_maf_spec_and_step( MAF_LIST *maf_header, 
  MOTIF_LIST **spec );

MAF_LIST *make_and_set_single_maf_spec( MAF_LIST *maf_header, MOTIF_LIST *spec );

MAF_LIST *put_single_maf_spec_into_list( MAF_LIST *maf_header, MAF_LIST *maf );

MAF_LIST *get_my_alignment_maf_list_single_gene( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FILE *seq_fh );

MAF_LIST *get_alignment_maf_single_multiz_line( MAF_LIST *maf_header, char line[], 
  GENCOORD_ENTRY *gene_entry, MOTIF_LIST *align_header, MOTIF_LIST *mf_header, 
  FPOS *fpos, FPOS *my_fpos, int *after_found, int *same_chr, FILE *seq_fh );

void get_spec_from_maf_line( char spec[], char line[] );

void get_gencoord_entry_from_maf_line( GENCOORD_ENTRY *entry, char line[] );

int set_same_chr( GENCOORD_ENTRY *gene_entry, GENCOORD_ENTRY *maf_entry, 
  int same_chr );

int gene_gencoord_matches_maf_gencoord( GENCOORD_ENTRY *gene_entry, 
  GENCOORD_ENTRY *maf_entry );

MAF_LIST *get_alignment_maf_first_major_species_line( MAF_LIST *maf_header, 
  char line[], GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry, 
  int *after_found, FPOS *fpos, FILE *seq_fh );

MAF_LIST *get_alignment_maf_single_matching_line( MAF_LIST *maf_header,
  char my_line[], char line[], GENCOORD_ENTRY *maf_entry, 
  GENCOORD_ENTRY *gene_entry, int *after_found, FPOS *fpos, int *still_going, 
  FILE *seq_fh );

void update_alignment_maf_single_maf_line( MAF_LIST *maf, int len, char line[] );










