#include "fname.h"

















#define FASTA_FNAME "refSeqProm_500_250.txt.final.txt"
#define GEN_COORD_FNAME "refSeq_genCoord"
#define HG_MAF_FNAME "multiz46way_MAF"
#define MM_MAF_FNAME "multiz30way_MAF"













void set_fasta_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  sprintf( f, "data/%s/%s_%s", phylo_spec, phylo_spec, FASTA_FNAME );

}











void set_gen_coord_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  sprintf( f, "data/%s/genCoord/%s_%s", phylo_spec, phylo_spec, GEN_COORD_FNAME );

}













void set_maf_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  if ( ! strcmp( phylo_spec, "hg19" )) {
    sprintf( f, "data/%s/maf/%s_%s", phylo_spec, phylo_spec, HG_MAF_FNAME );
  }
  else if ( ! strcmp( phylo_spec, "mm9" )) {
    sprintf( f, "data/%s/maf/%s_%s", phylo_spec, phylo_spec, MM_MAF_FNAME );  
  }
  else {
    error( 300, "Unrecognized phylo species.\n" );
  }

}














void set_align_info_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  sprintf( f, "data/%s/align/%s_refSeq_info.txt", phylo_spec, phylo_spec );

}












void set_align_maf_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  if ( ! strcmp( phylo_spec, "hg19" )) {
    sprintf( f, "data/%s/align/%s_%s_total.txt", phylo_spec, phylo_spec, 
      HG_MAF_FNAME );
  }
  else if ( ! strcmp( phylo_spec, "mm9" )) {
    sprintf( f, "data/%s/align/%s_%s_total.txt", phylo_spec, phylo_spec,
      MM_MAF_FNAME );
  }
  else {
    error( 301, "Unrecognized phylo species passed to align maf fname func.\n" );
  }

}













void set_final_maf_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  if ( ! strcmp( phylo_spec, "hg19" )) {
    sprintf( f, "data/%s/align/%s_%s.my_fa.txt", phylo_spec, phylo_spec,
      HG_MAF_FNAME );
  }
  else if ( ! strcmp( phylo_spec, "mm9" )) {
    sprintf( f, "data/%s/align/%s_%s.my_fa.txt", phylo_spec, phylo_spec,
      MM_MAF_FNAME );
  }
  else {
    error( 302, "Unrecognized phylo species passed to align maf fname func.\n" );
  }  

}













void set_region_maf_fname( char f[], char reg )
{

  extern char phylo_spec[ BUFFER ];
  
  sprintf( f, "data/%s/regions/%c/%s_region_%c.txt", phylo_spec, reg,
    phylo_spec, reg ); 
  
}
















void set_region_list_fname( char f[] )
{

  extern char phylo_spec[ BUFFER ];
  
  sprintf( f, "data/%s/regions/RegionList_%s.txt", phylo_spec, phylo_spec );

}















void set_spec_list_fname( char f[], char phylo_spec[] )
{

  sprintf( f, "data/tree/%s_species.txt", phylo_spec );

  /*  Previous:
  if ( ! strcmp( phylo_spec, "hg19" ))
    sprintf( f, "data/%s/%s_spec_%s.txt", phylo_spec, phylo_spec, HG_MAF_FNAME );
  else if ( ! strcmp( phylo_spec, "mm9" ))
    sprintf( f, "data/%s/%s_spec_%s.txt", phylo_spec, phylo_spec, MM_MAF_FNAME );  
  */
  
}




