#include "branch.h"









#define SINGLE_NODE 1 
#define NODE_LABEL "Simiiformes"

















BRANCH_LIST *get_branch_list_satd_model( BRANCH_LIST *branch_header, 
  MODEL_LIST *satd_model, TREE *tree, char bd )
{

  STAT (*val)( BRANCH_LIST *br );

  switch ( bd ) {
  
  case BIRTH :
    val = get_birth_branch;
    break;
    
  case DEATH :
    val = get_death_branch;
    break;
    
  default :
    error( 6140, "Unknown birth-death integer value set.\n" );
    break;
  
  }
  
  return get_my_branch_list_satd_model( branch_header, satd_model, tree, val );

}













BRANCH_LIST *get_my_branch_list_satd_model( BRANCH_LIST *branch_header,
  MODEL_LIST *satd_model, TREE *tree, STAT (*val)( BRANCH_LIST *br ) )
{

  PART_LIST *part = satd_model->my_model->part_header;
  
  while ( part != NULL ) {
  
    branch_header = (BRANCH_LIST *)get_branch_list_single_pt_and_step( branch_header,
      &part, tree, val );
  
    if (( SINGLE_NODE ) && 
      ( ! strcmp( branch_header->my_branch->node->my_node->label, NODE_LABEL )))
    {
      return branch_header;
    }    
    
  }
  
  return branch_header;

}












BRANCH_LIST *get_branch_list_single_pt_and_step( BRANCH_LIST *branch_header,
  PART_LIST **pt, TREE *tree, STAT (*val)( BRANCH_LIST *br ) )
{

  branch_header = (BRANCH_LIST *)get_branch_list_single_pt( branch_header, *pt,
    tree, val );
    
  *pt = (*pt)->next;
  
  return branch_header;

}












BRANCH_LIST *get_branch_list_single_pt( BRANCH_LIST *branch_header, PART_LIST *pt,
  TREE *tree, STAT (*val)( BRANCH_LIST *br ) )
{

  BRANCH_LIST *create_branch_lister( BRANCH_LIST *x );
  NODE_LIST *get_node_from_numb( TREE *tree, int numb );
  
  BRANCH_LIST *branch = NULL;
  branch = (BRANCH_LIST *)create_branch_lister( branch );
  
  /*  In ../tree/get.c:  */
  branch->my_branch->node = (NODE_LIST *)get_node_from_numb( tree, 
    pt->my_part->branch_header->elem.d );
    
  PARAMS *pp = pt->my_part->pp;
  
  branch->my_branch->a = pp->a;
  branch->my_branch->b = pp->b;
  
  if ( ! strcmp( branch->my_branch->node->my_node->label, "Root" )) {
    branch->my_branch->a = 0.0;
    branch->my_branch->b = 1.0;
  }
  
  printf( "Hey :   %s   %.4e   %.4e\n", branch->my_branch->node->my_node->label,
    (double)branch->my_branch->a, (double)branch->my_branch->b );
  
  return put_branch_lister_sorted_list_val_func( branch_header, branch, val );

}











BRANCH_LIST *put_branch_lister_sorted_list_val_func( BRANCH_LIST *branch_header,
  BRANCH_LIST *branch, STAT (*val)( BRANCH_LIST *br ) )
{

  if ( branch_header == NULL )
    return branch;
    
  if (( val( branch_header ) < val( branch )) || ( isnan( val( branch ))) 
    || ( isinf( val( branch )))) 
  {
    branch->next = branch_header;
    branch_header->prev = branch;
    return branch;
  }
  
  BRANCH_LIST *curr = branch_header, *prev = NULL;
  
  while (( curr != NULL ) && ( val( curr ) >= val( branch ))) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = branch;
    
  if ( curr != NULL )
    curr->prev = branch;
    
  branch->next = curr;
  branch->prev = prev;
  
  return branch_header;

}













STAT get_birth_branch( BRANCH_LIST *branch )
{
  return branch->my_branch->a / branch->my_branch->b;
  return branch->my_branch->a;
}









STAT get_death_branch( BRANCH_LIST *branch )
{
  return branch->my_branch->b;
}








