#include "data.h"













#define MIN_NUCL_COUNT 20










DATA_LIST *get_origin_data( DATA_LIST *data, MOTIF *mf )
{

  DATA_LIST *create_data_lister( DATA_LIST *x );

  data = (DATA_LIST *)create_data_lister( data );
  
  /*  In this file, below:  */  
  data->data = (DATA *)get_my_origin_data( data->data, mf );
  
  return data;

}











DATA *get_my_origin_data( DATA *data, MOTIF *mf )
{

  TREE *make_and_set_tree( TREE *tree );
  
  /*  In ../tree/create_tree.c:  */
  data->tree = (TREE *)make_and_set_tree( data->tree );
  
  /*  In this file, below:  */
  data->spec_cell = (SPEC_CELL *)get_spec_cell();
  
  /*  In this file, below:  */
  set_tree_ancestor_branches( data->tree );
  
  *(data->mf) = *mf;
  
  /*  In this file, below:  */
  data->pdata = (PDATA_LIST *)get_listed_pdata_list( data );
  
  /*  In this file, below:  */
  set_region_from_binary_file( data->reg, data->pdata );
    
  /*  In ../model/data.c:  */
  set_prior_probs_pdata( data->tree, data->pdata );
  
  /*  In ../model/data.c:  */
  set_max_occur( data->pdata );
  
  return data;

}









SPEC_CELL *get_spec_cell( void )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  SPEC_CELL *create_spec_cell( SPEC_CELL *x, INDEX n );
  
  extern char input_file[ BUFFER ];
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "x" );
  
  INDEX n;
  
  get( &n, sizeof(INDEX), fh );
  
  SPEC_CELL *spec_cell = NULL;
  spec_cell = (SPEC_CELL *)create_spec_cell( spec_cell, n );
  
  get( spec_cell->x, sizeof(SPEC) * n, fh );
  
  return spec_cell;

}















void set_tree_ancestor_branches( TREE *tree )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );

  extern char major_spec[ BUFFER ];

  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, major_spec );
  
  int i = 0;
  
  while ( node != NULL ) {
  
    char label[ BUFFER ];
    
    ++i;
    
    if ( node->my_node->label[ 0 ] == '\0' ) {
      if ( node->up == NULL )
        strcpy( node->my_node->label, "Root" );
      else
        sprintf( node->my_node->label, "Node_%d", i );
    }
    
    node = node->up;
  
  }

}










PDATA_LIST *get_listed_pdata_list( DATA *data )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *ft_fh = NULL, *ind_fh = NULL, *fpos_fh = NULL, *seq_fh = NULL;
  ft_fh = (FILE *)open_binary_file_reading( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_reading( input_file, "i" );
  seq_fh = (FILE *)open_binary_file_reading( input_file, "s" );
  fpos_fh = (FILE *)open_binary_file_reading( input_file, "p" );
  
  get_listed_pdata_list_w_fhs( data, ft_fh, ind_fh, seq_fh, fpos_fh );
  
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( seq_fh );
  close_file( fpos_fh );

  return data->pdata;

}













void get_listed_pdata_list_w_fhs( DATA *data, FILE *ft_fh, FILE *ind_fh,
  FILE *seq_fh, FILE *fpos_fh )
{

  int get_numb_leaves_from_tree( TREE *tree );
  int get_motif_stack_mismatches( MOTIF *mf, MF stack );
  
  /*  In format.c:  */
  int numb_of_spec = get_numb_leaves_from_tree( data->tree );
  
  PDATA_LIST *pdata = NULL;

  MF w;
  
  for ( w = 0; w < NUMB_OF_WORDS; w++ ) {
    /*  In ../main/nucl.c:  */
    if ( get_motif_stack_mismatches( data->mf, w ) <= 1 )
      /*  In this file, below:  */
      pdata = (PDATA_LIST *)get_listed_pdata_list_single_kmer( pdata, data, w, 
        numb_of_spec, ft_fh, ind_fh, seq_fh, fpos_fh );
  }
  
  data->pdata = pdata;
  
}











PDATA_LIST *get_listed_pdata_list_single_kmer( PDATA_LIST *pdata_header, 
  DATA *data, MF w, int numb_of_spec, FILE *ft_fh, FILE *ind_fh, FILE *seq_fh, 
  FILE *fpos_fh )
{

  void set_position( FPOS fpos, FILE *ff );
  
  FT ft_array[ NUMB_OF_SPEC ];
  FT_IND ind_array[ NUMB_OF_SPEC ];  
  FPOS fpos;
  
  initialize_first_ft_array( ft_array, NUMB_OF_SPEC );
  
  set_position( sizeof(FPOS) * w, fpos_fh );  
  get( &fpos, sizeof(FPOS), fpos_fh );
  
  if ( fpos < 0 )
    return pdata_header;

  set_position( fpos, ind_fh );
  get( ind_array, sizeof(FT_IND) * data->spec_cell->n, ind_fh );
  
  return get_my_listed_pdata_list_w_fhs( pdata_header, data, ft_array, ind_array, 
    ft_fh, seq_fh );

}










void initialize_first_ft_array( FT ft_array[], int n )
{

  FT ft = { .seq = 0 };

  int i;
  for ( i = 0; i < MOTIF_LENGTH; i++ ) {
    ft.pos[ i ] = 0;
    ft.site[ i ] = '\0';
  }
  
  for ( i = 0; i < n; i++ )
    ft_array[ i ] = ft;

}









PDATA_LIST *get_my_listed_pdata_list_w_fhs( PDATA_LIST *pdata_old, DATA *data, 
  FT ft_array[], FT_IND ind_array[], FILE *ft_fh, FILE *seq_fh )
{

  void set_position( FPOS fpos, FILE *ff );
  
  SEQ_INFO seq_info;
  int length[ NUMB_OF_SPEC ];  
    
  int i;
  for ( i = 0; i < data->spec_cell->n; i++ ) 
    update_ft_array_from_binary_fh( ft_array, ind_array, i, ft_fh );
    
  set_position( 0, seq_fh );

  PDATA_LIST *pdata_header = NULL, *last_pdata = NULL;
  
  int seq_numb = 0;
    
  while ( get_new_seq_region_fh( &seq_info, length, data->spec_cell->n, seq_fh )) 
    pdata_header = (PDATA_LIST *)get_pdata_list_single_seq( pdata_header,
      &last_pdata, data, ft_array, ind_array, &seq_info, length, ++seq_numb,
      ft_fh );
      
  return update_pdata_list( pdata_old, pdata_header, data->spec_cell->n );    
      
}












PDATA_LIST *update_pdata_list( PDATA_LIST *pdata_header, PDATA_LIST *pdata_new,
  int numb_of_spec )
{

  if ( pdata_header == NULL )
    return pdata_new;
    
  if ( pdata_new == NULL )
    return pdata_header;
    
  PDATA_LIST *pdata = pdata_header, *last = NULL, *new = pdata_new;
  PDATA_LIST *my_header = pdata_header;
  
  if ( pdata->my_pdata->seq_numb != new->my_pdata->seq_numb ) 
    error( 3700, "Unmatching sequence numbers.\n" );
  
  while ( pdata != NULL ) {
    update_pdata_lister_pair( pdata, new, numb_of_spec );
    pdata = pdata->next;
    new = new->next;
  }
  
  kill_pdata_list( pdata_new );
  
  return my_header;

}










void update_pdata_lister_pair( PDATA_LIST *pdata, PDATA_LIST *new_pdata,
  int numb_of_spec )
{

  if ( new_pdata == NULL )
    return;
    
  if ( pdata->my_pdata->seq_numb == new_pdata->my_pdata->seq_numb ) 
    update_pdata_lister_matching_seq_numb( pdata, new_pdata, numb_of_spec );
  
  if ( pdata->my_pdata->seq_numb > new_pdata->my_pdata->seq_numb )
    add_pdata_lister_uneven_seq_numb( pdata, new_pdata );

}









void update_pdata_lister_matching_seq_numb( PDATA_LIST *pdata, PDATA_LIST *new,
  int numb_of_spec )
{

  int spec_numb;
  
  for ( spec_numb = 0; spec_numb < numb_of_spec; spec_numb++ )
    update_pdata_lister_matching_seq_single_spec( pdata, new, spec_numb );

}












void update_pdata_lister_matching_seq_single_spec( PDATA_LIST *pdata,
  PDATA_LIST *new, int spec_numb )
{

  if ( new->my_pdata->use_array[ spec_numb ] )
    pdata->my_pdata->use_array[ spec_numb ] = 1;
    
  if ( pdata->my_pdata->use_array[ spec_numb ] == 0 )
    return;
    
  pdata->my_pdata->ct_array[ spec_numb ] += new->my_pdata->ct_array[ spec_numb ];

}












void add_pdata_lister_uneven_seq_numb( PDATA_LIST *pdata, PDATA_LIST *new )
{

  PDATA_LIST *create_pdata_lister( PDATA_LIST *x );
  
  PDATA_LIST *p = NULL;
  p = (PDATA_LIST *)create_pdata_lister( p );
  
  *(p->my_pdata) = *(new->my_pdata);

  PDATA_LIST *prev = pdata->prev;

  if ( prev != NULL ) {
    prev->next = p;
    p->prev = prev;
  }
  
  p->next = pdata;
  pdata->prev = p;

}










int get_new_seq_region_fh( SEQ_INFO *seq_info, int length[], int numb_of_spec,
  FILE *seq_fh )
{

  static int numb = 0;

  if ( ! get( seq_info, sizeof(SEQ_INFO), seq_fh ))
    return 0;
    
  get( length, sizeof(int) * numb_of_spec, seq_fh );
  
  return 1;

}










int update_ft_array_from_binary_fh( FT ft_array[], FT_IND ind_array[], int i,
  FILE *ft_fh )
{

  void set_position( FPOS fpos, FILE *fh );

  if ( ind_array[ i ].n <= 0 )
    return 0;
    
  set_position( ind_array[ i ].fpos, ft_fh );
  
  ind_array[ i ].fpos += sizeof(FT);
  
  if ( --(ind_array[ i ].n) < 0 )
    error( 3501, "Number of occurrences reached below zero.\n" );
  
  get( ft_array + i, sizeof(FT), ft_fh );
  
  return 1;

}












PDATA_LIST *get_pdata_list_single_seq( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  SEQ_INFO *seq_info, int length[], SEQ seq_numb, FILE *ft_fh )
{

  extern int score_thresh;

  int use_array[ NUMB_OF_SPEC ];
  
  if ( seq_info->score < score_thresh ) 
    return pdata_header;
  
  set_use_array_from_length_array( use_array, length, data->spec_cell->n );
  
  if ( array_sum( use_array, data->spec_cell->n ) <= 2 ) 
    return pdata_header;
    
  return get_and_put_pdata_lister_single_seq( pdata_header, last_pdata, data,
    ft_array, ind_array, use_array, seq_info, seq_numb, ft_fh );

}











void set_use_array_from_length_array( int use_array[], int length[], int n )
{

  int i;
  
  for ( i = 0; i < n; i++ )
    use_array[ i ] = ( length[ i ] >= MIN_NUCL_COUNT ) ? (1) : (0);

}








int array_sum( int array[], int n )
{

  int sum = 0, i;
  
  for ( i = 0; i < n; i++ )
    sum += array[ i ];
    
  return sum;

}












PDATA_LIST *get_and_put_pdata_lister_single_seq( PDATA_LIST *pdata_header, 
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, FILE *ft_fh )
{

  PDATA_LIST *create_pdata_lister( PDATA_LIST *x );
  
  PDATA_LIST *pdata = NULL;
  pdata = (PDATA_LIST *)create_pdata_lister( pdata );
  
  set_pdata_lister_info( pdata, data, ft_array, ind_array, use_array, seq_info,
    seq_numb, ft_fh );
    
  return put_pdata_lister_into_list( pdata_header, last_pdata, pdata );
  
}











PDATA_LIST *put_pdata_lister_into_list( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, PDATA_LIST *pdata )
{

  if ( pdata_header == NULL ) {
    *last_pdata = pdata;
    return pdata;
  }
  
  (*last_pdata)->next = pdata;
  pdata->prev = *last_pdata;

  *last_pdata = pdata;
  
  return pdata_header;

}









void set_pdata_lister_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  FILE *ft_fh )
{

  pdata->my_pdata->seq_numb = seq_numb;
  pdata->my_pdata->numb_of_spec = data->spec_cell->n;

  int i;
  
  for ( i = 0; i < data->spec_cell->n; i++ ) 
    set_pdata_lister_single_spec_info( pdata, data, ft_array, ind_array, use_array,
      seq_info, seq_numb, i, ft_fh );

}











void set_pdata_lister_single_spec_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  int spec_numb, FILE *ft_fh )
{

  extern int reg_start, reg_end;

  pdata->my_pdata->use_array[ spec_numb ] = use_array[ spec_numb ];
  pdata->my_pdata->ct_array[ spec_numb ] = 0;

  if ( ! use_array[ spec_numb ] )
    return;
    
  FT *ft = ft_array + spec_numb;

  while ( ft->seq <= seq_numb ) {
  
    if ( ft->seq == seq_numb ) {
      int center = seq_info->n / 2;
      int x = ft->pos[ 0 ];
      if (( center + reg_start <= x ) && ( center + reg_end > x ))
        ++(pdata->my_pdata->ct_array[ spec_numb ]);
    }
      
    /*  In this file, above:  */
    if ( ! update_ft_array_from_binary_fh( ft_array, ind_array, spec_numb, ft_fh ))
      break;
      
    ft = ft_array + spec_numb;
  
  }    

}














/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/










DATA_LIST *get_origin_kmer_data( DATA_LIST *data, MOTIF *mf )
{

  DATA_LIST *create_data_lister( DATA_LIST *x );

  data = (DATA_LIST *)create_data_lister( data );
  
  /*  In this file, below:  */  
  return get_my_origin_kmer_data( data, mf );

}











DATA_LIST *get_my_origin_kmer_data( DATA_LIST *my_data, MOTIF *mf )
{

  TREE *make_and_set_tree( TREE *tree );
  void get_rev_complement_seq( char rev_compl[], char seq[] );

  MOTIF rev_mf = { .length = WORD_LENGTH };
  /*  In ../main/nucl.c:  */
  get_rev_complement_seq( rev_mf.cons, mf->cons );
  
  DATA *data = my_data->data;
  DATA *rc_data = my_data->rc_data;
  
  /*  In ../tree/create_tree.c:  */
  data->tree = (TREE *)make_and_set_tree( data->tree );
  rc_data->tree = (TREE *)make_and_set_tree( rc_data->tree );
  
  /*  In this file, below:  */
  data->spec_cell = (SPEC_CELL *)get_spec_cell();
  rc_data->spec_cell = (SPEC_CELL *)get_spec_cell();
  
  /*  In this file, below:  */
  set_tree_ancestor_branches( data->tree );
  set_tree_ancestor_branches( rc_data->tree );
  
  *(data->mf) = *mf;
  *(rc_data->mf) = rev_mf;
  
  /*  In this file, below:  */
  get_listed_pdata_kmer_list( my_data );
  
  /*  In this file, below:  */
  set_region_from_binary_file( data->reg, data->pdata );
//  set_region_from_binary_file( rc_data->reg, rc_data->pdata );
    
  /*  In ../model/data.c:  */
  set_prior_probs_pdata( data->tree, data->pdata );
  set_prior_probs_pdata( rc_data->tree, rc_data->pdata );
  
  /*  In ../model/data.c:  */
  set_max_occur( data->pdata );
//  set_max_occur( rc_data->pdata );
  
  return my_data;

}











void get_listed_pdata_kmer_list( DATA_LIST *my_data )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  extern int reg_start, reg_end;
  
  char motif_fname[ BUFFER ], cons[ BUFFER ];
  
  DATA *data = my_data->data;
  
  upper( cons, data->mf->cons );
  
  sprintf( motif_fname, "%s.%d:%d_motif_%s.txt",
    input_file, reg_start, reg_end, cons );
  
  FILE *ft_fh = NULL, *ind_fh = NULL, *fpos_fh = NULL, *seq_fh = NULL;
  FILE *kmer_fh = NULL, *pwm_fh = NULL;
  
  ft_fh = (FILE *)open_binary_file_reading( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_reading( input_file, "i" );
  seq_fh = (FILE *)open_binary_file_reading( input_file, "s" );
  fpos_fh = (FILE *)open_binary_file_reading( input_file, "p" );
  
  if (( kmer_fh = (FILE *)fopen( motif_fname, "r" )) != NULL )
    pwm_fh = (FILE *)open_text_file_reading( motif_fname, "pwm" );
  else {
    sprintf( motif_fname, "%s.%d:%d_motif_%s.txt",
      input_file, -100, 100, cons );
    kmer_fh = (FILE *)open_text_file_reading( motif_fname, "" );
    pwm_fh = (FILE *)open_text_file_reading( motif_fname, "pwm" );
  }
  
  get_listed_pdata_kmer_list_w_fhs( my_data, ft_fh, ind_fh, seq_fh, fpos_fh,
    kmer_fh, pwm_fh );
  
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( seq_fh );
  close_file( fpos_fh );
  close_file( kmer_fh );
  close_file( pwm_fh );

}












void get_listed_pdata_kmer_list_w_fhs( DATA_LIST *my_data, FILE *ft_fh, FILE *ind_fh,
  FILE *seq_fh, FILE *fpos_fh, FILE *kmer_fh, FILE *pwm_fh )
{

  void set_bg_pwm( PWM *pwm, MOTIF *mf, SPEC_CELL *spec_cell, FILE *ft_fh, 
    FILE *ind_fh, FILE *seq_fh, FILE *fpos_fh );
  void set_pwm_freq( PWM *pwm );
  
  MOTIF_LIST *mf_header = NULL;
  PWM pwm = { .length = WORD_LENGTH }, bg_pwm = { .length = WORD_LENGTH };
  
  DATA *data = my_data->data;
  
  /*  In this file, below:  */
  mf_header = (MOTIF_LIST *)get_motif_list_w_fh( mf_header, kmer_fh );
  
  MOTIF_LIST *mf = mf_header;
  while ( mf != NULL ) {
    printf( "%s   %d\n", mf->my_mf->cons, (int)mf->my_mf->my_motif );
    mf = mf->next;
  }
  printf( "\n\n\n" );
  
  /*  In this file, below:  */
  get_pwm_from_text_file( &pwm, pwm_fh );
  
  /*  In ../pwm/pwm.c:  */
  set_bg_pwm( &bg_pwm, data->mf, data->spec_cell, ft_fh, ind_fh, seq_fh, 
    NULL );
    
  set_pwm_freq( &bg_pwm );
  
  /*  In this file, below:  */
  get_my_listed_pdata_kmer_list_w_fhs( my_data, mf_header, &pwm, &bg_pwm, ft_fh, 
    ind_fh, seq_fh, fpos_fh, pwm_fh );

}











MOTIF_LIST *get_motif_list_w_fh( MOTIF_LIST *mf_header, FILE *fh )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) 
    mf_header = (MOTIF_LIST *)get_and_put_motif_lister_from_line( mf_header, line );
    
  return mf_header;
  
}









MOTIF_LIST *get_and_put_motif_lister_from_line( MOTIF_LIST *mf_header, char line[] )
{
  
  MOTIF_LIST *create_motif_lister( MOTIF_LIST *x );
  MF get_stack_from_string( char cons[] );
  
  MOTIF_LIST *mf = NULL;
  mf = (MOTIF_LIST *)create_motif_lister( mf );
  
  char cons[ BUFFER ];
  
  sscanf( line, "%s", cons );
  
  upper( mf->my_mf->cons, cons );
  mf->my_mf->length = strlen( cons );
  
  /*  In ../main/nucl.c:  */
  mf->my_mf->my_motif = get_stack_from_string( cons );
  
  /*  In this file, below:  */
  return put_motif_lister_end_of_list( mf_header, mf );

}











MOTIF_LIST *put_motif_lister_end_of_list( MOTIF_LIST *mf_header, MOTIF_LIST *mf )
{

  if ( mf_header == NULL )
    return mf;
    
  MOTIF_LIST *curr = mf_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = mf;
  
  return mf_header;

}











void get_pwm_from_text_file( PWM *pwm, FILE *pwm_fh )
{

  char line[ LINE_BUFFER ];
  
  pwm->length = WORD_LENGTH;
  
  fgets( line, LINE_BUFFER, pwm_fh );
  
  int i;
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
    fgets( line, LINE_BUFFER, pwm_fh );
    sscanf( line, "%ld%ld%ld%ld%ld%ld%ld",
      &(pwm->pwm[ 0 ][ i ]),
      &(pwm->pwm[ 1 ][ i ]),
      &(pwm->pwm[ 2 ][ i ]),
      &(pwm->pwm[ 3 ][ i ]),
      &(pwm->pwm[ 4 ][ i ]),
      &(pwm->pwm[ 5 ][ i ]),
      &(pwm->pwm[ 6 ][ i ]) );
  }
    
  fgets( line, LINE_BUFFER, pwm_fh );
  fgets( line, LINE_BUFFER, pwm_fh );
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
    fgets( line, LINE_BUFFER, pwm_fh );
    sscanf( line, "%f%f%f%f%f%f%f",
      &(pwm->freq[ 0 ][ i ]),
      &(pwm->freq[ 1 ][ i ]),
      &(pwm->freq[ 2 ][ i ]),
      &(pwm->freq[ 3 ][ i ]),
      &(pwm->freq[ 4 ][ i ]),
      &(pwm->freq[ 5 ][ i ]),
      &(pwm->freq[ 6 ][ i ]) );
  }    

}












void get_my_listed_pdata_kmer_list_w_fhs( DATA_LIST *data, MOTIF_LIST *mf_header, 
  PWM *pwm, PWM *bg_pwm, FILE *ft_fh, FILE *ind_fh, FILE *seq_fh, 
  FILE *fpos_fh, FILE *pwm_fh )
{

  int get_numb_leaves_from_tree( TREE *tree );
  int get_motif_stack_mismatches( MOTIF *mf, MF stack );
  
  /*  In format.c:  */
  int numb_of_spec = get_numb_leaves_from_tree( data->data->tree );
  
  MOTIF_LIST *plus_mf = NULL, *minus_mf = NULL;
  
  /*  In this file, below:  */
  mf_header = (MOTIF_LIST *)sort_kmer_mf_list_by_score( &plus_mf, &minus_mf,    
    mf_header, pwm, bg_pwm );
  
  PDATA_LIST *plus_header = NULL, *minus_header = NULL;
  
  int index = 0;
  
  MOTIF_LIST *mf = plus_mf;
  
  printf( "pdata:\n" );
  
  while ( mf != NULL ) {
  
    printf( "%s   %d\n", mf->my_mf->cons, (int)mf->my_mf->my_motif );

    PDATA_LIST *pdata = NULL;

    /*  In this file, below:  */
    pdata = (PDATA_LIST *)get_listed_pdata_list_single_mf_lister( data->data, 
      pwm, bg_pwm, mf->my_mf, numb_of_spec, ft_fh, ind_fh, seq_fh, fpos_fh );
    
    /*  In this file, below:  */  
//    if (( index++ < 15 ) || ( pdata_lister_adds_seqs( plus_header, pdata )))
      /*  In this file, above:  */
      plus_header = (PDATA_LIST *)update_pdata_list( plus_header, pdata, 
        data->data->spec_cell->n );    

    mf = mf->next;
      
  }
  
  data->data->pdata = plus_header;
  
  index = 0;
  
  mf = minus_mf;
  
  printf( "\t\t\t\tyo yo\n" );
  
  while ( mf != NULL ) {
  
    printf( "RC :  %s   %d\n", mf->my_mf->cons, (int)mf->my_mf->my_motif );

    PDATA_LIST *pdata = NULL;

    /*  In this file, below:  */
    pdata = (PDATA_LIST *)get_listed_pdata_list_single_mf_lister( data->rc_data, 
      pwm, bg_pwm, mf->my_mf, numb_of_spec, ft_fh, ind_fh, seq_fh, fpos_fh );
    
    /*  In this file, below:  */  
//    if (( index++ < 15 ) || ( pdata_lister_adds_seqs( minus_header, pdata )))
      /*  In this file, above:  */
      minus_header = (PDATA_LIST *)update_pdata_list( minus_header, pdata, 
        data->data->spec_cell->n );    
    
    mf = mf->next;
  
  }
  
  data->rc_data->pdata = minus_header;

}









MOTIF_LIST *sort_kmer_mf_list_by_score( MOTIF_LIST **plus_mf, MOTIF_LIST **minus_mf,
  MOTIF_LIST *mf_header, PWM *pwm, PWM *bg_pwm )
{
    
  MOTIF_LIST *create_motif_lister( MOTIF_LIST *x );  
  float get_kmer_pwm_score( MF stack, PWM *pwm, PWM *bg_pwm, char length );
  void get_rev_compl_pwm( PWM *rc_pwm, PWM *pwm );
  MF get_stack_from_string( char cons[] );
  void set_pwm_freq( PWM *pwm );

  MOTIF_LIST *mf = mf_header;
  MOTIF_LIST *new_header = NULL;
  
  PWM rc_pwm, rc_bg;
  
  /*  In ../pwm/pwm.c:  */
  get_rev_compl_pwm( &rc_pwm, pwm );
  get_rev_compl_pwm( &rc_bg, bg_pwm );
  
  /*  In ../pwm/pwm.c:  */
  set_pwm_freq( &rc_pwm );
  set_pwm_freq( &rc_bg );
  
  float score_array[ BUFFER ], score_array2[ BUFFER ], score_array3[ BUFFER ];
  int total = 0, plus_total = 0, minus_total = 0;
  
  while ( mf != NULL ) {
  
    MOTIF_LIST *new_mf = NULL;
    new_mf = (MOTIF_LIST *)create_motif_lister( new_mf );
    
    *(new_mf->my_mf) = *(mf->my_mf);
    
    MF stack = get_stack_from_string( mf->my_mf->cons );
  
    /*  In ../pwm/pwm.c:  */
    float score_a = get_kmer_pwm_score( stack, pwm, bg_pwm, WORD_LENGTH );
    float score_b = get_kmer_pwm_score( stack, &rc_pwm, &rc_bg, WORD_LENGTH );
    
    float score = MAX( score_a, score_b );
    
    printf( "scores = %.3f\t%.3f\n", score_a, score_b );
    
    MOTIF_LIST *next = mf->next;    
    mf->next = NULL;

    /*  In this file, below:  */
    new_header = (MOTIF_LIST *)put_motif_lister_into_score_list( new_header,
      mf, score_array, total++, score );
      
    if ( score_a >= score_b )
      *plus_mf = (MOTIF_LIST *)put_motif_lister_into_score_list( *plus_mf, new_mf,
        score_array2, plus_total++, score_a );
    else
      *minus_mf = (MOTIF_LIST *)put_motif_lister_into_score_list( *minus_mf, new_mf,
        score_array3, minus_total++, score_b );
            
    mf = next;
    
  }
  
  return new_header;
  
}









MOTIF_LIST *put_motif_lister_into_score_list( MOTIF_LIST *mf_header,
  MOTIF_LIST *mf, float score_array[], int total, float score )
{
  
  if ( mf_header == NULL ) {
    score_array[ total ] = score;
    return mf;
  }    
  
  int index = get_score_index_update_array( score_array, score, total );

  if ( index == 0 ) {
    mf->next = mf_header;
    return mf;
  } 

  MOTIF_LIST *curr = mf_header, *prev = NULL;

  int i = 0;

  while ( i++ < index ) {
    prev = curr;
    curr = curr->next;
  }

  prev->next = mf;
  mf->next = curr;
  
  return mf_header;

}
  









int get_score_index_update_array( float score_array[], float score, int total )
{

  int i, j;
        
  for ( i = 0; i < total; i++ ) {

    if ( score > score_array[ i ] ) {
          
      for ( j = total; j > i; j-- )
        score_array[ j ] = score_array[ j - 1 ];

      score_array[ i ] = score;
      
      return i;

    }
  }
  
  return total;
  
}


   
      






PDATA_LIST *get_listed_pdata_list_single_mf_lister( DATA *data, PWM *pwm, 
  PWM *bg_pwm, MOTIF *mf, int numb_of_spec, FILE *ft_fh, FILE *ind_fh, 
  FILE *seq_fh, FILE *fpos_fh )
{

  void set_position( FPOS fpos, FILE *ff );
  float get_kmer_pwm_score( MF stack, PWM *pwm, PWM *bg_pwm, char length );
 
  FT ft_array[ NUMB_OF_SPEC ];
  FT_IND ind_array[ NUMB_OF_SPEC ];  
  FPOS fpos;
  
  /*  In this file, above:  */
  initialize_first_ft_array( ft_array, NUMB_OF_SPEC );
  
  set_position( sizeof(FPOS) * mf->my_motif, fpos_fh );  
  get( &fpos, sizeof(FPOS), fpos_fh );
  
  if ( fpos < 0 )
    return NULL;

  set_position( fpos, ind_fh );
  get( ind_array, sizeof(FT_IND) * data->spec_cell->n, ind_fh );
  
  /*  In this file, below:  */
  return get_my_listed_pdata_list_single_mf_lister( data, ft_array, ind_array, 
    ft_fh, seq_fh );    

}










PDATA_LIST *get_my_listed_pdata_list_single_mf_lister( DATA *data, FT ft_array[], 
  FT_IND ind_array[], FILE *ft_fh, FILE *seq_fh )
{

  void set_position( FPOS fpos, FILE *ff );
  
  SEQ_INFO seq_info;
  int length[ NUMB_OF_SPEC ];  
    
  int i;
  for ( i = 0; i < data->spec_cell->n; i++ ) 
    update_ft_array_from_binary_fh( ft_array, ind_array, i, ft_fh );
    
  set_position( 0, seq_fh );

  PDATA_LIST *pdata_header = NULL, *last_pdata = NULL;
  
  int seq_numb = 0;
    
  while ( get_new_seq_region_fh( &seq_info, length, data->spec_cell->n, seq_fh )) 
    pdata_header = (PDATA_LIST *)get_pdata_list_single_seq( pdata_header,
      &last_pdata, data, ft_array, ind_array, &seq_info, length, ++seq_numb,
      ft_fh );
      
  return pdata_header;    
      
}











int pdata_lister_adds_seqs( PDATA_LIST *pdata_header, PDATA_LIST *pdata )
{

  if ( pdata_header == NULL )
    return 1;
    
  int add = 0, sub = 0;
    
  PDATA_LIST *pa = pdata_header, *pb = pdata;
  
  while (( pa != NULL ) && ( pb != NULL )) {
  
    if ( pb->my_pdata->seq_numb < pa->my_pdata->seq_numb ) {
      ++add;
      pb = pb->next;
      continue;
    }
  
    if ( pa->my_pdata->seq_numb == pb->my_pdata->seq_numb ) {
      
      if (( pa->my_pdata->ct_array[ 0 ] > 0 ) &&
        ( pb->my_pdata->ct_array[ 0 ] > 0 ))
      {
        ++sub;
      }
      
      if (( pa->my_pdata->ct_array[ 0 ] == 0 ) &&
        ( pb->my_pdata->ct_array[ 0 ] > 0 ))
      {
        ++add;
      }
        
      pa = pa->next;
      pb = pb->next;
 
      continue;
 
    }
  
    else 
      pa = pa->next;

  }
  
  while ( pb != NULL ) {
    ++add;
    pb = pb->next;
  }
  
  return ( add >= sub ) ? (1) : (0);

}








/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/













void set_region_from_binary_file( REGION *reg, PDATA_LIST *pdata_header )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  set_region_from_binary_fh( reg, pdata_header, fh );
  
  close_file( fh );

}
















void set_region_from_binary_fh( REGION *reg, PDATA_LIST *pdata_header,
  FILE *fh )
{

  extern int reg_start, reg_end;

  PDATA_LIST *pdata = pdata_header;
  
  SEQ seq_numb = 0;
  
  long total_len = 0, total_seq = 0, x = 0;
  int array[ NUMB_OF_SPEC ];
  
  SEQ_INFO seq_info;
  
  while ( pdata != NULL ) {
  
    while ( get( &seq_info, sizeof(SEQ_INFO), fh )) {
    
      get( array, sizeof(int) * pdata->my_pdata->numb_of_spec, fh );
      
      if ( ++seq_numb == pdata->my_pdata->seq_numb )
        break;
    
    }
    
    total_len += MIN( seq_info.x, reg_end - reg_start );
    ++total_seq;
    
    pdata = pdata->next;
  
  }
  
  int len = total_len / total_seq;
  
  reg->a = 0;
  reg->b = len;
  
}









/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/












void set_prior_probs_pdata( TREE *tree, PDATA_LIST *pdata_header )
{

  int array[ OCCUR_BUFFER ];  
  
  initialize_int_array( array, OCCUR_BUFFER );

  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL )
    set_ct_array_single_pdata_lister_and_step( array, &pdata );
    
  set_prior_probs_w_array( tree, array );
  
}













void set_ct_array_single_pdata_lister_and_step( int array[], PDATA_LIST **pdata )
{
  set_ct_array_single_pdata_lister( array, *pdata );
  *pdata = (*pdata)->next;
}













void set_ct_array_single_pdata_lister( int array[], PDATA_LIST *pdata )
{

  int i;
  
  for ( i = 0; i < pdata->my_pdata->numb_of_spec; i++ ) {
    if ( pdata->my_pdata->use_array[ i ] )
      ++(array[ pdata->my_pdata->ct_array[ i ] ]);      
  }

}











void set_prior_probs_w_array( TREE *tree, int array[] )
{

  STAT mu = get_expected_val_int_array( array, OCCUR_BUFFER );
  
  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL )
    set_prior_probs_node_lister_and_step( &node, mu );
    
}














STAT get_expected_val_int_array( int array[], int buffer )
{

  STAT sum = 0.0, n = 0.0;
  
  int i;
  
  for ( i = 0; i < buffer; i++ ) {
    sum += (STAT)(array[ i ] * i);
    n += array[ i ];
  }
  
  return sum / n;

}














void set_prior_probs_node_lister_and_step( NODE_LIST **node, STAT mu )
{
  set_prior_probs_node_lister( *node, mu );
  *node = (*node)->next;
}














void set_prior_probs_node_lister( NODE_LIST *node, STAT mu )
{

  int i;
  
  for ( i = 0; i < OCCUR_BUFFER; i++ ) 
    node->prior->x[ i ] = get_poisson_prob( mu, i );

}













STAT get_poisson_prob( STAT mu, int k )
{

  COUNT i;
  
  STAT x = exp( -1.0 * mu );
  
  for ( i = 1; i <= k; i++ )
    x *= mu / (STAT)i;

  return x;
  
}











COUNT fac( int k )
{

  COUNT x = 1;

  int i;
  
  for ( i = 1; i <= k; i++ )
    x *= i;
    
  return x;

}













void set_max_occur( PDATA_LIST *pdata_header )
{

  extern int max_occur;
  
  max_occur = 0;

  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL ) {
  
    int i;
    
    for ( i = 0; i < pdata->my_pdata->numb_of_spec; i++ ) {
      if ( pdata->my_pdata->ct_array[ i ] > max_occur ) 
        max_occur = pdata->my_pdata->ct_array[ i ];
    }
    
    pdata = pdata->next;
  
  }
  
  if ( max_occur + 5 >= OCCUR_BUFFER )
    error( 6130, "Max numb of occurrences exceeds OCCUR_BUFFER.\n" );

}










