#include "../ext/struct.h"

















DATA_LIST *get_origin_data( DATA_LIST *data, MOTIF *mf );

DATA *get_my_origin_data( DATA *data, MOTIF *mf );

SPEC_CELL *get_spec_cell( void );

void set_tree_ancestor_branches( TREE *tree );

PDATA_LIST *get_listed_pdata_list( DATA *data );

void get_listed_pdata_list_w_fhs( DATA *data, FILE *ft_fh, FILE *ind_fh,
  FILE *seq_fh, FILE *fpos_fh );

PDATA_LIST *get_listed_pdata_list_single_kmer( PDATA_LIST *pdata_header, 
  DATA *data, MF w, int numb_of_spec, FILE *ft_fh, FILE *ind_fh, FILE *seq_fh, 
  FILE *fpos_fh );

void initialize_first_ft_array( FT ft_array[], int n );

PDATA_LIST *get_my_listed_pdata_list_w_fhs( PDATA_LIST *pdata_old, DATA *data, 
  FT ft_array[], FT_IND ind_array[], FILE *ft_fh, FILE *seq_fh );

PDATA_LIST *update_pdata_list( PDATA_LIST *pdata_header, PDATA_LIST *pdata_new,
  int numb_of_spec );

void update_pdata_lister_pair( PDATA_LIST *pdata, PDATA_LIST *new_pdata,
  int numb_of_spec );

void update_pdata_lister_matching_seq_numb( PDATA_LIST *pdata, PDATA_LIST *new,
  int numb_of_spec );

void update_pdata_lister_matching_seq_single_spec( PDATA_LIST *pdata,
  PDATA_LIST *new, int spec_numb );

void add_pdata_lister_uneven_seq_numb( PDATA_LIST *pdata, PDATA_LIST *new );

int get_new_seq_region_fh( SEQ_INFO *seq_info, int length[], int numb_of_spec,
  FILE *seq_fh );

int update_ft_array_from_binary_fh( FT ft_array[], FT_IND ind_array[], int i,
  FILE *ft_fh );

PDATA_LIST *get_pdata_list_single_seq( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  SEQ_INFO *seq_info, int length[], SEQ seq_numb, FILE *ft_fh );

void set_use_array_from_length_array( int use_array[], int length[], int n );

int array_sum( int array[], int n );

PDATA_LIST *get_and_put_pdata_lister_single_seq( PDATA_LIST *pdata_header, 
  PDATA_LIST **last_pdata, DATA *data, FT ft_array[], FT_IND ind_array[], 
  int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, FILE *ft_fh );

PDATA_LIST *put_pdata_lister_into_list( PDATA_LIST *pdata_header,
  PDATA_LIST **last_pdata, PDATA_LIST *pdata );

void set_pdata_lister_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  FILE *ft_fh );

void set_pdata_lister_single_spec_info( PDATA_LIST *pdata, DATA *data, FT ft_array[],
  FT_IND ind_array[], int use_array[], SEQ_INFO *seq_info, SEQ seq_numb, 
  int spec_numb, FILE *ft_fh );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



DATA_LIST *get_origin_kmer_data( DATA_LIST *data, MOTIF *mf );

DATA_LIST *get_my_origin_kmer_data( DATA_LIST *my_data, MOTIF *mf );

void get_listed_pdata_kmer_list( DATA_LIST *my_data );

void get_listed_pdata_kmer_list_w_fhs( DATA_LIST *my_data, FILE *ft_fh, FILE *ind_fh,
  FILE *seq_fh, FILE *fpos_fh, FILE *kmer_fh, FILE *pwm_fh );

MOTIF_LIST *get_motif_list_w_fh( MOTIF_LIST *mf_header, FILE *fh );

MOTIF_LIST *get_and_put_motif_lister_from_line( MOTIF_LIST *mf_header, char line[] );

MOTIF_LIST *put_motif_lister_end_of_list( MOTIF_LIST *mf_header, MOTIF_LIST *mf );

void get_pwm_from_text_file( PWM *pwm, FILE *pwm_fh );

void get_my_listed_pdata_kmer_list_w_fhs( DATA_LIST *data, MOTIF_LIST *mf_header, 
  PWM *pwm, PWM *bg_pwm, FILE *ft_fh, FILE *ind_fh, FILE *seq_fh, 
  FILE *fpos_fh, FILE *pwm_fh );

MOTIF_LIST *sort_kmer_mf_list_by_score( MOTIF_LIST **plus_mf, MOTIF_LIST **minus_mf,
  MOTIF_LIST *mf_header, PWM *pwm, PWM *bg_pwm );

MOTIF_LIST *put_motif_lister_into_score_list( MOTIF_LIST *mf_header,
  MOTIF_LIST *mf, float score_array[], int total, float score );

int get_score_index_update_array( float score_array[], float score, int total );

PDATA_LIST *get_listed_pdata_list_single_mf_lister( DATA *data, PWM *pwm, 
  PWM *bg_pwm, MOTIF *mf, int numb_of_spec, FILE *ft_fh, FILE *ind_fh, 
  FILE *seq_fh, FILE *fpos_fh );

PDATA_LIST *get_my_listed_pdata_list_single_mf_lister( DATA *data, FT ft_array[], 
  FT_IND ind_array[], FILE *ft_fh, FILE *seq_fh );

int pdata_lister_adds_seqs( PDATA_LIST *pdata_header, PDATA_LIST *pdata );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_region_from_binary_file( REGION *reg, PDATA_LIST *pdata_header );

void set_region_from_binary_fh( REGION *reg, PDATA_LIST *pdata_header,
  FILE *fh );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_prior_probs_pdata( TREE *tree, PDATA_LIST *pdata_header );

void set_ct_array_single_pdata_lister_and_step( int array[], PDATA_LIST **pdata );

void set_ct_array_single_pdata_lister( int array[], PDATA_LIST *pdata );

void set_prior_probs_w_array( TREE *tree, int array[] );

STAT get_expected_val_int_array( int array[], int buffer );

void set_prior_probs_node_lister_and_step( NODE_LIST **node, STAT mu );

void set_prior_probs_node_lister( NODE_LIST *node, STAT mu );

STAT get_poisson_prob( STAT mu, int k );

COUNT fac( int k );

void set_max_occur( PDATA_LIST *pdata_header );









