














#include "../ext/struct.h"











void set_tree_derivs( NODE_LIST *root, MODEL_LIST *model );

void set_node_derivs( NODE_LIST *node, MODEL_LIST *model );

void set_node_single_p_deriv( NODE_LIST *node, MODEL_LIST *model );

void set_node_u_deriv( STAT u[], PARAMS *pp, TIME t );

void set_node_v_deriv( STAT v[], PARAMS *pp, TIME t );

void set_node_u_double_deriv( STAT u[ BD ][ BD ], PARAMS *pp, TIME t );

void set_node_v_double_deriv( STAT v[ BD ][ BD ], PARAMS *pp, TIME t );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_p_deriv( NODE_LIST *node, PARAMS *pp, COUNT n );

void set_p_single_deriv( NODE_LIST *node, PARAMS *pp, COUNT n );

void set_p_single_deriv_single_i_val( NODE_LIST *node, PARAMS *pp, int i, int end );

void set_p_second_derivs( NODE_LIST *node, PARAMS *pp, int end );

void get_two_binom_arrays( STAT uu[], STAT vv[], NODE_LIST *node, int i );

void get_two_deriv_binom_arrays( STAT uu_d[], STAT vv_d[], NODE_LIST *node,
  int bd, int i );

void get_two_dd_binom_arrays( STAT uu_dd[], STAT vv_dd[], NODE_LIST *node,
  int bd_i, int bd_j, int i );

STAT get_p_deriv_elem( NODE_LIST *node, int i, int j, int bd, STAT uu[], STAT vv[],
  STAT uu_d[], STAT vv_d[] );

void get_binom_array( STAT array[], STAT pr, COUNT n, COUNT max_k );

void fill_zero_array( STAT array[], COUNT start, COUNT max );

void get_deriv_binom_array( STAT d_array[], STAT pr, STAT deriv, COUNT n,
  COUNT max_k );

void get_my_deriv_binom_array( STAT d_array[], STAT pr, STAT deriv, COUNT n,
  COUNT max_k );

void get_dd_binom_array( STAT array[], STAT pr, STAT da, STAT db, STAT dd, int n, 
  int max_k );

void get_my_dd_binom_array( STAT array[], STAT pr, STAT da, STAT db, STAT dd,
  int n, int max_k );

STAT get_p_double_deriv_elem( NODE_LIST *node, int i, int j, int bd_i, int bd_j, 
  STAT uu[], STAT vv[], STAT uu_d[], STAT vv_d[], STAT uu_f[], STAT vv_f[],
  STAT uu_dd[], STAT vv_dd[] );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void check_p_derivs( NODE_LIST *node, PARAMS *pp, int max );

void check_p_single_deriv( NODE_LIST *node, PARAMS *pp, int max );

void check_p_single_deriv_single_param( NODE_LIST *node, PARAMS *pp, int bd,
  int max );

int check_p_single_deriv_ij( NODE_LIST *node, PARAMS *pp, int bd, int i, int j,
  int flag );

int same_val( STAT a, STAT b );

void check_p_double_deriv( NODE_LIST *node, PARAMS *pp, int max );

void check_p_double_deriv_single_pp( NODE_LIST *node, PARAMS *pp, int bd_i,
  int bd_j, int max );

int check_p_double_deriv_ij( NODE_LIST *node, PARAMS *pp, int bd_i, int bd_j,
  int i, int j, int flag );













