#include "init.h"



























void set_init_null_model_params( MODEL_LIST *model, DATA *data )
{

  TAB tab = { .birth = 0.0, .death = 0.0, .t = 0.0 };

  get_init_tab_vals( &tab, data->tree, data->pdata );
  
  set_init_null_model_params_w_tab_info( model, &tab, data->pdata );

}












void get_init_tab_vals( TAB *tab, TREE *tree, PDATA_LIST *pdata_header )
{

  PDATA_LIST *pdata = pdata_header;
  
  while ( pdata != NULL )
    get_init_tab_vals_single_seq_and_step( tab, tree, &pdata );

}












void get_init_tab_vals_single_seq_and_step( TAB *tab, TREE *tree, 
  PDATA_LIST **pdata )
{
  get_init_tab_vals_single_seq( tab, tree, *pdata ); 
  *pdata = (*pdata)->next;
}











void get_init_tab_vals_single_seq( TAB *tab, TREE *tree, PDATA_LIST *pdata )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );

  /*  In analysis.c:  */
  clear_tree( tree->root );
  
  /*  In analysis.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  get_init_tab_vals_set_leaves( tab, tree );

}












void get_init_tab_vals_set_leaves( TAB *tab, TREE *tree )
{

  STAT x = 0.0;
  TIME t = 0.0;

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL )
    x += set_change_vals_single_node_lister_and_step( &node, &t );
    
  tab->birth += x;
  tab->t += t;

}











STAT set_change_vals_single_node_lister_and_step( NODE_LIST **node, TIME *t )
{
  STAT x = set_change_vals_single_node_lister( *node, t );
  *node = (*node)->next;
  return x;
}











STAT set_change_vals_single_node_lister( NODE_LIST *node, TIME *t )
{

  STAT get_mean_occur_node( NODE_LIST *node );

  if ( node->my_info->use == 0 )
    return 0.0;  
    
  *t += node->my_node->t;

  if ( node->my_node->leaf )
    return 0.0;
    
  /*  In lhood.c:  */  
  node->my_info->mean = get_mean_occur_node( node );    
  
  /*  In this file, below:  */
  return get_change_vals_node_lister( node );

}












STAT get_change_vals_node_lister( NODE_LIST *node )
{

  STAT sum = 0.0;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      break;
      
    if ( node->down[ i ]->my_info->use == 0 )
      continue;
      
    sum += fabs( node->my_info->mean - node->down[ i ]->my_info->mean );
    
  }
  
  return sum;

}













void set_init_null_model_params_w_tab_info( MODEL_LIST *model, TAB *tab,
  PDATA_LIST *pdata_header )
{

  STAT get_mean_occur_pdata( PDATA_LIST *pdata_header );
  
  REGION *r = model->my_model->my_region;
  
  int len = r->b - r->a;
  
  STAT a = (STAT)tab->birth / (STAT)(len * tab->t * MILLION);
  
  /*  In lhood.c:  */
  STAT mean = get_mean_occur_pdata( pdata_header );
  
  model->my_model->part_header->my_part->pp->a = a;
  model->my_model->part_header->my_part->pp->b = a * len * mean;
  
}




