















#include "../ext/struct.h"








void matrix_mult( MX *c, MX *a, MX *b );

STAT get_matrix_mult_elem( MX *a, MX *b, int i, int j );

void mx_times_vec( VEC *x, MX *a, VEC *b );

STAT get_mx_times_vec_elem( MX *a, VEC *b, int i );

void vec_mult_mx( VEC *c, VEC *s, MX *a );

STAT get_vec_mult_mx_elem( VEC *s, MX *a, int i );

void vec_mult_scalar( VEC *v, STAT c );

void add_vec( VEC *c, VEC *a, VEC *b );

void subtract_vec( VEC *c, VEC *a, VEC *b );

void increm_mx( MX *a, MX *b );

STAT dot_prod( VEC *a, VEC *b );

void outer_prod( MX *c, VEC *a, VEC *b );

void sym_mx( MX *mx );

void get_pos_x_vec( VEC *x, VEC *s, VEC *old_x );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void get_mx_inv( MX *inv, MX *a );

void get_my_mx_inv( MX *inv, MX *a, VEC *v, VEC *sol );

void get_mx_inv_single_col( MX *inv, MX *a, VEC *v, VEC *sol, int col );

void get_ident_vec_for_inv( VEC *v, int col );

void system_of_eq( VEC *sol, VEC *v, MX *a );

void do_system_of_eq( VEC *sol, VEC *v, MX *a, MX *L, MX *U );

void set_diag_l( MX *L );

void do_lu_decomp( MX *L, MX *U, MX *a );

STAT get_u_elem( MX *a, MX *L, MX *U, int i, int j );

STAT get_l_elem( MX *a, MX *L, MX *U, int i, int j );

void do_my_system_of_eq( VEC *sol, MX *L, MX *U, VEC *v );

void do_system_of_eq_y_vec( VEC *sol, VEC *y, MX *L, MX *U, VEC *v );

void find_y_system_of_eq( VEC *y, MX *L, VEC *v );

void find_sol_vector_system_of_eq( VEC *sol, MX *U, VEC *y );

void put_col_into_mx( MX *inv, VEC *sol, int col );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void print_mx( MX *mx );

void print_mx_fh( MX *mx, FILE *fh );

void print_my_mx( MX *mx, FILE *fh );

void print_vec( VEC *v );

void print_vec_fh( VEC *v, FILE *fh );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void check_mx_nan( MX *mx );

int mx_is_nan( MX *mx );

void check_vec_nan( VEC *v );

int vec_is_nan( VEC *v );

int stat_is_nan( STAT x );

int vec_is_zero( VEC *v );

void check_inv( MX *inv, MX *a );



















