
















#include "../ext/struct.h"










void do_newton( EM_INFO *info );

void set_broy_from_em_info( BROY *bb, EM_INFO *info );

void set_vec_from_pt_cell( VEC *vec, PT_CELL *pt_cell );

void do_newton_method( BROY *bb, EM_INFO *info );

int newton_is_going( BROY *bb );

void do_newton_single_iter( BROY *bb, EM_INFO *info );

void do_newton_first_loop( BROY *bb, EM_INFO *info );

void do_newtown_subsequent_loop( BROY *bb, EM_INFO *info );

void update_newton_iter_end( BROY *bb, EM_INFO *info );

void update_pt_cell_from_vec( PT_CELL *pt_cell, VEC *x );

STAT get_lhood_from_info( EM_INFO *info );

void get_step_param_vec( BROY *bb );

void get_new_b_mx( BROY *bb, VEC *w );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void get_hessian_and_grad_w_info( MX *j, VEC *f, EM_INFO *info );

void get_my_hessian_and_grad_w_info( MX *mx, VEC *f, EM_INFO *info );

void get_hessian_and_grad_single_row_w_info( MX *mx, VEC *f, EM_INFO *info, int pi, 
  int bi );

STAT get_hessian_elem_w_info( EM_INFO *info, VEC *f, int i, int j, int pi, int bi,
  int pj, int bj );

STAT get_hessian_elem_single_pdata_and_step( PDATA_LIST **pdata, EM_INFO *info,
  VEC *f, int i, int j, int pi, int bi, int pj, int bj );

STAT get_hessian_elem_single_pdata( PDATA_LIST *pdata, EM_INFO *info, VEC *f, int i,
  int j, int pi, int bi, int pj, int bj );

void set_use_vals_tree( TREE *tree );

void set_use_vals_single_leaf_and_step( NODE_LIST **node );

void set_use_vals_single_leaf( NODE_LIST *node );

STAT get_my_hessian_elem_single_pdata( TREE *tree, VEC *f, int i, int j, int pi, 
  int bi, int pj, int bj );

void get_hessian_elem_pdata_single_node_and_step( NODE_LIST **node, int pi, int bi,
  int pj, int bj );

void get_hessian_elem_pdata_single_node( NODE_LIST *node, int pi, int bi, int pj,
  int bj );

void get_my_hessian_elem_pdata_single_node( NODE_LIST *node, int pi, int bi, int pj,
  int bj );

STAT get_node_info_w_prior( NODE_INFO *x, NODE_INFO *prior );

STAT get_deriv_single_ct( NODE_LIST *node, int d_index, int i, int p, int b );

STAT get_deriv_single_ct_single_daughter_node( NODE_LIST *d, int d_index, int i, 
  int p, int b );

STAT get_deriv_single_daughter_denom( NODE_LIST *d, int i, int j );

STAT get_deriv_single_daughter_numer( NODE_LIST *d, int d_index, int i, int j, 
  int p, int b );

STAT get_dd_single_ct( NODE_LIST *node, int i, int pi, int bi, int pj, int bj );

STAT get_dd_term_single_ct( NODE_LIST *node, int i, int pi, int bi, int pj,
  int bj );

STAT get_dd_term_single_daughter_node( NODE_LIST *d, int i, int pi, int bi,
  int pj, int bj );

STAT get_second_deriv_term( STAT a, STAT b, STAT c[] );

STAT get_second_deriv_s_single_ct( NODE_LIST *d, int i, int j );

STAT get_second_deriv_d_single_ct( NODE_LIST *d, int d_index, int i, int j, 
  int p, int b );

STAT get_second_deriv_dd_single_ct( NODE_LIST *d, int i, int j, int pi, int bi, 
  int pj, int bj );

void set_trans_probs_derivs( TREE *tree, PT_CELL *pt_cell, REGION *reg );

void set_trans_probs_deriv_single_node_and_step( NODE_LIST **node, PT_CELL *pt_cell,
  REGION *reg );

void set_trans_probs_deriv_single_node( NODE_LIST *node, PT_CELL *pt_cell,
  REGION *reg );

int get_part_numb_pt_cell( NODE_LIST *node, PT_CELL *pt_cell );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void get_grad_vec_newton( VEC *f, EM_INFO *info );

void get_my_grad_vec_newton( VEC *f, EM_INFO *info );

STAT get_grad_vec_elem_newton( EM_INFO *info, int p, int b );

STAT get_grad_vec_elem_single_pdata_and_step( PDATA_LIST **pdata, EM_INFO *info,
  int p, int b );

STAT get_grad_vec_elem_single_pdata( PDATA_LIST *pdata, EM_INFO *info, int p, 
  int b );

STAT get_my_grad_vec_elem_single_pdata( TREE *tree, int p, int b );

void set_grad_deriv_vals_single_node_pdata_and_step( NODE_LIST **node, int p,
  int b );

void set_grad_deriv_vals_single_node_pdata( NODE_LIST *node, int p, int b );

void set_my_grad_deriv_vals_single_node_pdata( NODE_LIST *node, int p, int b );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void make_broy( BROY *b, INDEX n );

void set_broy( BROY *bb, VEC *param, MODEL_LIST *model, NODE_LIST *root, 
  OCCUR_CELL *occur_cell );

void kill_broy( BROY *bb );

















