#include "origin_branch.h"























void set_origin_site_list( ORIGIN_LIST *origin, DATA_LIST *data )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *ft_fh = NULL, *ind_fh = NULL, *ss_fh = NULL;
  
  ft_fh = (FILE *)open_binary_file_reading( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_reading( input_file, "i" );
  ss_fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  set_origin_site_list_w_fh( origin, data, ft_fh, ind_fh, ss_fh );
  
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( ss_fh );
  
}











void set_origin_site_list_w_fh( ORIGIN_LIST *origin, DATA_LIST *data, 
  FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  SITE_LIST *site_header = NULL;
  
  origin->my_origin->anc_bd = 0;
  
  MOTIF *mf = origin->my_origin->mf;
  
  site_header = (SITE_LIST *)get_site_list_from_data( origin, data->data,
    origin->my_origin->res->my_result->my_model, mf, ft_fh, ind_fh, ss_fh );

  origin->my_origin->site_header[ PLUS_STRAND ] = site_header;
  
}












SITE_LIST *get_site_list_from_data( ORIGIN_LIST *origin, DATA *data,
  MODEL_LIST *model, MOTIF *mf, FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  void set_trans_probs_model( TREE *tree, MODEL_LIST *model );
  void set_position( FPOS fpos, FILE *fh );
  
  int spec_index = get_my_spec_numb_from_spec_cell( data->spec_cell );
  
  FT_IND array[ NUMB_OF_SPEC ];
  SEQ_INFO seq_info;
  SEQ seq_numb = 0;
  
  get( array, sizeof(FT_IND) * data->spec_cell->n, ind_fh );
  
  FT_IND ft_ind = array[ spec_index ];
  
  set_position( ft_ind.fpos, ft_fh );
  
  SEQ_LIST *seq_header = NULL, *last = NULL;
  seq_header = (SEQ_LIST *)get_seq_list_single_spec_from_count( seq_header,
    ft_ind.n, data->pdata, &last, &seq_info, &seq_numb, ft_fh, ss_fh );

  PDATA_LIST *pdata = data->pdata;
  SEQ_LIST *seq = seq_header;
  
  /*  In ../model/lhood.c:  */
  set_trans_probs_model( data->tree, model );
  
  SITE_LIST *site_header = NULL, *last_site = NULL;
  
  while ( pdata != NULL ) 
    /*  In this file, below:  */
    site_header = (SITE_LIST *)get_site_list_single_seq_and_step( site_header,
      &seq, &pdata, &last_site, data->tree, origin, mf );
      
  return site_header;

}









int get_my_spec_numb_from_spec_cell( SPEC_CELL *spec_cell )
{

  extern char major_spec[ BUFFER ];

  int i;
  
  for ( i = 0; i < spec_cell->n; i++ ) {
    if ( ! strcmp( major_spec, (spec_cell->x + i)->spec ))
      return i;
  }
  
  return -1;

}










SEQ_LIST *get_seq_list_single_spec_from_count( SEQ_LIST *seq_header, int n, 
  PDATA_LIST *pdata_header, SEQ_LIST **last, SEQ_INFO *seq_info,
  SEQ *seq_numb, FILE *ft_fh, FILE *ss_fh )
{

  PDATA_LIST *pdata = pdata_header;
  
  int i;
  
  for ( i = 0; i < n; i++ )
    seq_header = (SEQ_LIST *)get_seq_list_from_count_single_site( seq_header,
      &pdata, last, seq_info, seq_numb, ft_fh, ss_fh );
      
  return seq_header;

}












SEQ_LIST *get_seq_list_from_count_single_site( SEQ_LIST *seq_header, 
  PDATA_LIST **pdata, SEQ_LIST **last, SEQ_INFO *seq_info, SEQ *seq_numb,
  FILE *ft_fh, FILE *ss_fh )
{

  FT ft;
  
  get( &ft, sizeof(FT), ft_fh );
  
  if ( *pdata == NULL )
    return seq_header;
    
  while ( (*pdata)->my_pdata->seq_numb < ft.seq )
    *pdata = (*pdata)->next;
    
  if ( (*pdata)->my_pdata->seq_numb != ft.seq )
    return seq_header;
    
  while ( *seq_numb < ft.seq ) {
    
    get( seq_info, sizeof(SEQ_INFO), ss_fh );
    
    int array[ NUMB_OF_SPEC ];
    get( array, sizeof(int) * (*pdata)->my_pdata->numb_of_spec, ss_fh );
    
    ++(*seq_numb);
    
  }
    
  return get_my_seq_list_from_count_single_site( seq_header, *pdata, &ft, last,
    seq_info, *seq_numb );
  
}










SEQ_LIST *get_my_seq_list_from_count_single_site( SEQ_LIST *seq_header, 
  PDATA_LIST *pdata, FT *ft, SEQ_LIST **last, SEQ_INFO *seq_info, SEQ seq_numb )
{

  SEQ_LIST *create_seq_lister( SEQ_LIST *x );
  
  SEQ_LIST *seq = NULL;
  seq = (SEQ_LIST *)create_seq_lister( seq );
  
  set_seq_lister_for_site( seq, ft, seq_info, seq_numb );
  
  if ( seq_header == NULL ) {
    *last = seq;
    return seq;
  }
  
  (*last)->next = seq;
  *last = seq;
  
  return seq_header;

}












void set_seq_lister_for_site( SEQ_LIST *seq, FT *ft, SEQ_INFO *seq_info,
  SEQ seq_numb )
{

  *(seq->my_seq) = *seq_info;
  
  seq->my_seq->start += ft->pos[ 0 ];
  seq->my_seq->end = seq->my_seq->start + strlen( ft->site );
  
  strcpy( seq->my_seq->gene, ft->site );
  
  seq->numb = seq_numb;

}







SITE_LIST *get_site_list_single_seq_and_step( SITE_LIST *site_header,
  SEQ_LIST **seq, PDATA_LIST **pdata, SITE_LIST **last_site, TREE *tree, 
  ORIGIN_LIST *origin, MOTIF *mf )
{

  SITE_LIST *new_site = NULL;

  new_site = (SITE_LIST *)get_new_site_list_single_seq( new_site, seq, *pdata,
    tree, origin, mf );
    
  site_header = (SITE_LIST *)put_new_site_list_into_list( site_header, new_site, 
    last_site );
    
  *pdata = (*pdata)->next;
  
  return site_header;
  
}











SITE_LIST *put_new_site_list_into_list( SITE_LIST *site_header, 
  SITE_LIST *new_sites, SITE_LIST **last_site )
{

  if ( new_sites == NULL ) 
    return site_header;
    
  if ( *last_site != NULL )
    (*last_site)->next = new_sites;
  else  
    *last_site = new_sites;

  while ( (*last_site)->next != NULL )
    *last_site = (*last_site)->next;
      
  if ( site_header == NULL )
    return new_sites;
    
  return site_header;

}













SITE_LIST *get_new_site_list_single_seq( SITE_LIST *new_site, SEQ_LIST **seq, 
  PDATA_LIST *pdata, TREE *tree, ORIGIN_LIST *origin, MOTIF *mf )
{

  if ( *seq == NULL )
    return NULL;
    
  new_site = (SITE_LIST *)make_new_site_list( new_site, seq, pdata );
  
  if ( new_site == NULL )
    return NULL;

  set_site_lister_origin( new_site, pdata, tree, origin );

  return new_site;

}










SITE_LIST *make_new_site_list( SITE_LIST *new_site, SEQ_LIST **seq, 
  PDATA_LIST *pdata )
{

  SITE_LIST *create_site_lister( SITE_LIST *x );

  SEQ_LIST *my_seq = *seq;
  SITE_LIST *last_site = NULL;
  
  while (( my_seq != NULL ) && ( my_seq->numb == pdata->my_pdata->seq_numb )) {
        
    SITE_LIST *site = NULL;
    site = (SITE_LIST *)create_site_lister( site );
    
    new_site = (SITE_LIST *)set_and_put_new_site_lister( new_site, site, &last_site,
      my_seq, pdata );
    
    my_seq = my_seq->next;
    
  }
  
  *seq = my_seq;

  return new_site;
  
}












SITE_LIST *set_and_put_new_site_lister( SITE_LIST *new_site, SITE_LIST *site,
  SITE_LIST **last_site, SEQ_LIST *seq, PDATA_LIST *pdata )
{

  set_new_site_lister( site, seq, pdata );
  
  return put_new_site_lister( new_site, site, last_site );

}












SITE_LIST *put_new_site_lister( SITE_LIST *new_site, SITE_LIST *site,
  SITE_LIST **last_site )
{

  if ( new_site == NULL ) {
    *last_site = site;
    return site;
  }
  
  (*last_site)->next = site;
  *last_site = site;
  
  return new_site;

}











void set_new_site_lister( SITE_LIST *site, SEQ_LIST *seq, PDATA_LIST *pdata )
{

  *(site->site->loc) = *(seq->my_seq);
  site->site->seq_numb = seq->numb;

  site->stats->occur_in_seq = 0;
  
  strcpy( site->site->seq, seq->my_seq->gene );

}










void set_site_lister_origin( SITE_LIST *new_site, PDATA_LIST *pdata, 
  TREE *tree, ORIGIN_LIST *origin )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );
  
  /*  In ../birth/set.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  set_site_lister_origin_w_tree( new_site, tree, origin );

}













void set_site_lister_origin_w_tree( SITE_LIST *new_site, TREE *tree,
  ORIGIN_LIST *origin )
{

  STAT get_my_lhood_pdata_single_seq( TREE *tree );
  void set_tree_q( TREE *tree );
  
  /*  In ../model/lhood.c:  */
  STAT lhood = get_my_lhood_pdata_single_seq( tree );
  
  /*  In ../model/lhood.c:  */
  set_tree_q( tree );
  
  /*  In this file, below:  */
  set_my_site_lister_origin_w_tree( new_site, tree, origin );

}













void set_my_site_lister_origin_w_tree( SITE_LIST *new_site, TREE *tree,
  ORIGIN_LIST *origin )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );
  
  extern char major_spec[ BUFFER ];
  
  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, major_spec );
    
  int unique = 1, done = 0, leaf_q = node->my_info->q;
  
  SITE_LIST *site = new_site;
    
  printf( "Q = %d\n", (int)node->my_info->q );
  
  while (( ! done ) && ( node != NULL ) && ( site != NULL ))
    done = set_site_lister_origin_single_branch_and_step( &site, &node, &unique,
      leaf_q );

}











int set_site_lister_origin_single_branch_and_step( SITE_LIST **site,
  NODE_LIST **node, int *unique, int leaf_q )
{

  int done = set_site_lister_origin_single_branch( site, *node, unique, leaf_q );
  
  *node = (*node)->up;
  
  return done;

}












int set_site_lister_origin_single_branch( SITE_LIST **site, NODE_LIST *node,
  int *unique, int leaf_q )
{

  if ( node->up == NULL ) {
  
    if ( node->my_info->q > 1 )
      *unique = 0;
  
    int new_site = 0;
    
    if ( leaf_q > node->my_info->q )
      new_site = 1;
      
    while ( *site != NULL )
      set_site_lister_node_and_step( site, *unique, node, new_site );
  
    return 1;
  
  }
  
  if ( node->my_info->q > node->up->my_info->q ) {
  
    if (( leaf_q > 1 ) && ( node->up->my_info->q > 0 ))
      *unique = 0;
      
    int new_site = 0;
    
    if ( leaf_q > node->up->my_info->q )
      new_site = 1;
      
    int i = 0, end = node->my_info->q - node->up->my_info->q;
    
    while (( *site != NULL ) && ( i++ < end )) 
      set_site_lister_node_and_step( site, *unique, node, new_site );

  }
  
  return ( node->my_info->q > 0 ) ? (0) : (1);

}











void set_site_lister_node_and_step( SITE_LIST **site, int unique, NODE_LIST *node,
  int new_site )
{

  strcpy( (*site)->stats->node, node->my_node->label );
  (*site)->stats->unique = unique;
  (*site)->stats->new_site = new_site;
  
  printf( "\t\t\t\t\t%12s\t%d\n", node->my_node->label, new_site );
  
  *site = (*site)->next;  

}
































