#include "origin_list.h"






















ORIGIN_LIST *get_set_origin_lister_w_data_lister( ORIGIN_LIST *origin, 
  DATA_LIST *data )
{

  void set_origin_site_list( ORIGIN_LIST *origin, DATA_LIST *data );

  /*  In this file, below:  */
  set_origin_result_listers( origin, data );

  /*  In origin_branch.c:  */  
  set_origin_site_list( origin, data );
  
  return origin;
  
}












void set_origin_result_listers( ORIGIN_LIST *origin, DATA_LIST *data )
{

  RESULT_LIST *res = NULL;
  /*  In this file, below:  */
  res = (RESULT_LIST *)get_origin_result_list_w_data_lister( res, data );
  
  origin->my_origin->res = res;

}










RESULT_LIST *get_origin_result_list_w_data_lister( RESULT_LIST *res,
  DATA_LIST *data )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *x );

  RESULT_LIST *r_old = NULL;
  r_old = (RESULT_LIST *)create_result_lister( r_old );
  
  set_result_lister_init( r_old, data );
  
  MOTIF *mf = data->data->mf;
  
  return do_new_birth_death_model_w_result_lister( res, r_old, data, mf );

}











void set_result_lister_init( RESULT_LIST *r, DATA_LIST *data )
{

  RESULT *rr = r->my_result;
  
  *(rr->mf) = *(data->data->mf);
  
  rr->model_header = NULL;
  rr->my_model = NULL;
  rr->null_model = NULL;
  rr->pval = 1.0;
  rr->m = 0;
  rr->use = 0;
  
}















RESULT_LIST *do_new_birth_death_model_w_result_lister( RESULT_LIST *res, 
  RESULT_LIST *r_old, DATA_LIST *data, MOTIF *mf )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *r );
  
  MODEL_LIST *null_model = NULL, *satd_model = NULL, *model_header = NULL;
  
  res = (RESULT_LIST *)create_result_lister( res );  
  *(res->my_result->mf) = *mf;
  
  null_model = (MODEL_LIST *)get_new_null_model( null_model, data->data, mf );

  res->my_result->null_model = null_model;
  res->my_result->my_model = null_model;
  
  return res;

  /*
  satd_model = (MODEL_LIST *)get_new_satd_model( satd_model, null_model, data, mf );
  
  model_header = (MODEL_LIST *)get_model_list_de_novo( model_header, null_model,
    satd_model, data, mf );
    
  kill_model_lister( satd_model );
    
  return set_result_lister_w_model_lists( new_r, null_model, model_header );
  */
  
}












MODEL_LIST *get_new_null_model( MODEL_LIST *null_model, DATA *data, MOTIF *mf )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX m );
  MODEL_LIST *get_opt_model_em_new( MODEL_LIST *new_model, MODEL_LIST *old_model,
    DATA *data );

  MODEL_LIST *model = NULL;
  
  model = (MODEL_LIST *)create_model_lister( model, data->mf, 0 );
  
  /*  In this file, below:  */
  set_null_model( model, data );
  
  /*  In em.c:  */
  null_model = (MODEL_LIST *)get_opt_model_em_new( null_model, model, data );
  
  kill_model_list( model );

  return null_model;
  
}











void set_null_model( MODEL_LIST *model, DATA *data )
{

  /*  In this file, below:  */
  set_region_from_input_files( model->my_model->my_region, data->pdata,
    data->spec_cell->n );
  
  /*  In ../birth/model_set.c:  */
  set_model_branches( model, data->tree->root );
  
  /*  In init.c:  */
  set_init_null_model_params( model, data );

}














void set_region_from_input_files( REGION *r, PDATA_LIST *pdata_header,
  int numb_of_spec )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  extern int score_thresh;
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  COORD total_length = 0, numb_of_seqs = 0;
  
  PDATA_LIST *pdata = pdata_header;
  
  SEQ seq = 0;
  
  SEQ_INFO seq_info;
  int array[ NUMB_OF_SPEC ];
  
  while ( get( &seq_info, sizeof(SEQ_INFO), fh )) {
  
    get( array, sizeof(int) * numb_of_spec, fh );
    
    if ( pdata == NULL )
      break;
      
    if ( pdata->my_pdata->seq_numb == ++seq ) {
      total_length += seq_info.end - seq_info.start;
      ++numb_of_seqs;
      pdata = pdata->next;
    }    
  
  }
  
  close_file( fh );
  
  r->a = 0;
  r->b = total_length / numb_of_seqs;

}








void set_model_branches( MODEL_LIST *model, NODE_LIST *root )
{

  set_part_list_numbs( model->my_model->part_header );
  
  LIST *branch_header = NULL;
  branch_header = (LIST *)get_branches_one_part( branch_header, root );
  
  model->my_model->part_header->my_part->branch_header = branch_header;

}











void set_part_list_numbs( PART_LIST *part_header )
{

  int i = 0;
  
  PART_LIST *part = part_header;
  
  while ( part != NULL ) {  
    part->my_part->part = i++;
    part = part->next;
  }

}









LIST *get_branches_one_part( LIST *branch_header, NODE_LIST *root )
{

  NODE_LIST *get_spec_header( NODE_LIST *node );
  LIST *create_lister( LIST *x, char type );
  
  NODE_LIST *node;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_spec_header( root );
  
  LIST *header = NULL, *last = NULL;
  
  while ( node != NULL ) {
  
    LIST *new = NULL;
    new = (LIST *)create_lister( new, INT_TYPE );
    
    new->elem.d = node->my_node->numb;
    
    header = (LIST *)put_lister_end_list_elem( header, new, &last );  
  
    node = node->next;
    
  }
  
  return header;

}










LIST *put_lister_end_list_elem( LIST *header, LIST *new, LIST **last )
{

  if ( header == NULL ) {
    *last = new;
    return new;
  }
  
  (*last)->next = new;
  *last = new;
  
  return header;

}












