#include "res.h"






















#define MAX_MODELS 4
#define MIN_MODELS 2















RESULT_LIST *get_result_lister_w_data( RESULT_LIST *res, DATA_LIST *data )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *x );

  RESULT_LIST *r_old = NULL;
  
  r_old = (RESULT_LIST *)create_result_lister( r_old );
  
  /*  In init.c:  */
  set_result_lister_init( r_old, data );
  
  MOTIF *mf = data->data->mf;
  
  res = (RESULT_LIST *)get_my_result_lister_w_data( res, r_old, data->data, mf );
  
  kill_result_lister( r_old );
  
  return res;

}














RESULT_LIST *get_my_result_lister_w_data( RESULT_LIST *res, RESULT_LIST *r_old,
  DATA *data, MOTIF *mf )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *r );
  MODEL_LIST *get_new_null_model( MODEL_LIST *null_model, DATA *data, MOTIF *mf );

  MODEL_LIST *null_model = NULL, *satd_model = NULL, *model_header = NULL;
  
  res = (RESULT_LIST *)create_result_lister( res );  
  *(res->my_result->mf) = *mf;
  
  /*  In origin_list.c:  */
  null_model = (MODEL_LIST *)get_new_null_model( null_model, data, mf );

  /*  In this file, below:  */
  satd_model = (MODEL_LIST *)get_new_satd_model( satd_model, null_model, data, mf );

  /*  In this file, below:  */
  model_header = (MODEL_LIST *)get_model_list_de_novo( model_header, null_model,
    satd_model, data, mf );

  kill_model_lister( satd_model );

  /*  In this file, below:  */
  return set_result_lister_w_model_lists( res, null_model, model_header );

}










RESULT_LIST *set_result_lister_w_model_lists( RESULT_LIST *new_r, 
  MODEL_LIST *null_model, MODEL_LIST *model_header )
{
    
  new_r->my_result->null_model = null_model;
  new_r->my_result->model_header = model_header;
  
  new_r->my_result->my_model = (MODEL_LIST *)get_best_model_lister( model_header );
  new_r->my_result->pval = new_r->my_result->my_model->my_model->stats->pval;
  
  if ( new_r->my_result->my_model == NULL )
    new_r->my_result->my_model = new_r->my_result->null_model;
  
  return new_r;
  
}











MODEL_LIST *get_best_model_lister( MODEL_LIST *model_header )
{

  MODEL_LIST *m = model_header, *best_model = m;
  
  while (( m != NULL ) && ( m->my_model->stats->pval < PVAL_THRESH )) {
    best_model = m;
    m = m->next;
  }
  
  return best_model;

}












MODEL_LIST *get_new_satd_model( MODEL_LIST *satd_model, MODEL_LIST *null_model,
  DATA *data, MOTIF *mf )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX m );
  INDEX get_numb_of_nodes_in_tree( TREE *tree );
  MODEL_LIST *get_opt_model_em_new( MODEL_LIST *new_model, MODEL_LIST *old_model,
    DATA *data );

  /*  In ../tree/get.c:  */
  INDEX n = get_numb_of_nodes_in_tree( data->tree );

  MODEL_LIST *approx = NULL;
  approx = (MODEL_LIST *)create_model_lister( approx, mf, n - 1 );
  
  /*  In this file, below:  */
  set_satd_model( approx, null_model, data );

  /*  In em.c:  */
  satd_model = (MODEL_LIST *)get_opt_model_em_new( satd_model, approx, data );
  
  kill_model_list( approx );
  
  return satd_model;

}













void set_satd_model( MODEL_LIST *satd_model, MODEL_LIST *null_model, DATA *data )
{

  REGION get_region_from_mode( char mode );
  void set_satd_model_branches( MODEL_LIST *model, TREE *tree );
  void set_init_satd_model_params( MODEL_LIST *satd_model, MODEL_LIST *null_model );

  *(satd_model->my_model->my_region) = *(data->reg);
  
  set_satd_model_branches( satd_model, data->tree );
  
  set_init_satd_model_params( satd_model, null_model );

}











void set_satd_model_branches( MODEL_LIST *model, TREE *tree )
{

  PART_LIST *part = model->my_model->part_header;
  NODE_LIST *node = tree->spec_header;
  
  while ( part != NULL ) 
    set_satd_model_single_part_lister_and_step( &part, &node );
  
}













void set_satd_model_single_part_lister_and_step( PART_LIST **part, 
  NODE_LIST **node )
{

  if ( *node == NULL )
    error( 5110, "Unexpected end of list for branches.\n" );

  set_satd_model_single_part_lister( *part, *node );
  
  *part = (*part)->next;
  *node = (*node)->next;

}












void set_satd_model_single_part_lister( PART_LIST *part, NODE_LIST *node )
{

  LIST *create_lister( LIST *x, char type );
  
  LIST *x = NULL;
  x = (LIST *)create_lister( x, INT_TYPE );
  
  x->elem.d = node->my_node->numb;
  
  part->my_part->branch_header = x;

}












void set_init_satd_model_params( MODEL_LIST *satd_model, MODEL_LIST *null_model )
{

  PARAMS *pp = null_model->my_model->part_header->my_part->pp;
  
  PART_LIST *part = satd_model->my_model->part_header;
  
  while ( part != NULL ) {
    *(part->my_part->pp) = *pp;
    part = part->next;
  }

}











/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/












MODEL_LIST *get_model_list_de_novo( MODEL_LIST *model_header, MODEL_LIST *null_model,
  MODEL_LIST *satd_model, DATA *data, MOTIF *mf )
{

  BRANCH_LIST *get_branch_list_satd_model( BRANCH_LIST *branch_header, 
    MODEL_LIST *satd_model, TREE *tree, char bd );

  BRANCH_LIST *branch_header = NULL;
  /*  In branch.c:  */
  branch_header = (BRANCH_LIST *)get_branch_list_satd_model( branch_header,
    satd_model, data->tree, BIRTH );

  /*  In this file, below:  */
  return get_first_model_list_set_de_novo( model_header, null_model, satd_model,
    branch_header, data, mf );

}









MODEL_LIST *get_first_model_list_set_de_novo( MODEL_LIST *model_header,
  MODEL_LIST *null_model, MODEL_LIST *satd_model, BRANCH_LIST *branch_header, 
  DATA *data, MOTIF *mf )
{

  int node_downstream( NODE_LIST *node, NODE_LIST *leaf );
  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );

  extern char major_spec[ BUFFER ];

  BRANCH_LIST *branch = branch_header;
  
  NODE_LIST *leaf = NULL;
  /*  In ../tree/get.c:  */
  leaf = (NODE_LIST *)get_node_from_label( data->tree->spec_header, major_spec );
  
  int iter = 0, non_sig = 0;

  do {
  
    /*  In ../tree/get.c:  */
    while (( branch != NULL ) &&
      ( strcmp( branch->my_branch->node->my_node->label, "Simiiformes" )))
    {
      branch = branch->next;
    }
    
    if ( branch == NULL )
      break;
      
    MODEL_LIST *model = NULL;
  
    /*  In this file, below:  */
    model = (MODEL_LIST *)get_model_lister_de_novo_w_node( model, null_model, 
      satd_model, branch->my_branch->node, data, mf );   
      
    if ( model->my_model->stats->pval >= PVAL_THRESH ) 
      ++non_sig;
      
    /*  In this file, below:  */
    model_header = (MODEL_LIST *)put_model_lister_sorted_down( model_header, 
      model ); 
      
    branch = branch->next;
      
  } while (( iter++ < MAX_MODELS ) && ( non_sig <= MIN_MODELS ));
  
  return model_header;
  
}














MODEL_LIST *put_model_lister_sorted_down( MODEL_LIST *model, MODEL_LIST *m )
{

  if ( model == NULL )
    return m;
    
  if ( m->my_model->stats->pval < model->my_model->stats->pval ) {
    m->down = model;
    return m;
  }
  
  MODEL_LIST *curr = model, *prev = NULL;
  
  while (( curr != NULL ) && 
    ( curr->my_model->stats->pval <= m->my_model->stats->pval ))
  {
    prev = curr;
    curr = curr->down;
  }
  
  if ( prev != NULL )
    prev->down = m;
    
  m->down = curr;
  
  return model;

}









MODEL_LIST *get_model_lister_de_novo_w_node( MODEL_LIST *model, 
  MODEL_LIST *old_model, MODEL_LIST *satd_model, NODE_LIST *node, DATA *data, 
  MOTIF *mf )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX m );
  MODEL_LIST *get_opt_model_em_new( MODEL_LIST *new_model, MODEL_LIST *old_model,
    DATA *data );
  void set_model_lister_sig( MODEL_LIST *model, MODEL_STATS *s, 
    MODEL_LIST *old_model, MODEL_LIST *satd_model, DATA *data, char label[], 
    MOTIF *mf );

  MODEL_LIST *approx = NULL;
  approx = (MODEL_LIST *)create_model_lister( approx, mf, 
    old_model->my_model->m + 1 );
    
  char label[ BUFFER ];
  
  strcpy( label, node->my_node->label );
    
  /*  In this file, below:  */  
  set_new_model_lister_node_label_old_model( approx, old_model, label, data->tree,
    data );
    
  printf( "\n" );
  printf( "Branch :  %s\n\n", node->my_node->label );
    
  /*  In em.c:  */
  model = (MODEL_LIST *)get_opt_model_em_new( model, approx, data );
  
  
  printf( "Null lhood :  %f\n", (float)old_model->my_model->stats->lhood );
  printf( "  My lhood :  %f\n\n", (float)model->my_model->stats->lhood );
  
  /*  In sig.c:  */
  set_model_lister_sig( model, model->my_model->stats, old_model, satd_model, data, 
    label, mf );
    
  *(model->my_model->null_stats) = *(model->my_model->stats);    
  
  kill_model_lister( approx );

  return model;

}














    
    
void set_new_model_lister_node_label_old_model( MODEL_LIST *new_model, 
  MODEL_LIST *old_model, char node_label[], TREE *tree, DATA *data )
{

  REGION get_region_from_mode( char mode );
  void set_model_branches( MODEL_LIST *model, NODE_LIST *root, ... );

  *(new_model->my_model->my_region) = *(data->reg);
  
  /*  In this file, below:  */
  set_model_lister_branches_node_label( new_model, old_model, node_label, tree );
  
  strcpy( new_model->my_model->stats->node_label, node_label );
  
  new_model->my_model->stats->old_lhood = old_model->my_model->stats->lhood;

}














void set_model_lister_branches_node_label( MODEL_LIST *new_model,
  MODEL_LIST *old_model, char node_label[], TREE *tree )
{

  /*  In ../birth/model_set.c:  */
  copy_part_list( new_model->my_model->part_header, 
    old_model->my_model->part_header );
    
  PART_LIST *new_part = NULL;
  /*  In this file, below:  */
  new_part = (PART_LIST *)get_last_part_lister( new_model->my_model->part_header );
  
  /*  In this file, below:  */
  transfer_part_lister_by_node_label( new_model->my_model->part_header, new_part,
    node_label, tree );
    
  new_model->my_model->part_n = old_model->my_model->part_n + 1;

}













PART_LIST *get_last_part_lister( PART_LIST *part_header )
{

  if ( part_header == NULL )
    error( 7401, "Unexpectedly empty part list.\n" );

  PART_LIST *part = part_header;
  
  while ( part->next != NULL )
    part = part->next;
    
  return part;

}












void transfer_part_lister_by_node_label( PART_LIST *part_header, 
  PART_LIST *new_part, char node_label[], TREE *tree )
{

  int node_numb = get_node_label_numb( tree, node_label );
  
  transfer_part_lister_elem_by_numb( part_header, new_part, node_numb );

}














int get_node_label_numb( TREE *tree, char node_label[] )
{

  int strs_match( char a[], char b[] );

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
  
    /*  In ../main/nucl.c:  */
    if ( strs_match( node->my_node->label, node_label ))
      return node->my_node->numb;
      
    node = node->next;
  
  }
  
}












void transfer_part_lister_elem_by_numb( PART_LIST *part_header, PART_LIST *new_part,
  int node_numb )
{

  PART_LIST *part = part_header;
  
  while ( part != NULL ) {  
    if ( transfer_single_plister_elem_and_step( &part, new_part, node_numb ))
      return;
  }
  
  printf( "Missing node number :  %d\n", node_numb );
  error( 7406, "Could not find node number in tree.\n" );

}













int transfer_single_plister_elem_and_step( PART_LIST **part, PART_LIST *new_part,
  int node_numb )
{

  int done = transfer_single_plister_elem( *part, new_part, node_numb );
  
  *part = (*part)->next;
  
  return done;

}












int transfer_single_plister_elem( PART_LIST *part, PART_LIST *new_part,
  int node_numb )
{

  int found = 0;

  LIST *list = part->my_part->branch_header, *prev = NULL;
  
  while (( ! found ) && ( list != NULL ))
    found = transfer_single_branch_elem_and_step( part, new_part, &list, &prev, 
      node_numb );
      
  return found;

}













int transfer_single_branch_elem_and_step( PART_LIST *part, PART_LIST *new_part, 
  LIST **list, LIST **prev, int node_numb )
{

  int found = transfer_single_branch_elem( part, new_part, *list, *prev, node_numb );
  
  *prev = *list;
  *list = (*list)->next;
  
  return found;

}











int transfer_single_branch_elem( PART_LIST *part, PART_LIST *new_part, LIST *list, 
  LIST *prev, int node_numb )
{

  if ( list->elem.d == node_numb )
    return transfer_my_single_branch_elem( part, new_part, list, prev );
    
  return 0;

}











int transfer_my_single_branch_elem( PART_LIST *part, PART_LIST *new_part, LIST *list, 
  LIST *prev )
{

  *(new_part->my_part->pp) = *(part->my_part->pp);

  if ( prev == NULL ) {
    part->my_part->branch_header = list->next;
    new_part->my_part->branch_header = list;
    list->next = NULL;
    return 1;
  }
  
  prev->next = list->next;
  new_part->my_part->branch_header = list;
  list->next = NULL;
  
  return 1;

}










    
    
    
    
    
    