#include "origin.h"


















ORIGIN_LIST *get_origin_w_data_lister( ORIGIN_LIST *origin, DATA_LIST *data,
  MOTIF *mf )
{

  ORIGIN_LIST *create_origin_lister( ORIGIN_LIST *x );
  
  origin = (ORIGIN_LIST *)create_origin_lister( origin );
  
  set_origin_lister( origin, data, mf );
  
  return get_d_set_origin_lister_w_data_lister( origin, data );

}










void set_origin_lister( ORIGIN_LIST *origin, DATA_LIST *data, MOTIF *mf )
{

  extern char major_spec[ BUFFER ];

  *(origin->my_origin->mf) = *mf;
  
  strcpy( origin->my_origin->spec, major_spec );  
  
  int n = 0;
  int total_seqs = get_numb_of_seqs_data( data, &n, origin->my_origin->spec );
  
  origin->my_origin->total_seqs = total_seqs;
  origin->my_origin->n = n;
  origin->my_origin->frac = (float)n / (float)total_seqs;
  
  printf( "\n" );
  printf( "TotalSeqs  = %d\n", total_seqs );
  printf( "OccurSeqs  = %d\n", n );
  printf( "Frac       = %.2f%%\n", origin->my_origin->frac * 100.0 );
  printf( "\n" );

}









int get_numb_of_seqs_data( DATA_LIST *data, int *n, char spec[] )
{

  int index = get_spec_numb_from_spec_cell( data->data->spec_cell, spec );
  
  PDATA_LIST *pdata = data->data->pdata;
  
  int total = 0;
  
  while ( pdata != NULL ) {
  
    if ( pdata->my_pdata->use_array[ 0 ] ) {
      ++total;
    
      if ( pdata->my_pdata->ct_array[ 0 ] > 0 ) 
        ++(*n);
      
    }
      
    pdata = pdata->next;
  
  }
  
  return total;
  
}












int get_spec_numb_from_spec_cell( SPEC_CELL *spec_cell, char spec[] )
{

  int i;
  
  for ( i = 0; i < spec_cell->n; i++ ) {
    if ( ! strcmp( (spec_cell->x + i)->spec, spec ))
      return i;
  }
  
  error( 13100, "Could not find species in occur_cell.\n" );
  
  return 0;

}













ORIGIN_LIST *get_d_set_origin_lister_w_data_lister( ORIGIN_LIST *origin, 
  DATA_LIST *data )
{

  void set_d_origin_site_list( ORIGIN_LIST *origin, DATA_LIST *data );

  set_d_origin_result_listers( origin, data );

  set_d_origin_site_list( origin, data );
  
  return origin;
  
}












void set_d_origin_result_listers( ORIGIN_LIST *origin, DATA_LIST *data )
{

  RESULT_LIST *res = NULL;
  res = (RESULT_LIST *)get_d_origin_result_list_w_data_lister( res, data );
  
  origin->my_origin->res = res;

}










RESULT_LIST *get_d_origin_result_list_w_data_lister( RESULT_LIST *res,
  DATA_LIST *data )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *x );

  RESULT_LIST *r_old = NULL;
  r_old = (RESULT_LIST *)create_result_lister( r_old );
  
  set_d_result_lister_init( r_old, data );
  
  MOTIF *mf = data->data->mf;
  
  return do_d_new_birth_death_model_w_result_lister( res, r_old, data, mf );

}











void set_d_result_lister_init( RESULT_LIST *r, DATA_LIST *data )
{

  RESULT *rr = r->my_result;
  
  *(rr->mf) = *(data->data->mf);
  
  rr->model_header = NULL;
  rr->my_model = NULL;
  rr->null_model = NULL;
  rr->pval = 1.0;
  rr->m = 0;
  rr->use = 0;
  
}















RESULT_LIST *do_d_new_birth_death_model_w_result_lister( RESULT_LIST *res, 
  RESULT_LIST *r_old, DATA_LIST *data, MOTIF *mf )
{

  RESULT_LIST *create_result_lister( RESULT_LIST *r );
  
  MODEL_LIST *null_model = NULL, *satd_model = NULL, *model_header = NULL;
  
  res = (RESULT_LIST *)create_result_lister( res );  
  *(res->my_result->mf) = *mf;
  
  null_model = (MODEL_LIST *)get_d_new_null_model( null_model, data->data, mf );

  res->my_result->null_model = null_model;
  res->my_result->my_model = null_model;
  
  return res;

}












MODEL_LIST *get_d_new_null_model( MODEL_LIST *null_model, DATA *data, MOTIF *mf )
{

  MODEL_LIST *create_model_lister( MODEL_LIST *x, MOTIF *mf, INDEX m );
  MODEL_LIST *get_opt_model_em_new( MODEL_LIST *new_model, MODEL_LIST *old_model,
    DATA *data );

  MODEL_LIST *model = NULL;
  
  model = (MODEL_LIST *)create_model_lister( model, data->mf, 0 );
  
  /*  In this file, below:  */
  set_d_null_model( model, data );
  
  /*  In em.c:  */
  null_model = (MODEL_LIST *)get_opt_model_em_new( null_model, model, data );
  
//  kill_model_lister( model );

  return null_model;
  
}











void set_d_null_model( MODEL_LIST *model, DATA *data )
{

  /*  In this file, below:  */
  set_d_region_from_input_files( model->my_model->my_region, data->pdata,
    data->spec_cell->n );
  
  /*  In ../birth/model_set.c:  */
  set_model_branches( model, data->tree->root );
  
  /*  In init.c:  */
  set_init_null_model_params( model, data );

}














void set_d_region_from_input_files( REGION *r, PDATA_LIST *pdata_header,
  int numb_of_spec )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  extern int score_thresh;
  
  FILE *fh = NULL;
  fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  COORD total_length = 0, numb_of_seqs = 0;
  
  PDATA_LIST *pdata = pdata_header;
  
  SEQ seq = 0;
  
  SEQ_INFO seq_info;
  int array[ NUMB_OF_SPEC ];
  
  while ( get( &seq_info, sizeof(SEQ_INFO), fh )) {
  
    get( array, sizeof(int) * numb_of_spec, fh );
    
    if ( pdata == NULL )
      break;
      
    if ( pdata->my_pdata->seq_numb == ++seq ) {
      total_length += seq_info.end - seq_info.start;
      ++numb_of_seqs;
      pdata = pdata->next;
    }    
  
  }
  
  close_file( fh );
  
  r->a = 0;
  r->b = total_length / numb_of_seqs;

}








void set_d_model_branches( MODEL_LIST *model, NODE_LIST *root )
{

  set_d_part_list_numbs( model->my_model->part_header );
  
  LIST *branch_header = NULL;
  branch_header = (LIST *)get_d_branches_one_part( branch_header, root );
  
  model->my_model->part_header->my_part->branch_header = branch_header;

}











void set_d_part_list_numbs( PART_LIST *part_header )
{

  int i = 0;
  
  PART_LIST *part = part_header;
  
  while ( part != NULL ) {  
    part->my_part->part = i++;
    part = part->next;
  }

}









LIST *get_d_branches_one_part( LIST *branch_header, NODE_LIST *root )
{

  NODE_LIST *get_spec_header( NODE_LIST *node );
  LIST *create_lister( LIST *x, char type );
  
  NODE_LIST *node;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_spec_header( root );
  
  LIST *header = NULL, *last = NULL;
  
  while ( node != NULL ) {
  
    LIST *new = NULL;
    new = (LIST *)create_lister( new, INT_TYPE );
    
    new->elem.d = node->my_node->numb;
    
    header = (LIST *)put_d_lister_end_list_elem( header, new, &last );  
  
    node = node->next;
    
  }
  
  return header;

}










LIST *put_d_lister_end_list_elem( LIST *header, LIST *new, LIST **last )
{

  if ( header == NULL ) {
    *last = new;
    return new;
  }
  
  (*last)->next = new;
  *last = new;
  
  return header;

}











/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/











void set_d_origin_site_list( ORIGIN_LIST *origin, DATA_LIST *data )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *ft_fh = NULL, *ind_fh = NULL, *ss_fh = NULL;
  
  ft_fh = (FILE *)open_binary_file_reading( input_file, "f" );
  ind_fh = (FILE *)open_binary_file_reading( input_file, "i" );
  ss_fh = (FILE *)open_binary_file_reading( input_file, "s" );
  
  set_d_origin_site_list_w_fh( origin, data, ft_fh, ind_fh, ss_fh );
  
  close_file( ft_fh );
  close_file( ind_fh );
  close_file( ss_fh );
  
}











void set_d_origin_site_list_w_fh( ORIGIN_LIST *origin, DATA_LIST *data, 
  FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  void get_rev_complement_seq( char rev_compl[], char seq[] );
  void set_position( FPOS fpos, FILE *ff );
  
  SITE_LIST *site_header = NULL, *rc_header = NULL;
  
  origin->my_origin->anc_bd = 0;
  
  MOTIF *mf = origin->my_origin->mf, rc_mf = *mf;
  
  /*  In nucl.c:  */
  get_rev_complement_seq( rc_mf.cons, mf->cons );
  
  site_header = (SITE_LIST *)get_d_site_list_from_data( origin, data->data,
    origin->my_origin->res->my_result->my_model, mf, ft_fh, ind_fh, ss_fh );

  origin->my_origin->site_header[ PLUS_STRAND ] = site_header;
  
  if ( data->rc_data->pdata != NULL ) {
    set_position( 0, ss_fh );
    set_position( 0, ind_fh );
    set_position( 0, ft_fh );
    rc_header = (SITE_LIST *)get_d_site_list_from_data( origin, data->rc_data,
      origin->my_origin->res->my_result->my_model, &rc_mf, ft_fh, ind_fh, ss_fh );
  }
  
  origin->my_origin->site_header[ MINUS_STRAND ] = rc_header;
  
}












SITE_LIST *get_d_site_list_from_data( ORIGIN_LIST *origin, DATA *data,
  MODEL_LIST *model, MOTIF *mf, FILE *ft_fh, FILE *ind_fh, FILE *ss_fh )
{

  void set_trans_probs_model( TREE *tree, MODEL_LIST *model );
  int get_my_spec_numb_from_spec_cell( SPEC_CELL *spec_cell );
  void set_position( FPOS fpos, FILE *fh );
  
  int spec_index = get_my_spec_numb_from_spec_cell( data->spec_cell );
  
  FT_IND array[ NUMB_OF_SPEC ];
  SEQ_INFO seq_info;
  SEQ seq_numb = 0;
  
  get( array, sizeof(FT_IND) * data->spec_cell->n, ind_fh );
  
  FT_IND ft_ind = array[ spec_index ];
  
  set_position( ft_ind.fpos, ft_fh );
  
  SEQ_LIST *seq_header = NULL, *last = NULL;
  seq_header = (SEQ_LIST *)get_d_seq_list_single_spec_from_count( seq_header,
    ft_ind.n, data->pdata, &last, &seq_info, &seq_numb, ft_fh, ss_fh );

  PDATA_LIST *pdata = data->pdata;
  SEQ_LIST *seq = seq_header;
  
  /*  In ../model/lhood.c:  */
  set_trans_probs_model( data->tree, model );
  
  SITE_LIST *site_header = NULL, *last_site = NULL;
  
  while ( pdata != NULL ) 
    /*  In this file, below:  */
    site_header = (SITE_LIST *)get_d_site_list_single_seq_and_step( site_header,
      &seq, &pdata, &last_site, data->tree, origin, mf );
      
  return site_header;

}











SEQ_LIST *get_d_seq_list_single_spec_from_count( SEQ_LIST *seq_header, int n, 
  PDATA_LIST *pdata_header, SEQ_LIST **last, SEQ_INFO *seq_info,
  SEQ *seq_numb, FILE *ft_fh, FILE *ss_fh )
{

  PDATA_LIST *pdata = pdata_header;
  
  int i;
  
  for ( i = 0; i < n; i++ )
    seq_header = (SEQ_LIST *)get_d_seq_list_from_count_single_site( seq_header,
      &pdata, last, seq_info, seq_numb, ft_fh, ss_fh );
      
  return seq_header;

}












SEQ_LIST *get_d_seq_list_from_count_single_site( SEQ_LIST *seq_header, 
  PDATA_LIST **pdata, SEQ_LIST **last, SEQ_INFO *seq_info, SEQ *seq_numb,
  FILE *ft_fh, FILE *ss_fh )
{

  extern int reg_start, reg_end;

  FT ft;
  
  get( &ft, sizeof(FT), ft_fh );
  
  if ( *pdata == NULL )
    return seq_header;
    
  while (( *pdata != NULL ) && ((*pdata)->my_pdata->seq_numb < ft.seq ))
    *pdata = (*pdata)->next;
    
  if ( *pdata == NULL )
    return seq_header;
    
  if ( (*pdata)->my_pdata->seq_numb != ft.seq )
    return seq_header;
    
  while ( *seq_numb < ft.seq ) {
    
    get( seq_info, sizeof(SEQ_INFO), ss_fh );
    
    int array[ NUMB_OF_SPEC ];
    get( array, sizeof(int) * (*pdata)->my_pdata->numb_of_spec, ss_fh );
    
    ++(*seq_numb);
    
  }
  
  
  int center = seq_info->x / 2;
  
  if (( center + reg_start > ft.pos[ 0 ] ) ||
    ( center + reg_end <= ft.pos[ 0 ] ))
  return seq_header;
  
  return get_d_my_seq_list_from_count_single_site( seq_header, *pdata, &ft, last,
    seq_info, *seq_numb );
  
}










SEQ_LIST *get_d_my_seq_list_from_count_single_site( SEQ_LIST *seq_header, 
  PDATA_LIST *pdata, FT *ft, SEQ_LIST **last, SEQ_INFO *seq_info, SEQ seq_numb )
{

  SEQ_LIST *create_seq_lister( SEQ_LIST *x );
  
  SEQ_LIST *seq = NULL;
  seq = (SEQ_LIST *)create_seq_lister( seq );
  
  set_d_seq_lister_for_site( seq, ft, seq_info, seq_numb );
  
  if ( seq_header == NULL ) {
    *last = seq;
    return seq;
  }
  
  (*last)->next = seq;
  *last = seq;
  
  return seq_header;

}












void set_d_seq_lister_for_site( SEQ_LIST *seq, FT *ft, SEQ_INFO *seq_info,
  SEQ seq_numb )
{

  *(seq->my_seq) = *seq_info;
  
  seq->my_seq->start += ft->pos[ 0 ];
  seq->my_seq->end = seq->my_seq->start + strlen( ft->site );
  
  strcpy( seq->my_seq->gene, ft->site );
  
  seq->numb = seq_numb;

}







SITE_LIST *get_d_site_list_single_seq_and_step( SITE_LIST *site_header,
  SEQ_LIST **seq, PDATA_LIST **pdata, SITE_LIST **last_site, TREE *tree, 
  ORIGIN_LIST *origin, MOTIF *mf )
{

  SITE_LIST *new_site = NULL;

  new_site = (SITE_LIST *)get_d_new_site_list_single_seq( new_site, seq, *pdata,
    tree, origin, mf );
    
  site_header = (SITE_LIST *)put_d_new_site_list_into_list( site_header, new_site, 
    last_site );
    
  *pdata = (*pdata)->next;
  
  return site_header;
  
}











SITE_LIST *put_d_new_site_list_into_list( SITE_LIST *site_header, 
  SITE_LIST *new_sites, SITE_LIST **last_site )
{

  if ( new_sites == NULL ) 
    return site_header;
    
  if ( *last_site != NULL )
    (*last_site)->next = new_sites;
  else  
    *last_site = new_sites;

  while (( *last_site != NULL ) && ((*last_site)->next != NULL ))
    *last_site = (*last_site)->next;
      
  if ( site_header == NULL )
    return new_sites;
    
  return site_header;

}













SITE_LIST *get_d_new_site_list_single_seq( SITE_LIST *new_site, SEQ_LIST **seq, 
  PDATA_LIST *pdata, TREE *tree, ORIGIN_LIST *origin, MOTIF *mf )
{

  if ( *seq == NULL )
    return NULL;
    
  new_site = (SITE_LIST *)make_d_new_site_list( new_site, seq, pdata );
  
  if ( new_site == NULL )
    return NULL;

  set_d_site_lister_origin( new_site, pdata, tree, origin );

  return new_site;

}










SITE_LIST *make_d_new_site_list( SITE_LIST *new_site, SEQ_LIST **seq, 
  PDATA_LIST *pdata )
{

  SITE_LIST *create_site_lister( SITE_LIST *x );

  SEQ_LIST *my_seq = *seq;
  SITE_LIST *last_site = NULL;
  
  while (( my_seq != NULL ) && ( my_seq->numb == pdata->my_pdata->seq_numb )) {
        
    SITE_LIST *site = NULL;
    site = (SITE_LIST *)create_site_lister( site );
    
    new_site = (SITE_LIST *)set_and_put_d_new_site_lister( new_site, site, 
      &last_site, my_seq, pdata );
    
    my_seq = my_seq->next;
    
  }
  
  *seq = my_seq;

  return new_site;
  
}












SITE_LIST *set_and_put_d_new_site_lister( SITE_LIST *new_site, SITE_LIST *site,
  SITE_LIST **last_site, SEQ_LIST *seq, PDATA_LIST *pdata )
{

  set_d_new_site_lister( site, seq, pdata );
  
  return put_d_new_site_lister( new_site, site, last_site );

}












SITE_LIST *put_d_new_site_lister( SITE_LIST *new_site, SITE_LIST *site,
  SITE_LIST **last_site )
{

  if ( new_site == NULL ) {
    *last_site = site;
    return site;
  }
  
  (*last_site)->next = site;  
  *last_site = site;
  
  return new_site;

}











void set_d_new_site_lister( SITE_LIST *site, SEQ_LIST *seq, PDATA_LIST *pdata )
{

  *(site->site->loc) = *(seq->my_seq);
  site->site->seq_numb = seq->numb;

  site->stats->occur_in_seq = 0;
  
  strcpy( site->site->seq, seq->my_seq->gene );

}










void set_d_site_lister_origin( SITE_LIST *new_site, PDATA_LIST *pdata, 
  TREE *tree, ORIGIN_LIST *origin )
{

  void clear_tree( NODE_LIST *root );
  void set_pdata_leaves( TREE *tree, PDATA_LIST *pdata );
  
  /*  In ../birth/set.c:  */
  clear_tree( tree->root );
  
  /*  In data.c:  */
  set_pdata_leaves( tree, pdata );
  
  /*  In this file, below:  */
  set_d_site_lister_origin_w_tree( new_site, tree, origin );

}













void set_d_site_lister_origin_w_tree( SITE_LIST *new_site, TREE *tree,
  ORIGIN_LIST *origin )
{

  STAT get_my_lhood_pdata_single_seq( TREE *tree );
  void set_tree_q( TREE *tree );
  
  /*  In ../model/lhood.c:  */
  STAT lhood = get_my_lhood_pdata_single_seq( tree );
  
  /*  In ../model/lhood.c:  */
  set_tree_q( tree );
  
  /*  In this file, below:  */
  set_my_d_site_lister_origin_w_tree( new_site, tree, origin );

}













void set_my_d_site_lister_origin_w_tree( SITE_LIST *new_site, TREE *tree,
  ORIGIN_LIST *origin )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );
  
  extern char major_spec[ BUFFER ];
  
  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, major_spec );
    
  int unique = 1, done = 0, leaf_q = node->my_info->q;
  
  SITE_LIST *site = new_site;
    
  printf( "Q = %d\n", (int)node->my_info->q );
  
  while (( ! done ) && ( node != NULL ) && ( site != NULL ))
    done = set_d_site_lister_origin_single_branch_and_step( &site, &node, &unique,
      leaf_q );

}











int set_d_site_lister_origin_single_branch_and_step( SITE_LIST **site,
  NODE_LIST **node, int *unique, int leaf_q )
{

  int done = set_d_site_lister_origin_single_branch( site, *node, unique, leaf_q );
  
  *node = (*node)->up;
  
  return done;

}












int set_d_site_lister_origin_single_branch( SITE_LIST **site, NODE_LIST *node,
  int *unique, int leaf_q )
{

  if ( node->up == NULL ) {
  
    if ( node->my_info->q > 1 )
      *unique = 0;
  
    int new_site = 0;
    
    if ( leaf_q > node->my_info->q )
      new_site = 1;
      
    while ( *site != NULL )
      set_d_site_lister_node_and_step( site, *unique, node, new_site );
  
    return 1;
  
  }
  
  if ( node->my_info->q > node->up->my_info->q ) {
  
    if (( leaf_q > 1 ) && ( node->up->my_info->q > 0 ))
      *unique = 0;
      
    int new_site = 0;
    
    if ( leaf_q > node->up->my_info->q )
      new_site = 1;
      
    int i = 0, end = node->my_info->q - node->up->my_info->q;
    
    while (( *site != NULL ) && ( i++ < end )) 
      set_d_site_lister_node_and_step( site, *unique, node, new_site );

  }
  
  return ( node->my_info->q > 0 ) ? (0) : (1);

}











void set_d_site_lister_node_and_step( SITE_LIST **site, int unique, NODE_LIST *node,
  int new_site )
{

  strcpy( (*site)->stats->node, node->my_node->label );
  (*site)->stats->unique = unique;
  (*site)->stats->new_site = new_site;
  
  printf( "\t\t\t\t\t%12s\t%d\n", node->my_node->label, new_site );
  
  *site = (*site)->next;  

}

















