#include "pair.h"





















void do_double_motif_origin_pair( void )
{

  extern MOTIF major_motif, minor_motif;
  
  extern char input_file[ BUFFER ], seq_align_file[ BUFFER ];
  
  strcpy( input_file, seq_align_file );
  
  do_my_double_motif_origin_pair( &major_motif, &minor_motif );

}











void do_my_double_motif_origin_pair( MOTIF *major_mf, MOTIF *minor_mf )
{

  DATA_LIST *get_origin_kmer_data( DATA_LIST *data, MOTIF *mf );
  
  DATA_LIST *major_data = NULL, *minor_data = NULL;
  
  /*  In ../model/data.c:  */
  major_data = (DATA_LIST *)get_origin_kmer_data( major_data, major_mf );
  minor_data = (DATA_LIST *)get_origin_kmer_data( minor_data, minor_mf );
  
  /*  In this file, below:  */
  do_double_motif_origin_pair_w_data( major_data, minor_data );

}











void do_double_motif_origin_pair_w_data( DATA_LIST *major_data, 
  DATA_LIST *minor_data )
{

  REL_ORIGIN_LIST *rel = NULL;
  rel = (REL_ORIGIN_LIST *)get_rel_origin_double_mf( rel, major_data, minor_data );

}











REL_ORIGIN_LIST *get_rel_origin_double_mf( REL_ORIGIN_LIST *rel,
  DATA_LIST *major_data, DATA_LIST *minor_data )
{

  REL_ORIGIN_LIST *create_rel_origin_lister( REL_ORIGIN_LIST *x );
  
  rel = (REL_ORIGIN_LIST *)create_rel_origin_lister( rel );
  
  return get_my_rel_origin_double_mf( rel, major_data, minor_data );

}











REL_ORIGIN_LIST *get_my_rel_origin_double_mf( REL_ORIGIN_LIST *rel,
  DATA_LIST *major_data, DATA_LIST *minor_data )
{

  DATA_LIST *get_origin_data( DATA_LIST *data, MOTIF *mf );
  ORIGIN_LIST *get_origin_w_data_lister( ORIGIN_LIST *origin, DATA_LIST *data, 
    MOTIF *mf );
  void get_rel_origin_stats_for_rel_lister( REL_ORIGIN_LIST *rel, 
    ORIGIN_LIST *major_origin, ORIGIN_LIST *minor_origin, DATA_LIST *major_data,
    DATA_LIST *minor_data );
  
  ORIGIN_LIST *major_origin = NULL, *minor_origin = NULL;

  /*  In ../origin/origin_list.c:  */
  major_origin = (ORIGIN_LIST *)get_origin_w_data_lister( major_origin, major_data, 
    major_data->data->mf );
  minor_origin = (ORIGIN_LIST *)get_origin_w_data_lister( minor_origin, minor_data,
    minor_data->data->mf );
    
  /*  In this file, below:  */
  get_origin_hist_array( rel->my_rel->major_hist, major_origin, 
    major_data->data->tree );
  get_origin_hist_array( rel->my_rel->minor_hist, minor_origin,
    minor_data->data->tree );
  
  *(rel->my_rel->major_mf) = *(major_data->data->mf);
  *(rel->my_rel->minor_mf) = *(minor_data->data->mf);  

  /*  In this file, below:  */
  get_rel_origin_stats_for_rel_lister( rel, major_origin, minor_origin,
    major_data, minor_data );
    
  kill_origin_list( major_origin );
  kill_origin_list( minor_origin );
  
  return rel;

}











void get_origin_hist_array( ORIGIN_HIST *my_hist[], ORIGIN_LIST *origin, 
  TREE *tree )
{

  initialize_origin_hist_array( my_hist, tree );
  
  get_my_origin_hist_array( my_hist, origin );
  
}










void initialize_origin_hist_array( ORIGIN_HIST *my_hist[], TREE *tree )
{

  extern char phylo_spec[ BUFFER ];

  int i;
  
  for ( i = 0; i < STRAND_BUFFER; i++ ) 
    initialize_origin_hist( my_hist[ i ], tree, phylo_spec );
  
}








void initialize_origin_hist( ORIGIN_HIST *my_hist, TREE *tree, char spec[] )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );
  
  NODE_LIST *node = NULL;
  /*  In ../tree/get.c:  */
  node = (NODE_LIST *)get_node_from_label( tree->spec_header, spec );
  
  int i = 0;
  
  while ( node != NULL ) {
  
    strcpy( my_hist->node[ i ], node->my_node->label );
    my_hist->time[ i ] = node->my_node->t;
    my_hist->ct[ i ] = 0;
    my_hist->new_site[ i ] = 0;
    
    ++i;
    
//    if ( ! strcmp( "Eutheria", node->my_node->label ))
  //    break;
      
    node = node->up;
  
  }
  
  my_hist->total_ct = 0;
  
  my_hist->n = i;

}










void get_my_origin_hist_array( ORIGIN_HIST *my_hist[], ORIGIN_LIST *origin )
{

  int a;
  
  for ( a = 0; a < STRAND_BUFFER; a++ ) {
  
    SITE_LIST *site = origin->my_origin->site_header[ a ];
  
    my_hist[ a ]->total_ct = 0;
    my_hist[ a ]->seq_ct = 0;
  
    char gene[ BUFFER ] = "xxx";
  
    while ( site != NULL ) {
  
      int i;
    
      if ( strcmp( gene, site->site->loc->gene )) {
        ++(my_hist[ a ]->seq_ct);
        strcpy( gene, site->site->loc->gene );
      }
    
      for ( i = 0; i < my_hist[ a ]->n; i++ ) {
        if ( ! strcmp( site->stats->node, my_hist[ a ]->node[ i ] )) {
          ++(my_hist[ a ]->ct[ i ]);
          ++(my_hist[ a ]->total_ct);
          break;
        }
      }
    
      site = site->next;
  
    }
    
    my_hist[ a ]->total_seqs = origin->my_origin->total_seqs;  
  
  } 

}















/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
















void do_double_motif_origin_pair_compr( void )
{

  extern MOTIF major_motif, minor_motif;
  
  extern char input_file[ BUFFER ], seq_align_file[ BUFFER ];
  
  strcpy( input_file, seq_align_file );
  
  do_my_double_motif_origin_pair_compr( &major_motif );
  
}














void do_my_double_motif_origin_pair_compr( MOTIF *major_mf )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  char fname[ BUFFER ], cons[ BUFFER ];
  
  upper( cons, major_mf->cons );
  
  sprintf( fname, "%s.%s.doubleMotif.txt", input_file, cons );
  
  FILE *sum_fh = NULL, *out_fh = NULL, *all_fh = NULL;
  out_fh = (FILE *)open_text_file_writing( fname, "" );
  sum_fh = (FILE *)open_text_file_writing( fname, "sum.txt" );
  all_fh = (FILE *)open_text_file_writing( fname, "all.txt" );
  
  do_double_motif_origin_pair_compr_w_fhs( major_mf, out_fh, sum_fh, all_fh );
  
  close_file( out_fh );
  close_file( sum_fh );
  close_file( all_fh );

}













void do_double_motif_origin_pair_compr_w_fhs( MOTIF *major_mf, FILE *out_fh,
  FILE *sum_fh, FILE *all_fh )
{

  DATA_LIST *get_origin_kmer_data( DATA_LIST *data, MOTIF *mf );
  ORIGIN_LIST *get_origin_w_data_lister( ORIGIN_LIST *origin, DATA_LIST *data, 
    MOTIF *mf );
  
  DATA_LIST *major_data = NULL;
  ORIGIN_LIST *major_origin = NULL;
  
  /*  In ../model/data.c:  */
  major_data = (DATA_LIST *)get_origin_kmer_data( major_data, major_mf );
  
  /*  In ../origin/origin_list.c:  */
  major_origin = (ORIGIN_LIST *)get_origin_w_data_lister( major_origin, major_data, 
    major_mf );
    
  /*  In this file, below:  */
  do_double_motif_origin_compr_w_major_data( major_data, major_origin, major_mf, 
    out_fh, sum_fh, all_fh );

}













void do_double_motif_origin_compr_w_major_data( DATA_LIST *major_data,
  ORIGIN_LIST *major_origin, MOTIF *major_mf, FILE *out_fh, FILE *sum_fh,
  FILE *all_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  extern char input_file[ BUFFER ];
  
  FILE *mf_fh = NULL;
  mf_fh = (FILE *)open_text_file_reading( input_file, "PartnerMfs.txt" );
  
  REL_ORIGIN_LIST *rel_header = NULL;
  
  rel_header = (REL_ORIGIN_LIST *)do_double_mf_origin_compr_w_mf_fh( rel_header,
    major_data, major_origin, major_mf, mf_fh, out_fh, sum_fh );
  
  print_rel_origin_sorted_list( rel_header, all_fh );
    
  close_file( mf_fh );

}













REL_ORIGIN_LIST *do_double_mf_origin_compr_w_mf_fh( REL_ORIGIN_LIST *rel_header,
  DATA_LIST *major_data, ORIGIN_LIST *major_origin, MOTIF *major_mf, FILE *mf_fh, 
  FILE *out_fh, FILE *sum_fh )
{

  extern MOTIF minor_motif;

  minor_motif.length = WORD_LENGTH;

  char label_line[ BUFFER ], mf_line[ BUFFER ];
  char mf_label[ BUFFER ], cons[ BUFFER ];
  int numb;
  float pval;

  while ( fgets( label_line, BUFFER, mf_fh ) != NULL ) {
  
    sscanf( label_line, "%*s%d%s%f", &numb, mf_label, &pval );
  
    if ( fgets( mf_line, BUFFER, mf_fh ) == NULL )
      break;  
    
    sscanf( mf_line, "%s", cons );
    
    upper( minor_motif.cons, cons );
    
    rel_header = (REL_ORIGIN_LIST *)do_double_mf_compr_single_mf( rel_header,
      major_data, major_origin, major_mf, &minor_motif, numb, mf_label, pval,
      out_fh, sum_fh );
    
  }
  
  return rel_header;

}













REL_ORIGIN_LIST *do_double_mf_compr_single_mf( REL_ORIGIN_LIST *rel_header,
  DATA_LIST *major_data, ORIGIN_LIST *major_origin, MOTIF *major_mf,
  MOTIF *minor_mf, int numb, char mf_label[], float pval, FILE *out_fh,
  FILE *sum_fh )
{

  REL_ORIGIN_LIST *create_rel_origin_lister( REL_ORIGIN_LIST *x );
  
  REL_ORIGIN_LIST *rel = NULL;
  rel = (REL_ORIGIN_LIST *)create_rel_origin_lister( rel );
  
  printf( "a1\n" );
  
  /*  In this file, above:  */
  get_origin_hist_array( rel->my_rel->major_hist, major_origin, 
    major_data->data->tree );
    
  *(rel->my_rel->major_mf) = *major_mf;
  
  /*  In this file, below:  */
  rel = (REL_ORIGIN_LIST *)get_rel_origin_single_minor_motif( rel, major_origin,
    major_data, major_mf, minor_mf, numb, out_fh, sum_fh );
    
  /*  In this file, below:  */
  return put_rel_origin_lister_into_sorted_list( rel_header, rel );

}












REL_ORIGIN_LIST *get_rel_origin_single_minor_motif( REL_ORIGIN_LIST *rel,
  ORIGIN_LIST *major_origin, DATA_LIST *major_data, MOTIF *major_mf, 
  MOTIF *minor_mf, int numb, FILE *out_fh, FILE *sum_fh )
{

  DATA_LIST *get_origin_kmer_data( DATA_LIST *data, MOTIF *mf );
  ORIGIN_LIST *get_origin_w_data_lister( ORIGIN_LIST *origin, DATA_LIST *data, 
    MOTIF *mf );
  void get_rel_origin_stats_for_rel_lister( REL_ORIGIN_LIST *rel, 
    ORIGIN_LIST *major_origin, ORIGIN_LIST *minor_origin, DATA_LIST *major_data, 
    DATA_LIST *minor_data );
  void get_rel_origin_stats_for_after_rel_lister( REL_ORIGIN_LIST *rel, 
    ORIGIN_LIST *major_origin, ORIGIN_LIST *minor_origin, DATA_LIST *major_data, 
    DATA_LIST *minor_data );

  
  DATA_LIST *minor_data = NULL;
  ORIGIN_LIST *minor_origin = NULL;
  
  /*  In ../model/data.c:  */
  minor_data = (DATA_LIST *)get_origin_kmer_data( minor_data, minor_mf );
  
  *(rel->my_rel->minor_mf) = *minor_mf;
  
  /*  In ../origin/origin_list.c:  */
  minor_origin = (ORIGIN_LIST *)get_origin_w_data_lister( minor_origin, minor_data, 
    minor_mf );
  
  /*  In this file, below:  */
  get_origin_hist_array( rel->my_rel->minor_hist, minor_origin,
    minor_data->data->tree );
    
  /*  In rel.c:  */
  get_rel_origin_stats_for_rel_lister( rel, major_origin, minor_origin,
    major_data, minor_data );
    
  /*  In this file, below:  */
  print_rel_origin_single_mf_pair_fhs( rel, numb, out_fh, sum_fh );
  
//  kill_origin_lister( minor_origin );
//  kill_data_lister( minor_data );
  
  return rel;
  
}














REL_ORIGIN_LIST *put_rel_origin_lister_into_sorted_list( REL_ORIGIN_LIST *rel_header,
  REL_ORIGIN_LIST *rel )
{

  if ( rel_header == NULL )
    return rel;
    
  if ( rel == NULL )
    return rel_header;
    
  if ( rel->my_rel->best_hist->pval < rel_header->my_rel->best_hist->pval ) {
    rel->next = rel_header;
    return rel;
  }
  
  REL_ORIGIN_LIST *curr = rel_header, *prev = NULL;
  
  while (( curr != NULL ) && 
    ( curr->my_rel->best_hist->pval <= rel->my_rel->best_hist->pval ))
  {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = rel;
    
  rel->next = curr;
  
  return rel_header;

}














void print_rel_origin_single_mf_pair_fhs( REL_ORIGIN_LIST *rel, int numb, 
  FILE *out_fh, FILE *sum_fh )
{

  fprintf( sum_fh, "%4d\t%16s\t%10.3e\t%10.3e\n",
    numb,
    rel->my_rel->minor_mf->cons,
    (double)rel->my_rel->best_hist->pval,
    (double)rel->my_rel->rev_hist->pval );
    
  print_rel_origin_single_mf_pair_all_fh( rel, numb, out_fh );
  
  fflush( sum_fh );
  fflush( out_fh );

}
















void print_rel_origin_single_mf_pair_all_fh( REL_ORIGIN_LIST *rel, int numb,
  FILE *fh )
{

  print_sep( fh );
  
  fprintf( fh, ">%4d   %16s\t%16s\n",
    numb, rel->my_rel->major_mf->cons,
    rel->my_rel->minor_mf->cons );
    
  fprintf( fh, "\n" );
  
  fprintf( fh, "BestPval:  %.3e\n", (double)rel->my_rel->best_hist->pval );
  fprintf( fh, "RevPval:   %.3e\n", (double)rel->my_rel->rev_hist->pval );
  
  fprintf( fh, "\n" );
  
  print_rel_origin_single_hist( rel, rel->my_rel->best_hist, "BestHist", fh );
  print_rel_origin_single_hist( rel, rel->my_rel->rev_hist, "RevHist", fh );
  print_rel_origin_single_hist( rel, rel->my_rel->all_hist, "AllHist", fh );
  
  print_sep( fh );
  
  fprintf( fh, "\n" );

}















void print_rel_origin_single_hist( REL_ORIGIN_LIST *rel, REL_HIST *my_hist, 
  char str[], FILE *fh )
{

  void print_rel_origin_hist_fh( REL_HIST *my_hist, FILE *fh );

  print_dot_sep( fh );
  
  fprintf( fh, "Type:  %s\n", str );

  print_rel_origin_motif_double_strand( rel, my_hist, my_hist->major_index, fh );
  print_rel_origin_motif_double_strand( rel, my_hist, my_hist->minor_index, fh );
  
  fprintf( fh, "\n" );
  
  print_rel_origin_motif_numbs( rel, my_hist, fh );
  
  fprintf( fh, "\n" );
  
  print_rel_origin_hist_fh( my_hist, fh );
  
  fprintf( fh, "\n" );

}












void print_rel_origin_motif_double_strand( REL_ORIGIN_LIST *rel, REL_HIST *my_hist, 
  int index[], FILE *fh )
{

  void get_rev_complement_seq( char rev_compl[], char seq[] );

  char major_mf[ BUFFER ], minor_mf[ BUFFER ];
  
  if ( index[ 0 ] == PLUS_STRAND )
    upper( major_mf, rel->my_rel->major_mf->cons );
  else
    /*  In ../main/nucl.c:  */
    get_rev_complement_seq( major_mf, rel->my_rel->major_mf->cons );
    
  if ( index[ 1 ] == PLUS_STRAND )
    upper( minor_mf, rel->my_rel->minor_mf->cons );
  else
    /*  In ../main/nucl.c:  */
    get_rev_complement_seq( minor_mf, rel->my_rel->minor_mf->cons );


  fprintf( fh, "Strands:  %16s  (%c)\t%16s  (%c)\n",
    major_mf,
    get_strand_char( my_hist->major_index[ 0 ] ),
    minor_mf,
    get_strand_char( my_hist->major_index[ 1 ] ) );

}













char get_strand_char( int x )
{

  switch ( x ) {
  
  case PLUS_STRAND :
    return '+';
    
  case MINUS_STRAND :
    return '-';
    
  default :
    error( 13020, "Unrecognized strand integer.\n" );
    break;
  
  }

}













void print_rel_origin_motif_numbs( REL_ORIGIN_LIST *rel, REL_HIST *my_hist, 
  FILE *fh )
{

  fprintf( fh, "Matching:  %d\n", my_hist->x );
  
  float exp = 0.0;
  
  int i;
  
  for ( i = 0; i < my_hist->n; i++ )
    exp += my_hist->exp[ i ][ i ];
    
  fprintf( fh, "Exp:       %.1f\n", exp );
  fprintf( fh, "Ratio:     %.3f\n", (float)my_hist->x / exp );
  fprintf( fh, "\n" );

}














void print_rel_origin_sorted_list( REL_ORIGIN_LIST *rel_header, FILE *fh )
{

  int i = 0;

  REL_ORIGIN_LIST *rel = rel_header;
  
  while ( rel != NULL )
    print_single_rel_origin_sorted_lister_and_step( &rel, ++i, fh );

}













void print_single_rel_origin_sorted_lister_and_step( REL_ORIGIN_LIST **rel,
  int numb, FILE *fh )
{
  print_single_rel_origin_sorted_lister( *rel, numb, fh );
  *rel = (*rel)->next;
}








void print_single_rel_origin_sorted_lister( REL_ORIGIN_LIST *rel, int numb,
  FILE *fh )
{

  fprintf( fh, "%4d\t%16s\t%10.3e\t%10.3e\t%10.3e\n",
    numb,
    rel->my_rel->minor_mf->cons,
    (double)rel->my_rel->best_hist->pval,
    (double)rel->my_rel->rev_hist->pval,
    (double)rel->my_rel->all_hist->pval );
    

}

























