#include "rel_sig.h"















#define SMALL_THRESH 1e-50









PVAL get_same_branch_pval_rel_hist( REL_HIST *my_hist )
{

  int major_total[ BUFFER ], minor_total[ BUFFER ];
  int x;
  
  int total = get_totals_rel_hist( my_hist, major_total, minor_total, &x );
  
  return get_my_same_branch_pval_rel_hist( x, major_total, minor_total, total,
    my_hist->n - 1 );  

}














int get_totals_rel_hist( REL_HIST *my_hist, int major_total[], int minor_total[],
  int *x )
{

  int i, j, end = my_hist->n - 1;
  
  *x = 0;
  
  int total = 0;
  
  for ( i = 0; i < end; i++ ) {
    major_total[ i ] = 0;
    minor_total[ i ] = 0;
  }
  
  for ( i = 0; i < end; i++ ) {
    for ( j = 0; j < end; j++ ) {
    
      total += my_hist->seq_ct[ i ][ j ];
      
      if ( i == j )
        *x += my_hist->seq_ct[ i ][ j ];
        
      major_total[ i ] += my_hist->seq_ct[ i ][ j ];
      minor_total[ j ] += my_hist->seq_ct[ i ][ j ];
    
    }
  }
  
  return total;

}













PVAL get_my_same_branch_pval_rel_hist( int x, int major_total[], int minor_total[],
  int nn, int loops )
{

  /*
  printf( "x = %d\n", x );
  printf( "\n" );
  
  int i;
  
  for ( i = 0; i <= loops; i++ ) {
    printf( "major[ %d ] = %d\n", i, major_total[ i ] );
    printf( "minor[ %d ] = %d\n", i, minor_total[ i ] );
    printf( "\n" );
  }
  */
  
  int i;
  
  PVAL pr[ LINE_BUFFER ];
  STAT w[ LINE_BUFFER ];
  
  for ( i = 0; i < loops; i++ ) {
    pr[ i ] = (PVAL)major_total[ i ] / (PVAL)nn;
    w[ i ] = (PVAL)minor_total[ i ] / (PVAL)nn;
  }
  
  PVAL pval = 0.0;
  
  int k;
  
  for ( k = x; k <= nn; k++ ) {
    pval += mixture_binom_term( k, nn, pr, w, loops );
  }
  
  return pval;
  
  
      
  return 1.0 - do_same_branch_pval_recursion( nn - x, major_total, minor_total, 
    0, 0, nn, loops );

}













PVAL mixture_binom_term( int k, int n, PVAL pr[], STAT w[], int m )
{

  PVAL bi = factln( n ) - factln( k ) - factln( n - k );
  
  PVAL x = 0.0;
  
  int i;
  for ( i = 0; i <= m; i++ )
    x += w[ i ] * powl( pr[ i ], k ) * powl( 1.0 - pr[ i ], n - k );
    
  return x * expl( bi );

}








PVAL do_same_branch_pval_recursion( int x, int major_total[], int minor_total[],
  int curr_sum, int iter, int nn, int loops )
{

  PVAL cumulative_binom_prob( STAT p, int k, int n );

  if ( iter == loops ) 
    /*  In ../model/sig.c:  */
    return cumulative_binom_prob( 1.0 - ((PVAL)minor_total[ iter ] / (PVAL)nn),
      major_total[ iter ] - (x - curr_sum), major_total[ iter ] );
      
  int i;
  
  int start = major_total[ iter ];  
  int end = major_total[ iter ] - x + 1;
  
  for ( i = iter + 1; i <= loops; i++ ) {
    end += major_total[ i ];
    if ( end > major_total[ iter ] ) {
      end = major_total[ iter ];
      break;
    }
  }
  
  PVAL z = 0.0;
  
  if ( end >= x - curr_sum ) {
    z = cumulative_binom_prob( 1.0 - ((PVAL)minor_total[ iter ] / (PVAL)nn),
      major_total[ iter ] - (x - curr_sum), major_total[ iter ] );
    end = x - curr_sum - 1;
  }
  
  /*
  printf( "loops = %d\n", loops );
  printf( "start = %d\n", start );
  printf( "end   = %d\n\n", major_total[ iter ] );
  */
  for ( i = end; i >= start; i-- ) {
      
    /*  In this file, below:  */
    PVAL y = single_binom_prob( (PVAL)minor_total[ iter ] / (PVAL)nn, i, 
      major_total[ iter ] );
    
    /*  Recursion:  */
    PVAL xx = do_same_branch_pval_recursion( x, major_total, minor_total,
      curr_sum + i, iter + 1, nn, loops );
  
    z += xx * y;
    
    if ( xx < SMALL_THRESH )
      break;
    
//    printf( "Pval calc :  %4d   %4d :   %10.3e   %10.3e\n", iter, i,
  //    (double)y, (double)xx );
 
  }
  
  return z;

}









PVAL single_binom_prob( PVAL p, int k, int n )
{

  PVAL x = factln(n) - factln(k) - factln( n - k );

  x += ((PVAL)k * logl( p )) + ((PVAL)(n - k) * logl( 1.0 - p ));
  
  return expl( x );
  
}














PVAL bico( int n, int k )
{
  return (PVAL)floor( 0.5 + expl( factln(n) - factln(k) - factln( n - k ) ));
}














PVAL factln( int n )
{

  PVAL gammln( PVAL x );

  static double a[ 101 ];

  if ( n <= 1 ) 
    return 0.0;
    
  if ( n <= 100 )
    return a[ n ] ? a[ n ] : (a[ n ] = gammln( n + 1.0 ));
    
  return gammln( n + 1.0 );

}




































