#include "create_tree.h"


















//#define TREE_FNAME "data/tree/hg19_tree.txt"



















TREE *make_and_set_tree( TREE *tree )
{

  TREE *create_tree( TREE *x );
  NODE_LIST *get_spec_header( NODE_LIST *node );
  NODE_LIST *get_inner_node_header( NODE_LIST *spec_header );
  tree = (TREE *)create_tree( tree );
  
  tree = (TREE *)get_phylo_tree( tree );
  
  set_branch_factor( tree );
  
  return tree;

}
















void set_branch_factor( TREE *tree )
{

  extern STAT branch_factor;
  
  branch_factor = 1.0;
  
  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
    branch_factor = get_branch_factor_single_node( node, branch_factor );
    node = node->next;
  }
  
  node = tree->spec_header;
  
  while ( node != NULL ) {
    node->my_node->t *= branch_factor;
    node = node->next;
  }

}














STAT get_branch_factor_single_node( NODE_LIST *node, STAT branch_factor )
{

  if ( node->my_node->t <= 0.0 )
    return branch_factor;
    
  STAT x = 1.0, t = node->my_node->t;
  
  while ( t < 5.0 ) {
    x *= 10.0;
    t *= 10.0;
  }
  
  return ( branch_factor > x ) ? (branch_factor) : (x);

}











TREE *get_phylo_tree( TREE *tree )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  extern char tree_file[ BUFFER ];
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( tree_file, "" );
  
  tree = (TREE *)get_phylo_tree_w_fh( tree, in );
  
  close_file( in );  

  return tree;

}

















TREE *get_phylo_tree_w_fh( TREE *tree, FILE *in )
{

  NODE_LIST *spec_header = NULL;
  
  spec_header = (NODE_LIST *)get_spec_node_list_fh( spec_header, in );
  
  tree = (TREE *)get_phylo_tree_w_spec_list( tree, spec_header, in );
  
  kill_node_list( spec_header );
  
  return tree;

}













NODE_LIST *get_spec_node_list_fh( NODE_LIST *spec_header, FILE *in )
{

  FPOS get_position( FILE *fh );

  char line[ BUFFER ];
  
  FPOS fpos = get_position( in );
  
  while ( fgets( line, BUFFER, in ) != NULL ) {
  
    if ( line[ 0 ] == '(' ) {
      set_position( fpos, in );
      return spec_header;
    }
    
    fpos = get_position( in );
      
    if ( line_is_non_line( line ))
      continue;
      
    spec_header = (NODE_LIST *)get_spec_node_list_single_line( spec_header, line );
  
  }
  
  return spec_header;

}














int line_is_non_line( char line[] )
{

  if ( line[ 0 ] == '#' )
    return 1;
    
  int i;
  
  for ( i = 0; i < strlen( line ); i++ ) {
    if ( ! isspace( line[ i ] ))
      return 0;
  }
  
  return 1;

}












NODE_LIST *get_spec_node_list_single_line( NODE_LIST *spec_header, char line[] )
{

  NODE_LIST *create_node_lister( NODE_LIST *x );
  
  NODE_LIST *node = NULL;
  node = (NODE_LIST *)create_node_lister( node );
  
  char x[ BUFFER ];
  
  sscanf( line, "%s", x );
  
  if ( ! strcmp( x, "BRANCH" ))
    set_spec_node_lister_internal_from_line( node, line );
  else
    set_spec_node_lister_from_line( node, line );
  
  return put_node_lister_end_of_list( spec_header, node );

}













void set_spec_node_lister_internal_from_line( NODE_LIST *node, char line[] )
{

  char node1[ BUFFER ], node2[ BUFFER ];

  sscanf( line, "%*s%s%s%s", node->my_node->label, node->my_node->seq,
    node->my_node->spec );
    
  node->my_node->leaf = 0;

}









void set_spec_node_lister_from_line( NODE_LIST *node, char line[] )
{

  sscanf( line, "%s%s", node->my_node->label, node->my_node->spec );
  
  node->my_node->leaf = 1;

}











NODE_LIST *put_node_lister_end_of_list( NODE_LIST *spec_header, NODE_LIST *node )
{

  if ( spec_header == NULL ) {
    node->my_node->numb = 1;
    return node;
  }
    
  NODE_LIST *curr = spec_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  node->prev = curr;
  curr->next = node;
  
  node->my_node->numb = curr->my_node->numb + 1;
  
  return spec_header;

}















TREE *get_phylo_tree_w_spec_list( TREE *tree, NODE_LIST *spec_header,
  FILE *in )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );

  char tree_str[ LINE_BUFFER ] = "";
  
  get_tree_line_string( tree_str, in );
  
  return get_phylo_tree_w_tree_line_string( tree, spec_header, tree_str );
  
}












void get_tree_line_string( char tree_str[], FILE *in )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL ) {
  
    strcat( tree_str, line );
    int len = strlen( tree_str );
    tree_str[ len - 1 ] = '\0';
    
    if ( tree_str[ len - 2 ] == ';' ) 
      return;
  
  }

}










TREE *get_phylo_tree_w_tree_line_string( TREE *tree, NODE_LIST *spec_header, 
  char tree_str[] )
{
  
  NODE_LIST *node = NULL;
  
  tree->root = (NODE_LIST *)make_next_node( tree, &node );
  
  long i = 0;
  int numb = 0;
  
  while ( i < strlen( tree_str ))
    set_tree_single_char( tree, &node, tree_str, &numb, &i );
    
  return set_tree_nodes_list( tree, spec_header );
  
}










TREE *set_tree_nodes_list( TREE *tree, NODE_LIST *spec_header )
{

  NODE_LIST *node = tree->root;
  
  while ( node->my_node->leaf == 0 ) 
    node = node->down[ 0 ];
    
  if ( node->my_node->numb != 1 )
    error( 2100, "Expected '1' for numb of first leaf.\n" );
  
  tree->spec_header = node;
  
  return set_my_tree_nodes_list( tree, spec_header );

}












TREE *set_my_tree_nodes_list( TREE *tree, NODE_LIST *spec_header )
{

  NODE_LIST *node = tree->spec_header;
  
  int i = 2;
  
  while ( node->my_node->numb != tree->root->my_node->numb ) {
  
    if ( node->my_node->leaf )
      set_tree_leaf_node_species( node, spec_header );

    NODE_LIST *next = (NODE_LIST *)get_node_lister_by_numb( tree, i );
    
    if ( next == NULL )
      break;
      
    node->next = next;
    next->prev = node;

    node = next;

    ++i;

  }
  
  node = tree->spec_header;
  
  while ( node != NULL ) {
  
    if ( node->my_node->leaf == 0 )  
      set_tree_internal_node_species( node, tree, spec_header );
      
    node = node->next;
  
  }
  
  return tree;

}











void set_tree_leaf_node_species( NODE_LIST *node, NODE_LIST *spec_header )
{

  NODE_LIST *my_node = spec_header;
  
  while ( my_node != NULL ) {
  
    if ( my_node->my_node->leaf == 0 ) {
      my_node = my_node->next;
      continue;
    }
  
    if ( ! strcmp( node->my_node->label, my_node->my_node->label )) {
      strcpy( node->my_node->spec, my_node->my_node->spec );
      break;
    }
    
    my_node = my_node->next;
  
  }

}











void set_tree_internal_node_species( NODE_LIST *node, TREE *tree,
  NODE_LIST *spec_header )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] );
  int node_downstream( NODE_LIST *node, NODE_LIST *leaf );

  NODE_LIST *my_node = spec_header;
  
  while ( my_node != NULL ) {
  
    if ( my_node->my_node->leaf ) {
      my_node = my_node->next;
      continue;
    }
    
    NODE_LIST *a, *b;
    
    /*  In get.c:  */
    a = (NODE_LIST *)get_node_from_label( tree->spec_header, 
      my_node->my_node->label );
    b = (NODE_LIST *)get_node_from_label( tree->spec_header, my_node->my_node->seq );
    
    /*  In get.c:  */
    if (( node_downstream( node, a )) && ( node_downstream( node, b ))) {
      if (( ! strcmp( node->down[ 0 ]->my_node->label, a->my_node->label ))
        || ( node_downstream( node->down[ 0 ], a ))) {
        if (( ! strcmp( node->down[ 1 ]->my_node->label, b->my_node->label ))
          || ( node_downstream( node->down[ 1 ], b ))) {
            strcpy( node->my_node->label, my_node->my_node->spec );
            break;
        }
      }
      if (( ! strcmp( node->down[ 1 ]->my_node->label, a->my_node->label ))
        || ( node_downstream( node->down[ 1 ], a ))) {
        if (( ! strcmp( node->down[ 0 ]->my_node->label, b->my_node->label ))
          || ( node_downstream( node->down[ 0 ], b ))) {
            strcpy( node->my_node->label, my_node->my_node->spec );
            break;
        }
      }
    }
    
    my_node = my_node->next;
  
  }

}









NODE_LIST *get_node_lister_by_numb( TREE *tree, int i )
{
  return get_node_lister_by_numb_recursion( tree->root, i );
}








NODE_LIST *get_node_lister_by_numb_recursion( NODE_LIST *node, int numb )
{

  if ( node->my_node->numb == numb ) 
    return node;
    
  if ( node->my_node->leaf )
    return NULL;
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      break;
      
    NODE_LIST *my_node = NULL;
    my_node = (NODE_LIST *)get_node_lister_by_numb_recursion( node->down[ i ],
      numb );
      
    if ( my_node != NULL )
      return my_node;

  }
  
  return NULL;

}








void set_tree_single_char( TREE *tree, NODE_LIST **node, char str[], 
  int *numb, long *pos )
{

  if ( str[ *pos ] == '(' ) 
    tree->root = (NODE_LIST *)make_next_node( tree, node );
    
  else if ( str[ *pos ] == ',' )
    make_new_branch( node, numb );
    
  else if ( str[ *pos ] == ')' )
    set_branch_length( node, str, numb, pos );
    
  else if ( str[ *pos ] == '\n' )
    ;
    
  else if ( str[ *pos ] == '\0' )
    ;
    
  else if ( str[ *pos ] == ';' ) 
    (*node)->my_node->numb = ++(*numb);
  
  else
    set_node_info( node, str, pos );
    
  ++(*pos);

}














NODE_LIST *make_next_node( TREE *tree, NODE_LIST **node )
{

  NODE_LIST *create_node_lister( NODE_LIST *x );
  
  NODE_LIST *new = NULL;
  new = (NODE_LIST *)create_node_lister( new );
  
  if ( *node == NULL ) {
    *node = new;
    return new;
  }
  
  (*node)->down[ 0 ] = new;
  new->up = *node;
  
  *node = new;
  
  return tree->root;

}















void make_new_branch( NODE_LIST **node, int *numb )
{

  NODE_LIST *create_node_lister( NODE_LIST *x );
  
  (*node)->my_node->numb = ++(*numb);

  *node = (*node)->up;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
    if ( (*node)->down[ i ] == NULL ) {
      (*node)->down[ i ] = (NODE_LIST *)create_node_lister( (*node)->down[ i ] );
      (*node)->down[ i ]->up = *node;
      *node = (*node)->down[ i ];
      break;
    }
  }

}












void set_branch_length( NODE_LIST **node, char str[], int *numb, long *pos )
{

  (*node)->my_node->numb = ++(*numb);

  *node = (*node)->up;
  
  *pos += 2;
  
  int i, end = 0;
  
  char len_str[ BUFFER ];
  
  for ( i = 0; i < BUFFER; i++ ) {
  
    int done = 0;
    
    switch ( str[ *pos + i ] ) {
    
    case ',' :
    case ')' :    
    case ';' :
      done = 1;
      break;
      
    default :
      len_str[ i ] = str[ *pos + i ];
      break;
    
    }
    
    if ( done ) {
      len_str[ i ] = '\0';
      break;
    }
    
    end = i;
    
  }
  
  *pos += end;
  
  (*node)->my_node->t = atof( len_str );
  
}














void set_node_info( NODE_LIST **node, char str[], long *pos )
{

  char spec[ BUFFER ], len_str[ BUFFER ];
  
  int i, j = 0, end = 0;
  
  int in_len = 0;
  
  for ( i = 0; i < BUFFER; i++ ) {
  
    int done = 0;
    
    switch ( str[ *pos + i ] ) {
    
    case ')' :
    case ',' :
    case ';' :
      done = 1;
      break;
      
    case ':' :
      spec[ i ] = '\0';
      in_len = 1;
      break;
      
    default :
    
      if ( in_len ) {
        len_str[ j++ ] = str[ *pos + i ];
      }
      else {
        spec[ i ] = str[ *pos + i ];
      }
      
      break;
    
    }
    
    if ( done ) {
      len_str[ j ] = '\0';
      break;
    }
    
    end = i;
  
  }
  
  *pos += end;
  
  (*node)->my_node->t = atof( len_str );
  strcpy( (*node)->my_node->label, spec );
  (*node)->my_node->leaf = 1;

}















/*================================================================================*/
/*================================================================================*/
/*================================================================================*/
/*================================================================================*/
/*================================================================================*/



















void kill_tree_from_root( NODE_LIST *root )
{

  NODE_LIST *get_spec_header( NODE_LIST *node );

  if ( root == NULL )
    return;
    
  NODE_LIST *node = NULL;
  
  /*  In get.c:  */
  node = (NODE_LIST *)get_spec_header( root );
  
  /*  In this file, below:  */
  kill_node_list( node );
  
}













void kill_node_list( NODE_LIST *header )
{

  if ( header == NULL )
    return;
    
  NODE_LIST *node = header;
  
  while ( node != NULL ) {
  
    NODE_LIST *next = node->next;
  
    /*  In ../main/dyn_alloc.c:  */
    kill_node_lister( node );
    
    node = next;
  
  }

}









