#include "get.h"


















#define RES 0.1













NODE_LIST *get_node_from_label( NODE_LIST *node_header, char label[] )
{

  NODE_LIST *node = node_header;
  
  while ( node != NULL ) {
  
    if ( ! strcmp( node->my_node->label, label ))
      return node;
      
    node = node->next;
  
  }
  
  node = node_header;
  
  while ( node != NULL ) {
  
    if ( ! strcmp( node->my_node->label, label ))
      return node;
      
    node = node->prev;
  
  }
  
  printf( "Unknown node label :  %s\n", label );
  error( 4100, "Could not find label in tree.\n" );
  
  return NULL;

}











NODE_LIST *get_node_from_numb( TREE *tree, int numb )
{

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
  
    if ( node->my_node->numb == numb )
      return node;
      
    node = node->next;
  
  }
  
  error( 4105, "Could not find node number in tree.\n" );
  
  return NULL;

}










NODE_LIST *get_spec_header( NODE_LIST *node )
{

  if ( node == NULL )
    return NULL;

  NODE_LIST *curr = node;
  
  while ( curr->prev != NULL )
    curr = curr->prev;
    
  return curr;

}















NODE_LIST *get_root( NODE_LIST *node )
{

  if ( node == NULL )
    return NULL;
    
  NODE_LIST *curr = node;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  return curr;

}











NODE_LIST *get_inner_node_header( NODE_LIST *spec_header )
{

  NODE_LIST *node = spec_header;
  
  while ( node != NULL ) {
  
    if ( node->my_node->leaf == 0 )
      return node;
      
    node = node->next;
  
  }
  
  return NULL;

}









STAT get_time_to_node( NODE_LIST *node )
{

  if ( node->my_node->leaf )
    return 0.0;
    
  STAT t = 0.0;  
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    STAT curr_t;
  
    if ( node->down[ i ] != NULL ) {

      curr_t = 
        get_time( node->down[ i ]->my_node->t + get_time_to_node( node->down[ i ] ));

      if ( t == 0.0 ) {
        t = curr_t;
      }
      else {
        /*
        if ( t != curr_t )
          error( 4101, "Times do not match.\n" );      
        */
      }
      
    }
  
  }
  
  return t;
  
}












STAT get_time( STAT t )
{

  STAT tt = (STAT)round( t );
  
  STAT i, best = 0.0, min = 2.0;
  
  for ( i = -0.5; i < 0.6; i += RES ) {
  
    STAT diff = fabs( t - (tt + i) );
    
    if ( diff < min ) {
      min = diff;
      best = i;
    }
  
  }
  
  return tt + best;

}
















TIME get_time_between_spec_labels( TREE *tree, char a[], char b[] )
{

  NODE_LIST *node = NULL;
  /*  In this file, below:  */
  node = (NODE_LIST *)get_common_ancestor_labels( tree, a, b );
  
  /*  In this file, above:  */
  return get_time_to_node( node );

}















NODE_LIST *get_common_ancestor_labels( TREE *tree, char a[], char b[] )
{

  NODE_LIST *a_node = NULL, *b_node = NULL;
  
  a_node = (NODE_LIST *)get_node_from_label( tree->spec_header, a );
  b_node = (NODE_LIST *)get_node_from_label( tree->spec_header, b );
  
  NODE_LIST *node = a_node->up;
  
  while ( node != NULL ) {
  
    if ( node_downstream( node, b_node ))
      return node;
      
    node = node->up;
  
  }
  
  return NULL;

}















int node_downstream( NODE_LIST *node, NODE_LIST *leaf )
{

  NODE_LIST *n = leaf;
  
  while ( n != NULL ) {
    if ( n->my_node->numb == node->my_node->numb )
      return 1;
    n = n->up;
  }
  
  return 0;

  if ( node == NULL )
    return 0;
    
  if ( node->my_node->numb == leaf->my_node->numb )
    return 1;  
    
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = node->down[ i ];
  
    if ( d == NULL )
      break;
  
    if ( node_downstream( d, leaf ))
      return 1;
  
  }
  
  return 0;

}










NODE_LIST *get_daughter_node_copy_list( NODE_LIST *d_header, NODE_LIST *node )
{

  NODE_LIST *create_node_lister( NODE_LIST *n );
  NODE_LIST *put_node_lister_end_of_list( NODE_LIST *spec_header, NODE_LIST *node );
  
  NODE_LIST *header = NULL;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( node->down[ i ] == NULL )
      return header;
  
    if ( ! node->down[ i ]->my_info->use )
      continue;
      
    NODE_LIST *new = NULL;
    new = (NODE_LIST *)create_node_lister( new );
    
    *(new->my_node) = *(node->down[ i ]->my_node);
    *(new->my_info) = *(node->down[ i ]->my_info);
    
    /*  In create_tree.c:  */
    header = (NODE_LIST *)put_node_lister_end_of_list( header, new );
  
  }
  
  return header;

}














INDEX get_numb_of_nodes_in_tree( TREE *tree )
{
  
  INDEX n = 0;
  
  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
    ++n;
    node = node->next;
  }
  
  return n;
  
}














COUNT get_numb_of_nodes( NODE_LIST *header )
{

  NODE_LIST *node = (NODE_LIST *)get_spec_header( header );
  
  COUNT n = 0;
  
  while ( node != NULL ) {
  
    ++n;
    
    node = node->next;
  
  }
  
  return n;

}














INDEX get_max_occur_node( NODE_LIST *node )
{

  if ( node == NULL ) 
    return 0;
    
  INDEX max = 0;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = node->down[ i ];
  
    if ( d == NULL )
      break;
      
    if (( d->my_info->use ) && ( d->my_info->max > max ))
      max = d->my_info->max;
  
  }
  
  return max;

}











int get_use( NODE_LIST *node )
{

  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = node->down[ i ];
    
    if ( d == NULL )
      break;
      
    if ( d->my_info->use == 1 )
      return 1;
  
  }
  
  return 0;

}














void get_label_from_numb( char label[], TREE *tree, int numb )
{

  NODE_LIST *node = tree->spec_header;
  
  while ( node != NULL ) {
  
    if ( node->my_node->numb == numb ) {
      strcpy( label, node->my_node->label );
      return;
    }
    
    node = node->next;
  
  }

}












int label_is_upstream( TREE *tree, char leaf[], char label[] )
{

  NODE_LIST *my_leaf = NULL;
  my_leaf = (NODE_LIST *)get_node_from_label( tree->spec_header, leaf );

  while ( my_leaf != NULL ) {
  
    if ( ! strcmp( my_leaf->my_node->label, label ))
      return 1;
      
    my_leaf = my_leaf->up;
  
  }
  
  return 0;

}












NODE_LIST *get_sister_node( TREE *tree, char label[] )
{

  NODE_LIST *node = (NODE_LIST *)get_node_from_label( tree->spec_header, label );
  
  NODE_LIST *parent = node->up;
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    NODE_LIST *d = parent->down[ i ];
    
    if ( strcmp( d->my_node->label, node->my_node->label ))
      return d;
  
  }
  
  return NULL;

}





/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/















NODE_LIST *copy_tree( NODE_LIST *root )
{

  if ( root == NULL )
    return NULL;
    
  NODE_LIST *a_header = NULL, *b_header = NULL;
  
  b_header = (NODE_LIST *)get_spec_header( root );
    
  a_header = (NODE_LIST *)copy_node_list( a_header, b_header );
  
  copy_edges( a_header, b_header );
  
  return get_root( a_header );
  
}











NODE_LIST *copy_node_list( NODE_LIST *a_header, NODE_LIST *b_header )
{

  NODE_LIST *b = b_header;
  
  while ( b != NULL )
    a_header = (NODE_LIST *)copy_single_node_lister_and_step( a_header, &b );
    
  return a_header;
  
}











NODE_LIST *copy_single_node_lister_and_step( NODE_LIST *a_header, NODE_LIST **b )
{
  a_header = (NODE_LIST *)copy_single_node_lister( a_header, *b );
  *b = (*b)->next;
  return a_header;
}











NODE_LIST *copy_single_node_lister( NODE_LIST *a_header, NODE_LIST *b )
{

  NODE_LIST *create_node_lister( NODE_LIST *x );
  NODE_LIST *put_node_lister_end_of_list( NODE_LIST *spec_header, NODE_LIST *node );
  
  NODE_LIST *a = NULL;
  a = (NODE_LIST *)create_node_lister( a );
  
  /*  In this file, below:  */
  copy_node_listers( a, b );
  
  /*  In create_tree.c:  */
  return put_node_lister_end_of_list( a_header, a );
  
}












void copy_node_listers( NODE_LIST *a, NODE_LIST *b )
{

  *(a->my_node) = *(b->my_node);
  *(a->my_trans) = *(b->my_trans);
  *(a->my_info) = *(b->my_info);
  *(a->my_dd) = *(b->my_dd);
  *(a->prior) = *(b->prior);
  
  int i;
  
  for ( i = 0; i < DBUFF; i++ )
    *(a->my_d[ i ]) = *(b->my_d[ i ]);

}














void copy_edges( NODE_LIST *a_header, NODE_LIST *b_header )
{

  NODE_LIST *a = a_header, *b = b_header;
  
  while ( a != NULL )
    copy_edges_node_lister_and_step( &a, &b, a_header );

}













void copy_edges_node_lister_and_step( NODE_LIST **a, NODE_LIST **b,
  NODE_LIST *a_header )
{
  copy_edges_node_lister( *a, *b, a_header );
  *a = (*a)->next;
  *b = (*b)->next;
}









void copy_edges_node_lister( NODE_LIST *a, NODE_LIST *b, NODE_LIST *a_header )
{

  if ( b->up != NULL )
    a->up = (NODE_LIST *)get_node_from_label( a_header, b->up->my_node->label );
  
  int i;
  
  for ( i = 0; i < BRANCH_BUFFER; i++ ) {
  
    if ( b->down[ i ] == NULL )
      break;
      
    a->down[ i ] = (NODE_LIST *)get_node_from_label( a_header, 
      b->down[ i ]->my_node->label );
      
  }

}











